<?php
/**
 * @package		Compile Grid
 * @author		Uta Marian - Alexandru
 * @license		http://www.compilegrid.com/license.html
 * @link		http://www.compilegrid.com
 */
 
//*********** SESSION ***********//
session_start();

//*********** DATABASE DETAILS ***********//
/*
* DB_DRIVER - > DEFAULT MYSQLI, ACTUALLY THIS IS THE ONLY INSTALLED DRIVER
* DB_HOSTNAME - > YOUR MYSQL HOSTING, DEFAULT "LOCALHOST"
* DB_USERNAME - > YOUR MYSQL USERNAME
* DB_PASSWORD - > YOUR MYSQL USERNAME PASSWORD
* DB_DATABASE - > YOUR MYSQL DATABASE NAME
* DB_PREFIX - > IF YOU NEED TO USE MULTIPLE APPS ON THE SAME DATABASE
*/

define('DB_DRIVER', 'mysqli');//don't change
define('DB_HOSTNAME', 'localhost');
define('DB_USERNAME', 'DB USERNAME');
define('DB_PASSWORD', 'DB PASSWORD');
define('DB_DATABASE', 'DB NAME');
define('DB_CHARSET', 'utf8');

//*********** UTF-8 ***********//
mb_internal_encoding('UTF-8'); 
mb_http_output('UTF-8'); 
mb_http_input('UTF-8'); 
mb_regex_encoding('UTF-8'); 

//*********** HTTP ***********//
/*
* DOMAIN_NAME - > YOUR DOMAIN NAME [ e.g. 'domain.com' ]
*/

//use this variable only if this cms is installed into a directory
//eg: "cms", and your url will be : domain.com/cms
$DOMAIN_DIRECTORY = '';

define('DOMAIN_NAME', 'domain.com'); // this is the used domain name

define('_COPYRIGHT', 'copyright &copy; domain.com'); // this is the copyright footer
define('_CMS_NAME', '<b>Project</b>Name');//If no logo image, will display this name
define('_CMS_NAME_SHORT', '<b>C</b>G');   //If no logo image, will display this name

if ( empty ( $DOMAIN_DIRECTORY ) ) {
  define('HTTP_MASTER', 'http://www.'.DOMAIN_NAME.'/');
} else {
  define('HTTP_MASTER', 'http://www.'.DOMAIN_NAME.'/'.$DOMAIN_DIRECTORY.'/');
}

define('HTTP_PLUGINS', HTTP_MASTER.'plugins/');
define('HTTP_POST', HTTP_MASTER.'system/post/');
define('ADMIN_DIR', 'mng');
define('HTTP_SERVER_ADMIN', HTTP_MASTER.ADMIN_DIR.'/');
define('HTTP_SERVER_WEBSITE', HTTP_MASTER);

//::: DEFINE VARIABLES
define('_DIR',dirname(__FILE__));
define('_CLS', _DIR.'/system/classes/');
define('_POST', _DIR.'/system/post/');
define('_PLUGINS_CLS', _DIR.'/plugins/');
define('_DB', _DIR.'/system/database/');
define('_THEMES', _DIR.'/themes/');


define('_UPLOAD_DIR', _DIR.'/uploads/');
define('_UPLOAD_DIR_HTTP', HTTP_MASTER.'uploads/');
define('MAX_UPLOAD_SIZE','9012000');
define('DATE_FORMAT','d.m.Y');
define('FULL_DATE_FORMAT','d.m.Y - h:i:s');
define('HOUR_FORMAT','h:i:s');

//DEV MODE
$_DEV   = 'DISABLED';//set "ON", if you want to enable it.

//::: VERSION
$_VERSION_FILE  = _DIR.'/version';
$fh             = fopen($_VERSION_FILE, "rb");
$_VERSION_READ  = fread($fh, filesize($_VERSION_FILE));
fclose($fh);
define('_VERSION', $_VERSION_READ );

//::: LOAD MAIN FILE
require_once(_CLS.'main.class.php');

//::: _CLS EXEC
$_VIEW                              = new template;
$_VIEW->_DB         = $_DB          = new database;
$_VIEW->_PREPARE    = $_PREPARE     = new prepare;
$_VIEW->_PLUGINS    = $_PLUGINS     = new plugins;
$_VIEW->_UPLOAD     = $_UPLOAD      = new chip_upload();
$_VIEW->_VISITOR_IP = $_VISITOR_IP  =	$_PREPARE->get_client_ip();
define('_VISITOR_IP',$_VISITOR_IP);

/************ DON'T CHANGE **************/
if (get_magic_quotes_gpc()) {
    $process = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
    while (list($key, $val) = each($process)) {
        foreach($val as $k => $v) {
            unset($process[$key][$k]);
            if (is_array($v)) {
                $process[$key][stripslashes($k)] = $v;
                $process[] = &$process[$key][stripslashes($k)];
            } else {
                $process[$key][stripslashes($k)] = stripslashes($v);
            }
        }
    }
    unset($process);
}
/*****************************************/
if ( $_DEV == 'ON' ) {
  error_reporting(E_ALL);
  ini_set('display_errors', '1');
} else {
  error_reporting(0);
  ini_set('display_errors', '0');
}
//::: LANGUAGE SYSTEM
define('_LANG', 'en');
define('_LANG_DEFAULT', 'en');
$_LANG  = array();

//::: LOAD PLUGINS CLASSES
foreach (glob(_PLUGINS_CLS."_*") as $filename)
{//::: GET THE CLASS/FILE NAME
  $_CLASS = str_replace(_PLUGINS_CLS,"", $filename );
  require_once( $filename.'/'.$_CLASS.'.class.php' );
}

//::: LOAD PLUGINS LANGUAGE FILE
foreach (glob(_PLUGINS_CLS."_*") as $filename)
{//::: GET THE CLASS/FILE NAME
  if (file_exists( $filename.'/translations/'._LANG.'/'._LANG.'.php' )) {
    require_once( $filename.'/translations/'._LANG.'/'._LANG.'.php' );
  } else {
  //:: LOAD DEFAULT TRANSLATION
    if (file_exists( $filename.'/translations/'._LANG_DEFAULT.'/'._LANG_DEFAULT.'.php' )) {
      require_once( $filename.'/translations/'._LANG_DEFAULT.'/'._LANG_DEFAULT.'.php' );
    }
  //:: LOAD DEFAULT TRANSLATION
  }
}
$_VIEW->_LANG = $_LANG;

//::: GLOBAL VARIABLES
$_VIEW->_GET_PLUGIN       = '';
$_VIEW->_PAGINATION_LINK  = $_PAGINATION_LINK = '?p=';

//::: ADMINS SESSION
if ( empty ( $_SESSION['ADMIN_SESSION'] ) ) {
  $_VIEW->_ADMIN_SESSION  = '';
} else {
  $_VIEW->_ADMIN_SESSION  = $_SESSION['ADMIN_SESSION'];
}

$_WEBSITE_SETTINGS        = $_ADMINISTRATORS->_SETTINGS_FIELDS_LIST ( array( "" ) );
$_VIEW->_WEBSITE_SETTINGS = $_WEBSITE_SETTINGS;
if ( empty ( $_WEBSITE_SETTINGS['0']['website_theme'] ) ) {
  define('_TMD', 'default');
} else {
  define('_TMD', $_WEBSITE_SETTINGS['0']['website_theme']);
}

define('_TMA', 'admin');

define('_TMDR', _THEMES._TMD.'/');
define('_TMDRP', _THEMES._TMD.'/plugins/');
define('_TMDA', _THEMES._TMA.'/');

?>