<?php
/**
 * @package   Compile Grid
 * @author    Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

require_once(dirname(__FILE__).'/config.php');
//:: GENERATE THE ROUTE
$_REQUEST_URI         = urldecode( $_SERVER['REQUEST_URI'] );

if ( !empty ( $DOMAIN_DIRECTORY ) ) {
  $_REQUEST_URI         = str_replace('/'.$DOMAIN_DIRECTORY, "", $_REQUEST_URI );
}

$_VIEW->_REQUEST_URI  = $_REQUEST_URI;

$_ROUTE_MODE    = ltrim ($_REQUEST_URI, '/');
$_ROUTE_MODE    = explode("?", $_ROUTE_MODE);

if ( empty ( $DOMAIN_DIRECTORY ) ) {
  $_REQUEST_ROUTE = $_ROUTE_MODE['0'];
} else {
  $_REQUEST_ROUTE = str_replace( $DOMAIN_DIRECTORY, "", $_ROUTE_MODE['0'] );
}

if ( empty ( $_WEBSITE_SETTINGS['0']['website_default_route'] ) OR ( $_REQUEST_URI != "/" ) ) {
  $_VIEW->_ROUTE        = $_ROUTE  = isset( $_REQUEST_ROUTE ) ? $_PREPARE->sanitize( $_REQUEST_ROUTE, 'input' ) : '';
} else {
  $_VIEW->_ROUTE        = $_ROUTE  = $_WEBSITE_SETTINGS['0']['website_default_route'];
}

$_ROUTE_EXPLODE       = explode("/",strtoupper( $_ROUTE ) );
$_MSJ_DETAILS         = explode("_MSJ_INFO=",$_REQUEST_URI);
$_VIEW->_MSJ_INFO     = $_MSJ_INFO  = isset($_MSJ_DETAILS['1']) ? $_MSJ_DETAILS['1'] : '';
$_VIEW->_HEADER_F = $_VIEW->render(_TMDR.'functions/header.functions.php');

if ( empty ( $_ROUTE ) ) {
  //:: DEFAULT HOMEPAGE
  $_SEO_DEFAULT = $_ADMINISTRATORS->_SEO_DEFAULT( $_ARRAY = array() );


$_SEO = array (
                "_TITLE"=>$_SEO_DEFAULT['_NAME'],
                "_DESCRIPTION"=>$_SEO_DEFAULT['_DESCRIPTION'],
                "_KEYWORDS"=>$_SEO_DEFAULT['_TAGS']
                );

$_VIEW->_SEO  = $_SEO;

$_VIEW->_HEADER = $_VIEW->render(_TMDR.'header.php');
$_VIEW->_FOOTER = $_VIEW->render(_TMDR.'footer.php');
echo $_VIEW->render(_TMDR.'index.php');


} else {

  //:: LOAD THE ROUTE
$_CLASS_NAME          = '_'.$_ROUTE_EXPLODE['0'];
$_VIEW->_CLASS_NAME   = $_CLASS_NAME;
$_VIEW->_GET_PLUGIN   = $_CLASS_NAME;


//:: REDIRECT TO THE 404 ERROR PLUGIN
if (!class_exists($_CLASS_NAME)) {
    header ( 'Location: '.HTTP_MASTER.'404/ref='.$_ROUTE );
}


$_VIEW->_PLUGIN_CLASS = $_PLUGIN_CLASS  = new $_CLASS_NAME;


//:: GET THE PLUGIN INFO
$_VIEW->_INFO         = $_PLUGIN_CLASS->_INFO(  );

//:: VALIDATE THE AUTHENTIFICATION PART [ ONLY IF IS NEEDED ]
$_REQUIRED_SESSION  = $_PLUGIN_CLASS->_REQUIRED_SESSION( $_ARRAY = array ( "_ROUTE" => $_ROUTE, "_REQUEST_URI" => $_REQUEST_URI ) );

if ( $_REQUIRED_SESSION['_REQUIRED_SESSION'] ) {
  if ( empty ( $_SESSION[$_REQUIRED_SESSION['_REQUIRED_SESSION_STRING']] ) ) {
    //:: REDIRECT TO THE LOGIN PAGE
    header ( 'Location: '.HTTP_MASTER.$_REQUIRED_SESSION['_REDIRECT_PAGE'] );
  }
}





//:: GET THE PAGE DETAILS
$_ARRAY               = array ( "_ROUTE" => $_ROUTE, "_REQUEST_URI" => $_REQUEST_URI );
$_VIEW->_VIEW_DETAILS = $_VIEW_DETAILS = $_PLUGIN_CLASS->_DESIGN( $_ARRAY );

//:: REDIRECT TO THE 404 ERROR PLUGIN : IF ERROR
if ( empty ( $_VIEW_DETAILS ) ) {
    header ( 'Location: '.HTTP_MASTER.'404/ref='.$_ROUTE );
}

//:: GET THE HTML FIELDS DETAILS
$_VIEW->_FIELDS_LIST  = $_VIEW_DETAILS['DESIGN']['fields'];
$_VIEW->_GET_ROUTE    = $_GET_ROUTE = $_VIEW_DETAILS['DESIGN']['_GET_ROUTE'];
//:: POPULATE ALL FIELDS WITH DATA [ IF EXISTS ]
$_VIEW->_DETAILS        = $_VIEW_DETAILS['DESIGN']['fields_data'];




if ( array_key_exists('_GET_ROUTE_ID', $_VIEW_DETAILS['DESIGN'] ) && $_VIEW_DETAILS['DESIGN']['_GET_ROUTE_ID'] ) {
  $_ID              = $_VIEW_DETAILS['DESIGN']['_GET_ROUTE_ID'];
} else {
  $_ID              = '';
}

if ( array_key_exists('_UPDATE_ROUTE_ID', $_VIEW_DETAILS['DESIGN'] ) && $_VIEW_DETAILS['DESIGN']['_UPDATE_ROUTE_ID'] ) {
  $_UPDATE_ROUTE_ID = $_VIEW_DETAILS['DESIGN']['_UPDATE_ROUTE_ID'];
} else {
  $_UPDATE_ROUTE_ID = '';
}




  $_VIEW->_ID     = $_ID;

//*** LIST MODE **/
if ( array_key_exists('_LIST_MODE', $_VIEW_DETAILS['DESIGN'] ) && $_VIEW_DETAILS['DESIGN']['_LIST_MODE'] ) {
  $_FIELDS_HTML     = $_GET_ROUTE . '_FIELDS';
  $_FIELDS_DATABASE = $_GET_ROUTE . '_FIELDS_LIST';
  
  $_VIEW->_ALL_FIELDS       = $_PLUGIN_CLASS->$_FIELDS_HTML ( );
  $_ALL_FIELDS_LIST         = $_PLUGIN_CLASS->$_FIELDS_DATABASE ( $_ARRAY = array( "limit" => false ) );

  $numbers = count ($_ALL_FIELDS_LIST);
  //PAGINATION
  $_P_URL =   $_SERVER['REQUEST_URI'];
  $_P_URL_E   =   explode("?p=", $_P_URL );

  if ( count($_P_URL_E) == 1 ) {
    $page		=	'1';
  } else {
    $page		=	$_P_URL_E['1'];
  }
  $on_page	=	"20";
  $page=!empty($page)?$page:"1";
  $limitfrom=($page-1)*$on_page;
  $limitto=($page*$on_page)-($page-1)*$on_page;
  $itemsPerPage=$on_page;
      $paginator['pager']=$_PREPARE->page($page,$numbers,$itemsPerPage);
      $paginator['limitfrom']=$limitfrom+1;
      $paginator['limitto']=$limitfrom+$numbers;
      $paginator['itemsnum']=$numbers;
      $paginator['page']=$page;
      $paginator['onpage']=$on_page;
  $_VIEW->paginator	=	$paginator;
  //END PAGINATION
  $_VIEW->_ALL_FIELDS_LIST  = array_slice($_ALL_FIELDS_LIST, $limitfrom, $limitto);
//***********************************************************************//
}





$_CSS = $_PLUGIN_CLASS->_LOAD_CSS ( $_CLASS_NAME, $_ROUTE );

if ( empty ( $_CSS ) ) {
  $_VIEW->_CSS  = '';
} else {
  $_VIEW->_CSS  = '<style>'.$_CSS['0']['css_info'].'</style>';
}







//::: POST DATA

if ( $_POST ) {
  $_POST_ARRAY      = $_POST;
  $_FILES_ARRAY     = $_FILES;
  $_MANAGE          = $_PLUGIN_CLASS->$_GET_ROUTE( $_POST_ARRAY, $_UPLOAD, $_FILES_ARRAY );

  if ( empty ( $_ID ) ) {
    //:: ADD DATA INTO DATABASE
    if ( $_MANAGE ) {
      header ( 'Location: '.HTTP_SERVER_WEBSITE.$_ROUTE.'?_MSJ_INFO=_ADDED' );
    } else {
      header ( 'Location: '.HTTP_SERVER_WEBSITE.$_ROUTE.'?_MSJ_INFO=_ERROR' );
    }
  } else {
    //:: UPDATE DATABASE DATA

if ( $_UPDATE_ROUTE_ID ) {

    if ( $_MANAGE ) {
      header ( 'Location: '.HTTP_SERVER_WEBSITE.$_ROUTE.'?id='.$_UPDATE_ROUTE_ID.'?_MSJ_INFO=_UPDATED' );
    } else {
      header ( 'Location: '.HTTP_SERVER_WEBSITE.$_ROUTE.'?id='.$_UPDATE_ROUTE_ID.'?_MSJ_INFO=_ERROR' );
    }
} else {
    if ( $_MANAGE ) {
      header ( 'Location: '.HTTP_SERVER_WEBSITE.$_ROUTE.'?_MSJ_INFO=_UPDATED' );
    } else {
      header ( 'Location: '.HTTP_SERVER_WEBSITE.$_ROUTE.'?_MSJ_INFO=_ERROR' );
    }
}

  }
}

//::: END POST DATA












$_SEO = array (
  "_TITLE"=>$_VIEW_DETAILS['SEO']['_TITLE'],
  "_DESCRIPTION"=>$_VIEW_DETAILS['SEO']['_DESCRIPTION'],
  "_KEYWORDS"=>$_VIEW_DETAILS['SEO']['_KEYWORDS']
);

$_VIEW->_SEO  = $_SEO;

$_VIEW->_HEADER = $_VIEW->render(_TMDR.'header.php');
$_VIEW->_FOOTER = $_VIEW->render(_TMDR.'footer.php');
echo $_VIEW->render(_TMDR.'route.php');
}
?>