<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _404 {

  private function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  private function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  private function _DB () {
    $_DB  = new database;
    return $_DB;
  }


  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();

    $_TEXT_TYPE = "props:['color','background-color','text-decoration','font-weight','letter-spacing','line-height','text-align','text-transform','word-spacing','text-shadow','border','border-radius','box-shadow','margin','padding']";
    $_BOX_TYPE  = "props:['background-color','border','border-top','border-right','border-bottom','border-left','border-radius','box-shadow','margin','padding']";
    
    $_COMBINED  = "props:['color','background-color','text-decoration','font-weight','letter-spacing','line-height','text-align','text-transform','word-spacing','text-shadow','border','border-top','border-right','border-bottom','border-left','border-radius','box-shadow','margin','padding','background-color','border','border-radius','box-shadow','margin','padding']";
    
    $_INFO  = array (
      "name"=>"404 not found",
      "url"=>"_404",
      "description"=>$_LANG['404']['DESCRIPTION'],
      "menu" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['404']['ALL'] ),
        "item_3" => array( "option" => true, "url" => "pluginUninstall", "name" => $_LANG['404']['UNINSTALL'] )
      ),
      "menu_design" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "_ALL" => "page-not-found", "name" => $_LANG['404']['CUSTOMIZE'] )
      ),
      "def"  => "
      
          def: {
            '._404 .page-title':{
              name: '".$_LANG['404']['CUSTOMIZE_PAGE_NAME']."',
              ".$_TEXT_TYPE."
            },
            '._404 .big-404':{
              name: '".$_LANG['404']['CUSTOMIZE_BIG_404']."',
              ".$_TEXT_TYPE."
            },
            '._404 .error-page > .error-content > h3':{
              name: '".$_LANG['404']['CUSTOMIZE_HEADLINE']."',
              ".$_TEXT_TYPE."
            },
            '._404 .error-page > .error-content > p':{
              name: '".$_LANG['404']['CUSTOMIZE_DETAILS']."',
              ".$_COMBINED."
            }
          }
      
      "
    );
    return $_INFO;
  }

  //:: CREATE THE SUBMENU
  function _SUBMENU ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_RETURN  = array (
      "all_errors" => array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['404']['ALL']
        )
    );
    return $_RETURN;
  }

  //:: PLUGIN INSTALL
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_INSTALL = "
      CREATE TABLE IF NOT EXISTS `404_not_found` (
        `404nf_id` int(11) NOT NULL AUTO_INCREMENT,
        `404nf_ref` varchar(250) NOT NULL,
        `404nf_counter` int(11) NOT NULL,
        `404nf_first_seen` int(11) NOT NULL,
        `404nf_latest_seen` int(11) NOT NULL,
        PRIMARY KEY (`404nf_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_INSTALL);
    return $_RETURN;
  }

  //:: PLUGIN UNINSTALL
  function _UNINSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_DROP    = "DROP TABLE IF EXISTS `404_not_found`;";
    $_RETURN  = $_CONN->NoQuery($_DROP);
    return $_RETURN;
  }

  //:: INFO LISTING : HTML FIELDS
  function _ALL_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['404']['ALL'],
          "group" => true,
          "special" => true
        ),
      "404nf_latest_seen" => array (
          "options" => false,
          "translation" => $_LANG['404']['LATEST_REQUESTED'],
          "type"        => 'date'
        ),
      "404nf_ref" => array (
          "options" => false,
          "translation" => $_LANG['404']['REF']
        ),
      "404nf_counter" => array (
          "options" => false,
          "translation" => $_LANG['404']['COUNTER']
        ),
      "404nf_id" => array (
          "options" => array (
              "remove" => array( "url" => "", "route" => "_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['404']['REMOVE'] ),
            ),
          "translation" => $_LANG['404']['OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: LISTING DATA : MYSQL DETAILS
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN = $_CONN->Query("SELECT `404nf_id`, `404nf_ref`, `404nf_counter`, `404nf_first_seen`, `404nf_latest_seen` FROM 404_not_found order by 404nf_id desc");
    return $_RETURN;
  }



  //:: WIDGET REMOVE
  function _REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->NoQuery("DELETE FROM 404_not_found WHERE 404nf_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }


  //:: _REQUIRED_SESSION :: JUST IF NEED AUTHENTIFICATION
  function _REQUIRED_SESSION ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = array (
      "_REQUIRED_SESSION"         => false,
      "_REQUIRED_SESSION_STRING"  => '',
      "_REDIRECT_PAGE"            => '',
    );
    return $_RETURN;
  }

  //:: DESIGN THE WIDGET
  function _WIDGET ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();
    
    $_COUNT = $_CONN->Query("SELECT `404nf_id` FROM 404_not_found");
    $_COUNT = count ( $_COUNT );
    $_FORM  = '';

    ob_start();
    if ( file_exists ( _TMDRP.'_404/admin.widget.php' ) ) {
      include( _TMDRP.'_404/admin.widget.php' );
    } else {
      include('design/admin.widget.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();

    return $_FORM;
  }


  function _TRACK ( $_ARRAY ){
    $_ARRAY['404nf_ref']          = $_ARRAY['_ROUTE'];
    $_ARRAY['404nf_counter']      = 1;
    $_ARRAY['404nf_first_seen']   = strtotime( "now" );
    $_ARRAY['404nf_latest_seen']  = strtotime( "now" );

    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();

    $_VALIDATE = $_CONN->Query("SELECT `404nf_id` FROM 404_not_found where 404nf_ref=? limit 1","s",$_ARRAY['404nf_ref']);

    if ( empty ( $_VALIDATE ) ) {
      $_CONN->NoQuery("INSERT INTO 404_not_found VALUES(NULL,?,?,?,?)","ssss",$_ARRAY['404nf_ref'],$_ARRAY['404nf_counter'],$_ARRAY['404nf_first_seen'],$_ARRAY['404nf_latest_seen']);
    } else {
      $_CONN->NoQuery("UPDATE 404_not_found SET 404nf_counter=404nf_counter+1, 404nf_latest_seen=? WHERE 404nf_ref=? limit 1","ss",$_ARRAY['404nf_latest_seen'],$_ARRAY['404nf_ref']);
    }
  }


  //:: DESIGN ROUTE!
  function _DESIGN ( $_ARRAY ) {
    $_TRACK    = $this->_TRACK( $_ARRAY );
    $_LANG     = $this->_LANGUAGE();
    $_FORM     =  '';

    ob_start();
    if ( file_exists ( _TMDRP.'_404/index.php' ) ) {
      include( _TMDRP.'_404/index.php' );
    } else {
      include('design/index.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();


    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_LANG['404']['SEO_TITLE'],
        "_DESCRIPTION" => $_LANG['404']['SEO_DESCRIPTION'],
        "_KEYWORDS" => $_LANG['404']['SEO_KEYWORDS']
        ),
      "DESIGN" => array (
        "ICO" => '<i class="fa fa-warning"></i>',
        "title" => $_LANG['404']['TITLE'],
        "form" => $_FORM,
        "fields_start" =>false,
        "fields" =>false,
        "fields_end" =>false,
        "fields_data" =>false,
        "_GET_ROUTE"  => ''
      )
    );

    return $_RETURN;

  }

  function _LOAD_CSS ( $_PLUGIN, $_ROUTE ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();

    $_RETURN = $_CONN->Query("SELECT `css_id`, `css_plugin`, `css_plugin_route`, `css_info` FROM custom_css where css_plugin=? limit 1","s","_404");
    return $_RETURN;
  }

}

//:: WIDGETS CLASS
$_VIEW->_404  = $_404  = new _404;
?>