<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _ADMINISTRATORS {
  function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  function _DB () {
    $_DB  = new database;
    return $_DB;
  }


  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_INFO  = array (
      "name" => $_LANG['ADM']['PLUGIN_NAME'],
      "url" => "_ADMINISTRATORS",
      "description" => $_LANG['ADM']['PLUGIN_DESCRIPTION'],
      "menu" => array(
        "item_3" => array( "option" => false, "url" => "FIELDS/_SETTINGS", "name" => $_LANG['ADM']['SETTINGS'] ),
        "item_4" => array( "option" => false, "url" => "FIELDS/_SMTP", "name" => $_LANG['ADM']['SETTINGS_SMTP'] ),
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['ADM']['ADMINISTRATORS_MANAGE'] ),
        "item_2" => array( "option" => false, "url" => "FIELDS/_MANAGE", "name" => $_LANG['ADM']['NEW_ADMIN'] )
      )
    );
    return $_INFO;
  }

  //:: INSTALL ADMINISTRATORS PLUGIN
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_CUSTOM_CSS = "
      CREATE TABLE IF NOT EXISTS `custom_css` (
        `css_id` int(11) NOT NULL AUTO_INCREMENT,
        `css_plugin` varchar(150) NOT NULL,
        `css_plugin_route` varchar(150) NOT NULL,
        `css_info` text NOT NULL,
        PRIMARY KEY (`css_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_CONN->NoQuery($_CUSTOM_CSS);


    $_SETTINGS = "
      CREATE TABLE IF NOT EXISTS `website_settings` (
        `website_id` int(11) NOT NULL AUTO_INCREMENT,
        `website_name` varchar(150) NOT NULL,
        `website_seo_tags` varchar(250) NOT NULL,
        `website_seo_description` text NOT NULL,
        `website_author` varchar(150) NOT NULL,
        `website_email` varchar(150) NOT NULL,
        `website_phone` varchar(150) NOT NULL,
        `website_fax` varchar(150) NOT NULL,
        `website_address` varchar(150) NOT NULL,
        `website_theme` varchar(250) NOT NULL,
        `website_default_route` varchar(250) NOT NULL,
        `website_logo` varchar(250) NOT NULL,
        PRIMARY KEY (`website_id`)
      ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;
    ";
    $_CONN->NoQuery($_SETTINGS);

    $_DEFAULT_DATA  = "INSERT INTO `website_settings` (`website_id`, `website_name`, `website_seo_tags`, `website_seo_description`, `website_author`, `website_email`, `website_phone`, `website_fax`, `website_address`) VALUES (1, 'Compile Grid', 'Compile Grid', 'Compile Grid', 'Compile Grid', '', '', '', '', 'default', '');";
    $_CONN->NoQuery($_DEFAULT_DATA);


    $_SETTINGS = "
      CREATE TABLE IF NOT EXISTS `smtp_settings` (
        `smtp_id` int(11) NOT NULL AUTO_INCREMENT,
        `smtp_secure` varchar(20) NOT NULL,
        `smtp_host` varchar(150) NOT NULL,
        `smtp_port` int(11) NOT NULL,
        `smtp_username` varchar(150) NOT NULL,
        `smtp_password` varchar(150) NOT NULL,
        `smtp_set_from` varchar(150) NOT NULL,
        `smtp_set_name` varchar(150) NOT NULL,
        PRIMARY KEY (`smtp_id`)
      ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;
    ";
    $_CONN->NoQuery($_SETTINGS);

    $_DEFAULT_DATA  = "INSERT INTO `smtp_settings` (`smtp_id`, `smtp_secure`, `smtp_host`, `smtp_port`, `smtp_username`, `smtp_password`, `smtp_set_from`, `smtp_set_name`) VALUES (1, 'ssl', 'mail.domain.com', 465, 'noreply@domain.com', 'password', 'noreply@domain.com', 'Project Name');";
    $_CONN->NoQuery($_DEFAULT_DATA);

    $_ADMINISTRATORS_TABLE = "
      CREATE TABLE IF NOT EXISTS `administrator` (
        `admin_id` int(11) NOT NULL AUTO_INCREMENT,
        `admin_name` varchar(150) NOT NULL,
        `admin_email` varchar(150) NOT NULL,
        `admin_username` varchar(150) NOT NULL,
        `admin_image` varchar(250) NOT NULL,
        `admin_password` varchar(150) NOT NULL,
        `admin_session_id` varchar(150) NOT NULL,
        PRIMARY KEY (`admin_id`)
      ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;
    ";
    $_CONN->NoQuery($_ADMINISTRATORS_TABLE);
    $_DEFAULT_DATA  = "
      INSERT INTO `administrator` (`admin_id`, `admin_name`, `admin_email`, `admin_username`, `admin_password`, `admin_session_id`) VALUES
      (1, 'Admin', 'admin@mail.com', 'admin@mail.com', '21232f297a57a5a743894a0e4a801fc3', '21232f297a57a5a743894a0e4a801fc3');
    ";
    $_RETURN  = $_CONN->NoQuery($_DEFAULT_DATA);
    return $_RETURN;
  }



  function _ADDED_MSJ ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    if ( $_ARRAY['_ROUTE'] ) {
        if ( $_ARRAY['_ROUTE'] == '_SETTINGS' ) {
          return '<div class="callout callout-success">'.$_LANG['ADM']['SETTINGS_UPDATED'].'</div>';
        }
        if ( $_ARRAY['_ROUTE'] == '_MANAGE' ) {
          return '<div class="callout callout-success">'.$_LANG['ADM']['MANAGE_ADDED'].'</div>';
        }
    } else {
      return '<div class="callout callout-success">'.$_LANG['ADM']['MANAGE_ADDED'].'</div>';
    }
  }


  function _UPDATED_MSJ ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-success">'.$_LANG['ADM']['MANAGE_UPDATED'].'</div>';
  }

  function _ERROR_MSJ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-danger">'.$_LANG['ADM']['MANAGE_ERROR'].'</div>';
  }


  //:: GET ADMINISTRATOR DETAILS
  function _MANAGE_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `admin_id`, `admin_name`, `admin_image`, `admin_email`, `admin_username`, `admin_password`, `admin_session_id` FROM administrator where admin_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: LIST ADMINISTRATORS PLUGIN FIELDS
  function _MANAGE_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['ADM']['NEW_ADMIN'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "admin_name"            =>array( 
          "translation" => $_LANG['ADM']['FIELD_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "admin_email"            =>array( 
          "translation" => $_LANG['ADM']['FIELD_EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "email",
          "options" => false,
          "class" => "col-md-6"
        ),
      "admin_username"            =>array( 
          "translation" => $_LANG['ADM']['FIELD_USERNAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "admin_password"            =>array( 
          "translation" => $_LANG['ADM']['FIELD_PASSWORD'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "password",
          "options" => false,
          "class" => "col-md-6"
        ),
      "admin_image"            =>array( 
          "translation" => $_LANG['ADM']['FIELD_IMAGE'],
          "field" => "upload",
          "type" => "image",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "admin_session_id"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "admin_id"  =>array(
          "translation" => $_LANG['ADM']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: ADMINS LIST FIELDS
  function _ALL_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['ADM']['ALL_ADMINS'],
          "group" => true,
          "special" => true
        ),
      "admin_name" => array (
          "options" => false,
          "translation" => $_LANG['ADM']['FIELD_USERNAME']
        ),
      "admin_email" => array (
          "options" => false,
          "translation" => $_LANG['ADM']['FIELD_NAME']
        ),
      "admin_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_MANAGE", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['ADM']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['ADM']['REMOVE'] ),
            ),
          "translation" => $_LANG['ADM']['FIELD_OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: ADMINS LIST
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_RETURN = $_CONN->Query("SELECT `admin_name`, `admin_email`, `admin_id` FROM administrator order by admin_id desc");
    return $_RETURN;
  }

  //:: ADMINS SUBMENU
  function _SUBMENU ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_RETURN  = array (
      "all_admins" => array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['ADM']['ALL_ADMINS']
        ),
      "new_admin" => array (
          "url" => 'FIELDS/_ADD',
          "translation" => $_LANG['ADM']['NEW_ADMIN']
        ),
      "website_settings" => array (
          "url" => 'FIELDS/_SETTINGS',
          "translation" => $_LANG['ADM']['SETTINGS']
        ),
      "smtp_settings" => array (
          "url" => 'FIELDS/_SMTP',
          "translation" => $_LANG['ADM']['SETTINGS_SMTP']
        )
    );
    return $_RETURN;
  }

  //:: ADD OR UPDATE ADMINS
  function _MANAGE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['admin_id'] ) ) {
      $_RETURN  = $this->_ADD ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }
      return $_RETURN;
  }

  //:: ADD A NEW ADMINISTRATOR
  function _ADD ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['admin_image'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['admin_image'] = $_FULL_IMAGE;
      } else {
          $_ARRAY['admin_image'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE
    $_ARRAY['admin_session_id'] = '';

    $_RETURN = $_CONN->NoQuery("INSERT INTO administrator VALUES(NULL,?,?,?,?,?,?)","ssssss",$_ARRAY['admin_name'],$_ARRAY['admin_email'],$_ARRAY['admin_username'],$_ARRAY['admin_image'],md5($_ARRAY['admin_password']),$_ARRAY['admin_session_id']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['ADM']['MANAGE_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['ADM']['MANAGE_ERROR'];
    }
      return $error;
  }

  //:: ADMINISTRATOR UPDATE
  function _UPDATE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['admin_image'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['admin_image'] = $_FULL_IMAGE;
          
          //:: OLD IMAGE
          $_OLD_IMAGE  = $_CONN->Query("SELECT `admin_image` FROM administrator where admin_id=? limit 1","s",$_ARRAY['admin_id']);

          if ( !empty ( $_OLD_IMAGE ) ) {
          $_FILE_LOCATION	=	_UPLOAD_DIR.$_OLD_IMAGE['0']['admin_image'];
            if ( !empty ( $_OLD_IMAGE['0']['admin_image'] ) ) {
              if (file_exists($_FILE_LOCATION)) {
                unlink($_FILE_LOCATION);
              }
            }
          }
          //:: /OLD IMAGE

          $_CONN->NoQuery("UPDATE administrator SET admin_image=? WHERE admin_id=? limit 1","ss",$_FULL_IMAGE,$_ARRAY['admin_id']);
      } else {
          $_ARRAY['admin_image'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE


    $_RETURN = $_CONN->NoQuery("UPDATE administrator SET admin_name=?, admin_email=?, admin_username=? WHERE admin_id=? limit 1","sssi",$_ARRAY['admin_name'],$_ARRAY['admin_email'],$_ARRAY['admin_username'],$_ARRAY['admin_id']);
    if ( !empty ( $_ARRAY['admin_password'] ) ) {
      $_CONN->NoQuery("UPDATE administrator SET admin_password=? WHERE admin_id=? limit 1","si",md5($_ARRAY['admin_password']),$_ARRAY['admin_id']);
    }
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['ADM']['MANAGE_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['ADM']['MANAGE_ERROR'];
      }
      return $error;
  }

  //:: REMOVE
  function _FILE_REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    if ( $_ARRAY['_ROUTE'] == '_SETTINGS' ) {
    $_FILE_LOCATION	=	_UPLOAD_DIR.$_ARRAY['_FILE'];
      if (file_exists($_FILE_LOCATION)) {
        unlink($_FILE_LOCATION);
      }

      $_RETURN = $_CONN->NoQuery("UPDATE website_settings SET website_logo=? WHERE website_id=? limit 1","ss","",1);

    } else {
    $_VALIDATE  = $_CONN->Query("SELECT `admin_image` FROM administrator where admin_id=? and admin_image=? limit 1","ss",$_ARRAY['_ID'], $_ARRAY['_FILE']);
    if ( !empty ( $_VALIDATE['0']['admin_image'] ) ) {
    $_FILE_LOCATION	=	_UPLOAD_DIR.$_VALIDATE['0']['admin_image'];

        if (file_exists($_FILE_LOCATION)) {
          unlink($_FILE_LOCATION);
        }

      $_RETURN = $_CONN->NoQuery("UPDATE administrator SET admin_image=? WHERE admin_id=? limit 1","ss","",$_ARRAY['_ID']);
    } else {
      $_RETURN  = false;
    }
  }

    return $_RETURN;
  }

  //:: ADMINISTRATOR REMOVE
  function _REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_FILE  = $_CONN->Query("SELECT `admin_image` FROM administrator where admin_id=? limit 1","s",$_ARRAY['_ID']);

    if ( !empty ( $_FILE['0']['slider_image'] ) ) {
    $_FILE_LOCATION	=	_UPLOAD_DIR.$_FILE['0']['admin_image'];
      
        if (file_exists($_FILE_LOCATION)) {
          unlink($_FILE_LOCATION);
        }

    }



    $_RETURN = $_CONN->NoQuery("DELETE FROM administrator WHERE admin_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: LIST ALL ADMINISTRATORS
  function _ALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN = $_CONN->Query("SELECT `admin_id`, `admin_name`, `admin_email`, `admin_username`, `admin_password`, `admin_session_id` FROM administrator");
    return $_RETURN;
  }

  function _ADMIN_DETAILS ( ) {
    if ( empty ( $_SESSION['ADMIN_SESSION'] ) ) {
      $_RETURN  = false;
    } else {
      $_CONN    = $this->_DB();
      $_RETURN = $_CONN->Query("SELECT `admin_id`, `admin_name`, `admin_email`, `admin_username`, `admin_image`, `admin_password`, `admin_session_id` FROM administrator where admin_id=?",'i',$_SESSION['ADMIN_SESSION']['0']['admin_id']);
    }
    return $_RETURN;
  }

  //:: LOGIN
  function _LOGIN ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN = $_CONN->Query("SELECT `admin_id`, `admin_name`, `admin_email`, `admin_username`, `admin_password`, `admin_session_id` FROM administrator where admin_email=? and admin_password=? limit 1","ss",$_ARRAY['admin_email'],$_ARRAY['admin_password']);
    return $_RETURN;
  }



  //:: SMTP SETTINGS
  function _SMTP_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['ADM']['SETTINGS_SMTP'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "smtp_secure"            =>array( 
          "translation" => $_LANG['ADM']['SMTP_SECURE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "smtp_host"            =>array( 
          "translation" => $_LANG['ADM']['SMTP_HOST'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "smtp_port"            =>array( 
          "translation" => $_LANG['ADM']['SMTP_PORT'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "smtp_username"            =>array( 
          "translation" => $_LANG['ADM']['SMTP_USERNAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "smtp_password"            =>array( 
          "translation" => $_LANG['ADM']['SMTP_PASSWORD'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "smtp_set_from"            =>array( 
          "translation" => $_LANG['ADM']['SMTP_FROM'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "smtp_set_name"            =>array( 
          "translation" => $_LANG['ADM']['SMTP_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "smtp_id"  =>array(
          "translation" => $_LANG['ADM']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: SMTP SETTINGS DATABASE FIELDS
  function _SMTP_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN = $_CONN->Query("SELECT `smtp_id`, `smtp_secure`, `smtp_host`, `smtp_port`, `smtp_username`, `smtp_password`, `smtp_set_from`, `smtp_set_name` FROM smtp_settings where smtp_id=?","i",1);
    return $_RETURN;
  }

  //:: SMTP SETTINGS UPDATE
  function _SMTP ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("UPDATE smtp_settings SET smtp_secure=?, smtp_host=?, smtp_port=?, smtp_username=?, smtp_password=?, smtp_set_from=?, smtp_set_name=? WHERE smtp_id=? limit 1","ssssssss",$_ARRAY['smtp_secure'],$_ARRAY['smtp_host'],$_ARRAY['smtp_port'],$_ARRAY['smtp_username'],$_ARRAY['smtp_password'],$_ARRAY['smtp_set_from'],$_ARRAY['smtp_set_name'],$_ARRAY['smtp_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['ADM']['SETTINGS_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['ADM']['MANAGE_ERROR'];
      }
        return $error;
  }



  //:: WEBSITE SETTINGS
  function _SETTINGS_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['ADM']['SETTINGS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "website_name"            =>array( 
          "translation" => $_LANG['ADM']['WEBSITE_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "website_seo_tags"            =>array( 
          "translation" => $_LANG['ADM']['WEBSITE_SEO_TAGS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "website_seo_description"            =>array( 
          "translation" => $_LANG['ADM']['WEBSITE_SEO_DESCRIPTION'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "website_author"            =>array( 
          "translation" => $_LANG['ADM']['WEBSITE_AUTHOR'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "website_email"            =>array( 
          "translation" => $_LANG['ADM']['WEBSITE_EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "email",
          "options" => false,
          "class" => "col-md-6"
        ),
      "website_phone"            =>array( 
          "translation" => $_LANG['ADM']['WEBSITE_PHONE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "website_fax"            =>array( 
          "translation" => $_LANG['ADM']['WEBSITE_FAX'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "website_address"            =>array( 
          "translation" => $_LANG['ADM']['WEBSITE_ADDRESS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "GROUP_2"  => array(
          "translation" => $_LANG['ADM']['THEME_SETTINGS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "website_theme"            =>array( 
          "translation" => $_LANG['ADM']['THEME_SETTINGS_DIRECTORY'],
          "field" => "select",
          "method" => "_THEMES_LIST",
          "_ARRAY" => array(""),
          "_NO_DATA" => $_LANG['ADM']['THEME_SETTINGS_NO_DATA'],
          "_SELECT_DATA" => $_LANG['ADM']['THEME_SETTINGS_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "website_default_route"            =>array( 
          "translation" => $_LANG['ADM']['THEME_SETTINGS_DEFAULT_ROUTE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "website_logo"            =>array( 
          "translation" => $_LANG['ADM']['THEME_SETTINGS_DEFAULT_LOGO'],
          "field" => "upload",
          "type" => "image",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "website_id"  =>array(
          "translation" => $_LANG['ADM']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  function _THEMES_LIST ( $_ARRAY ) {
    $_LANG        = $this->_LANGUAGE();
    $_RETURN      = array();
    $_THEMES_LOAD = glob(_THEMES . '*' , GLOB_ONLYDIR);
    $_IGNORE      = array("admin");
    $i=0;
    foreach ( $_THEMES_LOAD as $_THEME ) {

      $_THEME_NAME = str_replace( _THEMES, '', $_THEME );
      if ( !in_array( $_THEME_NAME, $_IGNORE ) ) {
        $_RETURN[$i]['_ID'] = $_THEME_NAME;
        $_RETURN[$i]['_NAME'] = $_THEME_NAME;
        
        $i++;        
      }

    }
    return $_RETURN;
  }


  //:: WEBSITE SETTINGS DATABASE FIELDS
  function _SETTINGS_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN = $_CONN->Query("SELECT `website_id`, `website_name`, `website_seo_tags`, `website_seo_description`, `website_author`, `website_email`, `website_phone`, `website_fax`, `website_address`, `website_theme`, `website_default_route`, `website_logo` FROM website_settings where website_id=?","i",1);
    return $_RETURN;
  }

  //:: WEBSITE SETTINGS UPDATE
  function _SETTINGS ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();



  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['website_logo'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['website_logo'] = $_FULL_IMAGE;
          
          //:: OLD IMAGE
          $_OLD_IMAGE  = $_CONN->Query("SELECT `website_logo` FROM website_settings where website_id=? limit 1","i",1);

          if ( !empty ( $_OLD_IMAGE ) ) {
          $_FILE_LOCATION	=	_UPLOAD_DIR.$_OLD_IMAGE['0']['website_logo'];
            if ( !empty ( $_OLD_IMAGE['0']['website_logo'] ) ) {
              if (file_exists($_FILE_LOCATION)) {
                unlink($_FILE_LOCATION);
              }
            }
          }
          //:: /OLD IMAGE
          $_CONN->NoQuery("UPDATE website_settings SET website_logo=? WHERE website_id=? limit 1","ss",$_FULL_IMAGE,1);
      } else {
          $_ARRAY['slider_image'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

    $_RETURN = $_CONN->NoQuery("UPDATE website_settings SET website_name=?, website_seo_tags=?, website_seo_description=?, website_author=?, website_email=?, website_phone=?, website_fax=?, website_address=?, website_theme=?, website_default_route=? WHERE website_id=? limit 1","sssssssssss",$_ARRAY['website_name'],$_ARRAY['website_seo_tags'],$_ARRAY['website_seo_description'],$_ARRAY['website_author'],$_ARRAY['website_email'],$_ARRAY['website_phone'],$_ARRAY['website_fax'],$_ARRAY['website_address'],$_ARRAY['website_theme'],$_ARRAY['website_default_route'],$_ARRAY['website_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['ADM']['SETTINGS_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['ADM']['MANAGE_ERROR'];
      }
        return $error;
  }

  //:: RETURN WEBSITE DETAILS
  function _SEO_DEFAULT ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN = $_CONN->Query("SELECT website_name as _NAME, website_seo_tags as _TAGS, website_seo_description as _DESCRIPTION, website_author as _AUTHOR, website_email as _EMAIL, website_phone as _PHONE, website_address as _ADDRESS FROM website_settings where website_id=?","i",1);
    return $_RETURN['0'];
  }


  //:: RETURN CONTACT DETAILS WIDGET
  function _CONTACT_US ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_CONN   = new database();
    $_WIDGET  = $_CONN->Query("SELECT `website_id`, `website_name`, `website_seo_tags`, `website_seo_description`, `website_author`, `website_email`, `website_phone`, `website_fax`, `website_address` FROM website_settings where website_id=?","i",1);

    $_RETURN   = '';

    ob_start();
    if ( file_exists ( _TMDRP.'_ADMINISTRATORS/contact.widget.php' ) ) {
      include( _TMDRP.'_ADMINISTRATORS/contact.widget.php' );
    } else {
      include('design/contact.widget.php');
    }
    $_RETURN = ob_get_contents();
    ob_end_clean();
    
    return $_RETURN;
  }


  //:: CSS MANAGE
  function _CSS_MANAGE ( $_PLUGIN, $_ROUTE, $_CSS) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `css_id` FROM custom_css where css_plugin=? and css_plugin_route=? limit 1","ss",$_PLUGIN,$_ROUTE);
      $css_plugin       = $_PLUGIN;
      $css_plugin_route = $_ROUTE;
      $css_info         = $_CSS;
    if ( empty ( $_RETURN ) ) {
      $_RETURN  = $_CONN->NoQuery("INSERT INTO custom_css VALUES(NULL,?,?,?)","sss",$css_plugin,$css_plugin_route,$css_info);
        if ( $_RETURN ) {
          $error['code']		=	'1';
          $error['message']	=	$_LANG['ADM']['CSS_ADDED'];
        } else {
          $error['code']		=	'2';
          $error['message']	=	$_LANG['ADM']['MANAGE_ERROR'];
        }
    } else {
      $_RETURN  = $_CONN->NoQuery("UPDATE custom_css SET css_info=? WHERE css_plugin=? and css_plugin_route=? limit 1","sss",$css_info,$css_plugin,$css_plugin_route);
        if ( $_RETURN ) {
          $error['code']		=	'1';
          $error['message']	=	$_LANG['ADM']['CSS_UPDATED'];
        } else {
          $error['code']		=	'2';
          $error['message']	=	$_LANG['ADM']['MANAGE_ERROR'];
        }
    }
        return $error;
  }

  //:: _REQUIRED_SESSION :: JUST IF NEED AUTHENTIFICATION
  function _REQUIRED_SESSION ( $_ARRAY ) {
    $_ROUTE        = $_ARRAY['_ROUTE'];
    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];

    $NO_SECURE  = array( "");
    if (in_array($_ROUTE, $NO_SECURE)) {
      $_RETURN  = array (
        "_REQUIRED_SESSION"         => false,
        "_REQUIRED_SESSION_STRING"  => '',
        "_REDIRECT_PAGE"            => '',
      );
    } else {
      $_RETURN  = array (
        "_REQUIRED_SESSION"         => true,
        "_REQUIRED_SESSION_STRING"  => 'ADMIN_SESSION',
        "_REDIRECT_PAGE"            => '',
      );
    }
    return $_RETURN;
  }


  //:: DESIGN ROUTE!
  function _DESIGN ( $_ARRAY ) {
    $_CONN            = $this->_DB();
    $_LANG            = $this->_LANGUAGE();
    $_PREPARE         = $this->_PREPARE();
    $_PLUGIN_SETTIGS  = $this->_SETTINGS_FIELDS_LIST( array() );

    $_ROUTE        = $_ARRAY['_ROUTE'];
    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];

    //STAFF OPEN TICKET
    if ( $_ROUTE == 'administrators/get' ) {
    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];

    $_REQUEST_FILE  = explode("?f=", $_REQUEST_URI );
    if ( count( $_REQUEST_FILE ) > 1 ) {
      $_FILE    = _UPLOAD_DIR.$_REQUEST_FILE['1'];
    } else {
      $_FILE    = '';
    }

      // Quick check to verify that the file exists
      if( !file_exists($_FILE) ) die( $_LANG['ADM']['FILE_NOT_FOUND'] );
      // Force the download
      header("Content-Disposition: attachment; filename=".basename($_FILE));
      header("Content-Length: " . filesize($_FILE));
      header("Content-Type: application/octet-stream;");
      readfile($_FILE);

      $_TITLE_SEO = $_DESCRIPTION = $_KEYWORDS = $_TITLE = '';
      $_FORM        = '';

      $_RETURN  = array (
        "SEO" => array (
          "_TITLE" => $_TITLE_SEO,
          "_DESCRIPTION" => $_DESCRIPTION,
          "_KEYWORDS" => $_KEYWORDS
          ),
        "DESIGN" => array (
          "_LIST_MODE" => true,
          "ICO" => '',
          "title" => $_TITLE,
          "form" => $_FORM,
          "fields_start" =>$_FIELDS_START,
          "fields" =>$_FIELDS,
          "fields_end" =>$_FIELDS_END,
          "fields_data" =>$_FIELDS_DATA,
          "_GET_ROUTE"  => "_STAFF_ALL_TICKETS",
          "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
          "_UPDATE_ROUTE_ID"  => $_UPDATE_ROUTE_ID
        )
      );
    }

    return $_RETURN;

  }

}

//:: ADMINISTRATORS CLASS
$_VIEW->_ADMINISTRATORS = $_ADMINISTRATORS  = new _ADMINISTRATORS;
?>