<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _BLOG {
  function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  function _DB () {
    $_DB  = new database;
    return $_DB;
  }

  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_INFO  = array (
      "name"=>"Blog",
      "url"=>"_BLOG",
      "description"=>$_LANG['BLOG']['DESCRIPTION'],
      "menu" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['BLOG']['ALL'] ),
        "item_2" => array( "option" => false, "url" => "FIELDS/_MANAGE", "name" => $_LANG['BLOG']['ADD'] ),
        "item_3" => array( "option" => false, "url" => "LIST/_CATEGORIES", "name" => $_LANG['BLOG']['CATEGORIES'] ),
        "item_4" => array( "option" => false, "url" => "FIELDS/_CATEGORY", "name" => $_LANG['BLOG']['ADD_CATEGORY'] ),
        
        "item_5" => array( "option" => false, "url" => "LIST/_COMMENTS", "name" => $_LANG['BLOG']['ALL_COMMENTS'] ),
        
        "item_7" => array( "option" => false, "url" => "FIELDS/_SETTINGS", "name" => $_LANG['BLOG']['SETTINGS'] ),
        "item_8" => array( "option" => true, "url" => "pluginUninstall", "name" => $_LANG['BLOG']['UNINSTALL'] )
      ),
      "table" => true,
    );
    return $_INFO;
  }

  //:: DESIGN THE WIDGET
  function _WIDGET ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();

    $_WIDGET_ARRAY = $_CONN->Query("SELECT `blog_comment_status` FROM blog_comments");
    $_COUNT = count ( $_WIDGET_ARRAY );

    $_COUNT_ARTICLES = $_CONN->Query("SELECT `bp_id` FROM blog_posts");
    $_COUNT_ARTICLES = count ( $_COUNT_ARTICLES );



    $_FORM  = '';
    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/admin.widget.php' ) ) {
      include( _TMDRP.'_BLOG/admin.widget.php' );
    } else {
      include('design/admin.widget.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();
    
    return $_FORM;
  }

  //:: DESIGN THE CATEGORIES WIDGET
  function _WIDGET_CATEGORIES ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();

    $_CATEGORIES          = $this->_CATEGORIES_FIELDS_LIST( array() );
    $_RETURN              = '';

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/categories.widget.php' ) ) {
      include( _TMDRP.'_BLOG/categories.widget.php' );
    } else {
      include('design/categories.widget.php');
    }
    $_RETURN = ob_get_contents();
    ob_end_clean();

    if ( empty ( $_CATEGORIES ) ) {
      $_RETURN  = false;
    }

    return $_RETURN;
  }
  //:: ./DESIGN THE CATEGORIES WIDGET



  function _ADDED_MSJ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-success">'.$_LANG['BLOG']['ADDED'].'</div>';
  }

  function _UPDATED_MSJ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-success">'.$_LANG['BLOG']['UPDATED'].'</div>';
  }

  function _ERROR_MSJ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-danger">'.$_LANG['BLOG']['ERROR'].'</div>';
  }

  //:: CREATE THE SUBMENU
  function _SUBMENU ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "all_items" => array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['BLOG']['ALL']
        ),
      "new_item" => array (
          "url" => 'FIELDS/_MANAGE',
          "translation" => $_LANG['BLOG']['ADD']
        ),
      "all_categories" => array (
          "url" => 'LIST/_CATEGORIES',
          "translation" => $_LANG['BLOG']['CATEGORIES']
        ),
      "new_category" => array (
          "url" => 'FIELDS/_CATEGORY',
          "translation" => $_LANG['BLOG']['ADD_CATEGORY']
        ),
      "all_comments" => array (
          "url" => 'LIST/_COMMENTS',
          "translation" => $_LANG['BLOG']['ALL_COMMENTS']
        )
    );
    return $_RETURN;
  }

  //:: PLUGIN INSTALL
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_INSTALL = "
        CREATE TABLE IF NOT EXISTS `blog_posts` (
          `bp_id` int(11) NOT NULL AUTO_INCREMENT,
          `bp_title` varchar(150) NOT NULL,
          `bp_url` varchar(150) NOT NULL,
          `bp_seo_description` text NOT NULL,
          `bp_seo_tags` varchar(250) NOT NULL,
          `bp_category` int(11) NOT NULL,
          `bp_tags` text NOT NULL,
          `bp_details` text NOT NULL,
          `bp_date` int(11) NOT NULL,
          `bp_updated` int(11) NOT NULL,
          PRIMARY KEY (`bp_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_INSTALL);

    $_INSTALL = "
      CREATE TABLE IF NOT EXISTS `blog_pictures` (
        `blog_picture_id` int(11) NOT NULL AUTO_INCREMENT,
        `blog_picture_post_id` int(11) NOT NULL,
        `blog_picture_location` varchar(150) NOT NULL,
        PRIMARY KEY (`blog_picture_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_INSTALL);

    $_INSTALL = "
      CREATE TABLE IF NOT EXISTS `blog_categories` (
        `bc_id` int(11) NOT NULL AUTO_INCREMENT,
        `bc_name` varchar(150) NOT NULL,
        `bc_url` varchar(150) NOT NULL,
        `bc_description` text NOT NULL,
        `bc_seo_description` text NOT NULL,
        `bc_seo_tags` varchar(150) NOT NULL,
        `bc_ico` varchar(250) NOT NULL,
        `bc_order` int(11) NOT NULL,
        PRIMARY KEY (`bc_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_INSTALL);

    $_INSTALL = "
        CREATE TABLE IF NOT EXISTS `blog_comments` (
          `blog_comment_id` int(11) NOT NULL AUTO_INCREMENT,
          `blog_comment_post_id` int(11) NOT NULL,
          `blog_comment_name` varchar(150) NOT NULL,
          `blog_comment_email` varchar(150) NOT NULL,
          `blog_comment_website` varchar(150) NOT NULL,
          `blog_comment_comment` text NOT NULL,
          `blog_comment_status` int(11) NOT NULL,
          `blog_comment_date` int(11) NOT NULL,
          PRIMARY KEY (`blog_comment_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_INSTALL);

    $_INSTALL = "
        CREATE TABLE IF NOT EXISTS `blog_settings` (
          `bs_id` int(11) NOT NULL AUTO_INCREMENT,
          `bs_name` varchar(150) NOT NULL,
          `bs_description` text NOT NULL,
          `bs_tags` varchar(250) NOT NULL,
          PRIMARY KEY (`bs_id`)
        ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_INSTALL);

    $_INSTALL = "
        INSERT INTO `blog_settings` (`bs_id`, `bs_name`, `bs_description`, `bs_tags`) VALUES
        (1, 'Compile Grid - Blog', 'Compile Grid - Blog', 'Compile Grid - Blog');
    ";
    $_RETURN  = $_CONN->NoQuery($_INSTALL);
    return $_RETURN;
  }

  //:: PLUGIN UNINSTALL
  function _UNINSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_UNINSTALL = "
      DROP TABLE IF EXISTS `blog_posts`;
      DROP TABLE IF EXISTS `blog_pictures`;
      DROP TABLE IF EXISTS `blog_categories`;
      DROP TABLE IF EXISTS `blog_comments`;
      DROP TABLE IF EXISTS `blog_settings`;
    ";
    $_RETURN  = $_CONN->MultiNoQuery($_UNINSTALL);
    return $_RETURN;
  }





  //:: GET THE INFO FROM THE DATABASE
  function _MANAGE_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `bp_id`, `bp_title`, `bp_url`, `bp_seo_description`, `bp_seo_tags`, `bp_category`, `bp_tags`, `bp_details`, `bp_date`, `blog_picture_id`, `blog_picture_post_id`, `blog_picture_location` FROM blog_posts left join blog_pictures on blog_pictures.blog_picture_post_id = blog_posts.bp_id where bp_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }


  //:: SETTINGS : HTML FIELDS
  function _SETTINGS_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['BLOG']['SETTINGS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "bs_name"            =>array( 
          "translation" => $_LANG['BLOG']['BLOG_SETTINGS_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "bs_description"            =>array( 
          "translation" => $_LANG['BLOG']['BLOG_SETTINGS_DESCRIPTION'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "bs_tags"            =>array( 
          "translation" => $_LANG['BLOG']['BLOG_SETTINGS_TAGS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "bs_id"  =>array(
          "translation" => $_LANG['BLOG']['SUBMIT'],
          "field" => "int",
          "type" => "upload",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: LISTING _SETTINGS_DATA : MYSQL DETAILS
  function _SETTINGS_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `bs_id`, `bs_name`, `bs_description`, `bs_tags` FROM blog_settings where bs_id=?","i",1);
    return $_RETURN;
  }

  //:: BLOG SETTINGS UPDATE
  function _SETTINGS ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();

    $_RETURN = $_CONN->NoQuery("UPDATE blog_settings SET bs_name=?, bs_description=?, bs_tags=? WHERE bs_id=? limit 1","ssss",$_ARRAY['bs_name'],$_ARRAY['bs_description'],$_ARRAY['bs_tags'],$_ARRAY['bs_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['BLOG']['BLOG_SETTINGS_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['BLOG']['BLOG_SETTINGS_ERROR'];
      }
        return $error;
  }


  //:: GENERATE THE HTML FIELDS FOR EDITING/ADDING INFO TO THE DATABASE
  function _MANAGE_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['BLOG']['DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "bp_title"            =>array( 
          "translation" => $_LANG['BLOG']['NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "bp_url"            =>array( 
          "translation" => $_LANG['BLOG']['URL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "bp_category"            =>array( 
          "translation" => $_LANG['BLOG']['CATEGORY'],
          "field" => "select",
          "method" => "_BLOG_CATEGORIES",
          "_ARRAY" => array(""),
          "_NO_DATA" => $_LANG['BLOG']['NO_DATA'],
          "_SELECT_DATA" => $_LANG['BLOG']['SELECT_DATA'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "bp_tags"            =>array( 
          "translation" => $_LANG['BLOG']['TAGS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "bp_details"            =>array( 
          "translation" => $_LANG['BLOG']['DETAILS'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "bp_date"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "bp_updated"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "blog_images"            =>array( 
          "translation" => $_LANG['BLOG']['IMAGES'],
          "field" => "upload",
          "type" => "image",
          "length" => array("1","2","3","4","5"),
          "mandatory" => false,
          "request" => "multiple",
          "method" => "_BLOG_IMAGES",
          "_ARRAY" => array(""),
          "options" => false,
          "class" => "col-md-12"
        ),
      "GROUP_2"  => array(
          "translation" => $_LANG['BLOG']['BLOG_SEO'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "bp_seo_description"            =>array( 
          "translation" => $_LANG['BLOG']['SEO_DESCRIPTION'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "bp_seo_tags"            =>array( 
          "translation" => $_LANG['BLOG']['SEO_TAGS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "bp_id"  =>array(
          "translation" => $_LANG['BLOG']['SUBMIT'],
          "field" => "int",
          "type" => "upload",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: INFO LISTING : HTML FIELDS
  function _ALL_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['BLOG']['ALL'],
          "group" => true,
          "special" => true
        ),
      "bp_title" => array (
          "options" => false,
          "translation" => $_LANG['BLOG']['NAME']
        ),
      "bp_url" => array (
          "options" => false,
          "translation" => $_LANG['BLOG']['URL']
        ),
      "bp_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_MANAGE", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['BLOG']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['BLOG']['REMOVE'] ),
            ),
          "translation" => $_LANG['BLOG']['OPTIONS']
        )
    );
    return $_RETURN;
  }


  //:: POPULATE THE SELECT OPTION
  function _BLOG_CATEGORIES ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `bc_id` as _ID, `bc_name` as _NAME FROM blog_categories");
    return $_RETURN;
  }


  //:: LISTING DATA : MYSQL DETAILS
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    if ( $_ARRAY['limit'] ) {
      $_RETURN = $_CONN->Query("SELECT `bp_title`, `bp_url`, `bp_id` FROM blog_posts order by bp_id DESC limit ".$_ARRAY['limit'] );
    } else {
      $_RETURN = $_CONN->Query("SELECT `bp_title`, `bp_url`, `bp_id` FROM blog_posts order by bp_id DESC");
    }
    return $_RETURN;
  }

  //:: INFO LISTING : HTML FIELDS
  function _CATEGORIES_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['BLOG']['CATEGORIES'],
          "group" => true,
          "special" => true
        ),
      "bc_name" => array (
          "options" => false,
          "translation" => $_LANG['BLOG']['CATEGORY_NAME']
        ),
      "bc_url" => array (
          "options" => false,
          "translation" => $_LANG['BLOG']['CATEGORY_URL']
        ),
      "bc_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_CATEGORY", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['BLOG']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_CATEGORY_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['BLOG']['REMOVE'] ),
            ),
          "translation" => $_LANG['BLOG']['OPTIONS']
        )
    );
    return $_RETURN;
  }


  //:: LISTING DATA : MYSQL DETAILS
  function _CATEGORIES_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `bc_id`, `bc_name`, `bc_url`, `bc_description`, `bc_seo_description`, `bc_seo_tags`, `bc_ico`, `bc_order` FROM blog_categories order by bc_id");
    return $_RETURN;
  }



  //:: INFO LISTING : HTML FIELDS
  function _CATEGORY_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['BLOG']['CATEGORY_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "bc_name"            =>array( 
          "translation" => $_LANG['BLOG']['CATEGORY_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "bc_url"            =>array( 
          "translation" => $_LANG['BLOG']['CATEGORY_URL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "bc_description"            =>array( 
          "translation" => $_LANG['BLOG']['CATEGORY_DESCRIPTION'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "GROUP_2"  => array(
          "translation" => $_LANG['BLOG']['CATEGORY_SETTINGS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "bc_ico"            =>array( 
          "translation" => $_LANG['BLOG']['CATEGORY_ICO'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "bc_order"            =>array( 
          "translation" => $_LANG['BLOG']['CATEGORY_ORDER'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "GROUP_3"  => array(
          "translation" => $_LANG['BLOG']['CATEGORY_SEO'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "bc_seo_description"            =>array( 
          "translation" => $_LANG['BLOG']['CATEGORY_SEO_DESCRIPTION'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "bc_seo_tags"            =>array( 
          "translation" => $_LANG['BLOG']['CATEGORY_SEO_TAGS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "bc_id"  =>array(
          "translation" => $_LANG['BLOG']['SUBMIT'],
          "field" => "int",
          "type" => "upload",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: LISTING DATA : MYSQL DETAILS
  function _CATEGORY_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `bc_id`, `bc_name`, `bc_url`, `bc_description`, `bc_seo_description`, `bc_seo_tags`, `bc_ico`, `bc_order` FROM blog_categories where bc_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }



  //:: INFO LISTING : HTML FIELDS
  function _COMMENTS_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['BLOG']['ALL_COMMENTS'],
          "group" => true,
          "special" => true
        ),
      "blog_comment_status" => array (
          "options" => false,
          "translation" => $_LANG['BLOG']['COMMENTS_STATUS']
        ),
      "blog_comment_date" => array (
          "options" => false,
          "translation" => $_LANG['BLOG']['COMMENTS_DATE'],
          "type"        => 'date'
        ),
      "bp_title" => array (
          "options" => false,
          "translation" => $_LANG['BLOG']['COMMENTS_POST_TITLE']
        ),
      "blog_comment_name" => array (
          "options" => false,
          "translation" => $_LANG['BLOG']['COMMENTS_ADDED_BY']
        ),
      "blog_comment_comment" => array (
          "options" => false,
          "translation" => $_LANG['BLOG']['COMMENT_DETAILS']
        ),
      "blog_comment_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_COMMENT", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['BLOG']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_COMMENT_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['BLOG']['REMOVE'] ),
            ),
          "translation" => $_LANG['BLOG']['OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: POPULATE THE SELECT OPTION
  function _COMMENTS_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_PREPARE = new prepare;
    $_LANG    = $this->_LANGUAGE();
    $_RETURN = $_CONN->Query("SELECT `blog_comment_status`, `blog_comment_date`, `blog_comment_name`, `bp_title`, `blog_comment_comment`, `blog_comment_id` FROM blog_comments left join blog_posts on blog_posts.bp_id = blog_comments.blog_comment_post_id order by blog_comment_id desc");
    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'blog_comment_status', '0', $_LANG['BLOG']['COMMENTS_STATUS_DISABLED'] );
    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'blog_comment_status', '1', $_LANG['BLOG']['COMMENTS_STATUS_APPROVED'] );
    return $_RETURN;
  }



  //:: INFO LISTING : HTML FIELDS
  function _COMMENT_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP_1"  => array(
          "translation" => $_LANG['BLOG']['COMMENT_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "blog_comment_name"            =>array( 
          "translation" => $_LANG['BLOG']['COMMENT_MANAGE_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "blog_comment_email"            =>array( 
          "translation" => $_LANG['BLOG']['COMMENT_MANAGE_EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "blog_comment_website"            =>array( 
          "translation" => $_LANG['BLOG']['COMMENT_MANAGE_WEBSITE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "blog_comment_comment"            =>array( 
          "translation" => $_LANG['BLOG']['COMMENT_MANAGE_DETAILS'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "blog_comment_status"            =>array( 
          "translation" => $_LANG['BLOG']['COMMENT_MANAGE_STATUS'],
          "field" => "select",
          "method" => "_COMMENT_STATUS",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['BLOG']['COMMENT_MANAGE_STATUS_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "blog_comment_date"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "blog_comment_id"  =>array(
          "translation" => $_LANG['BLOG']['COMMENT_MANAGE_SUBMIT'],
          "field" => "int",
          "type" => "upload",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  function _COMMENT_STATUS ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array(
      array( "_ID" => "0", "_NAME" => $_LANG['BLOG']['COMMENTS_STATUS_DISABLED'] ),
      array( "_ID" => "1", "_NAME" => $_LANG['BLOG']['COMMENTS_STATUS_APPROVED'] ),
    );
    return $_RETURN;
  }

  //:: LISTING DATA : MYSQL DETAILS
  function _COMMENT_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `blog_comment_id`, `blog_comment_post_id`, `blog_comment_name`, `blog_comment_email`, `blog_comment_website`, `blog_comment_comment`, `blog_comment_status`, `blog_comment_date` FROM blog_comments where blog_comment_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: _COMMENT UPDATE
  function _COMMENT ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->NoQuery("UPDATE blog_comments SET blog_comment_name=?, blog_comment_email=?, blog_comment_website=?, blog_comment_comment=?, blog_comment_status=? WHERE blog_comment_id=? limit 1","ssssss",$_ARRAY['blog_comment_name'],$_ARRAY['blog_comment_email'],$_ARRAY['blog_comment_website'],$_ARRAY['blog_comment_comment'],$_ARRAY['blog_comment_status'],$_ARRAY['blog_comment_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['BLOG']['COMMENT_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['BLOG']['COMMENT_UPDATED_ERROR'];
      }
        return $error;
  }


  //:: LISTING IMAGES/FILES BASED ON THE REQUESTED ID _BLOG_IMAGES
  function _BLOG_IMAGES ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->Query("SELECT blog_picture_location as _FILE FROM blog_pictures where blog_picture_post_id=?","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: MANAGE _CATEGORY DATA ADD / UPDATE
  function _CATEGORY ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();
    
    if ( empty ( $_ARRAY['bc_id'] ) ) {
      $_RETURN  = $this->_ADD_CATEGORY ( $_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE_CATEGORY ( $_ARRAY );
    }
      return $_RETURN;
  }


  //:: ADD A NEW CATEGORY
  function _ADD_CATEGORY ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();
    $_CONN    = $this->_DB();

    $_RETURN = $_CONN->NoQuery("INSERT INTO blog_categories VALUES(NULL,?,?,?,?,?,?,?)","sssssss",$_ARRAY['bc_name'],$_ARRAY['bc_url'],$_ARRAY['bc_description'],$_ARRAY['bc_seo_description'],$_ARRAY['bc_seo_tags'],$_ARRAY['bc_ico'],$_ARRAY['bc_order']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['BLOG']['CATEGORY_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['BLOG']['ERROR'];
    }
      return $error;
  }

  //:: CATEGORY UPDATE
  function _UPDATE_CATEGORY ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_RETURN = $_CONN->NoQuery("UPDATE blog_categories SET bc_name=?, bc_url=?, bc_description=?, bc_seo_description=?, bc_seo_tags=?, bc_ico=?, bc_order=? WHERE bc_id=? limit 1","ssssssss",$_ARRAY['bc_name'],$_PREPARE->title($_ARRAY['bc_url']),$_ARRAY['bc_description'],$_ARRAY['bc_seo_description'],$_ARRAY['bc_seo_tags'],$_ARRAY['bc_ico'],$_ARRAY['bc_order'],$_ARRAY['bc_id']);

      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['BLOG']['CATEGORY_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['BLOG']['ERROR'];
      }
      return $error;
  }



  //:: MANAGE DATA ADD / UPDATE
  function _MANAGE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['bp_id'] ) ) {
      $_RETURN  = $this->_ADD ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }
      return $_RETURN;
  }

  //:: ADD NEW DATA
  function _ADD ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {

    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_ARRAY['bp_date']    = strtotime( "now" );
    $_ARRAY['bp_updated'] = strtotime( "now" );
    $_ARRAY['bp_url']     = $_PREPARE->title( $_ARRAY['bp_url'] );
    $_ARRAY['bp_tags']    = $_PREPARE->tagsLink( $_ARRAY['bp_tags'] );

    //CREATE BLOG POST AND GET THE LAST ID
    $_RETURN = $_CONN->NoQuery("INSERT INTO blog_posts VALUES(NULL,?,?,?,?,?,?,?,?,?)","sssssssss",$_ARRAY['bp_title'],$_ARRAY['bp_url'],$_ARRAY['bp_seo_description'],$_ARRAY['bp_seo_tags'],$_ARRAY['bp_category'],$_ARRAY['bp_tags'],$_ARRAY['bp_details'],$_ARRAY['bp_date'],$_ARRAY['bp_updated']);
    
    $bp_id  = $_CONN->LastID();


  //::: UPLOAD THE PICTURES
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['blog_images'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          //blog_pictures
          $blog_picture_id        = '';
          $blog_picture_post_id   = $bp_id;
          $blog_picture_location  = $_FULL_IMAGE;
          
          //ONCE IS UPLOADED SAVE INTO DATABASE
          $_RETURN = $_CONN->NoQuery("INSERT INTO blog_pictures VALUES(NULL,?,?)","ss",$blog_picture_post_id,$blog_picture_location);
      } else {
          //NO IMAGE UPLOADED
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['BLOG']['ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['BLOG']['ERROR'];
    }
    return $error;
  }


  //:: DATA UPDATE
  function _UPDATE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {

    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_ARRAY['bp_date']    = strtotime( "now" );
    $_ARRAY['bp_updated'] = strtotime( "now" );
    $_ARRAY['bp_url']     = $_PREPARE->title( $_ARRAY['bp_url'] );
    $_ARRAY['bp_tags']    = $_PREPARE->tagsLink( $_ARRAY['bp_tags'] );

    //UPDATE POST DETAILS AND GET THE LAST ID
    $_RETURN  = $_CONN->NoQuery("UPDATE blog_posts SET bp_title=?, bp_url=?, bp_seo_description=?, bp_seo_tags=?, bp_category=?, bp_tags=?, bp_details=?, bp_updated=? WHERE bp_id=? limit 1","sssssssss",$_ARRAY['bp_title'],$_ARRAY['bp_url'],$_ARRAY['bp_seo_description'],$_ARRAY['bp_seo_tags'],$_ARRAY['bp_category'],$_ARRAY['bp_tags'],$_ARRAY['bp_details'],$_ARRAY['bp_updated'],$_ARRAY['bp_id']);



  //::: UPLOAD THE PICTURES
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['blog_images'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          //blog_pictures
          $blog_picture_id        = '';
          $blog_picture_post_id   = $_ARRAY['bp_id'];
          $blog_picture_location  = $_FULL_IMAGE;
          
          //ONCE IS UPLOADED SAVE INTO DATABASE
          $_CONN->NoQuery("INSERT INTO blog_pictures VALUES(NULL,?,?)","ss",$blog_picture_post_id,$blog_picture_location);
      } else {
          //NO IMAGE UPLOADED
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['BLOG']['UPDATED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['BLOG']['ERROR'];
    }
    return $error;
  }

  //:: DATA UPLOAD
  function _UPLOAD ( $_CLASS, $_ARRAY ) {
    
  }

  //:: REMOVE
  function _FILE_REMOVE ( $_ARRAY ) {

    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_VALIDATE  = $_CONN->Query("SELECT `blog_picture_id`, `blog_picture_post_id`, `blog_picture_location` FROM blog_pictures where blog_picture_post_id=? and blog_picture_location=? limit 1","ss",$_ARRAY['_ID'], $_ARRAY['_FILE']);
    if ( !empty ( $_VALIDATE['0']['blog_picture_location'] ) ) {
    $blog_picture_id  = $_VALIDATE['0']['blog_picture_id'];
    $_FILE_LOCATION	  =	_UPLOAD_DIR.$_VALIDATE['0']['blog_picture_location'];
    if ( !empty ( $_VALIDATE['0']['blog_picture_location'] ) ) {
        if (file_exists($_FILE_LOCATION)) {
          unlink($_FILE_LOCATION);
        }
    }
      $_RETURN  = $_CONN->NoQuery("DELETE FROM blog_pictures WHERE blog_picture_id=? limit 1","i",$blog_picture_id);
    } else {
      $_RETURN  = false;
    }

    return $_RETURN;
  }


  //:: COMMENT REMOVE
  function _COMMENT_REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->NoQuery("DELETE FROM blog_comments WHERE blog_comment_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: _CATEGORY_REMOVE REMOVE
  function _CATEGORY_REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->NoQuery("DELETE FROM blog_categories WHERE bc_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }


  //:: REMOVE
  function _REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_FILES  = $_CONN->Query("SELECT `blog_picture_id`, `blog_picture_post_id`, `blog_picture_location` FROM blog_pictures where blog_picture_post_id=?","s",$_ARRAY['_ID']);

  foreach ( $_FILES as $_FILE ) {
    $_FILE_LOCATION	=	_UPLOAD_DIR.$_FILE['blog_picture_location'];
    if ( !empty ( $_FILE['blog_picture_location'] ) ) {
        if (file_exists($_FILE_LOCATION)) {
          unlink($_FILE_LOCATION);
        }
      }
    $_CONN->NoQuery("DELETE FROM blog_pictures WHERE blog_picture_id=? limit 1","i",$_FILE['blog_picture_id']);
  }

    $_RETURN  = $_CONN->NoQuery("DELETE FROM blog_posts WHERE bp_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: GET ALL CATEGORIES FROM THE DATABASE
  function _BLOG_CATEGORIES_DESIGN ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `bc_id`, `bc_name`, `bc_url`, `bc_description`, `bc_seo_description`, `bc_seo_tags`, `bc_ico`, `bc_order` FROM blog_categories");
    return $_RETURN;
  }

  //:: GET CATEGORY DETAILS FROM THE DATABASE
  function _BLOG_CATEGORY_DESIGN ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `bc_id`, `bc_name`, `bc_url`, `bc_description`, `bc_seo_description`, `bc_seo_tags`, `bc_ico`, `bc_order` FROM blog_categories where bc_url=? limit 1","s",$_ARRAY['bc_url']);
    return $_RETURN;
  }

  //:: GET ALL POSTS FROM THE DATABASE
  function _BLOG_POSTS_DESIGN ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = '';
    if ( empty ( $_ARRAY ) ) {
    $_RETURN = $_CONN->Query("SELECT `bp_id`, `bp_title`, `bp_url`, `bp_seo_description`, `bp_seo_tags`, `bp_category`, `bp_tags`, `bp_details`, `bp_date`, `bp_updated`, `bc_id`, `bc_name`, `bc_url`, `bc_description`, `bc_seo_description`, `bc_seo_tags`, `bc_ico`, `bc_order` FROM blog_posts left join blog_categories on blog_categories.bc_id = blog_posts.bp_category order by bp_id desc");
    } else {
      if ( $_ARRAY['filter'] == 'category' ) {
        $_RETURN = $_CONN->Query("SELECT `bp_id`, `bp_title`, `bp_url`, `bp_seo_description`, `bp_seo_tags`, `bp_category`, `bp_tags`, `bp_details`, `bp_date`, `bp_updated`, `bc_id`, `bc_name`, `bc_url`, `bc_description`, `bc_seo_description`, `bc_seo_tags`, `bc_ico`, `bc_order` FROM blog_posts left join blog_categories on blog_categories.bc_id = blog_posts.bp_category where bp_category=? order by bp_id desc","i",$_ARRAY['bp_category']);
      }
      if ( $_ARRAY['filter'] == 'tags' ) {
        $_RETURN = $_CONN->Query("SELECT `bp_id`, `bp_title`, `bp_url`, `bp_seo_description`, `bp_seo_tags`, `bp_category`, `bp_tags`, `bp_details`, `bp_date`, `bp_updated`, `bc_id`, `bc_name`, `bc_url`, `bc_description`, `bc_seo_description`, `bc_seo_tags`, `bc_ico`, `bc_order` FROM blog_posts left join blog_categories on blog_categories.bc_id = blog_posts.bp_category where bp_tags LIKE CONCAT('%',?,'%') order by bp_id desc","s",$_ARRAY['string']);
      }
      if ( $_ARRAY['filter'] == 'search' ) {
        
        //:: GENERATE THE SEARCH TITLE KEYWORDS
        $_STRING  = $_ARRAY['string'];
        $_SEARCH_FOR  = '';
        foreach ( explode( ' ', $_STRING ) as $S ) {
          $_SEARCH_FOR  .= " or ( bp_title LIKE '%".$S."%' ) or ( bp_tags LIKE '%".$S."%' ) or ( bp_seo_tags LIKE '%".$S."%' ) ";
        }
        
        $_RETURN = $_CONN->Query("SELECT `bp_id`, `bp_title`, `bp_url`, `bp_seo_description`, `bp_seo_tags`, `bp_category`, `bp_tags`, `bp_details`, `bp_date`, `bp_updated`, `bc_id`, `bc_name`, `bc_url`, `bc_description`, `bc_seo_description`, `bc_seo_tags`, `bc_ico`, `bc_order` FROM blog_posts left join blog_categories on blog_categories.bc_id = blog_posts.bp_category where bp_title LIKE CONCAT('%',?,'%') or bp_details LIKE CONCAT('%',?,'%') ".$_SEARCH_FOR." order by bp_id desc","ss",$_ARRAY['string'],$_ARRAY['string']);
      }
    }
    return $_RETURN;
  }

  //:: GET POSTS BASED ON CATEGORY
  function _POSTS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `bp_id`, `bp_title`, `bp_url`, `bp_seo_description`, `bp_seo_tags`, `bp_category`, `bp_tags`, `bp_details`, `bp_date`, `bp_updated` FROM blog_posts where bp_category=? order by bp_id desc limit ".$_ARRAY['limit'],"i",$_ARRAY['bp_category']);
    return $_RETURN;
  }

  //:: GET POST FIRST IMAGE FROM THE DATABASE
  function _BLOG_POSTS_IMAGE_DESIGN ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    if ( $_ARRAY['_LIMIT'] ) {
      $_RETURN = $_CONN->Query("SELECT `blog_picture_id`, `blog_picture_post_id`, `blog_picture_location` FROM blog_pictures where blog_picture_post_id=? limit ".$_ARRAY['_LIMIT'],"i",$_ARRAY['_ID']);
    } else {
      $_RETURN = $_CONN->Query("SELECT `blog_picture_id`, `blog_picture_post_id`, `blog_picture_location` FROM blog_pictures where blog_picture_post_id=?","i",$_ARRAY['_ID']);
    }
    return $_RETURN;
  }

  //:: _REQUIRED_SESSION :: JUST IF NEED AUTHENTIFICATION
  function _REQUIRED_SESSION ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = array (
      "_REQUIRED_SESSION"         => false,
      "_REQUIRED_SESSION_STRING"  => 'ADMIN_SESSION',
      "_REDIRECT_PAGE"            => 'user/login',
    );
    return $_RETURN;
  }

  //:: REQUIRE SESSION PART
  function _SESSION_VALIDATE ( $_ARRAY ) {
    if ( $_ARRAY['_REQUIRED_SESSION'] ) {
      if ( empty ( $_SESSION[$_ARRAY['_REQUIRED_SESSION']] ) ) {
        return false;
      } else {
        return true;
      }
    } else {
      return true;
    }
  }

  //:: STORE MESSAGE INTO DATABASE
  function _PROTECTION_ADD_COMMENT ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_SESSION_VALIDATE  = $this->_SESSION_VALIDATE( array( "_REQUIRED_SESSION" => '' ) );

    if ( !$_SESSION_VALIDATE ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['CONTACT']['NOT_ALLOWED'];
      return $error;
      break;
    }



    //:: VALIDATE CAPTCHA 
    if ( $_SESSION['captcha'] != $_ARRAY['captcha'] ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['CONTACT']['INVALID_CAPTCHA'];
      return $error;
      break;
    }


      //::: GET POSTING DETAILS
      $blog_comment_post_id = $_PREPARE->sanitize( $_ARRAY['blog_comment_post_id'], 'input' );
      $_POST_URL  = explode( "/", $blog_comment_post_id );
      $_POST_URL  = explode( "?", $_POST_URL['2'] );
      $_POST_URL  = $_POST_URL['0'];



      $_POST_DETAILS  = $_CONN->Query("SELECT `bp_id`, `bp_title`, `bp_url`, `bp_seo_description`, `bp_seo_tags`, `bp_category`, `bp_tags`, `bp_details`, `bp_date`, `bp_updated`, `bc_id`, `bc_name`, `bc_url`, `bc_ico` FROM blog_posts left join blog_categories on blog_categories.bc_id = blog_posts.bp_category where concat(bp_url,'-',bp_id)=?","s",$_POST_URL);

    $_ARRAY['blog_comment_post_id'] = $_POST_DETAILS['0']['bp_id'];
    $_ARRAY['blog_comment_comment'] = $_PREPARE->sanitize( $_ARRAY['blog_comment_comment'], 'input' );
    $_ARRAY['blog_comment_status']  = "0";
    $_ARRAY['blog_comment_date']    = strtotime( "now" );

    $_RETURN = $_CONN->NoQuery("INSERT INTO blog_comments VALUES(NULL,?,?,?,?,?,?,?)","sssssss",$_ARRAY['blog_comment_post_id'],$_ARRAY['blog_comment_name'],$_ARRAY['blog_comment_email'],$_ARRAY['blog_comment_website'],$_ARRAY['blog_comment_comment'],$_ARRAY['blog_comment_status'],$_ARRAY['blog_comment_date']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['BLOG']['COMMENT_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['BLOG']['ERROR'];
    }
    return $error;

  }

  function _POST_COMMENTS ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `blog_comment_id`, `blog_comment_post_id`, `blog_comment_name`, `blog_comment_email`, `blog_comment_website`, `blog_comment_comment`, `blog_comment_status`, `blog_comment_date` FROM blog_comments where blog_comment_status=? and blog_comment_post_id=?","ii",1,$_ARRAY['_ID']);
    return $_RETURN;
  }


  //:: DESIGN ROUTE!
  function _DESIGN ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_ROUTING = array_filter( explode("/",$_ARRAY['_ROUTE'] ) );
    $_ROUTING_ELEMENTS  = count ( $_ROUTING );

    $_PAGE  = explode("?p=", $_ARRAY['_REQUEST_URI'] );
    if ( count( $_PAGE ) > 1 ) {
      $_PAGE_NUMBER = $_PAGE['1'];
    } else {
      $_PAGE_NUMBER = 1;
    }


    $_BLOG_SETTINGS     = $this->_SETTINGS_FIELDS_LIST ( $_ARRAY );
    $_BLOG_CATEGORIES   = $this->_BLOG_CATEGORIES_DESIGN ( $_ARRAY );
    $_FORM_DESCRIPTION  = '';

if ( $_ROUTING_ELEMENTS > 1 ) {
  if ( $_ROUTING['1'] == 'search' ) {
    $_SEARCHED    = str_replace("+"," ",$_ROUTING['2']);
  } else {
    $_SEARCHED    = '';
  }
} else {
    $_SEARCHED    = '';
}

    $_SEARCH_FORM = '';
    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/search.form.php' ) ) {
      include( _TMDRP.'_BLOG/search.form.php' );
    } else {
      include('design/search.form.php');
    }
    $_SEARCH_FORM = ob_get_contents();
    ob_end_clean();

    if ( $_ROUTING_ELEMENTS > 1 ) {
      if ( $_ROUTING_ELEMENTS  == 2 ) {



  //:: START POST DETAILS
        //::: GET POSTING DETAILS
      $_POST_URL  =  explode("/",$_ARRAY['_ROUTE'] );
      $_POST_URL  = $_POST_URL['1'];

      $_SHORT_PAGES  = array( "blog/categories", "blog/all" );
      if (in_array($_ARRAY['_ROUTE'], $_SHORT_PAGES)) {

  //:: ALL CATEGORIES
    if ( $_ARRAY['_ROUTE'] == 'blog/categories' ) {

    $_TITLE         = '1';
    $_DESCRIPTION   = '2';
    $_KEYWORDS      = '3';
    $_FORM          = '';
    $_FIELDS_START  = '';
    $_FIELDS_END    = '';

    $_FIELDS_DATA   = false;
    $_FIELDS        = false;

      $_RETURN  = array (
        "SEO" => array (
          "_TITLE" => $_TITLE,
          "_DESCRIPTION" => $_DESCRIPTION,
          "_KEYWORDS" => $_KEYWORDS
          ),
        "DESIGN" => array (
          "ICO" => '',
          "title" => $_TITLE,
          "form" => $_FORM,
          "fields_start" =>$_FIELDS_START,
          "fields" =>$_FIELDS,
          "fields_end" =>$_FIELDS_END,
          "fields_data" =>$_FIELDS_DATA,
          "_GET_ROUTE"  => '_ADD_COMMENT'
        )
      );
    }
  //:: ./ ALL CATEGORIES

  //:: ALL POSTS
    if ( $_ARRAY['_ROUTE'] == 'blog/all' ) {

//::: BLOG HOMEPAGE
$_FORM  = '';
$_BLOG_POSTS      = $this->_BLOG_POSTS_DESIGN ( $_ARRAY = array() );

$_TITLE         = $_BLOG_SETTINGS['0']['bs_name'];
$_DESCRIPTION   = $_BLOG_SETTINGS['0']['bs_description'];
$_KEYWORDS      = $_BLOG_SETTINGS['0']['bs_tags'];
$_PAGE_URL      = 'blog';





//:: USE PAGINATOR
  $numbers  = count ( $_BLOG_POSTS );
  $page     = $_PAGE_NUMBER;
  $on_page	=	"10";
  $page=!empty($page)?$page:"1";
  $limitfrom=($page-1)*$on_page;
  $limitto=($page*$on_page)-($page-1)*$on_page;
  $itemsPerPage=$on_page;
      $paginator['pager']=$_PREPARE->page($page,$numbers,$itemsPerPage);
      $paginator['limitfrom']=$limitfrom+1;
      $paginator['limitto']=$limitfrom+$numbers;
      $paginator['page']=$page;

    if ( $on_page > $numbers ) {
      $paginator['pager'] = '';
    }

    if ( empty ( $_BLOG_POSTS ) ) {
      $_POSTS_LIST  = '';
    } else {
      $_POSTS_LIST  = array_slice($_BLOG_POSTS, $limitfrom, $limitto);
    }

$_CATEGORIES_DESIGN = '';
foreach ( $_BLOG_CATEGORIES as $_BC ) {

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/blog.categories.menu.php' ) ) {
      include( _TMDRP.'_BLOG/blog.categories.menu.php' );
    } else {
      include('design/blog.categories.menu.php');
    }
    $_CATEGORIES_DESIGN .= ob_get_contents();
    ob_end_clean();

}

$_POSTS_DESIGN  = '';
if ( !empty ( $_POSTS_LIST ) ) {
  foreach ( $_POSTS_LIST as $_BP ) {
    if ( empty ( $_BP['bc_ico'] ) ) {
      $_ICO = $_BP['bc_ico'];
    } else {
      $_ICO = $_PREPARE->sanitize( $_BP['bc_ico'], 'textarea-decode' );
    }
    $DATE   = date( DATE_FORMAT, $_BP['bp_date'] );
    $HOUR   = date( HOUR_FORMAT, $_BP['bp_date'] );
    $_POST_TITLE    = $_PREPARE->utf_substr($_BP['bp_title'],70);
    $_POST_DETAILS  = $_PREPARE->utf_substr( $_BP['bp_details'], 370 );
    $_POST_URL      = HTTP_MASTER.'blog/'.$_BP['bp_url'].'-'.$_BP['bp_id'];
    $_TAGS_URL      = HTTP_MASTER.'blog/tag/';

    $_POST_TAGS       = array_filter( explode( ",", $_BP['bp_tags'] ) );
    $_POST_TAGS_LIST  = '';

    $_POST_IMAGES     = $this->_BLOG_POSTS_IMAGE_DESIGN ( $_ARRAY = array ( "_ID" => $_BP['bp_id'], "_LIMIT" => '1' ) );
    $_POST_IMAGE      = '';

   if ( !empty ( $_POST_TAGS ) ) {
      foreach ( $_POST_TAGS as $_TAG ) {

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/blog.listing.tag.php' ) ) {
      include( _TMDRP.'_BLOG/blog.listing.tag.php' );
    } else {
      include('design/blog.listing.tag.php');
    }
    $_POST_TAGS_LIST .= ob_get_contents();
    ob_end_clean();

      }
   }

   if ( !empty ( $_POST_IMAGES ) ) {

      ob_start();
      if ( file_exists ( _TMDRP.'_BLOG/blog.listing.image.php' ) ) {
        include( _TMDRP.'_BLOG/blog.listing.image.php' );
      } else {
        include('design/blog.listing.image.php');
      }
      $_POST_IMAGE = ob_get_contents();
      ob_end_clean();

   }

      ob_start();
      if ( file_exists ( _TMDRP.'_BLOG/blog.listing.php' ) ) {
        include( _TMDRP.'_BLOG/blog.listing.php' );
      } else {
        include('design/blog.listing.php');
      }
      $_POSTS_DESIGN .= ob_get_contents();
      ob_end_clean();

  }
}

      $_FIELDS_START  = '';
      ob_start();
      if ( file_exists ( _TMDRP.'_BLOG/blog.listing.container.php' ) ) {
        include( _TMDRP.'_BLOG/blog.listing.container.php' );
      } else {
        include('design/blog.listing.container.php');
      }
      $_FIELDS_START = ob_get_contents();
      ob_end_clean();


      $_FIELDS        = false;
      $_FIELDS_END    = '';
      ob_start();
      if ( file_exists ( _TMDRP.'_BLOG/blog.right.php' ) ) {
        include( _TMDRP.'_BLOG/blog.right.php' );
      } else {
        include('design/blog.right.php');
      }
      $_FIELDS_END = ob_get_contents();
      ob_end_clean();



      $_BREADCRUMB  = '';
      ob_start();
      if ( file_exists ( _TMDRP.'_BLOG/all-posts.breadcrumb.php' ) ) {
        include( _TMDRP.'_BLOG/all-posts.breadcrumb.php' );
      } else {
        include('design/all-posts.breadcrumb.php');
      }
      $_BREADCRUMB = ob_get_contents();
      ob_end_clean();


$_FIELDS_DATA   = false;
    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_TITLE,
        "_DESCRIPTION" => $_DESCRIPTION,
        "_KEYWORDS" => $_KEYWORDS
        ),
      "DESIGN" => array (
        "_BREADCRUMB" => $_BREADCRUMB,
        "ICO" => '',
        "title" => $_TITLE,
        "form" => $_FORM,
        "fields_start" =>$_FIELDS_START,
        "fields" =>$_FIELDS,
        "fields_end" =>$_FIELDS_END,
        "fields_data" =>$_FIELDS_DATA,
        "_GET_ROUTE"  => $_PAGE_URL
      )
    );

    }
  //:: ./ALL POSTS



      } else {

      $_POST_DETAILS  = $_CONN->Query("SELECT `bp_id`, `bp_title`, `bp_url`, `bp_seo_description`, `bp_seo_tags`, `bp_category`, `bp_tags`, `bp_details`, `bp_date`, `bp_updated`, `bc_id`, `bc_name`, `bc_url`, `bc_ico` FROM blog_posts left join blog_categories on blog_categories.bc_id = blog_posts.bp_category where concat(bp_url,'-',bp_id)=?","s",$_POST_URL);


    $_POST_IMAGES     = $this->_BLOG_POSTS_IMAGE_DESIGN ( $_ARRAY = array ( "_ID" => $_POST_DETAILS['0']['bp_id'], "_LIMIT" => false ) );

      $_FORM_DESCRIPTION  = $_PREPARE->sanitize( $_POST_DETAILS['0']['bp_details'], 'textarea-decode' );

   if ( !empty ( $_POST_DETAILS ) ) {

      //GET ALL COMMENTS
      $_COMMENTS  = $this->_POST_COMMENTS ( $_ARRAY = array ( "_ID" => $_POST_DETAILS['0']['bp_id'] ) );

      //COMMENTS LIST
    $_COMMENTS_LIST = '';
    if ( !empty ( $_COMMENTS ) ) {
      foreach ( $_COMMENTS as $_COMMENT ) {
        if ( empty ( $_COMMENT['blog_comment_website'] ) ) {
          $_WEBSITE = '';
        } else {
          $_WEBSITE = '<cite title="'.$_COMMENT['blog_comment_website'].'">( '.$_COMMENT['blog_comment_website'].' )</cite>';
        }


    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/post.comments.php' ) ) {
      include( _TMDRP.'_BLOG/post.comments.php' );
    } else {
      include('design/post.comments.php');
    }
    $_COMMENTS_LIST .= ob_get_contents();
    ob_end_clean();

      }
    }

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/post.comments.container.php' ) ) {
      include( _TMDRP.'_BLOG/post.comments.container.php' );
    } else {
      include('design/post.comments.container.php');
    }
    $_COMMENTS_LIST   = ob_get_contents();
    ob_end_clean();

    $_CATEGORIES_DESIGN = '';
    foreach ( $_BLOG_CATEGORIES as $_BC ) {
      ob_start();
      if ( file_exists ( _TMDRP.'_BLOG/blog.categories.menu.php' ) ) {
        include( _TMDRP.'_BLOG/blog.categories.menu.php' );
      } else {
        include('design/blog.categories.menu.php');
      }
      $_CATEGORIES_DESIGN .= ob_get_contents();
      ob_end_clean();
    }

  


    $_POST_IMAGE      = '';
   if ( !empty ( $_POST_IMAGES ) ) {
    $T  = 0;
      foreach ( $_POST_IMAGES as $_IMAGE ) {

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/post.image.php' ) ) {
      include( _TMDRP.'_BLOG/post.image.php' );
    } else {
      include('design/post.image.php');
    }
    $_POST_IMAGE .= ob_get_contents();
    ob_end_clean();

      }
   }

    $_TAGS_URL        = HTTP_MASTER.'blog/tag/';
    $_POST_TAGS       = array_filter( explode( ",", $_POST_DETAILS['0']['bp_tags'] ) );
    $_POST_TAGS_LIST  = '';
    
   if ( !empty ( $_POST_TAGS ) ) {
      foreach ( $_POST_TAGS as $_TAG ) {

        ob_start();
        if ( file_exists ( _TMDRP.'_BLOG/post.tags.php' ) ) {
          include( _TMDRP.'_BLOG/post.tags.php' );
        } else {
          include('design/post.tags.php');
        }
        $_POST_TAGS_LIST .= ob_get_contents();
        ob_end_clean();

      }
   }

  if ( empty ( $_POST_DETAILS['0']['bc_ico'] ) ) {
    $_CAT_ICO = $_POST_DETAILS['0']['bc_ico'];
  } else {
    $_CAT_ICO = $_PREPARE->sanitize( $_POST_DETAILS['0']['bc_ico'], 'textarea-decode' );
  }

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/post.details.php' ) ) {
      include( _TMDRP.'_BLOG/post.details.php' );
    } else {
      include('design/post.details.php');
    }
    $_FORM_START = ob_get_contents();
    ob_end_clean();

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/blog.right.php' ) ) {
      include( _TMDRP.'_BLOG/blog.right.php' );
    } else {
      include('design/blog.right.php');
    }
    $_FORM_END = ob_get_contents();
    ob_end_clean();

  $_TITLE             = $_POST_DETAILS['0']['bp_title'];
  $_DESCRIPTION       = $_POST_DETAILS['0']['bp_seo_description'];
  $_KEYWORDS          = $_POST_DETAILS['0']['bp_seo_tags'];
  $_PAGE_URL          = 'blog/'.$_POST_DETAILS['0']['bp_url'].'-'.$_POST_DETAILS['0']['bp_id'];

  $_FORM          = $_FORM_START.$_FORM_END;
  $_FIELDS_START  = $_COMMENTS_LIST.'<div class="row"><div class="col-md-8">';
  $_FIELDS_END    = '</div><div class="col-md-4"></div>';


    $_FIELDS  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "blog_comment_name"            =>array( 
          "translation" => $_LANG['BLOG']['COMMENT_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "blog_comment_email"            =>array( 
          "translation" => $_LANG['BLOG']['COMMENT_EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "email",
          "options" => false,
          "class" => "col-md-6"
        ),
      "blog_comment_website"            =>array( 
          "translation" => $_LANG['BLOG']['COMMENT_WEBSITE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "blog_comment_comment"            =>array( 
          "translation" => $_LANG['BLOG']['COMMENT_COMMENT'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "minimum_chr" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "captcha"            =>array( 
          "translation" => $_LANG['BLOG']['COMMENT_CAPTCHA'],
          "field" => "captcha",
          "type" => "security",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "blog_comment_status"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "blog_comment_date"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "blog_comment_post_id"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => '_REQUEST_URI',
          "options" => false
        ),
      "blog_comment_id"  =>array(
          "translation" => $_LANG['BLOG']['COMMENT_SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/post.breadcrumb.php' ) ) {
      include( _TMDRP.'_BLOG/post.breadcrumb.php' );
    } else {
      include('design/post.breadcrumb.php');
    }
    $_BREADCRUMB = ob_get_contents();
    ob_end_clean();

  $_FIELDS_DATA   = false;
      $_RETURN  = array (
        "SEO" => array (
          "_TITLE" => $_TITLE,
          "_DESCRIPTION" => $_DESCRIPTION,
          "_KEYWORDS" => $_KEYWORDS
          ),
        "DESIGN" => array (
          "_BREADCRUMB" => $_BREADCRUMB,
          "ICO" => '',
          "title" => $_TITLE,
          "form" => $_FORM,
          "fields_start" =>'<div class="row">'.$_FIELDS_START,
          "fields" =>$_FIELDS,
          "fields_end" =>$_FIELDS_END.'</div>',
          "fields_data" =>$_FIELDS_DATA,
          "_GET_ROUTE"  => '_ADD_COMMENT'
        )
      );
    } else{
      $_RETURN  = false;
    }
    return $_RETURN;

  //:: END POST DETAILS
        
      }



      }

      if ( $_ROUTING_ELEMENTS  == 3 ) {
        //::: GET CATEGORY / TAGS OR SEARCH INFO
      $_FORM  = '';

$_ROUTING_ARRAY = array ( "category", "tag", "search");
$_BREADCRUMB  = '';


if ( $_ROUTING['1'] == 'category' ) {
    //:: VALIDATE CATEGORY
    $_ARRAY             = array( "bc_url" => $_ROUTING['2']);
    $_CATEGORY_DETAILS  = $this->_BLOG_CATEGORY_DESIGN( $_ARRAY );
    if ( empty ( $_CATEGORY_DETAILS ) ) {
      return false;
      break;
    }

//::: BLOG CATEGORY
$_FORM          = '';
$_BPDA          = array( "filter" => "category", "bp_category" => $_CATEGORY_DETAILS['0']['bc_id'] );
$_BLOG_POSTS    = $this->_BLOG_POSTS_DESIGN ( $_BPDA );

$_TITLE             = $_CATEGORY_DETAILS['0']['bc_name'];
$_DESCRIPTION       = $_CATEGORY_DETAILS['0']['bc_seo_description'];
$_KEYWORDS          = $_CATEGORY_DETAILS['0']['bc_seo_tags'];
$_PAGE_URL          = 'blog/category/'.$_CATEGORY_DETAILS['0']['bc_url'];

  if ( !empty ( $_CATEGORY_DETAILS['0']['bc_description'] ) ) {

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/category.description.php' ) ) {
      include( _TMDRP.'_BLOG/category.description.php' );
    } else {
      include('design/category.description.php');
    }
    $_FORM_DESCRIPTION = ob_get_contents();
    ob_end_clean();

  }

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/category.breadcrumb.php' ) ) {
      include( _TMDRP.'_BLOG/category.breadcrumb.php' );
    } else {
      include('design/category.breadcrumb.php');
    }
    $_BREADCRUMB = ob_get_contents();
    ob_end_clean();

}

if ( $_ROUTING['1'] == 'tag' ) {
  //::: BLOG TAGS
  $_FORM          = '';
  $_TAG           = $_ROUTING['2'];
  $_BPDA          = array( "filter" => "tags", "string" => $_TAG );
  $_BLOG_POSTS    = $this->_BLOG_POSTS_DESIGN ( $_BPDA );

  $_TITLE             = $_LANG['BLOG']['DESIGN_TAGS_SEO_TITLE'].$_TAG;
  $_DESCRIPTION       = $_LANG['BLOG']['DESIGN_TAGS_SEO_DESCRIPTION'].$_TAG;
  $_KEYWORDS          = $_LANG['BLOG']['DESIGN_TAGS_SEO_KEYWORDS'].$_TAG;
  $_PAGE_URL          = 'blog/tag/'.$_TAG;
}

if ( $_ROUTING['1'] == 'search' ) {
  //::: BLOG SEARCH
  $_FORM          = '';
  $_SEARCH        = str_replace("+"," ",$_ROUTING['2']);
  $_BPDA          = array( "filter" => "search", "string" => $_SEARCH );
  $_BLOG_POSTS    = $this->_BLOG_POSTS_DESIGN ( $_BPDA );

  $_TITLE             = $_LANG['BLOG']['DESIGN_TAGS_SEO_TITLE'].$_SEARCH;
  $_DESCRIPTION       = $_LANG['BLOG']['DESIGN_TAGS_SEO_DESCRIPTION'].$_SEARCH;
  $_KEYWORDS          = $_LANG['BLOG']['DESIGN_TAGS_SEO_KEYWORDS'].$_SEARCH;
  $_PAGE_URL          = 'blog/search/'.$_SEARCH;
}



if (in_array( $_ROUTING['1'], $_ROUTING_ARRAY )) {

//:: USE PAGINATOR
  $numbers  = count ( $_BLOG_POSTS );
  $page     = $_PAGE_NUMBER;
  $on_page	=	"10";
  $page=!empty($page)?$page:"1";
  $limitfrom=($page-1)*$on_page;
  $limitto=($page*$on_page)-($page-1)*$on_page;
  $itemsPerPage=$on_page;
      $paginator['pager']=$_PREPARE->page($page,$numbers,$itemsPerPage);
      $paginator['limitfrom']=$limitfrom+1;
      $paginator['limitto']=$limitfrom+$numbers;
      $paginator['page']=$page;

    if ( $on_page > $numbers ) {
      $paginator['pager'] = '';
    }

    if ( empty ( $_BLOG_POSTS ) ) {
      $_POSTS_LIST  = '';
    } else {
      $_POSTS_LIST  = array_slice($_BLOG_POSTS, $limitfrom, $limitto);
    }

$_CATEGORIES_DESIGN = '';
foreach ( $_BLOG_CATEGORIES as $_BC ) {

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/blog.categories.menu.php' ) ) {
      include( _TMDRP.'_BLOG/blog.categories.menu.php' );
    } else {
      include('design/blog.categories.menu.php');
    }
    $_CATEGORIES_DESIGN .= ob_get_contents();
    ob_end_clean();

}

$_POSTS_DESIGN  = '';
if ( !empty ( $_POSTS_LIST ) ) {
  foreach ( $_POSTS_LIST as $_BP ) {
    if ( empty ( $_BP['bc_ico'] ) ) {
      $_ICO = $_BP['bc_ico'];
    } else {
      $_ICO = $_PREPARE->sanitize( $_BP['bc_ico'], 'textarea-decode' );
    }
    $DATE   = date( DATE_FORMAT, $_BP['bp_date'] );
    $HOUR   = date( HOUR_FORMAT, $_BP['bp_date'] );

    $_POST_TITLE    = $_PREPARE->utf_substr($_BP['bp_title'],70);
    $_POST_DETAILS  = $_PREPARE->utf_substr( $_BP['bp_details'], 370 );

    $_POST_URL      = HTTP_MASTER.'blog/'.$_BP['bp_url'].'-'.$_BP['bp_id'];
    $_TAGS_URL      = HTTP_MASTER.'blog/tag/';

    $_POST_TAGS       = array_filter( explode( ",", $_BP['bp_tags'] ) );
    $_POST_TAGS_LIST  = '';

    $_POST_IMAGES     = $this->_BLOG_POSTS_IMAGE_DESIGN ( $_ARRAY = array ( "_ID" => $_BP['bp_id'], "_LIMIT" => '1' ) );
    
   if ( !empty ( $_POST_TAGS ) ) {
      foreach ( $_POST_TAGS as $_TAG ) {

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/blog.listing.tag.php' ) ) {
      include( _TMDRP.'_BLOG/blog.listing.tag.php' );
    } else {
      include('design/blog.listing.tag.php');
    }
    $_POST_TAGS_LIST .= ob_get_contents();
    ob_end_clean();

      }
   }

   if ( !empty ( $_POST_IMAGES ) ) {

      ob_start();
      if ( file_exists ( _TMDRP.'_BLOG/blog.listing.image.php' ) ) {
        include( _TMDRP.'_BLOG/blog.listing.image.php' );
      } else {
        include('design/blog.listing.image.php');
      }
      $_POST_IMAGE = ob_get_contents();
      ob_end_clean();

   }

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/blog.listing.php' ) ) {
      include( _TMDRP.'_BLOG/blog.listing.php' );
    } else {
      include('design/blog.listing.php');
    }
    $_POSTS_DESIGN .= ob_get_contents();
    ob_end_clean();

  }
} else {

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/blog.listing.php' ) ) {
      include( _TMDRP.'_BLOG/blog.listing.not-found.php' );
    } else {
      include('design/blog.listing.not-found.php');
    }
    $_POSTS_DESIGN = ob_get_contents();
    ob_end_clean();

}

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/blog.listing.container.php' ) ) {
      include( _TMDRP.'_BLOG/blog.listing.container.php' );
    } else {
      include('design/blog.listing.container.php');
    }
    $_FIELDS_START = ob_get_contents();
    ob_end_clean();

$_FIELDS        = false;
$_FIELDS_END    = '';

    ob_start();
    if ( file_exists ( _TMDRP.'_BLOG/blog.right.php' ) ) {
      include( _TMDRP.'_BLOG/blog.right.php' );
    } else {
      include('design/blog.right.php');
    }
    $_FIELDS_END = ob_get_contents();
    ob_end_clean();

$_FIELDS_DATA   = false;
    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_TITLE,
        "_DESCRIPTION" => $_DESCRIPTION,
        "_KEYWORDS" => $_KEYWORDS
        ),
      "DESIGN" => array (
        "_BREADCRUMB" => $_BREADCRUMB,
        "ICO" => '',
        "title" => $_TITLE,
        "form" => $_FORM,
        "fields_start" =>$_FIELDS_START,
        "fields" =>$_FIELDS,
        "fields_end" =>$_FIELDS_END,
        "fields_data" =>$_FIELDS_DATA,
        "_GET_ROUTE"  => $_PAGE_URL
      )
    );

}
}

    } else {
//::: BLOG HOMEPAGE
$_BREADCRUMB    = '';
$_BLOG_POSTS    = $this->_BLOG_POSTS_DESIGN ( $_ARRAY = array() );
$_TITLE         = $_BLOG_SETTINGS['0']['bs_name'];

$_DESCRIPTION   = $_BLOG_SETTINGS['0']['bs_description'];
$_KEYWORDS      = $_BLOG_SETTINGS['0']['bs_tags'];
$_PAGE_URL      = 'blog';
$_FIELDS_START  = '';
$_FIELDS_END    = '';
$_FIELDS        = false;


    $_CATEGORIES  = $this->_CATEGORIES_FIELDS_LIST( array() );
    $_CATEGORIES_LIST = '';


  if ( empty ( $_CATEGORIES ) ) {
    $_CATEGORIES_LIST  = '';
  } else {
    foreach ( $_CATEGORIES as $_CATEGORY ) {
      $_POSTS_LIST  = '';

      //GET POSTS FROM THE DATABASE
      $_POSTS = $this->_POSTS_LIST( array( "limit" => 5, "bp_category" => $_CATEGORY['bc_id'] ) );

      if ( empty ( $_POSTS ) ) {
        $_POSTS_LIST  = '';
      } else {
          $_POSTS_LIST  .=  '';
        foreach ( $_POSTS as $_PL ) {
          $_POST_URL      = HTTP_MASTER.'blog/'.$_PL['bp_url'].'-'.$_PL['bp_id'];
          
          //GENERATE THE POSTS LISTINGS
          ob_start();
          if ( file_exists ( _TMDRP.'_BLOG/homepage.posts.php' ) ) {
            include( _TMDRP.'_BLOG/homepage.posts.php' );
          } else {
            include('design/homepage.posts.php');
          }
          $_POSTS_LIST  .= ob_get_contents();
          ob_end_clean();

        }
      }
      
          ob_start();
          if ( file_exists ( _TMDRP.'_BLOG/homepage.categories.php' ) ) {
            include( _TMDRP.'_BLOG/homepage.categories.php' );
          } else {
            include('design/homepage.categories.php');
          }
          $_CATEGORIES_LIST  .= ob_get_contents();
          ob_end_clean();

    }
  }

          ob_start();
          if ( file_exists ( _TMDRP.'_BLOG/homepage.breadcrumb.php' ) ) {
            include( _TMDRP.'_BLOG/homepage.breadcrumb.php' );
          } else {
            include('design/homepage.breadcrumb.php');
          }
          $_BREADCRUMB  .= ob_get_contents();
          ob_end_clean();

$_FORM  = $_CATEGORIES_LIST;

$_FIELDS_DATA   = false;
    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_TITLE,
        "_DESCRIPTION" => $_DESCRIPTION,
        "_KEYWORDS" => $_KEYWORDS
        ),
      "DESIGN" => array (
        "ICO" => '',
        "_BREADCRUMB" => $_BREADCRUMB,
        "title" => $_TITLE,
        "form" => $_FORM,
        "fields_start" =>$_FIELDS_START,
        "fields" =>$_FIELDS,
        "fields_end" =>$_FIELDS_END,
        "fields_data" =>$_FIELDS_DATA,
        "_GET_ROUTE"  => $_PAGE_URL
      )
    );

//::: ./BLOG HOMEPAGE
  }

    return $_RETURN;
  }


  function _LOAD_CSS ( $_PLUGIN, $_ROUTE ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_RETURN = $_CONN->Query("SELECT `css_id`, `css_plugin`, `css_plugin_route`, `css_info` FROM custom_css where css_plugin=? and css_plugin_route=? limit 1","ss",$_PLUGIN,$_ROUTE);
    return false;
  }


}

//:: DEFINE CLASS
$_VIEW->_BLOG  = $_BLOG  = new _BLOG;
?>