<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _FAQ {
  function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  function _DB () {
    $_DB  = new database;
    return $_DB;
  }


  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();

    
    $_TEXT_TYPE = "props:['color','background-color','text-decoration','font-weight','letter-spacing','line-height','text-align','text-transform','word-spacing','text-shadow','border','border-radius','box-shadow','margin','padding']";
    $_BOX_TYPE  = "props:['background-color','border','border-top','border-right','border-bottom','border-left','border-radius','box-shadow','margin','padding']";
    
    $_COMBINED  = "props:['color','background-color','text-decoration','font-weight','letter-spacing','line-height','text-align','text-transform','word-spacing','text-shadow','border','border-top','border-right','border-bottom','border-left','border-radius','box-shadow','margin','padding','background-color','border','border-radius','box-shadow','margin','padding']";
    
    $_RETURN  = array (
      "name"=>"F.A.Q.",
      "url"=>"_FAQ",
      "description"=>$_LANG['FAQ']['DESCRIPTION'],
      "menu" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['FAQ']['ALL'] ),
        "item_2" => array( "option" => false, "url" => "FIELDS/_MANAGE", "name" => $_LANG['FAQ']['ADD'] ),
        "item_3" => array( "option" => true, "url" => "pluginUninstall", "name" => $_LANG['FAQ']['UNINSTALL'] )
      ),
      "menu_design" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "_ALL" => "faq", "name" => $_LANG['FAQ']['DESIGN_ALL'] )
      ),
      "def"  => "
      
          def: {
            '._FAQ .page-title':{
              name: '".$_LANG['FAQ']['NAME']."',
              ".$_TEXT_TYPE."
            },
            '._FAQ .faq-title a':{
              name: '".$_LANG['FAQ']['DESIGN_PAGE_TITLE']."',
              ".$_TEXT_TYPE."
            },
            '._FAQ .faq-details':{
              name: '".$_LANG['FAQ']['DETAILS']."',
              ".$_COMBINED."
            }
          }
      
      ",
    );
    return $_RETURN;
  }

  //:: CREATE THE SUBMENU
  function _SUBMENU ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "all_faq" => array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['FAQ']['ALL']
        ),
      "add_faq" => array (
          "url" => 'FIELDS/_MANAGE',
          "translation" => $_LANG['FAQ']['ADD']
        )
    );
    return $_RETURN;
  }

  //:: PLUGIN INSTALL
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_MAIN_TABLE = "
      CREATE TABLE IF NOT EXISTS `faq` (
        `faq_id` int(11) NOT NULL AUTO_INCREMENT,
        `faq_name` varchar(250) NOT NULL,
        `faq_details` text NOT NULL,
        `faq_ico` varchar(100) NOT NULL,
        `faq_url` text NOT NULL,
        `faq_box_type` varchar(50) NOT NULL,
        `faq_order` int(11) NOT NULL,
        PRIMARY KEY (`faq_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_MAIN_TABLE);
    return $_RETURN;
  }

  //:: PLUGIN UNINSTALL
  function _UNINSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_TABLE = "DROP TABLE IF EXISTS `faq`;";
    $_RETURN  = $_CONN->NoQuery($_TABLE);
    return $_RETURN;
  }

  //:: GET THE INFO FROM THE DATABASE
  function _MANAGE_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `faq_id`, `faq_name`, `faq_details`, `faq_ico`, `faq_url`, `faq_box_type`, `faq_order` FROM faq where faq_id=? limit 1","s",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: GENERATE THE HTML FIELDS FOR EDITING/ADDING INFO TO THE DATABASE
  function _MANAGE_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['FAQ']['DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "faq_name"            =>array( 
          "translation" => $_LANG['FAQ']['NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "faq_details"          =>array(
          "translation" => $_LANG['FAQ']['DETAILS'],
          "field" => "editor",
          "type" => "text",
          "length" => "5",
          "mandatory" => true,
          "request" => "textarea",
          "options" => false,
          "class" => "col-md-12"
        ),
      "faq_ico"            =>array( 
          "translation" => $_LANG['FAQ']['ICO'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "faq_url"            =>array( 
          "translation" => $_LANG['FAQ']['URL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "faq_box_type"            =>array( 
          "translation" => $_LANG['FAQ']['BOX_TYPE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "faq_order"            =>array( 
          "translation" => $_LANG['FAQ']['ORDER'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "faq_id"  =>array(
          "translation" => $_LANG['FAQ']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: INFO LISTING : HTML FIELDS
  function _ALL_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['FAQ']['ALL'],
          "group" => true,
          "special" => true
        ),
      "faq_name" => array (
          "options" => false,
          "translation" => $_LANG['FAQ']['NAME']
        ),
      "faq_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_MANAGE", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['FAQ']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['FAQ']['REMOVE'] ),
            ),
          "translation" => $_LANG['FAQ']['OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: LISTING DATA : MYSQL DETAILS
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `faq_name`, `faq_id` FROM faq order by faq_id desc");
    return $_RETURN;
  }

  //:: MANAGE ADD / UPDATE
  function _MANAGE ( $_ARRAY ) {
    if ( empty ( $_ARRAY['faq_id'] ) ) {
      $_RETURN  = $this->_ADD ( $_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE ( $_ARRAY );
    }
      return $_RETURN;
  }

  //:: ADD DATA
  function _ADD ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("INSERT INTO faq VALUES(NULL,?,?,?,?,?,?)","ssssss",$_ARRAY['faq_name'],$_ARRAY['faq_details'],$_ARRAY['faq_ico'],$_ARRAY['faq_url'],$_ARRAY['faq_box_type'],$_ARRAY['faq_order']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['FAQ']['ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['FAQ']['ERROR'];
    }
    return $error;
  }

  //:: UPDATE
  function _UPDATE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("UPDATE faq SET faq_name=?, faq_details=?, faq_ico=?, faq_url=?, faq_box_type=?, faq_order=? WHERE faq_id=? limit 1","sssssss",$_ARRAY['faq_name'],$_ARRAY['faq_details'],$_ARRAY['faq_ico'],$_ARRAY['faq_url'],$_ARRAY['faq_box_type'],$_ARRAY['faq_order'],$_ARRAY['faq_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['FAQ']['UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['FAQ']['ERROR'];
      }
    return $error;
  }

  //:: REMOVE
  function _REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->NoQuery("DELETE FROM faq WHERE faq_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: _REQUIRED_SESSION :: JUST IF NEED AUTHENTIFICATION
  function _REQUIRED_SESSION ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = array (
      "_REQUIRED_SESSION"         => false,
      "_REQUIRED_SESSION_STRING"  => '',
      "_REDIRECT_PAGE"            => 'user/login',
    );
    return $_RETURN;
  }

  //:: DESIGN THE WIDGET
  function _WIDGET ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();

    $_COUNT = $_CONN->Query("SELECT `faq_id` FROM faq");
    $_COUNT = count ( $_COUNT );

    ob_start();
    if ( file_exists ( _TMDRP.'_FAQ/admin.widget.php' ) ) {
      include( _TMDRP.'_FAQ/admin.widget.php' );
    } else {
      include('design/admin.widget.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();

    return $_FORM;
  }

  //:: DESIGN ROUTE!
  function _DESIGN ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_FAQ_LIST  = $_CONN->Query("SELECT `faq_id`, `faq_name`, `faq_details`, `faq_ico`, `faq_url`, `faq_box_type`, `faq_order` FROM faq order by faq_order ASC");

    $_FORM    = '';

    foreach ( $_FAQ_LIST as $_FAQ ) {
    $_FAQ_DETAILS = $_PREPARE->sanitize( $_FAQ['faq_details'], 'textarea-decode' );
    if ( empty ( $_FAQ['faq_box_type'] ) ) {
      $_FAQ_TYPE  = 'primary';
    } else {
      $_FAQ_TYPE  = $_FAQ['faq_box_type'];
    }

    if ( empty ( $_FAQ['faq_ico'] ) ) {
      $_FAQ_ICO  = '';
    } else {
      $_FAQ_ICO  = $_PREPARE->sanitize( $_FAQ['faq_ico'], 'textarea-decode' );
    }

    if ( empty ( $_FAQ['faq_url'] ) ) {
      $_FAQ_URL  = '';
    } else {
      $_FAQ_URL  = '<a href="'.$_FAQ['faq_url'].'" target="_blank">'.$_LANG['FAQ']['VIEW_MORE'].'</a>';
    }

      
    ob_start();
    if ( file_exists ( _TMDRP.'_FAQ/index.php' ) ) {
      include( _TMDRP.'_FAQ/index.php' );
    } else {
      include('design/index.php');
    }
    $_FORM .= ob_get_contents();
    ob_end_clean();

    }


    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_LANG['FAQ']['SEO_TITLE'],
        "_DESCRIPTION" => $_LANG['FAQ']['SEO_DESCRIPTION'],
        "_KEYWORDS" => $_LANG['FAQ']['SEO_KEYWORDS']
        ),
      "DESIGN" => array (
        "ICO" => '<i class="fa fa-fw fa-question-circle"></i>',
        "title" => $_LANG['FAQ']['TITLE'],
        "form" => $_FORM,
        "fields_start" =>false,
        "fields" =>false,
        "fields_end" =>false,
        "fields_data" =>false,
        "_GET_ROUTE"  => ''
      )
    );


    return $_RETURN;
  }


  function _LOAD_CSS ( $_PLUGIN, $_ROUTE ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();

    $_RETURN = $_CONN->Query("SELECT `css_id`, `css_plugin`, `css_plugin_route`, `css_info` FROM custom_css where css_plugin=? limit 1","s","_FAQ");
    return $_RETURN;
  }

}

//:: PAGES CLASS
$_VIEW->_FAQ  = $_FAQ  = new _FAQ;
?>