<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _PAGE {
  function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  function _VIEW () {
    $_VIEW = new template();
    return $_VIEW;
  }

  function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  function _DB () {
    $_DB  = new database;
    return $_DB;
  }

  function _TEMPLATE () {
    $_TEMPLATE  = new template;
    return $_TEMPLATE;
  }


  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_INFO  = array (
      "name"=>$_LANG['PAGES']['_PLUGIN_NAME'],
      "url"=>"_PAGE",
      "description"=>$_LANG['PAGES']['_PLUGIN_DESCRIPTION'],
      "menu" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['PAGES']['ALL_PAGES'] ),
        "item_2" => array( "option" => false, "url" => "FIELDS/_MANAGE", "name" => $_LANG['PAGES']['NEW_PAGE'] ),
        "item_3" => array( "option" => true, "url" => "pluginUninstall", "name" => $_LANG['PAGES']['UNINSTALL'] )
      ),
      "table" => true
    );
    return $_INFO;
  }

  //:: CREATE THE SUBMENU
  function _SUBMENU ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "all_pages" => array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['PAGES']['ALL_PAGES']
        ),
      "new_page" => array (
          "url" => 'FIELDS/_MANAGE',
          "translation" => $_LANG['PAGES']['NEW_PAGE']
        )
    );
    return $_RETURN;
  }

  //:: PLUGIN INSTALL
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_PAGES_TABLE = "
      CREATE TABLE IF NOT EXISTS `pages` (
        `page_id` int(11) NOT NULL AUTO_INCREMENT,
        `page_title` varchar(150) NOT NULL,
        `page_url` varchar(150) NOT NULL,
        `page_details` text NOT NULL,
        `page_code` text NOT NULL,
        `page_metatags` varchar(250) NOT NULL,
        `page_metadescription` text NOT NULL,
        PRIMARY KEY (`page_id`)
      ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_PAGES_TABLE);
    return $_RETURN;
  }

  //:: PLUGIN UNINSTALL
  function _UNINSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_PAGES_TABLE = "DROP TABLE IF EXISTS `pages`;";
    $_RETURN  = $_CONN->NoQuery($_PAGES_TABLE);
    return $_RETURN;
  }

//:: FUNCTIONS
	private function title ( $str ) {
		$str = strtolower($str);
		$bad = array("","'", "@", "!", "", "+", "<", ">", "", "", "$", "%", "^", "", "*", "(", ")", "", ":", '"', "", "","","","  "," ");
		$good   = array("","", "", "", "", "", "","","","", "", "", "", "", "", "", "","","","","","","",""," ","-");

		$return = strip_tags(str_replace($bad, $good, $str));
		return $return;

	}		

  //:: GET THE INFO FROM THE DATABASE
  function _MANAGE_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_RETURN = $_CONN->Query("SELECT `page_id`, `page_title`, `page_url`, `page_details`, `page_code`, `page_metatags`, `page_metadescription` FROM pages where page_id=? limit 1","s",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: GENERATE THE HTML FIELDS FOR EDITING/ADDING INFO TO THE DATABASE
  function _MANAGE_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['PAGES']['DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "page_title"            =>array( 
          "translation" => $_LANG['PAGES']['FIELD_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "page_url"              =>array(
          "translation" => $_LANG['PAGES']['FIELD_URL'],
          "field" => "input", "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "url",
          "options" => false,
          "class" => "col-md-6"
        ),
      "page_details"          =>array(
          "translation" => $_LANG['PAGES']['FIELD_DETAILS'],
          "field" => "editor",
          "type" => "text",
          "length" => "NULL",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-12"
        ),
      "GROUP_2"  => array(
          "translation" => $_LANG['PAGES']['SEO'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "page_metatags"         =>array(
          "translation" => $_LANG['PAGES']['FIELD_METATAGS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "page_metadescription"  =>array(
          "translation" => $_LANG['PAGES']['FIELD_METADESCRIPTION'],
          "field" => "textarea",
          "type" => "text",
          "length" => "5",
          "mandatory" => false,
          "request" => "",
          "options" => false,
          "class" => "col-md-12"
        ),
      "GROUP_3"  => array(
          "translation" => $_LANG['PAGES']['OPTIONS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "page_code"  =>array(
          "translation" => $_LANG['PAGES']['FIELD_CODE'],
          "field" => "textarea",
          "type" => "text",
          "length" => "5",
          "mandatory" => false,
          "request" => "",
          "options" => false,
          "class" => "col-md-12"
        ),
      "page_id"  =>array(
          "translation" => $_LANG['PAGES']['FIELD_SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: INFO LISTING : HTML FIELDS
  function _ALL_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['PAGES']['ALL_PAGES'],
          "group" => true,
          "special" => true
        ),
      "page_title" => array (
          "options" => false,
          "translation" => $_LANG['PAGES']['FIELD_NAME']
        ),
      "page_url" => array (
          "options" => false,
          "translation" => $_LANG['PAGES']['FIELD_URL']
        ),
      "page_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_MANAGE", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['PAGES']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['PAGES']['REMOVE'] ),
            ),
          "translation" => $_LANG['PAGES']['FIELD_OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: LISTING DATA : MYSQL DETAILS
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `page_title`, `page_url`, `page_id` FROM pages order by page_id desc");
    return $_RETURN;
  }

  //:: MANAGE PAGES ADD / UPDATE
  function _MANAGE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    if ( empty ( $_ARRAY['page_id'] ) ) {
      $_RETURN  = $this->_ADD ( $_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE ( $_ARRAY );
    }
      return $_RETURN;
  }

  //:: ADD A NEW PAGE
  function _ADD ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("INSERT INTO pages VALUES(NULL,?,?,?,?,?,?)","ssssss",$_ARRAY['page_title'],$_ARRAY['page_url'],$_ARRAY['page_details'],$_ARRAY['page_code'],$_ARRAY['page_metatags'],$_ARRAY['page_metadescription']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['PAGES']['MANAGE_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['PAGES']['MANAGE_ERROR'];
    }
    return $error;
  }

  //:: PAGE UPDATE
  function _UPDATE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("UPDATE pages SET page_title=?, page_url=?, page_details=?, page_code=?, page_metatags=?, page_metadescription=? WHERE page_id=? limit 1","sssssss",$_ARRAY['page_title'],$this->title($_ARRAY['page_url']),$_ARRAY['page_details'],$_ARRAY['page_code'],$_ARRAY['page_metatags'],$_ARRAY['page_metadescription'],$_ARRAY['page_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['PAGES']['MANAGE_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['PAGES']['MANAGE_ERROR'];
      }
    return $error;
  }

  //:: PAGE REMOVE
  function _REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_RETURN  = $_CONN->NoQuery("DELETE FROM pages WHERE page_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: _REQUIRED_SESSION :: JUST IF NEED AUTHENTIFICATION
  function _REQUIRED_SESSION ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN  = array (
      "_REQUIRED_SESSION"         => false,
      "_REQUIRED_SESSION_STRING"  => 'ADMIN_SESSION',
      "_REDIRECT_PAGE"            => 'user/login',
    );
    return $_RETURN;
  }

  //:: DESIGN THE WIDGET
  function _WIDGET ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();

    $_COUNT = $_CONN->Query("SELECT `page_id` FROM pages");
    $_COUNT = count ( $_COUNT );

    ob_start();
    if ( file_exists ( _TMDRP.'_PAGE/admin.widget.php' ) ) {
      include( _TMDRP.'_PAGE/admin.widget.php' );
    } else {
      include('design/admin.widget.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();

    return $_FORM;
  }

  //:: DESIGN ROUTE!
  function _DESIGN ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_PAGE_URL =  explode("/",$_ARRAY['_ROUTE'] );
    $_PAGE_URL = $_PAGE_URL['1'];

    $_PAGE_INFO = $_CONN->Query("SELECT `page_id`, `page_title`, `page_url`, `page_details`, `page_code`, `page_metatags`, `page_metadescription` FROM pages where page_url=? limit 1","s",$_PAGE_URL);

    if ( !empty ( $_PAGE_INFO ) ) {

    $_PAGE_DETAILS  = $_PREPARE->sanitize( $_PAGE_INFO['0']['page_details'], 'textarea-decode' );
    $_PAGE_CODE     = $_PREPARE->sanitize( $_PAGE_INFO['0']['page_code'], 'textarea-decode' );


    ob_start();
    if ( file_exists ( _TMDRP.'_PAGE/index.php' ) ) {
      include( _TMDRP.'_PAGE/index.php' );
    } else {
      include('design/index.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();


    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_PAGE_INFO['0']['page_title'],
        "_DESCRIPTION" => $_PAGE_INFO['0']['page_metadescription'],
        "_KEYWORDS" => $_PAGE_INFO['0']['page_metatags']
        ),
      "DESIGN" => array (
        "ICO" => '',
        "title" => $_PAGE_INFO['0']['page_title'],
        "form" => $_FORM,
        "fields_start" =>false,
        "fields" =>false,
        "fields_end" =>false,
        "fields_data" =>false,
        "_GET_ROUTE"  => $_PAGE_URL
      )
    );
    } else{
      $_RETURN  = false;
    }
    return $_RETURN;
  }

  function _LOAD_CSS ( $_PLUGIN, $_ROUTE ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `css_id`, `css_plugin`, `css_plugin_route`, `css_info` FROM custom_css where css_plugin=? and css_plugin_route=? limit 1","ss",$_PLUGIN,$_ROUTE);
    return false;
  }


}

//:: PAGES CLASS
$_VIEW->_PAGE  = $_PAGE  = new _PAGE;
?>