<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _PORTFOLIO {

  function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  function _DB () {
    $_DB  = new database;
    return $_DB;
  }


  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "name"=>$_LANG['PORTFOLIO']['_PLUGIN_NAME'],
      "url"=>"_PORTFOLIO",
      "description"=>$_LANG['PORTFOLIO']['_PLUGIN_DESCRIPTION'],
      "menu" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['PORTFOLIO']['ALL_ITEMS'] ),
        "item_2" => array( "option" => false, "url" => "FIELDS/_MANAGE", "name" => $_LANG['PORTFOLIO']['ADD_ITEM'] ),

        "item_3" => array( "option" => false, "url" => "LIST/_CATEGORIES", "name" => $_LANG['PORTFOLIO']['CATEGORIES'] ),
        "item_4" => array( "option" => false, "url" => "FIELDS/_CATEGORY", "name" => $_LANG['PORTFOLIO']['ADD_CATEGORY'] ),


        "item_999" => array( "option" => true, "url" => "pluginUninstall", "name" => $_LANG['PORTFOLIO']['_PLUGIN_UNINSTALL'] )
      )
    );
    return $_RETURN;
  }

  //:: CREATE THE PLUGIN SUBMENU
  function _SUBMENU ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "all_items" => array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['PORTFOLIO']['ALL_ITEMS']
        ),
      "add_item" => array (
          "url" => 'FIELDS/_MANAGE',
          "translation" => $_LANG['PORTFOLIO']['ADD_ITEM']
        ),
      "all_categories" => array (
          "url" => 'LIST/_CATEGORIES',
          "translation" => $_LANG['PORTFOLIO']['CATEGORIES']
        ),
      "add_category" => array (
          "url" => 'FIELDS/_CATEGORY',
          "translation" => $_LANG['PORTFOLIO']['ADD_CATEGORY']
        ),

    );
    return $_RETURN;
  }


  //:: PLUGIN INSTALL
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();

      $_INSTALL = "
        CREATE TABLE IF NOT EXISTS `portfolio` (
          `portfolio_id` int(11) NOT NULL AUTO_INCREMENT,
          `portfolio_title` varchar(150) NOT NULL,
          `portfolio_url` varchar(150) NOT NULL,
          `portfolio_category` int(11) NOT NULL,
          `portfolio_cover` varchar(250) NOT NULL,
          `portfolio_short_description` text NOT NULL,
          `portfolio_description` text NOT NULL,
          `portfolio_date` int(11) NOT NULL,
          `portfolio_status` int(11) NOT NULL,
          PRIMARY KEY (`portfolio_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

        CREATE TABLE IF NOT EXISTS `portfolio_details` (
          `portfolio_details_portfolio_id` int(11) NOT NULL,
          `portfolio_details_date_created` int(11) NOT NULL,
          `portfolio_details_location` varchar(150) NOT NULL,
          `portfolio_details_client` varchar(150) NOT NULL,
          `portfolio_details_client_website` varchar(250) NOT NULL,
          `portfolio_details_case_study` text NOT NULL,
          `portfolio_details_our_approach` text NOT NULL,
          `portfolio_details_the_result` text NOT NULL,
          `portfolio_details_seo_tags` varchar(250) NOT NULL,
          `portfolio_details_seo_description` text NOT NULL,
          PRIMARY KEY (`portfolio_details_portfolio_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

        CREATE TABLE IF NOT EXISTS `portfolio_images` (
          `portfolio_images_id` int(11) NOT NULL AUTO_INCREMENT,
          `portfolio_images_portfolio_id` int(11) NOT NULL,
          `portfolio_images_image_location` varchar(150) NOT NULL,
          PRIMARY KEY (`portfolio_images_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

        CREATE TABLE IF NOT EXISTS `portfolio_categories` (
          `portfolio_categories_id` int(11) NOT NULL AUTO_INCREMENT,
          `portfolio_categories_name` varchar(150) NOT NULL,
          `portfolio_categories_url` varchar(150) NOT NULL,
          `portfolio_categories_description` text NOT NULL,
          `portfolio_categories_seo_description` text NOT NULL,
          `portfolio_categories_seo_tags` varchar(150) NOT NULL,
          `portfolio_categories_order` int(11) NOT NULL,
          PRIMARY KEY (`portfolio_categories_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


      ";
      $_RETURN  = $_CONN->MultiNoQuery($_INSTALL);

    return $_RETURN;
  }


  //:: PLUGIN UNINSTALL
  function _UNINSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_UNINSTALL = "
      DROP TABLE IF EXISTS `portfolio`;
      DROP TABLE IF EXISTS `portfolio_details`;
      DROP TABLE IF EXISTS `portfolio_images`;
    ";
    $_RETURN  = $_CONN->MultiNoQuery($_UNINSTALL);
    return $_RETURN;
  }


  //:: USE $_ARRAY['_ROUTE'] if is needed
  function _ADDED_MSJ ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    
    if ( $_ARRAY['_ROUTE'] == '_MANAGE' ) {
      return '<div class="callout callout-success">'.$_LANG['PORTFOLIO']['ITEM_ADDED'].'</div>';
    }
  }

  function _UPDATED_MSJ ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    if ( $_ARRAY['_ROUTE'] == '_MANAGE' ) {
      return '<div class="callout callout-success">'.$_LANG['PORTFOLIO']['ITEM_UPDATED'].'</div>';
    }
  }

  function _ERROR_MSJ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-danger">'.$_LANG['PORTFOLIO']['_PLUGIN_DATA_ERROR'].'</div>';
  }


  //:: CATEGORIES MANAGE
  //:: LISTING : HTML FIELDS
  function _CATEGORIES_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['PORTFOLIO']['CATEGORIES_MANAGE'],
          "group" => true,
          "special" => true
        ),

      "portfolio_categories_order" => array (
          "options" => false,
          "translation" => $_LANG['PORTFOLIO']['CATEGORIES_ORDER']
        ),

      "portfolio_categories_name" => array (
          "options" => false,
          "translation" => $_LANG['PORTFOLIO']['CATEGORIES_NAME']
        ),

      "portfolio_categories_url" => array (
          "options" => false,
          "translation" => $_LANG['PORTFOLIO']['CATEGORIES_URL']
        ),

      "portfolio_categories_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_CATEGORY", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['PORTFOLIO']['_PLUGIN_EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE_CATEGORY", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['PORTFOLIO']['_PLUGIN_REMOVE'] ),
            ),
          "translation" => $_LANG['PORTFOLIO']['_PLUGIN_OPTIONS']
        )
    );
    return $_RETURN;
  }
  //:: LISTING DATA : MYSQL DETAILS
  function _CATEGORIES_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `portfolio_categories_id`, `portfolio_categories_name`, `portfolio_categories_url`, `portfolio_categories_description`, `portfolio_categories_seo_description`, `portfolio_categories_seo_tags`, `portfolio_categories_order` from portfolio_categories ");

    return $_RETURN;
  }


  //:: GENERATE THE HTML FIELDS FOR EDITING/ADDING CATEGORY TO THE DATABASE
  function _CATEGORY_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['PORTFOLIO']['CATEGORY_MANAGE'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

      "portfolio_categories_name"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['CATEGORY_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "portfolio_categories_url"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['CATEGORY_URL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "portfolio_categories_description"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['CATEGORY_DESCRIPTION'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "10",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "portfolio_categories_seo_description"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['CATEGORY_SEO_DESCRIPTION'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "portfolio_categories_seo_tags"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['CATEGORY_SEO_TAGS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "portfolio_categories_order"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['CATEGORY_ORDER'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "portfolio_categories_id"  =>array(
          "translation" => $_LANG['PORTFOLIO']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: GET THE CATEGORY DETAILS FROM THE DATABASE
  function _CATEGORY_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `portfolio_categories_id`, `portfolio_categories_name`, `portfolio_categories_url`, `portfolio_categories_description`, `portfolio_categories_seo_description`, `portfolio_categories_seo_tags`, `portfolio_categories_order` FROM portfolio_categories where portfolio_categories_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  function _CATEGORY ( $_ARRAY ) {
    if ( empty ( $_ARRAY['portfolio_categories_id'] ) ) {
      $_RETURN  = $this->_ADD_CATEGORY ( $_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE_CATEGORY ( $_ARRAY );
    }
      return $_RETURN;
  }

  //:: ADD NEW CATEGORY
  function _ADD_CATEGORY ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_ARRAY['portfolio_categories_url'] = $_PREPARE->title ( $_ARRAY['portfolio_categories_url'] );

    $_RETURN = $_CONN->NoQuery("INSERT INTO portfolio_categories VALUES(NULL,?,?,?,?,?,?)","ssssss",$_ARRAY['portfolio_categories_name'],$_ARRAY['portfolio_categories_url'],$_ARRAY['portfolio_categories_description'],$_ARRAY['portfolio_categories_seo_description'],$_ARRAY['portfolio_categories_seo_tags'],$_ARRAY['portfolio_categories_order']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $_ID  = $_CONN->LastID();
      $error['message']	=	$_LANG['PORTFOLIO']['CATEGORY_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['PORTFOLIO']['_PLUGIN_DATA_ERROR'];
    }
    return $error;
  }

  //:: UPDATE YOUR CATEGORY DETAILS
  function _UPDATE_CATEGORY ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_ARRAY['portfolio_categories_url'] = $_PREPARE->title ( $_ARRAY['portfolio_categories_url'] );
    
    $_RETURN = $_CONN->NoQuery("UPDATE portfolio_categories SET portfolio_categories_name=?, portfolio_categories_url=?, portfolio_categories_description=?, portfolio_categories_seo_description=?, portfolio_categories_seo_tags=?, portfolio_categories_order=? WHERE portfolio_categories_id=? limit 1","sssssss",$_ARRAY['portfolio_categories_name'],$_ARRAY['portfolio_categories_url'],$_ARRAY['portfolio_categories_description'],$_ARRAY['portfolio_categories_seo_description'],$_ARRAY['portfolio_categories_seo_tags'],$_ARRAY['portfolio_categories_order'],$_ARRAY['portfolio_categories_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['PORTFOLIO']['CATEGORY_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['PORTFOLIO']['_PLUGIN_DATA_ERROR'];
      }
    return $error;
  }

  //:: REMOVE CATEGORY FROM THE DATABSE
  function _REMOVE_CATEGORY ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->NoQuery("DELETE FROM portfolio_categories WHERE portfolio_categories_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: END CATEGORIES MANAGE






  //:: PORTFOLIO MANAGE

  //:: LISTING : HTML FIELDS
  function _ALL_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['PORTFOLIO']['ITEMS_MANAGE'],
          "group" => true,
          "special" => true
        ),

      "portfolio_title" => array (
          "options" => false,
          "translation" => $_LANG['PORTFOLIO']['ITEMS_TITLE']
        ),

      "portfolio_url" => array (
          "options" => false,
          "translation" => $_LANG['PORTFOLIO']['ITEMS_URL']
        ),

      "portfolio_status" => array (
          "options" => false,
          "translation" => $_LANG['PORTFOLIO']['ITEMS_STATUS']
        ),

      "portfolio_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_MANAGE", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['PORTFOLIO']['_PLUGIN_EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE_ITEM", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['PORTFOLIO']['_PLUGIN_REMOVE'] ),
            ),
          "translation" => $_LANG['PORTFOLIO']['_PLUGIN_OPTIONS']
        )
    );
    return $_RETURN;
  }
  //:: LISTING DATA : MYSQL DETAILS
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `portfolio_id`, `portfolio_title`, `portfolio_url`, `portfolio_category`, `portfolio_cover`, `portfolio_short_description`, `portfolio_date`, `portfolio_status` from portfolio order by portfolio_id desc");

    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'portfolio_status', '0', $_LANG['PORTFOLIO']['ITEMS_STATUS_DISABLED'] );
    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'portfolio_status', '1', $_LANG['PORTFOLIO']['ITEMS_STATUS_ENABLED'] );

    return $_RETURN;
  }

  //:: GENERATE THE HTML FIELDS FOR EDITING/ADDING CATEGORY TO THE DATABASE
  function _MANAGE_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['PORTFOLIO']['ITEM_MANAGE'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

      "portfolio_title"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "portfolio_url"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_URL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "portfolio_category"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_CATEGORY'],
          "field" => "select",
          "method" => "_CATEGORIES_LIST",
          "_ARRAY" => array(""),
          "_NO_DATA" => $_LANG['PORTFOLIO']['ITEM_NO_DATA'],
          "_SELECT_DATA" => $_LANG['PORTFOLIO']['ITEM_SELECT_CATEGORY'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "portfolio_details_date_created"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_CREATED_ON'],
          "field" => "date",
          "dateType" => "dd-mm-yyyy",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "GROUP_2"  => array(
          "translation" => $_LANG['PORTFOLIO']['ITEM_CLIENT_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),


      "portfolio_details_client"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_CLIENT'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "portfolio_details_location"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_LOCATION'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "portfolio_details_client_website"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_WEBSITE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),


      "GROUP_3"  => array(
          "translation" => $_LANG['PORTFOLIO']['ITEM_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),


      "portfolio_description"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_DESCRIPTION'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "portfolio_short_description"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_SHORT_DESCRIPTION'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "portfolio_details_case_study"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_CASE_STUDY'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "portfolio_details_our_approach"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_OUR_APPROACH'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "portfolio_details_the_result"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_THE_RESULTS'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "project_images"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_ATTACH_IMAGES'],
          "field" => "upload",
          "type" => "image",
          "length" => array("1","2","3","4","5"),
          "mandatory" => false,
          "request" => "multiple",
          "method" => "_IMAGES_LIST",
          "_ARRAY" => array(""),
          "options" => false,
          "class" => "col-md-12"
        ),


      "portfolio_cover"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_COVER'],
          "field" => "upload",
          "type" => "image",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),



      "GROUP_4"  => array(
          "translation" => $_LANG['PORTFOLIO']['ITEM_SEO_SETTINGS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),



      "portfolio_details_seo_description"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_SEO_DESCRIPTION'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "portfolio_details_seo_tags"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_SEO_TAGS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "portfolio_status"            =>array( 
          "translation" => $_LANG['PORTFOLIO']['ITEM_ITEM_STATUS'],
          "field" => "select",
          "method" => "_ITEM_STATUS",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['PORTFOLIO']['ITEM_ITEM_STATUS_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "portfolio_id"  =>array(
          "translation" => $_LANG['PORTFOLIO']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: POPULATE THE SELECT OPTION
  function _CATEGORIES_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `portfolio_categories_id` as _ID, `portfolio_categories_name` as _NAME FROM portfolio_categories order by portfolio_categories_order desc");
    return $_RETURN;
  }
  function _ITEM_STATUS ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array(
      array( "_ID" => "0", "_NAME" => $_LANG['PORTFOLIO']['ITEM_ITEM_STATUS_DISABLED'] ),
      array( "_ID" => "1", "_NAME" => $_LANG['PORTFOLIO']['ITEM_ITEM_STATUS_ENABLED'] ),
    );
    return $_RETURN;
  }
  function _IMAGES_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->Query("SELECT portfolio_images_image_location as _FILE FROM portfolio_images where portfolio_images_portfolio_id=?","i",$_ARRAY['_ID']);
    return $_RETURN;
  }


  //:: GET THE CATEGORY DETAILS FROM THE DATABASE
  function _MANAGE_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `portfolio_id`, `portfolio_title`, `portfolio_url`, `portfolio_category`, `portfolio_cover`, `portfolio_short_description`, `portfolio_description`, `portfolio_date`, `portfolio_status`, `portfolio_details_portfolio_id`, `portfolio_details_date_created`, `portfolio_details_location`, `portfolio_details_client`, `portfolio_details_client_website`, `portfolio_details_case_study`, `portfolio_details_our_approach`, `portfolio_details_the_result`, `portfolio_details_seo_tags`, `portfolio_details_seo_description` FROM portfolio left join portfolio_details on portfolio_details.portfolio_details_portfolio_id = portfolio.portfolio_id where portfolio_id=? limit 1","i",$_ARRAY['_ID']);

    if ( !empty ( $_RETURN['0']['portfolio_details_date_created'] ) ) {
      $_RETURN['0']['portfolio_details_date_created']  = date('d-m-Y', $_RETURN['0']['portfolio_details_date_created'] );
    }

    return $_RETURN;
  }



  //:: MANAGE DATA ADD / UPDATE PORTFOLIO ITEM
  function _MANAGE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['portfolio_id'] ) ) {
      $_RETURN  = $this->_ADD_ITEM ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE_ITEM ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }
      return $_RETURN;
  }



  //:: ADD NEW DATA
  function _ADD_ITEM ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    //:: portfolio
    $_ARRAY['portfolio_date']   = strtotime( "now" );
    $_ARRAY['portfolio_url']    = $_PREPARE->title( $_ARRAY['portfolio_url'] );
    $_ARRAY['portfolio_cover']  = '';

  //::: UPLOAD THE COVER FIRST
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['portfolio_cover'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_ARRAY['portfolio_cover']	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
      } else {
          //NO IMAGE UPLOADED
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

    //CREATE ITEM POST AND GET THE LAST ID
    $_RETURN = $_CONN->NoQuery("INSERT INTO portfolio VALUES(NULL,?,?,?,?,?,?,?,?)","ssssssss",$_ARRAY['portfolio_title'],$_ARRAY['portfolio_url'],$_ARRAY['portfolio_category'],$_ARRAY['portfolio_cover'],$_ARRAY['portfolio_short_description'],$_ARRAY['portfolio_description'],$_ARRAY['portfolio_date'],$_ARRAY['portfolio_status']);
    $portfolio_details_portfolio_id           = $_CONN->LastID();
    $_ARRAY['portfolio_details_portfolio_id'] = $portfolio_details_portfolio_id;


    //:: portfolio_details
    $_ARRAY['portfolio_details_date_created']    = strtotime( $_PREPARE->sanitize( $_ARRAY['portfolio_details_date_created'], 'input' ) );

    $_CONN->NoQuery("INSERT INTO portfolio_details VALUES(?,?,?,?,?,?,?,?,?,?)","ssssssssss",$_ARRAY['portfolio_details_portfolio_id'],$_ARRAY['portfolio_details_date_created'],$_ARRAY['portfolio_details_location'],$_ARRAY['portfolio_details_client'],$_ARRAY['portfolio_details_client_website'],$_ARRAY['portfolio_details_case_study'],$_ARRAY['portfolio_details_our_approach'],$_ARRAY['portfolio_details_the_result'],$_ARRAY['portfolio_details_seo_tags'],$_ARRAY['portfolio_details_seo_description']);

  //::: UPLOAD THE PICTURES
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['project_images'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          //blog_pictures
          $portfolio_images_id              = '';
          $portfolio_images_portfolio_id    = $portfolio_details_portfolio_id;
          $portfolio_images_image_location  = $_FULL_IMAGE;

          //ONCE IS UPLOADED SAVE INTO DATABASE
          $_RETURN = $_CONN->NoQuery("INSERT INTO portfolio_images VALUES(NULL,?,?)","ss",$portfolio_images_portfolio_id,$portfolio_images_image_location);
      } else {
          //NO IMAGE UPLOADED
      }
    }
  //::: /END UPLOAD THE PICTURES


    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['PORTFOLIO']['ITEM_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['PORTFOLIO']['_PLUGIN_DATA_ERROR'];
    }
    return $error;
  }


  //:: DATA UPDATE
  function _UPDATE_ITEM ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {

    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_ARRAY['portfolio_url']    = $_PREPARE->title( $_ARRAY['portfolio_url'] );
    $_ARRAY['portfolio_cover']  = '';

    $_PORTFOLIO_ID  = $_ARRAY['portfolio_id'];

    //UPDATE PORTFOLIO DETAILS AND GET THE LAST ID
    $_RETURN  = $_CONN->NoQuery("UPDATE portfolio SET portfolio_title=?, portfolio_url=?, portfolio_category=?, portfolio_short_description=?, portfolio_description=?, portfolio_status=? WHERE portfolio_id=? limit 1","sssssss",$_ARRAY['portfolio_title'],$_ARRAY['portfolio_url'],$_ARRAY['portfolio_category'],$_ARRAY['portfolio_short_description'],$_ARRAY['portfolio_description'],$_ARRAY['portfolio_status'],$_ARRAY['portfolio_id']);


  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['portfolio_cover'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['portfolio_cover'] = $_FULL_IMAGE;
          
          //:: OLD IMAGE
          $_OLD_IMAGE  = $_CONN->Query("SELECT `portfolio_cover` FROM portfolio where portfolio_id=? limit 1","s",$_ARRAY['portfolio_id']);

          if ( !empty ( $_OLD_IMAGE ) ) {
          $_FILE_LOCATION	=	_UPLOAD_DIR.$_OLD_IMAGE['0']['portfolio_cover'];
            if ( !empty ( $_OLD_IMAGE['0']['portfolio_cover'] ) ) {
              if (file_exists($_FILE_LOCATION)) {
                unlink($_FILE_LOCATION);
              }
            }
          }
          //:: /OLD IMAGE

          $_CONN->NoQuery("UPDATE portfolio SET portfolio_cover=? WHERE portfolio_id=? limit 1","ss",$_FULL_IMAGE,$_ARRAY['portfolio_id']);
      } else {
          $_ARRAY['portfolio_cover'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

    $_ARRAY['portfolio_details_portfolio_id'] = $_PORTFOLIO_ID;
    $_ARRAY['portfolio_details_date_created'] = strtotime( $_PREPARE->sanitize( $_ARRAY['portfolio_details_date_created'], 'input' ) );

    $_CONN->NoQuery("UPDATE portfolio_details SET portfolio_details_date_created=?, portfolio_details_location=?, portfolio_details_client=?, portfolio_details_client_website=?, portfolio_details_case_study=?, portfolio_details_our_approach=?, portfolio_details_the_result=?, portfolio_details_seo_tags=?, portfolio_details_seo_description=? WHERE portfolio_details_portfolio_id=? limit 1","ssssssssss",$_ARRAY['portfolio_details_date_created'],$_ARRAY['portfolio_details_location'],$_ARRAY['portfolio_details_client'],$_ARRAY['portfolio_details_client_website'],$_ARRAY['portfolio_details_case_study'],$_ARRAY['portfolio_details_our_approach'],$_ARRAY['portfolio_details_the_result'],$_ARRAY['portfolio_details_seo_tags'],$_ARRAY['portfolio_details_seo_description'],$_ARRAY['portfolio_details_portfolio_id']);


  //::: UPLOAD THE PICTURES
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['project_images'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          //blog_pictures
          $portfolio_images_id              = '';
          $portfolio_images_portfolio_id    = $_PORTFOLIO_ID;
          $portfolio_images_image_location  = $_FULL_IMAGE;

          //ONCE IS UPLOADED SAVE INTO DATABASE
          $_RETURN = $_CONN->NoQuery("INSERT INTO portfolio_images VALUES(NULL,?,?)","ss",$portfolio_images_portfolio_id,$portfolio_images_image_location);
      } else {
          //NO IMAGE UPLOADED
      }
    }
  //::: /END UPLOAD THE PICTURES


    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['PORTFOLIO']['ITEM_UPDATED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['PORTFOLIO']['_PLUGIN_DATA_ERROR'];
    }
    return $error;
  }

  //:: END PORTFOLIO MANAGE



  //:: REMOVE
  function _FILE_REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    if ( $_ARRAY['_ROUTE'] == '_MANAGE' ) {
      //:: COVER REMOVE
      if ( $_ARRAY['_FIELD'] == 'portfolio_cover' ) {
          $_VALIDATE  = $_CONN->Query("SELECT `portfolio_cover` FROM portfolio where portfolio_id=? limit 1","s",$_ARRAY['_ID']);
          if ( !empty ( $_VALIDATE ) ) {
          $_FILE_LOCATION	=	_UPLOAD_DIR.$_VALIDATE['0']['portfolio_cover'];
            if ( !empty ( $_VALIDATE['0']['portfolio_cover'] ) ) {
              if (file_exists($_FILE_LOCATION)) {
                unlink($_FILE_LOCATION);
              }
            }
            $_RETURN = $_CONN->NoQuery("UPDATE portfolio SET portfolio_cover=? WHERE portfolio_id=? limit 1","ss","",$_ARRAY['_ID']);
          } else {
            $_RETURN  = false;
          }
      }
      //:: END COVER REMOVE

      //:: ATTACHMENT REMOVE
      if ( $_ARRAY['_FIELD'] == 'project_images' ) {
          $_VALIDATE  = $_CONN->Query("SELECT `portfolio_images_image_location` FROM portfolio_images where portfolio_images_portfolio_id=? and portfolio_images_image_location=? limit 1","ss",$_ARRAY['_ID'], $_ARRAY['_FILE']);
          if ( !empty ( $_VALIDATE ) ) {
          $_FILE_LOCATION	=	_UPLOAD_DIR.$_VALIDATE['0']['portfolio_images_image_location'];
            if ( !empty ( $_VALIDATE['0']['portfolio_images_image_location'] ) ) {
              if (file_exists($_FILE_LOCATION)) {
                unlink($_FILE_LOCATION);
              }
            }
            $_RETURN = $_CONN->NoQuery("DELETE FROM portfolio_images WHERE portfolio_images_portfolio_id=? and portfolio_images_image_location=? limit 1","is",$_ARRAY['_ID'],$_ARRAY['_FILE']);
          } else {
            $_RETURN  = false;
          }
      }
      //:: END ATTACHMENT REMOVE

    }

    return $_RETURN;
  }

  //:: PROJECT REMOVE
  function _REMOVE_ITEM ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_FILES  = $_CONN->Query("SELECT `portfolio_images_id`, `portfolio_images_portfolio_id`, `portfolio_images_image_location` FROM portfolio_images where portfolio_images_portfolio_id=?","i",$_ARRAY['_ID']);

  foreach ( $_FILES as $_FILE ) {
    $_FILE_LOCATION	=	_UPLOAD_DIR.$_FILE['portfolio_images_image_location'];
    if ( !empty ( $_FILE['portfolio_images_image_location'] ) ) {
        if (file_exists($_FILE_LOCATION)) {
          unlink($_FILE_LOCATION);
        }
      }
    $_CONN->NoQuery("DELETE FROM portfolio_images WHERE portfolio_images_id=? limit 1","i",$_FILE['portfolio_images_id']);
  }

    //:: COVER REMOVE
  $_COVER_REMOVE  = $_CONN->Query("SELECT `portfolio_cover` FROM portfolio where portfolio_id=? limit 1","s",$_ARRAY['_ID']);
  if ( !empty ( $_COVER_REMOVE ) ) {
  $_FILE_LOCATION	=	_UPLOAD_DIR.$_COVER_REMOVE['0']['portfolio_cover'];
    if ( !empty ( $_COVER_REMOVE['0']['portfolio_cover'] ) ) {
        if (file_exists($_FILE_LOCATION)) {
          unlink($_FILE_LOCATION);
        }
      }
    }

    $_CONN->NoQuery("DELETE FROM portfolio_details WHERE portfolio_details_portfolio_id=? limit 1","i",$_ARRAY['_ID']);
    $_RETURN  = $_CONN->NoQuery("DELETE FROM portfolio WHERE portfolio_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }
  //:: END PROJECT REMOVE



  //:: _REQUIRED_SESSION :: JUST IF NEED AUTHENTIFICATION
  function _REQUIRED_SESSION ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = array (
      "_REQUIRED_SESSION"         => false,
      "_REQUIRED_SESSION_STRING"  => 'ADMIN_SESSION',
      "_REDIRECT_PAGE"            => 'user/login',
    );
    return $_RETURN;
  }

  function _LOAD_CSS ( $_PLUGIN, $_ROUTE ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();

    $_RETURN = $_CONN->Query("SELECT `css_id`, `css_plugin`, `css_plugin_route`, `css_info` FROM custom_css where css_plugin=? limit 1","s","_404");
    return $_RETURN;
  }

  function _CSS ( $_ARRAY ) {
    
$_RETURN = '
portfolio.portfolio-item{box-shadow:0 0 5px rgba(0,0,0,0.15);font-family:"Raleway",Arial,sans-serif;color:#fff;position:relative;float:left;overflow:hidden;margin:10px 1%;min-width:220px;width:100%;text-align:center}
portfolio.portfolio-item *{-webkit-box-sizing:border-box;box-sizing:border-box;-webkit-transition:all .3s;transition:all .3s}
portfolio.portfolio-item h3{font-size:12px;}
portfolio.portfolio-item:before,portfolio.portfolio-item:after{position:absolute;width:100%;background:#000;height:0;display:block;content:"";-webkit-transition:all .3s;transition:all .3s}
portfolio.portfolio-item:before{top:0}
portfolio.portfolio-item:after{bottom:0}
portfolio.portfolio-item img{max-width:100%;margin-bottom:-5px}
portfolio.portfolio-item figcaption{position:relative;background:#fff}
portfolio.portfolio-item h3,portfolio.portfolio-item p{margin:0;display:inline-block;width:100%}
portfolio.portfolio-item h3{width:70%;padding:12px 15px;background:#333;text-transform:uppercase;-webkit-transform:translateY(-50%) rotate(0deg) scale(1);transform:translateY(-50%) rotate(0deg) scale(1)}
portfolio.portfolio-item p{font-size:.9em;font-weight:500;background:#fff;color:#4d4d4d;padding:10px 40px 40px}
portfolio.portfolio-item a{left:0;right:0;top:0;bottom:0;position:absolute;color:#fff}
portfolio.portfolio-item.blue h3,portfolio.portfolio-item.blue:before,portfolio.portfolio-item.blue:after{background:#2980b9}
portfolio.portfolio-item.red h3,portfolio.portfolio-item.red:before,portfolio.portfolio-item.red:after{background:#c0392b}
portfolio.portfolio-item.yellow h3,portfolio.portfolio-item.yellow:before,portfolio.portfolio-item.yellow:after{background:#f39c12}
portfolio.portfolio-item.navy h3,portfolio.portfolio-item.navy:before,portfolio.portfolio-item.navy:after{background:#34495e}
portfolio.portfolio-item:hover figcaption h3,portfolio.portfolio-item.hover figcaption h3{-webkit-transform:translateY(-50%) rotate(-8deg) scale(1.1);transform:translateY(-50%) rotate(-8deg) scale(1.1)}
portfolio.portfolio-item:hover:before,portfolio.portfolio-item.hover:before,portfolio.portfolio-item:hover:after,portfolio.portfolio-item.hover:after{height:10px}

#imagelightbox{cursor:pointer;position:fixed;z-index:10000;-ms-touch-action:none;touch-action:none;-webkit-box-shadow:0 0 3.125em rgba(0,0,0,.75);box-shadow:0 0 3.125em rgba(0,0,0,.75)}#imagelightbox-loading,#imagelightbox-loading div{border-radius:50%}#imagelightbox-loading{width:2.5em;height:2.5em;background-color:#444;background-color:rgba(0,0,0,.5);position:fixed;z-index:10003;top:50%;left:50%;padding:.625em;margin:-1.25em 0 0 -1.25em;-webkit-box-shadow:0 0 2.5em rgba(0,0,0,.75);box-shadow:0 0 2.5em rgba(0,0,0,.75)}#imagelightbox-loading div{width:1.25em;height:1.25em;background-color:#fff;-webkit-animation:imagelightbox-loading .5s ease infinite;animation:imagelightbox-loading .5s ease infinite}@-webkit-keyframes imagelightbox-loading{from,to{opacity:.5;-webkit-transform:scale(.75)}50%{opacity:1;-webkit-transform:scale(1)}}@keyframes imagelightbox-loading{from,to{opacity:.5;transform:scale(.75)}50%{opacity:1;transform:scale(1)}}#imagelightbox-overlay{background-color:#fff;background-color:rgba(255,255,255,.9);position:fixed;z-index:9998;top:0;right:0;bottom:0;left:0}#imagelightbox-close{outline:none;width:2.5em;height:2.5em;text-align:left;background-color:#666;border-radius:50%;position:fixed;z-index:10002;top:2.5em;right:2.5em;-webkit-transition:color .3s ease;transition:color .3s ease}#imagelightbox-close:focus,#imagelightbox-close:hover{background-color:#111}#imagelightbox-close:after,#imagelightbox-close:before{width:2px;background-color:#fff;content:"";position:absolute;top:20%;bottom:20%;left:50%;margin-left:-1px}#imagelightbox-close:before{-webkit-transform:rotate(45deg);-ms-transform:rotate(45deg);transform:rotate(45deg)}#imagelightbox-close:after{-webkit-transform:rotate(-45deg);-ms-transform:rotate(-45deg);transform:rotate(-45deg)}#imagelightbox-caption{text-align:center;color:#fff;background-color:#666;position:fixed;z-index:10001;left:0;right:0;bottom:0;padding:.625em}#imagelightbox-nav{background-color:#444;background-color:rgba(0,0,0,.5);border-radius:20px;position:fixed;z-index:10001;left:50%;bottom:3.75em;padding:.313em;-webkit-transform:translateX(-50%);-ms-transform:translateX(-50%);transform:translateX(-50%)}#imagelightbox-nav button{width:1em;height:1em;background-color:transparent;border:1px solid #fff;border-radius:50%;display:inline-block;margin:0 .313em}#imagelightbox-nav button.active{background-color:#fff}.imagelightbox-arrow{width:3.75em;height:7.5em;background-color:#444;background-color:rgba(0,0,0,.5);vertical-align:middle;display:none;position:fixed;z-index:10001;top:50%;margin-top:-3.75em}.imagelightbox-arrow:focus,.imagelightbox-arrow:hover{outline:none;background-color:#666;background-color:rgba(0,0,0,.75)}.imagelightbox-arrow:active{background-color:#111}.imagelightbox-arrow-left{left:2.5em}.imagelightbox-arrow-right{right:2.5em}.imagelightbox-arrow:before{width:0;height:0;border:1em solid transparent;content:"";display:inline-block;margin-bottom:-.125em}.imagelightbox-arrow-left:before{border-left:none;border-right-color:#fff;margin-left:-.313em}.imagelightbox-arrow-right:before{border-right:none;border-left-color:#fff;margin-right:-.313em}#imagelightbox-caption,#imagelightbox-close,#imagelightbox-loading,#imagelightbox-nav,#imagelightbox-overlay,.imagelightbox-arrow{-webkit-animation:fade-in .25s linear;animation:fade-in .25s linear}@-webkit-keyframes fade-in{from{opacity:0}to{opacity:1}}@keyframes fade-in{from{opacity:0}to{opacity:1}}@media only screen and (max-width:41.250em){#container{width:100%}#imagelightbox-close{top:1.25em;right:1.25em}#imagelightbox-nav{bottom:1.25em}.imagelightbox-arrow{width:2.5em;height:3.75em;margin-top:-2.75em}.imagelightbox-arrow-left{left:1.25em}.imagelightbox-arrow-right{right:1.25em}}@media only screen and (max-width:20em){.imagelightbox-arrow-left{left:0}.imagelightbox-arrow-right{right:0}}
@media (max-width:1200px){ ._BLOG .post-cover img { width:100%; } }

._PORTFOLIO #project-cover {
    padding: 5px;
    background-color: #fff;
    box-shadow: 0 0 5px rgba(0,0,0,0.15);
}

._PORTFOLIO #project-images .project-image {
    padding: 5px;
    background-color: #fff;
    box-shadow: 0 0 5px rgba(0,0,0,0.15);
    float: left;
    margin-top: 10px;
    margin-right: 2px;
    margin-left: 4px;
}

._PORTFOLIO .description h3 {
    border-bottom: 1px solid #F5F5F5;
    padding-bottom: 5px;
}

._PORTFOLIO .nav-tabs-custom > .nav-tabs > li.active {
    border-top-color: #F15D58;
}

._PORTFOLIO .project-dd {
  font-size:15px;
}

._PORTFOLIO .project-dd dd {
    border-bottom: 1px solid #F5F5F5;
    padding-bottom: 10px;
    margin-bottom: 10px;
    padding-top: 5px;
    padding-left: 0px;
}

._PORTFOLIO .client-details {
    box-shadow: -1px 1px 3px rgba(0,0,0,0.15);
    padding: 10px;
    margin-bottom: 20px;
}


';
    return $_RETURN;
  }

  function _JS ( $_ARRAY ) {
    $_RETURN = '
$(function(){var t=function(){$(\'<div id="imagelightbox-loading"><div></div></div>\').appendTo("body")},o=function(){$("#imagelightbox-loading").remove()},n=function(){$(\'<div id="imagelightbox-overlay"></div>\').appendTo("body")},i=function(){$("#imagelightbox-overlay").remove()},a=function(t){$(\'<button type="button" id="imagelightbox-close" title="Close"></button>\').appendTo("body").on("click touchend",function(){return $(this).remove(),t.quitImageLightbox(),!1})},e=function(){$("#imagelightbox-close").remove()},g=function(){var t=$(\'a[href="\'+$("#imagelightbox").attr("src")+\'"] img\').attr("alt");t.length>0&&$(\'<div id="imagelightbox-caption">\'+t+"</div>").appendTo("body")},d=function(){$("#imagelightbox-caption").remove()},c=function(t,o){var n=$(o);if(n.length){for(var i=$(\'<div id="imagelightbox-nav"></div>\'),a=0;a<n.length;a++)i.append(\'<button type="button"></button>\');i.appendTo("body"),i.on("click touchend",function(){return!1});var e=i.find("button");e.on("click touchend",function(){var o=$(this);return n.eq(o.index()).attr("href")!=$("#imagelightbox").attr("src")&&t.switchImageLightbox(o.index()),e.removeClass("active"),e.eq(o.index()).addClass("active"),!1}).on("touchend",function(){return!1})}},r=function(t){var o=$("#imagelightbox-nav button");o.removeClass("active"),o.eq($(t).filter(\'[href="\'+$("#imagelightbox").attr("src")+\'"]\').index(t)).addClass("active")},u=function(){$("#imagelightbox-nav").remove()},l=function(t,o){var n=$(\'<button type="button" class="imagelightbox-arrow imagelightbox-arrow-left"></button><button type="button" class="imagelightbox-arrow imagelightbox-arrow-right"></button>\');n.appendTo("body"),n.on("click touchend",function(n){n.preventDefault();var i=$(this),a=$(o+\'[href="\'+$("#imagelightbox").attr("src")+\'"]\'),e=a.index(o);return i.hasClass("imagelightbox-arrow-left")?(e-=1,$(o).eq(e).length||(e=$(o).length)):(e+=1,$(o).eq(e).length||(e=0)),t.switchImageLightbox(e),!1})},b=function(){$(".imagelightbox-arrow").remove()};$(\'a[data-imagelightbox="a"]\').imageLightbox({onLoadStart:function(){t()},onLoadEnd:function(){o()},onEnd:function(){o()}}),$(\'a[data-imagelightbox="b"]\').imageLightbox({onStart:function(){n()},onEnd:function(){i(),o()},onLoadStart:function(){t()},onLoadEnd:function(){o()}});var h=$(\'a[data-imagelightbox="c"]\').imageLightbox({quitOnDocClick:!1,onStart:function(){a(h)},onEnd:function(){e(),o()},onLoadStart:function(){t()},onLoadEnd:function(){o()}});$(\'a[data-imagelightbox="d"]\').imageLightbox({onLoadStart:function(){d(),t()},onLoadEnd:function(){g(),o()},onEnd:function(){d(),o()}});var f=\'a[data-imagelightbox="g"]\',m=$(f).imageLightbox({onStart:function(){l(m,f)},onEnd:function(){b(),o()},onLoadStart:function(){t()},onLoadEnd:function(){$(".imagelightbox-arrow").css("display","block"),o()}}),x=\'a[data-imagelightbox="e"]\',v=$(x).imageLightbox({onStart:function(){c(v,x)},onEnd:function(){u(),o()},onLoadStart:function(){t()},onLoadEnd:function(){r(x),o()}}),s=\'a[data-imagelightbox="portfolioImage"]\',L=$(s).imageLightbox({onStart:function(){n(),a(L),l(L,s)},onEnd:function(){i(),d(),e(),b(),o()},onLoadStart:function(){d(),t()},onLoadEnd:function(){g(),o(),$(".imagelightbox-arrow").css("display","block")}})});
    ';
    return $_RETURN;
  }


  function _DESIGN_CATEGORIES ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `portfolio_categories_id`, `portfolio_categories_name`, `portfolio_categories_url`, `portfolio_categories_description`, `portfolio_categories_seo_description`, `portfolio_categories_seo_tags`, `portfolio_categories_order` from portfolio_categories order by portfolio_categories_order ASC");

    return $_RETURN;
  }

  function _CATEGORY_DETAILS ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN = $_CONN->Query("SELECT `portfolio_categories_id`, `portfolio_categories_name`, `portfolio_categories_url`, `portfolio_categories_description`, `portfolio_categories_seo_description`, `portfolio_categories_seo_tags`, `portfolio_categories_order` from portfolio_categories where portfolio_categories_url=? limit 1","s",$_ARRAY['_URL']);

    return $_RETURN;
  }

  function _PROJECTS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = '';

    if ( empty ( $_ARRAY ) ) {
        $_RETURN = $_CONN->Query("SELECT `portfolio_id`, `portfolio_title`, `portfolio_url`, `portfolio_category`, `portfolio_cover`, `portfolio_short_description`, `portfolio_description`, `portfolio_date`, `portfolio_status`, `portfolio_details_portfolio_id`, `portfolio_details_date_created`, `portfolio_details_location`, `portfolio_details_client`, `portfolio_details_client_website`, `portfolio_details_case_study`, `portfolio_details_our_approach`, `portfolio_details_the_result`, `portfolio_details_seo_tags`, `portfolio_details_seo_description` from portfolio left join portfolio_details on portfolio_details.portfolio_details_portfolio_id = portfolio.portfolio_id order by portfolio_details_date_created DESC");
    } else {
      if ( $_ARRAY['_MODE'] == '_CATEGORY' ) {
        $_RETURN = $_CONN->Query("SELECT `portfolio_id`, `portfolio_title`, `portfolio_url`, `portfolio_category`, `portfolio_cover`, `portfolio_short_description`, `portfolio_description`, `portfolio_date`, `portfolio_status`, `portfolio_details_portfolio_id`, `portfolio_details_date_created`, `portfolio_details_location`, `portfolio_details_client`, `portfolio_details_client_website`, `portfolio_details_case_study`, `portfolio_details_our_approach`, `portfolio_details_the_result`, `portfolio_details_seo_tags`, `portfolio_details_seo_description` from portfolio left join portfolio_details on portfolio_details.portfolio_details_portfolio_id = portfolio.portfolio_id where portfolio_category=? order by portfolio_details_date_created DESC","i",$_ARRAY['_CATEGORY']);
      }

      if ( $_ARRAY['_MODE'] == '_PROJECT' ) {
        $_RETURN = $_CONN->Query("SELECT `portfolio_id`, `portfolio_title`, `portfolio_url`, `portfolio_category`, `portfolio_cover`, `portfolio_short_description`, `portfolio_description`, `portfolio_date`, `portfolio_status`, `portfolio_details_portfolio_id`, `portfolio_details_date_created`, `portfolio_details_location`, `portfolio_details_client`, `portfolio_details_client_website`, `portfolio_details_case_study`, `portfolio_details_our_approach`, `portfolio_details_the_result`, `portfolio_details_seo_tags`, `portfolio_details_seo_description` from portfolio left join portfolio_details on portfolio_details.portfolio_details_portfolio_id = portfolio.portfolio_id where portfolio_url=? limit 1","s",$_ARRAY['_PROJECT']);
      }
  }

    return $_RETURN;
  }

  function _PROJECT_IMAGES ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->Query("SELECT `portfolio_images_id`, `portfolio_images_portfolio_id`, `portfolio_images_image_location` FROM portfolio_images where portfolio_images_portfolio_id=?","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: DESIGN ROUTE!
  function _DESIGN ( $_ARRAY ) {
    $_CONN                  = $this->_DB();
    $_LANG                  = $this->_LANGUAGE();
    $_PREPARE               = $this->_PREPARE();
    $_FORM                  = '';
    $_CATEGORY_DESCRIPTION  = '';
    $_GET_ROUTE             = $_ARRAY['_ROUTE'];
    //:: SPLIT ROUTE
    $_SPLIT_ROUTE = explode( "/", $_GET_ROUTE );
    $_ROUTE_COUNT = count ( $_SPLIT_ROUTE );
    $_GET_CATEGORIES  = $this->_DESIGN_CATEGORIES( $_ARRAY );

    $_PAGE  = explode("?p=", $_ARRAY['_REQUEST_URI'] );
    if ( count( $_PAGE ) > 1 ) {
      $_PAGE_NUMBER = $_PAGE['1'];
    } else {
      $_PAGE_NUMBER = 1;
    }


    if ( $_GET_ROUTE == 'portfolio' ) {
      $_BREADCRUMB  = '';
      ob_start();
      if ( file_exists ( _TMDRP.'_PORTFOLIO/homepage.breadcrumb.php' ) ) {
        include( _TMDRP.'_PORTFOLIO/homepage.breadcrumb.php' );
      } else {
        include('design/homepage.breadcrumb.php');
      }
      $_BREADCRUMB = ob_get_contents();
      ob_end_clean();


      $_PROJECTS_LIST = $this->_PROJECTS_LIST ( $_ARRAY = array() );
      //:: USE PAGINATION
      $numbers  = count ( $_PROJECTS_LIST );
      $page     = $_PAGE_NUMBER;
      $on_page	=	"12";
      $page=!empty($page)?$page:"1";
      $limitfrom=($page-1)*$on_page;
      $limitto=($page*$on_page)-($page-1)*$on_page;
      $itemsPerPage=$on_page;
          $paginator['pager']=$_PREPARE->page($page,$numbers,$itemsPerPage);
          $paginator['limitfrom']=$limitfrom+1;
          $paginator['limitto']=$limitfrom+$numbers;
          $paginator['page']=$page;

        if ( $on_page > $numbers ) {
          $paginator['pager'] = '';
        }

        if ( empty ( $_PROJECTS_LIST ) ) {
          $_PROJECTS_LIST  = '';
        } else {
          $_PROJECTS_LIST  = array_slice($_PROJECTS_LIST, $limitfrom, $limitto);
        }
      //:: USE PAGINATION

$_PROJECT = '';
if ( !empty ( $_PROJECTS_LIST ) ) {
  foreach ( $_PROJECTS_LIST as $_ITEM ) {

    ob_start();
    if ( file_exists ( _TMDRP.'_PORTFOLIO/items.list.php' ) ) {
      include( _TMDRP.'_PORTFOLIO/items.list.php' );
    } else {
      include('design/items.list.php');
    }
    $_PROJECT .= ob_get_contents();
    ob_end_clean();

  }
}

    ob_start();
    if ( file_exists ( _TMDRP.'_PORTFOLIO/items.container.php' ) ) {
      include( _TMDRP.'_PORTFOLIO/items.container.php' );
    } else {
      include('design/items.container.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();

        $_RETURN  = array (
          "SEO" => array (
            "_TITLE" => $_LANG['PORTFOLIO']['DESIGN_TITLE'],
            "_DESCRIPTION" => $_LANG['PORTFOLIO']['DESIGN_DESCRIPTION'],
            "_KEYWORDS" => $_LANG['PORTFOLIO']['DESIGN_TAGS']
            ),
          "DESIGN" => array (
            "_BREADCRUMB" => $_BREADCRUMB,
            "ICO" => '',
            "title" => $_LANG['PORTFOLIO']['DESIGN_TITLE'],
            "form" => $_FORM,
            "fields_start" =>false,
            "fields" =>false,
            "fields_end" =>false,
            "fields_data" =>false,
            "_GET_ROUTE"  => $_GET_ROUTE
          )
        );
    }

    //:: PORTFOLIO DETAILS

    if ( $_ROUTE_COUNT == 2 ) {
    $_CATEGORY_DETAILS = $this->_CATEGORY_DETAILS ( array("_URL"=> $_SPLIT_ROUTE['1']) );

    if ( empty ( $_CATEGORY_DETAILS ) ) {
      return false;
    } else {
      //:: CATEGORY EXISTS

      $_BREADCRUMB  = '';
      ob_start();
      if ( file_exists ( _TMDRP.'_PORTFOLIO/category.breadcrumb.php' ) ) {
        include( _TMDRP.'_PORTFOLIO/category.breadcrumb.php' );
      } else {
        include('design/category.breadcrumb.php');
      }
      $_BREADCRUMB = ob_get_contents();
      ob_end_clean();

      ob_start();
      if ( file_exists ( _TMDRP.'_PORTFOLIO/category.description.php' ) ) {
        include( _TMDRP.'_PORTFOLIO/category.description.php' );
      } else {
        include('design/category.description.php');
      }
      $_CATEGORY_DESCRIPTION = ob_get_contents();
      ob_end_clean();


      $_PROJECTS_LIST = $this->_PROJECTS_LIST ( array( "_MODE" =>"_CATEGORY", "_CATEGORY" => $_CATEGORY_DETAILS['0']['portfolio_categories_id'] ) );
      //:: USE PAGINATION
      $numbers  = count ( $_PROJECTS_LIST );
      $page     = $_PAGE_NUMBER;
      $on_page	=	"12";
      $page=!empty($page)?$page:"1";
      $limitfrom=($page-1)*$on_page;
      $limitto=($page*$on_page)-($page-1)*$on_page;
      $itemsPerPage=$on_page;
          $paginator['pager']=$_PREPARE->page($page,$numbers,$itemsPerPage);
          $paginator['limitfrom']=$limitfrom+1;
          $paginator['limitto']=$limitfrom+$numbers;
          $paginator['page']=$page;

        if ( $on_page > $numbers ) {
          $paginator['pager'] = '';
        }

        if ( empty ( $_PROJECTS_LIST ) ) {
          $_PROJECTS_LIST  = '';
        } else {
          $_PROJECTS_LIST  = array_slice($_PROJECTS_LIST, $limitfrom, $limitto);
        }
      //:: USE PAGINATION

    $_PROJECT = '';
    if ( !empty ( $_PROJECTS_LIST ) ) {
      foreach ( $_PROJECTS_LIST as $_ITEM ) {

        ob_start();
        if ( file_exists ( _TMDRP.'_PORTFOLIO/items.list.php' ) ) {
          include( _TMDRP.'_PORTFOLIO/items.list.php' );
        } else {
          include('design/items.list.php');
        }
        $_PROJECT .= ob_get_contents();
        ob_end_clean();

      }
    }

    ob_start();
    if ( file_exists ( _TMDRP.'_PORTFOLIO/items.container.php' ) ) {
      include( _TMDRP.'_PORTFOLIO/items.container.php' );
    } else {
      include('design/items.container.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();

        $_RETURN  = array (
          "SEO" => array (
            "_TITLE" => $_CATEGORY_DETAILS['0']['portfolio_categories_name'],
            "_DESCRIPTION" => $_CATEGORY_DETAILS['0']['portfolio_categories_seo_description'],
            "_KEYWORDS" => $_CATEGORY_DETAILS['0']['portfolio_categories_seo_tags']
            ),
          "DESIGN" => array (
            "_BREADCRUMB" => $_BREADCRUMB,
            "ICO" => '',
            "title" => $_CATEGORY_DETAILS['0']['portfolio_categories_name'],
            "form" => $_FORM,
            "fields_start" =>false,
            "fields" =>false,
            "fields_end" =>false,
            "fields_data" =>false,
            "_GET_ROUTE"  => '_PROJECT_DETAILS'
          )
        );
    }
      //:: CATEGORY EXISTS
    }

    if ( $_ROUTE_COUNT == 3 ) {

    $_PROJECT_DETAILS = $this->_PROJECTS_LIST ( array( "_MODE" =>"_PROJECT", "_PROJECT" => $_SPLIT_ROUTE['2'] ) );


    if ( empty ( $_PROJECT_DETAILS ) ) {
      return false;
    } else {
      //:: PROJECT EXISTS
      $_BREADCRUMB  = '';
      ob_start();
      if ( file_exists ( _TMDRP.'_PORTFOLIO/details.breadcrumb.php' ) ) {
        include( _TMDRP.'_PORTFOLIO/details.breadcrumb.php' );
      } else {
        include('design/details.breadcrumb.php');
      }
      $_BREADCRUMB = ob_get_contents();
      ob_end_clean();

      $_PROJECT_IMAGES  = $this->_PROJECT_IMAGES ( array( "_ID" => $_PROJECT_DETAILS['0']['portfolio_id'] ) );
      if ( empty ( $_PROJECT_IMAGES ) ) {
        $_PI_CONTAINER  = '';
      } else {
        foreach ( $_PROJECT_IMAGES as $_PI ) {
          ob_start();
          if ( file_exists ( _TMDRP.'_PORTFOLIO/images.container.php' ) ) {
            include( _TMDRP.'_PORTFOLIO/images.container.php' );
          } else {
            include('design/images.container.php');
          }
          $_PI_CONTAINER .= ob_get_contents();
          ob_end_clean();
        }
      }



    ob_start();
    if ( file_exists ( _TMDRP.'_PORTFOLIO/details.container.php' ) ) {
      include( _TMDRP.'_PORTFOLIO/details.container.php' );
    } else {
      include('design/details.container.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();


        $_RETURN  = array (
          "SEO" => array (
            "_TITLE" => $_PROJECT_DETAILS['0']['portfolio_title'],
            "_DESCRIPTION" => $_PROJECT_DETAILS['0']['portfolio_details_seo_description'],
            "_KEYWORDS" => $_PROJECT_DETAILS['0']['portfolio_details_seo_tags']
            ),
          "DESIGN" => array (
            "_BREADCRUMB" => $_BREADCRUMB,
            "ICO" => '',
            "title" => $_PROJECT_DETAILS['0']['portfolio_title'],
            "form" => $_FORM,
            "fields_start" =>false,
            "fields" =>false,
            "fields_end" =>false,
            "fields_data" =>false,
            "_GET_ROUTE"  => $_GET_ROUTE
          )
        );

    }
      //:: PROJECT EXISTS
    }


    return $_RETURN;
  }

}

//:: PAGES CLASS
$_VIEW->_PORTFOLIO  = $_PORTFOLIO  = new _PORTFOLIO;
?>