<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _TESTIMONIALS {
  function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  function _DB () {
    $_DB  = new database;
    return $_DB;
  }


  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_TEXT_TYPE = "props:['color','background-color','text-decoration','font-weight','letter-spacing','line-height','text-align','text-transform','word-spacing','text-shadow','border','border-radius','box-shadow','margin','padding']";
    $_BOX_TYPE  = "props:['background-color','border','border-top','border-right','border-bottom','border-left','border-radius','box-shadow','margin','padding']";
    
    $_COMBINED  = "props:['color','background-color','text-decoration','font-weight','letter-spacing','line-height','text-align','text-transform','word-spacing','text-shadow','border','border-top','border-right','border-bottom','border-left','border-radius','box-shadow','margin','padding','background-color','border','border-radius','box-shadow','margin','padding']";
    
    
    $_RETURN  = array (
      "name"=>"Testimonials",
      "url"=>"_TESTIMONIALS",
      "description"=>$_LANG['TESTIMONIALS']['DESCRIPTION'],
      "menu" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['TESTIMONIALS']['ALL'] ),
        "item_2" => array( "option" => false, "url" => "FIELDS/_MANAGE", "name" => $_LANG['TESTIMONIALS']['ADD'] ),
        "item_3" => array( "option" => true, "url" => "pluginUninstall", "name" => $_LANG['TESTIMONIALS']['UNINSTALL'] )
      ),
      "menu_design" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "_ALL" => "testimonials", "name" => $_LANG['TESTIMONIALS']['CUSTOMIZE'] )
      ),
      "def"  => "
      
          def: {
            '._TESTIMONIALS .page-title':{
              name: '".$_LANG['TESTIMONIALS']['CUSTOMIZE_PAGE_NAME']."',
              ".$_TEXT_TYPE."
            },
            '._TESTIMONIALS .blockquote p, blockquote footer, blockquote p':{
              name: '".$_LANG['TESTIMONIALS']['CUSTOMIZE_DETAILS']."',
              ".$_TEXT_TYPE."
            },
            '._TESTIMONIALS .blockquote .small, blockquote footer, blockquote small':{
              name: '".$_LANG['TESTIMONIALS']['CLIENT_NAME']."',
              ".$_TEXT_TYPE."
            }
          }
      
      ",
    );
    return $_RETURN;
  }

  //:: CREATE THE SUBMENU
  function _SUBMENU ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "all_testimonials" => array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['TESTIMONIALS']['ALL']
        ),
      "add_testimonials" => array (
          "url" => 'FIELDS/_MANAGE',
          "translation" => $_LANG['TESTIMONIALS']['ADD']
        )
    );
    return $_RETURN;
  }

  //:: PLUGIN INSTALL
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_MAIN_TABLE = "
      CREATE TABLE IF NOT EXISTS `testimonials` (
        `testimonial_id` int(11) NOT NULL AUTO_INCREMENT,
        `testimonial_title` varchar(150) NOT NULL,
        `testimonial_details` text NOT NULL,
        `testimonial_client` varchar(150) NOT NULL,
        `testimonial_website` varchar(150) NOT NULL,
        PRIMARY KEY (`testimonial_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_MAIN_TABLE);
    return $_RETURN;
  }

  //:: PLUGIN UNINSTALL
  function _UNINSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_TABLE = "DROP TABLE IF EXISTS `testimonials`;";
    $_RETURN  = $_CONN->NoQuery($_TABLE);
    return $_RETURN;
  }

  //:: GET THE INFO FROM THE DATABASE
  function _MANAGE_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN = $_CONN->Query("SELECT `testimonial_id`, `testimonial_title`, `testimonial_details`, `testimonial_client`, `testimonial_website` FROM testimonials where testimonial_id=? limit 1","s",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: GENERATE THE HTML FIELDS FOR EDITING/ADDING INFO TO THE DATABASE
  function _MANAGE_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP"  => array(
          "translation" => $_LANG['TESTIMONIALS']['TESTIOMONIAL_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "testimonial_title"            =>array( 
          "translation" => $_LANG['TESTIMONIALS']['NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "testimonial_client"            =>array( 
          "translation" => $_LANG['TESTIMONIALS']['CLIENT'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "testimonial_website"            =>array( 
          "translation" => $_LANG['TESTIMONIALS']['WEBSITE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "testimonial_details"          =>array(
          "translation" => $_LANG['TESTIMONIALS']['DETAILS'],
          "field" => "textarea",
          "type" => "text",
          "length" => "5",
          "mandatory" => true,
          "request" => "textarea",
          "options" => false,
          "class" => "col-md-12"
        ),
      "testimonial_id"  =>array(
          "translation" => $_LANG['TESTIMONIALS']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: INFO LISTING : HTML FIELDS
  function _ALL_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['TESTIMONIALS']['ALL'],
          "group" => true,
          "special" => true
        ),
      "testimonial_title" => array (
          "options" => false,
          "translation" => $_LANG['TESTIMONIALS']['NAME']
        ),
      "testimonial_client" => array (
          "options" => false,
          "translation" => $_LANG['TESTIMONIALS']['CLIENT']
        ),
      "testimonial_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_MANAGE", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['TESTIMONIALS']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['TESTIMONIALS']['REMOVE'] ),
            ),
          "translation" => $_LANG['TESTIMONIALS']['OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: LISTING DATA : MYSQL DETAILS
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `testimonial_title`, `testimonial_client`, `testimonial_id` FROM testimonials order by testimonial_id desc");
    return $_RETURN;
  }

  //:: MANAGE ADD / UPDATE
  function _MANAGE ( $_ARRAY ) {
    if ( empty ( $_ARRAY['testimonial_id'] ) ) {
      $_RETURN  = $this->_ADD ( $_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE ( $_ARRAY );
    }
      return $_RETURN;
  }

  //:: ADD DATA
  function _ADD ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("INSERT INTO testimonials VALUES(NULL,?,?,?,?)","ssss",$_ARRAY['testimonial_title'],$_ARRAY['testimonial_details'],$_ARRAY['testimonial_client'],$_ARRAY['testimonial_website']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['TESTIMONIALS']['ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['TESTIMONIALS']['ERROR'];
    }
    return $error;
  }

  //:: UPDATE
  function _UPDATE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("UPDATE testimonials SET testimonial_title=?, testimonial_details=?, testimonial_client=?, testimonial_website=? WHERE testimonial_id=? limit 1","sssss",$_ARRAY['testimonial_title'],$_ARRAY['testimonial_details'],$_ARRAY['testimonial_client'],$_ARRAY['testimonial_website'],$_ARRAY['testimonial_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['TESTIMONIALS']['UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['TESTIMONIALS']['ERROR'];
      }
    return $error;
  }

  //:: REMOVE
  function _REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN  = $_CONN->NoQuery("DELETE FROM testimonials WHERE testimonial_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: _REQUIRED_SESSION :: JUST IF NEED AUTHENTIFICATION
  function _REQUIRED_SESSION ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN  = array (
      "_REQUIRED_SESSION"         => false,
      "_REQUIRED_SESSION_STRING"  => '',
      "_REDIRECT_PAGE"            => 'user/login',
    );
    return $_RETURN;
  }

  //:: DESIGN ROUTE!
  function _DESIGN ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_RETURN  = $_CONN->Query("SELECT `testimonial_id`, `testimonial_title`, `testimonial_details`, `testimonial_client`, `testimonial_website` FROM testimonials order by testimonial_id desc");

    $_FORM   =  '<div class="testimonials-plugin">';

    foreach ( $_RETURN as $_TESTIMONIAL ) {
      
      $_DETAILS = $_PREPARE->sanitize( $_TESTIMONIAL['testimonial_details'], 'textarea-decode' );
      
      $_FORM  .=  '<blockquote>';
      $_FORM  .=  '<p>'. $_DETAILS .'</p>';
      $_FORM  .=  '';
      $_FORM  .=  '<small>'.$_TESTIMONIAL['testimonial_client'].' <cite title="'.$_TESTIMONIAL['testimonial_website'].'">'.$_TESTIMONIAL['testimonial_website'].'</cite></small>';
      $_FORM  .=  '</blockquote>';
    }

    $_FORM  .=  '</div>';

    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_LANG['TESTIMONIALS']['SEO_TITLE'],
        "_DESCRIPTION" => $_LANG['TESTIMONIALS']['SEO_DESCRIPTION'],
        "_KEYWORDS" => $_LANG['TESTIMONIALS']['SEO_KEYWORDS']
        ),
      "DESIGN" => array (
        "ICO" => '<i class="fa fa-fw fa-users"></i>',
        "title" => $_LANG['TESTIMONIALS']['TITLE'],
        "form" => $_FORM,
        "fields_start" =>false,
        "fields" =>false,
        "fields_end" =>false,
        "fields_data" =>false,
        "_GET_ROUTE"  => ''
      )
    );

    return $_RETURN;
  }

  //:: SLIDER
  function _SLIDER ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = $_CONN->Query("SELECT `testimonial_id`, `testimonial_title`, `testimonial_details`, `testimonial_client`, `testimonial_website` FROM testimonials order by testimonial_id desc");

    //::  DEFINE VARIABLED
    $_IMAGES            = '';
    $_IMAGES_CONTAINER  = '';
    $_IMAGES_START      = '<div class="carousel-inner">';
    $_IMAGES_END        = '</div>';
    
    $_PREV_NEXT         = '';
    
    $t                  = 0;
    $i                  = 0;

  if ( !empty ( $_RETURN ) ) {
    foreach ( $_RETURN as $_IMAGE ) {
        if ( $i == 0 ) {
          $_ACTIVE  = ' class="item active"';
        } else {
          $_ACTIVE  = ' class="item"';
        }

    ob_start();
    if ( file_exists ( _TMDRP.'_TESTIMONIALS/testimonials.list.php' ) ) {
      include( _TMDRP.'_TESTIMONIALS/testimonials.list.php' );
    } else {
      include('design/testimonials.list.php');
    }
    $_IMAGES_CONTAINER .= ob_get_contents();
    ob_end_clean();


        $i++;
    }
  }


    $_IMAGES  = $_IMAGES_START.$_IMAGES_CONTAINER.$_IMAGES_END;

    ob_start();
    if ( file_exists ( _TMDRP.'_TESTIMONIALS/testimonials.menu.php' ) ) {
      include( _TMDRP.'_TESTIMONIALS/testimonials.menu.php' );
    } else {
      include('design/testimonials.menu.php');
    }
    $_PREV_NEXT = ob_get_contents();
    ob_end_clean();


    ob_start();
    if ( file_exists ( _TMDRP.'_SLIDER/testimonials.container.php' ) ) {
      include( _TMDRP.'_SLIDER/testimonials.container.php' );
    } else {
      include('design/testimonials.container.php');
    }
    $_SLIDER = ob_get_contents();
    ob_end_clean();


  if ( empty ( $_RETURN ) ) {
    $_SLIDER  = false;
  }

    return $_SLIDER;
  }

  function _LOAD_CSS ( $_PLUGIN, $_ROUTE ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `css_id`, `css_plugin`, `css_plugin_route`, `css_info` FROM custom_css where css_plugin=? limit 1","s","_TESTIMONIALS");
    return $_RETURN;
  }

}

//:: PAGES CLASS
$_VIEW->_TESTIMONIALS  = $_TESTIMONIALS  = new _TESTIMONIALS;
?>