<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _USER {
  function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  function _PLUGINS () {
    $_PLUGINS = new plugins();
    return $_PLUGINS;
  }

  function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  function _DB () {
    $_DB  = new database;
    return $_DB;
  }

  function _SMTP () {
    $_ADMIN       = new _ADMINISTRATORS;
    $_SMTP        = $_ADMIN->_SMTP_FIELDS_LIST( array() );
    return $_SMTP;
  }

  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_INFO  = array (
      "name"=>$_LANG['USER']['INFO_NAME'] ,
      "url"=>"_USER",
      "description"=>$_LANG['USER']['INFO_DESCRIPTION'],
      "menu" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['USER']['ALL'] ),
        "item_2" => array( "option" => false, "url" => "FIELDS/_MANAGE", "name" => $_LANG['USER']['ADD'] ),
        "item_3" => array( "option" => false, "url" => "LIST/_GROUPS", "name" => $_LANG['USER']['ALL_GROUPS'] ),
        "item_4" => array( "option" => false, "url" => "FIELDS/_GROUP", "name" => $_LANG['USER']['ADD_GROUP'] ),
        "item_5" => array( "option" => false, "url" => "FIELDS/_GROUP_USER", "name" => $_LANG['USER']['ADD_GROUP_USER'] ),
        "item_6" => array( "option" => false, "url" => "LIST/_GROUP_USERS", "name" => $_LANG['USER']['ALL_GROUP_USER'] ),
        "item_7" => array( "option" => false, "url" => "FIELDS/_SETTINGS", "name" => $_LANG['USER']['SETTINGS'] ),
        "item_8" => array( "option" => true, "url" => "pluginUninstall", "name" => $_LANG['USER']['INFO_UNINSTALL'] )
      ),
    );
    return $_INFO;
  }



  //:: DESIGN THE WIDGET
  function _WIDGET ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();

    $_WIDGET_ARRAY = $_CONN->Query("SELECT `user_status` FROM users");
    $_COUNT = count ( $_WIDGET_ARRAY );
    $_FORM  = '';


    ob_start();
    if ( file_exists ( _TMDRP.'_USER/admin.widget.php' ) ) {
      include( _TMDRP.'_USER/admin.widget.php' );
    } else {
      include('design/admin.widget.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();

    return $_FORM;
  }


  //:: CREATE THE SUBMENU
  function _SUBMENU ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "all_users" => array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['USER']['ALL']
        ),
      "add_user" => array (
          "url" => 'FIELDS/_MANAGE',
          "translation" => $_LANG['USER']['ADD']
        ),
      "all_groups" => array (
          "url" => 'LIST/_GROUPS',
          "translation" => $_LANG['USER']['ALL_GROUPS']
        ),
      "add_group" => array (
          "url" => 'FIELDS/_GROUP',
          "translation" => $_LANG['USER']['ADD_GROUP']
        ),
      "plugin_settings" => array (
          "url" => 'FIELDS/_SETTINGS',
          "translation" => $_LANG['USER']['SETTINGS']
        )
    );
    return $_RETURN;
  }


  //:: PLUGIN INSTALL
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_INSTALL_USERS = "
      CREATE TABLE IF NOT EXISTS `users` (
        `user_id` int(11) NOT NULL AUTO_INCREMENT,
        `user_group` int(50) NOT NULL,
        `user_email` varchar(150) NOT NULL,
        `user_password` varchar(150) NOT NULL,
        `user_short_name` varchar(150) NOT NULL,
        `user_registered_date` int(50) NOT NULL,
        `user_session` varchar(150) NOT NULL,
        `user_status` int(11) NOT NULL,
        PRIMARY KEY (`user_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_CONN->NoQuery($_INSTALL_USERS);

    $_INSTALL_GROUPS = "
      CREATE TABLE IF NOT EXISTS `users_groups` (
        `users_groups_id` int(11) NOT NULL AUTO_INCREMENT,
        `users_groups_name` varchar(150) NOT NULL,
        `users_groups_ico` varchar(250) NOT NULL,
        `users_groups_order` int(11) NOT NULL,
        PRIMARY KEY (`users_groups_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_CONN->NoQuery($_INSTALL_GROUPS);

    $_INSTALL_USERS_GROUPS = "
      CREATE TABLE IF NOT EXISTS `users_groups_list` (
        `users_groups_list_id` int(11) NOT NULL AUTO_INCREMENT,
        `users_groups_list_user_id` int(11) NOT NULL,
        `users_groups_list_group_id` int(11) NOT NULL,
        PRIMARY KEY (`users_groups_list_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_CONN->NoQuery($_INSTALL_USERS_GROUPS);

    $_INSTALL_USERS_PROFILES = "
      CREATE TABLE IF NOT EXISTS `users_profiles` (
        `users_profiles_user_id` int(11) NOT NULL,
        `users_profiles_picture` varchar(150) NOT NULL,
        `users_profiles_first_name` varchar(150) NOT NULL,
        `users_profiles_last_name` varchar(150) NOT NULL,
        `users_profiles_birthday` varchar(50) CHARACTER SET utf8 COLLATE utf8_estonian_ci NOT NULL,
        `users_profiles_gender` int(11) NOT NULL,
        PRIMARY KEY (`users_profiles_user_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
    ";
    $_CONN->NoQuery($_INSTALL_USERS_PROFILES);


    $_INSTALL_PLUGIN_SETTINGS = "
      CREATE TABLE IF NOT EXISTS `users_plugin_settings` (
        `users_plugin_settings_id` int(11) NOT NULL AUTO_INCREMENT,
        `users_plugin_settings_enable` int(11) NOT NULL,
        `users_plugin_default_status` int(11) NOT NULL,
        `users_plugin_settings_description_top` text NOT NULL,
        `users_plugin_settings_description_bottom` text NOT NULL,
        `users_plugin_settings_code` text NOT NULL,
        `users_plugin_settings_seo_title` varchar(150) NOT NULL,
        `users_plugin_settings_seo_keywords` varchar(150) NOT NULL,
        `users_plugin_settings_seo_description` varchar(250) NOT NULL,
        `users_plugin_settings_log_in_description_top` text NOT NULL,
        `users_plugin_settings_log_in_description_bottom` text NOT NULL,
        `users_plugin_settings_log_in_code` text NOT NULL,
        `users_plugin_settings_log_in_seo_title` varchar(150) NOT NULL,
        `users_plugin_settings_log_in_seo_keywords` varchar(150) NOT NULL,
        `users_plugin_settings_log_in_seo_description` varchar(250) NOT NULL,
        `users_plugin_settings_recover_description_top` text NOT NULL,
        `users_plugin_settings_recover_description_bottom` text NOT NULL,
        `users_plugin_settings_recover_code` text NOT NULL,
        `users_plugin_settings_recover_seo_title` varchar(150) NOT NULL,
        `users_plugin_settings_recover_seo_keywords` varchar(150) NOT NULL,
        `users_plugin_settings_recover_seo_description` varchar(250) NOT NULL,
        `users_plugin_settings_status` int(11) NOT NULL,
        PRIMARY KEY (`users_plugin_settings_id`)
      ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;
    ";
    $_CONN->NoQuery($_INSTALL_PLUGIN_SETTINGS);


    $_INSTALL_PLUGIN_SETTINGS_DATA = "
      INSERT INTO `users_plugin_settings` (`users_plugin_settings_id`, `users_plugin_settings_enable`, `users_plugin_default_status`, `users_plugin_settings_description_top`, `users_plugin_settings_description_bottom`, `users_plugin_settings_code`, `users_plugin_settings_seo_title`, `users_plugin_settings_seo_keywords`, `users_plugin_settings_seo_description`, `users_plugin_settings_log_in_description_top`, `users_plugin_settings_log_in_description_bottom`, `users_plugin_settings_log_in_code`, `users_plugin_settings_log_in_seo_title`, `users_plugin_settings_log_in_seo_keywords`, `users_plugin_settings_log_in_seo_description`, `users_plugin_settings_recover_description_top`, `users_plugin_settings_recover_description_bottom`, `users_plugin_settings_recover_code`, `users_plugin_settings_recover_seo_title`, `users_plugin_settings_recover_seo_keywords`, `users_plugin_settings_recover_seo_description`, `users_plugin_settings_status`) VALUES
      (1, 1, 1, '', '', '', 'Sign up - Please complete the following form', '', '', '', '', '', 'Log in', '', '', '', '', '', 'Password recover', '', '', 1);
    ";
    $_CONN->NoQuery($_INSTALL_PLUGIN_SETTINGS_DATA);




    $_INSTALL_USERS_CONTACT = "
      CREATE TABLE IF NOT EXISTS `users_contact` (
        `users_contact_user_id` int(11) NOT NULL,
        `users_contact_profiles_phone` varchar(150) NOT NULL,
        `users_contact_profiles_website` varchar(150) NOT NULL,
        `users_contact_country` varchar(150) NOT NULL,
        `users_contact_full_address` varchar(250) NOT NULL,
        `users_contact_city` varchar(150) CHARACTER SET utf16 NOT NULL,
        `users_contact_state` varchar(150) NOT NULL,
        PRIMARY KEY (`users_contact_user_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
    ";
    $_RETURN  = $_CONN->NoQuery($_INSTALL_USERS_CONTACT);

    return $_RETURN;
  }


  //:: PLUGIN UNINSTALL
  function _UNINSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_UNINSTALL = "
      DROP TABLE IF EXISTS `users`;
      DROP TABLE IF EXISTS `users_profiles`;
      DROP TABLE IF EXISTS `users_contact`;
      DROP TABLE IF EXISTS `users_groups`;
      DROP TABLE IF EXISTS `users_groups_list`;
      DROP TABLE IF EXISTS `users_plugin_settings`;
    ";
    $_RETURN  = $_CONN->MultiNoQuery($_UNINSTALL);
    return $_RETURN;
  }

  //:: INFO LISTING : HTML FIELDS
  function _ALL_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['USER']['ALL_USERS'],
          "group" => true,
          "special" => true
        ),
      "user_status" => array (
          "options" => false,
          "translation" => $_LANG['USER']['USERS_STATUS']
        ),
      "user_registered_date" => array (
          "options" => false,
          "translation" => $_LANG['USER']['REGISTERED_DATE'],
          "type"        => 'date'
        ),
      "user_email" => array (
          "options" => false,
          "translation" => $_LANG['USER']['EMAIL']
        ),
      "users_profiles_first_name" => array (
          "options" => false,
          "translation" => $_LANG['USER']['FIRST_NAME']
        ),
      "users_profiles_last_name" => array (
          "options" => false,
          "translation" => $_LANG['USER']['LAST_NAME']
        ),
      "user_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_MANAGE", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['USER']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['USER']['REMOVE'] ),
            ),
          "translation" => $_LANG['USER']['OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: LISTING DATA : MYSQL DETAILS
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_PREPARE = new prepare;
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `user_id`, `user_registered_date`, `user_email`, `users_profiles_first_name`, `users_profiles_last_name`, `user_status` FROM users left join users_profiles on users_profiles.users_profiles_user_id = users.user_id order by user_id desc");
    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'user_status', '0', $_LANG['USER']['USERS_STATUS_DISABLED'] );
    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'user_status', '1', $_LANG['USER']['USERS_STATUS_APPROVED'] );
    return $_RETURN;
  }

  //:: GET THE INFO FROM THE DATABASE
  function _MANAGE_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN = $_CONN->Query("SELECT `user_id`, `user_group`, `user_email`, `user_password`, `user_short_name`, `user_registered_date`, `user_session`, `user_status`, `users_profiles_user_id`, `users_profiles_picture`, `users_profiles_first_name`, `users_profiles_last_name`, `users_profiles_birthday`, `users_profiles_gender`, `users_contact_user_id`, `users_contact_profiles_phone`, `users_contact_profiles_website`, `users_contact_country`, `users_contact_full_address`, `users_contact_city`, `users_contact_state` FROM users left join users_profiles on users_profiles.users_profiles_user_id = users.user_id left join users_contact on users_contact.users_contact_user_id = users.user_id where user_id=? limit 1","s",$_ARRAY['_ID']);
    
    if ( !empty ( $_RETURN['0']['users_profiles_birthday'] ) ) {
      $_RETURN['0']['users_profiles_birthday']  = date('d-m-Y', $_RETURN['0']['users_profiles_birthday'] );
    }
    return $_RETURN;
  }

  //:: GENERATE THE HTML FIELDS FOR EDITING/ADDING INFO TO THE DATABASE
  function _MANAGE_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "require_validation"  => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['USER']['FORM_GROUP_1'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_profiles_first_name"            =>array( 
          "translation" => $_LANG['USER']['FIRST_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_profiles_last_name"            =>array( 
          "translation" => $_LANG['USER']['LAST_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_profiles_birthday"            =>array( 
          "translation" => $_LANG['USER']['BIRTHDAY'],
          "field" => "date",
          "dateType" => "dd-mm-yyyy",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_profiles_gender"            =>array( 
          "translation" => $_LANG['USER']['GENDER'],
          "field" => "select",
          "method" => "_USER_GENDER",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['USER']['GENDER_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "GROUP_2"  => array(
          "translation" => $_LANG['USER']['FORM_GROUP_2'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "user_short_name"            =>array( 
          "translation" => $_LANG['USER']['SHORT_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "user_email"            =>array( 
          "translation" => $_LANG['USER']['EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "email",
          "options" => false,
          "class" => "col-md-6"
        ),
      "user_password"            =>array( 
          "translation" => $_LANG['USER']['PASSWORD'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "password",
          "options" => false,
          "class" => "col-md-6"
        ),
      "user_status"            =>array( 
          "translation" => $_LANG['USER']['STATUS'],
          "field" => "select",
          "method" => "_USER_STATUS",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['USER']['STATUS_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_profiles_picture"            =>array( 
          "translation" => $_LANG['USER']['IMAGE'],
          "field" => "upload",
          "type" => "image",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "GROUP_3"  => array(
          "translation" => $_LANG['USER']['FORM_GROUP_3'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_contact_profiles_phone"            =>array( 
          "translation" => $_LANG['USER']['PHONE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_contact_profiles_website"            =>array( 
          "translation" => $_LANG['USER']['WEBSITE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_contact_country"            =>array( 
          "translation" => $_LANG['USER']['COUNTRY'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_contact_state"            =>array( 
          "translation" => $_LANG['USER']['STATE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_contact_city"            =>array( 
          "translation" => $_LANG['USER']['CITY'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_contact_full_address"            =>array( 
          "translation" => $_LANG['USER']['FULL_ADDRESS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "user_group"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "user_registered_date"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "user_session"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_profiles_user_id"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_contact_user_id"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "user_id"  =>array(
          "translation" => $_LANG['USER']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  function _USER_GROUP ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `users_groups_id` as _ID, `users_groups_name` as _NAME FROM users_groups");
    return $_RETURN;
  }

  function _USERS ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `user_id` as _ID, concat(users_profiles_last_name,' ', users_profiles_first_name,' ( ',user_email ,' ) ') as _NAME FROM users left join users_profiles on users_profiles.users_profiles_user_id = users.user_id");
    return $_RETURN;
  }

  function _USER_STATUS ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array(
      array( "_ID" => "0", "_NAME" => $_LANG['USER']['STATUS_DISABLED'] ),
      array( "_ID" => "1", "_NAME" => $_LANG['USER']['STATUS_ENABLED'] ),
    );
    return $_RETURN;
  }

  function _USER_GENDER ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array(
      array( "_ID" => "1", "_NAME" => $_LANG['USER']['GENDER_MALE'] ),
      array( "_ID" => "2", "_NAME" => $_LANG['USER']['GENDER_FEMALE'] ),
    );
    return $_RETURN;
  }


  function _SETTINGS_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "require_validation"  => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['USER']['SETTINGS_FORM_SIGN_UP'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_plugin_settings_enable"            =>array( 
          "translation" => $_LANG['USER']['SIGN_UP_STATUS'],
          "field" => "select",
          "method" => "_PLUGIN_STATUS",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['USER']['SIGN_UP_STATUS_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_default_status"            =>array( 
          "translation" => $_LANG['USER']['SIGN_UP_DEFAULT_STATUS'],
          "field" => "select",
          "method" => "_SIGN_UP_STATUS",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['USER']['SIGN_UP_DEFAULT_STATUS_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      // REGISTER PAGE SETTINGS
      "users_plugin_settings_description_top"          =>array(
          "translation" => $_LANG['USER']['SIGN_UP_DESCRIPTION_TOP'],
          "field" => "editor",
          "type" => "text",
          "length" => "NULL",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_settings_description_bottom"          =>array(
          "translation" => $_LANG['USER']['SIGN_UP_DESCRIPTION_BOTTOM'],
          "field" => "editor",
          "type" => "text",
          "length" => "NULL",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_settings_code"          =>array(
          "translation" => $_LANG['USER']['SIGN_UP_CODE'],
          "field" => "textarea",
          "type" => "text",
          "length" => "5",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-12"
        ),
      "users_plugin_settings_seo_title"            =>array( 
          "translation" => $_LANG['USER']['SEO_TITLE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_settings_seo_keywords"            =>array( 
          "translation" => $_LANG['USER']['SEO_KEYWORDS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_settings_seo_description"          =>array(
          "translation" => $_LANG['USER']['SEO_DESCRIPTION'],
          "field" => "textarea",
          "type" => "text",
          "length" => "5",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-12"
        ),
      "users_plugin_settings_status"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
        // ./REGISTER PAGE SETTINGS


      // LOG IN PAGE SETTINGS
      "GROUP_2"  => array(
          "translation" => $_LANG['USER']['SETTINGS_FORM_LOG_IN'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_plugin_settings_log_in_description_top"          =>array(
          "translation" => $_LANG['USER']['LOG_IN_DESCRIPTION_TOP'],
          "field" => "editor",
          "type" => "text",
          "length" => "NULL",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_settings_log_in_description_bottom"          =>array(
          "translation" => $_LANG['USER']['LOG_IN_DESCRIPTION_BOTTOM'],
          "field" => "editor",
          "type" => "text",
          "length" => "NULL",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_settings_log_in_code"          =>array(
          "translation" => $_LANG['USER']['LOG_IN_CODE'],
          "field" => "textarea",
          "type" => "text",
          "length" => "5",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-12"
        ),
      "users_plugin_settings_log_in_seo_title"            =>array( 
          "translation" => $_LANG['USER']['LOG_IN_SEO_TITLE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_settings_log_in_seo_keywords"            =>array( 
          "translation" => $_LANG['USER']['LOG_IN_SEO_KEYWORDS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_settings_log_in_seo_description"          =>array(
          "translation" => $_LANG['USER']['LOG_IN_SEO_DESCRIPTION'],
          "field" => "textarea",
          "type" => "text",
          "length" => "5",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-12"
        ),

      // ./LOG IN PAGE SETTINGS



      // RECOVER SETTINGS
      "GROUP_3"  => array(
          "translation" => $_LANG['USER']['SETTINGS_FORM_RECOVER'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_plugin_settings_recover_description_top"          =>array(
          "translation" => $_LANG['USER']['RECOVER_DESCRIPTION_TOP'],
          "field" => "editor",
          "type" => "text",
          "length" => "NULL",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_settings_recover_description_bottom"          =>array(
          "translation" => $_LANG['USER']['RECOVER_DESCRIPTION_BOTTOM'],
          "field" => "editor",
          "type" => "text",
          "length" => "NULL",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_settings_recover_code"          =>array(
          "translation" => $_LANG['USER']['RECOVER_CODE'],
          "field" => "textarea",
          "type" => "text",
          "length" => "5",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-12"
        ),
      "users_plugin_settings_recover_seo_title"            =>array( 
          "translation" => $_LANG['USER']['RECOVER_SEO_TITLE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_settings_recover_seo_keywords"            =>array( 
          "translation" => $_LANG['USER']['RECOVER_SEO_KEYWORDS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_plugin_settings_recover_seo_description"          =>array(
          "translation" => $_LANG['USER']['RECOVER_SEO_DESCRIPTION'],
          "field" => "textarea",
          "type" => "text",
          "length" => "5",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-12"
        ),
      // ./RECOVER SETTINGS


      "users_plugin_settings_id"  =>array(
          "translation" => $_LANG['USER']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )

    );
    return $_RETURN;
  }

  function _PLUGIN_STATUS ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array(
      array( "_ID" => "0", "_NAME" => $_LANG['USER']['PLUGIN_STATUS_DISABLED'] ),
      array( "_ID" => "1", "_NAME" => $_LANG['USER']['PLUGIN_STATUS_ENABLED'] ),
    );
    return $_RETURN;
  }

  function _SIGN_UP_STATUS ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array(
      array( "_ID" => "0", "_NAME" => $_LANG['USER']['SIGN_UP_DEFAULT_STATUS_DISABLE'] ),
      array( "_ID" => "1", "_NAME" => $_LANG['USER']['SIGN_UP_DEFAULT_STATUS_ENABLE'] )
    );
    return $_RETURN;
  }


  //:: GROUPS LISTINGS
  function _GROUPS_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['USER']['GROUPS_ALL'],
          "group" => true,
          "special" => true
        ),
      "users_groups_name" => array (
          "options" => false,
          "translation" => $_LANG['USER']['GROUPS_NAME']
        ),
      "users_groups_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_GROUP", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['USER']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE_GROUP", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['USER']['REMOVE'] ),
            ),
          "translation" => $_LANG['USER']['OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: LISTING DATA : GROUPS DB
  function _GROUPS_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_PREPARE = new prepare;
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `users_groups_id`, `users_groups_name`, `users_groups_ico`, `users_groups_order` FROM users_groups order by users_groups_order desc");
    return $_RETURN;
  }

  //:: ADD GROUP
  function _GROUP_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['USER']['GROUPS_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_groups_name"            =>array( 
          "translation" => $_LANG['USER']['GROUPS_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_groups_order"            =>array( 
          "translation" => $_LANG['USER']['GROUPS_ORDER'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_groups_ico"            =>array( 
          "translation" => $_LANG['USER']['GROUPS_ICO'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "users_groups_id"  =>array(
          "translation" => $_LANG['USER']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: GET THE GROUP DETAILS FROM THE DATABASE
  function _GROUP_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN = $_CONN->Query("SELECT `users_groups_id`, `users_groups_name`, `users_groups_ico`, `users_groups_order` FROM users_groups where users_groups_id=? limit 1","s",$_ARRAY['_ID']);

    return $_RETURN;
  }

  //:: MANAGE ADD / UPDATE
  function _GROUP ( $_ARRAY ) {
    if ( empty ( $_ARRAY['users_groups_id'] ) ) {
      $_RETURN  = $this->_ADD_GROUP ( $_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE_GROUP ( $_ARRAY );
    }
      return $_RETURN;
  }

  //:: ADD _GROUP
  function _ADD_GROUP ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("INSERT INTO users_groups VALUES(NULL,?,?,?)","sss",$_ARRAY['users_groups_name'],$_ARRAY['users_groups_ico'],$_ARRAY['users_groups_order']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['USER']['GROUPS_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['ERROR'];
    }
    return $error;
  }

  //:: UPDATE _GROUP
  function _UPDATE_GROUP ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("UPDATE users_groups SET users_groups_name=?, users_groups_ico=?, users_groups_order=? WHERE users_groups_id=? limit 1","ssss",$_ARRAY['users_groups_name'],$_ARRAY['users_groups_ico'],$_ARRAY['users_groups_order'],$_ARRAY['users_groups_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['USER']['GROUPS_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['USER']['ERROR'];
      }
    return $error;
  }


  //:: REMOVE GROUP
  function _REMOVE_GROUP ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN  = $_CONN->NoQuery("DELETE FROM users_groups WHERE users_groups_id=? limit 1","i",$_ARRAY['_ID']);
    if ( $_RETURN ) {
      //:: REMOVE GROUP ID FROM USERS
      $_CONN->NoQuery("UPDATE users SET user_group=? WHERE user_group=? limit 1","si",'0',$_ARRAY['_ID']);
    }
    return $_RETURN;
  }


  //:: USERS ADDED TO THE GROUPS : LISTINGS
  function _GROUP_USERS_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['USER']['GROUPS_USERS_ADDED'],
          "group" => true,
          "special" => true
        ),
      "users_groups_name" => array (
          "options" => false,
          "translation" => $_LANG['USER']['GROUPS_GROUP_NAME']
        ),
      "_NAME" => array (
          "options" => false,
          "translation" => $_LANG['USER']['GROUPS_USER_NAME']
        ),
      "users_groups_list_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_GROUP_USER", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['USER']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE_USER_GROUP", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['USER']['REMOVE'] ),
            ),
          "translation" => $_LANG['USER']['OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: ./USERS ADDED TO THE GROUPS : LISTINGS

  //:: LISTING DATA : USERS ADDED TO THE GROUPS
  function _GROUP_USERS_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_PREPARE = new prepare;
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `users_groups_list_id`, `users_groups_list_user_id`, `users_groups_list_group_id`, `users_groups_name`, concat(users_profiles_last_name,' ', users_profiles_first_name) as _NAME FROM users_groups_list left join users_groups on users_groups.users_groups_id = users_groups_list.users_groups_list_group_id left join users_profiles on users_profiles.users_profiles_user_id = users_groups_list.users_groups_list_user_id order by users_groups_list_user_id desc");
    return $_RETURN;
  }


  //:: ADD USER TO THE GROUP
  function _GROUP_USER_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['USER']['GROUPS_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_groups_list_user_id"            =>array( 
          "translation" => $_LANG['USER']['GROUPS_USER_SELECT'],
          "field" => "select",
          "method" => "_USERS",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['USER']['GROUPS_USER_SELECT_DATA'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "users_groups_list_group_id"            =>array( 
          "translation" => $_LANG['USER']['GROUPS_GROUP_SELECT'],
          "field" => "select",
          "method" => "_USER_GROUP",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['USER']['GROUPS_GROUP_SELECT_DATA'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_groups_list_id"  =>array(
          "translation" => $_LANG['USER']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  function _GROUP_USER_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `users_groups_list_id`, `users_groups_list_user_id`, `users_groups_list_group_id` FROM users_groups_list where users_groups_list_id=? limit 1","s",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: ./ ADD USER TO THE GROUP

  //:: MANAGE ADD / UPDATE : USER TO THE GROUP
  function _GROUP_USER ( $_ARRAY ) {
    $_LANG  = $this->_LANGUAGE();
    
    $_DATA_VALIDATE = $this->_USER_GROUP_VALIDATE ( $_ARRAY );
    
    if ( $_DATA_VALIDATE ) {
      if ( empty ( $_ARRAY['users_groups_list_id'] ) ) {
        $_RETURN  = $this->_ADD_USER_GROUP ( $_ARRAY );
      } else {
        $_RETURN  = $this->_UPDATE_USER_GROUP ( $_ARRAY );
      }
    } else {
      $_RETURN['code']		=	'2';
      $_RETURN['message']	=	$_LANG['USER']['GROUPS_DUBLICATE_DATA'];
    }

      return $_RETURN;
  }

  //:: VALIDATE :: USER / GROUP
  function _USER_GROUP_VALIDATE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG  = $this->_LANGUAGE();

    $_RETURN  = $_CONN->Query("SELECT `users_groups_list_id` FROM users_groups_list where users_groups_list_user_id=? and users_groups_list_group_id=? limit 1","ii",$_ARRAY['users_groups_list_user_id'],$_ARRAY['users_groups_list_group_id']);
    if ( empty ( $_RETURN ) ) {
      return true;
    } else {
      return false;
    }
  }
  //:: ./ VALIDATE :: USER / GROUP


  //:: ADD USER :: _ADD_USER_GROUP
  function _ADD_USER_GROUP ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("INSERT INTO users_groups_list VALUES(NULL,?,?)","ss",$_ARRAY['users_groups_list_user_id'],$_ARRAY['users_groups_list_group_id']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['USER']['GROUPS_USER_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['ERROR'];
    }
    return $error;
  }

  //:: UPDATE USER :: _UPDATE_USER_GROUP
  function _UPDATE_USER_GROUP ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("UPDATE users_groups_list SET users_groups_list_user_id=?, users_groups_list_group_id=? WHERE users_groups_list_id=? limit 1","sss",$_ARRAY['users_groups_list_user_id'],$_ARRAY['users_groups_list_group_id'],$_ARRAY['users_groups_list_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['USER']['GROUPS_USER_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['USER']['ERROR'];
      }
    return $error;
  }

  //:: REMOVE USER FROM THE GROUP
  function _REMOVE_USER_GROUP ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->NoQuery("DELETE FROM users_groups_list WHERE users_groups_list_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  function _SETTINGS_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN = $_CONN->Query("SELECT `users_plugin_settings_id`, `users_plugin_settings_enable`, `users_plugin_default_status`, `users_plugin_settings_description_top`, `users_plugin_settings_description_bottom`, `users_plugin_settings_code`, `users_plugin_settings_seo_title`, `users_plugin_settings_seo_keywords`, `users_plugin_settings_seo_description`, `users_plugin_settings_log_in_description_top`, `users_plugin_settings_log_in_description_bottom`, `users_plugin_settings_log_in_code`, `users_plugin_settings_log_in_seo_title`, `users_plugin_settings_log_in_seo_keywords`, `users_plugin_settings_log_in_seo_description`, `users_plugin_settings_recover_description_top`, `users_plugin_settings_recover_description_bottom`, `users_plugin_settings_recover_code`, `users_plugin_settings_recover_seo_title`, `users_plugin_settings_recover_seo_keywords`, `users_plugin_settings_recover_seo_description`, `users_plugin_settings_status` FROM users_plugin_settings where users_plugin_settings_status=? limit 1","i",1);
    return $_RETURN;
  }


  function _SETTINGS ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("UPDATE users_plugin_settings SET users_plugin_settings_enable=?, users_plugin_default_status=?, users_plugin_settings_description_top=?, users_plugin_settings_description_bottom=?, users_plugin_settings_code=?, users_plugin_settings_seo_title=?, users_plugin_settings_seo_keywords=?, users_plugin_settings_seo_description=?, users_plugin_settings_log_in_description_top=?, users_plugin_settings_log_in_description_bottom=?, users_plugin_settings_log_in_code=?, users_plugin_settings_log_in_seo_title=?, users_plugin_settings_log_in_seo_keywords=?, users_plugin_settings_log_in_seo_description=?, users_plugin_settings_recover_description_top=?, users_plugin_settings_recover_description_bottom=?, users_plugin_settings_recover_code=?, users_plugin_settings_recover_seo_title=?, users_plugin_settings_recover_seo_keywords=?, users_plugin_settings_recover_seo_description=? WHERE users_plugin_settings_id=? limit 1","sssssssssssssssssssss",$_ARRAY['users_plugin_settings_enable'],$_ARRAY['users_plugin_default_status'],$_ARRAY['users_plugin_settings_description_top'],$_ARRAY['users_plugin_settings_description_bottom'],$_ARRAY['users_plugin_settings_code'],$_ARRAY['users_plugin_settings_seo_title'],$_ARRAY['users_plugin_settings_seo_keywords'],$_ARRAY['users_plugin_settings_seo_description'],$_ARRAY['users_plugin_settings_log_in_description_top'],$_ARRAY['users_plugin_settings_log_in_description_bottom'],$_ARRAY['users_plugin_settings_log_in_code'],$_ARRAY['users_plugin_settings_log_in_seo_title'],$_ARRAY['users_plugin_settings_log_in_seo_keywords'],$_ARRAY['users_plugin_settings_log_in_seo_description'],$_ARRAY['users_plugin_settings_recover_description_top'],$_ARRAY['users_plugin_settings_recover_description_bottom'],$_ARRAY['users_plugin_settings_recover_code'],$_ARRAY['users_plugin_settings_recover_seo_title'],$_ARRAY['users_plugin_settings_recover_seo_keywords'],$_ARRAY['users_plugin_settings_recover_seo_description'],$_ARRAY['users_plugin_settings_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['USER']['SETTINGS_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['USER']['SETTINGS_ERROR'];
      }
    return $error;
  }

  //:: _VALIDATE_MANAGE DATA ADD / UPDATE
  function _VALIDATE_MANAGE ( $_ARRAY ) {
    if ( empty ( $_ARRAY['user_id'] ) ) {
      $_RETURN  = $this->_VALIDATE_ADD ( $_ARRAY );
    } else {
      $_RETURN  = $this->_VALIDATE_UPDATE ( $_ARRAY );
    }
      return $_RETURN;
  }

  function _VALIDATE_ADD ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG  = $this->_LANGUAGE();

    $_VALIDATE_SHORT_NAME  = $_CONN->Query("SELECT `user_id` FROM users where user_short_name=? and user_short_name!=? limit 1","ss",$_ARRAY['user_short_name'],"");
    if( !empty ( $_VALIDATE_SHORT_NAME ) ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['VALIDATE_SHORTNAME'];
      return $error;
      break;
    }

    $_VALIDATE_EMAIL  = $_CONN->Query("SELECT `user_id` FROM users where user_email=? limit 1","s",$_ARRAY['user_email']);
    if( !empty ( $_VALIDATE_EMAIL ) ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['VALIDATE_EMAIL'];
      return $error;
      break;
    }

      $error['code']		=	'1';
      $error['message']	=	$_LANG['USER']['VALIDATE_OK'];
      return $error;
  }

  function _VALIDATE_UPDATE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG  = $this->_LANGUAGE();

    $_VALIDATE_SHORT_NAME  = $_CONN->Query("SELECT `user_id` FROM users where user_short_name=? and user_id!=? and user_short_name!=? limit 1","sis",$_ARRAY['user_short_name'],$_ARRAY['user_id'],"");
    if( !empty ( $_VALIDATE_SHORT_NAME ) ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['VALIDATE_SHORTNAME'];
      return $error;
      break;
    }

    $_VALIDATE_EMAIL  = $_CONN->Query("SELECT `user_id` FROM users where user_email=? and user_id!=? limit 1","si",$_ARRAY['user_email'],$_ARRAY['user_id']);
    if( !empty ( $_VALIDATE_EMAIL ) ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['VALIDATE_EMAIL'];
      return $error;
      break;
    }

      $error['code']		=	'1';
      $error['message']	=	$_LANG['USER']['VALIDATE_OK'];
      return $error;
  }

  //:: MANAGE DATA ADD / UPDATE
  function _MANAGE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['user_id'] ) ) {
      $_RETURN  = $this->_ADD ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }
      return $_RETURN;
  }

  function _ADDED_MSJ ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-success">'.$_LANG['USER']['ADDED'].'</div>';
  }

  function _UPDATED_MSJ ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-success">'.$_LANG['USER']['UPDATED'].'</div>';
  }

  function _ERROR_MSJ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-danger">'.$_LANG['USER']['ERROR'].'</div>';
  }

  function _UPDATED ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-success">'.$_LANG['USER']['PROFILE_UPDATED'].'</div>';
  }

  function _ERROR ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-danger">'.$_LANG['USER']['PROFILE_ERROR'].'</div>';
  }


  //:: ADD NEW DATA
  function _ADD ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();
    

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['users_profiles_picture'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['users_profiles_picture'] = $_FULL_IMAGE;
      } else {
          $_ARRAY['users_profiles_picture'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

    //:: USERS
    $_ARRAY['user_group']           = '';
    $_ARRAY['user_email']           = $_PREPARE->sanitize( $_ARRAY['user_email'], 'input' );
    $_ARRAY['user_password']        = md5( $_PREPARE->sanitize( $_ARRAY['user_password'], 'input' ) );
    $_ARRAY['user_short_name']      = $_PREPARE->sanitize( $_ARRAY['user_short_name'], 'input' );
    $_ARRAY['user_registered_date'] = strtotime( "now" );
    $_ARRAY['user_session']         = md5( rand().strtotime( "now" ) );
    $_ARRAY['user_status']          = $_PREPARE->sanitize( $_ARRAY['user_status'], 'input' );
    
    $_RETURN = $_CONN->NoQuery("INSERT INTO users VALUES(NULL,?,?,?,?,?,?,?)","sssssss",$_ARRAY['user_group'],$_ARRAY['user_email'],$_ARRAY['user_password'],$_ARRAY['user_short_name'],$_ARRAY['user_registered_date'],$_ARRAY['user_session'],$_ARRAY['user_status']);
    if ( $_RETURN ) {
      $user_id  = $_CONN->LastID();

      //:: users_profiles
      $_ARRAY['users_profiles_user_id']     = $user_id;
      $_ARRAY['users_profiles_picture']     = $_ARRAY['users_profiles_picture'];
      $_ARRAY['users_profiles_first_name']  = $_PREPARE->sanitize( $_ARRAY['users_profiles_first_name'], 'input' );
      $_ARRAY['users_profiles_last_name']   = $_PREPARE->sanitize( $_ARRAY['users_profiles_last_name'], 'input' );
      $_ARRAY['users_profiles_birthday']    = strtotime( $_PREPARE->sanitize( $_ARRAY['users_profiles_birthday'], 'input' ) );
      $_ARRAY['users_profiles_gender']      = $_PREPARE->sanitize( $_ARRAY['users_profiles_gender'], 'input' );


      $_CONN->NoQuery("INSERT INTO users_profiles VALUES(?,?,?,?,?,?)","ssssss",$_ARRAY['users_profiles_user_id'],$_ARRAY['users_profiles_picture'],$_ARRAY['users_profiles_first_name'],$_ARRAY['users_profiles_last_name'],$_ARRAY['users_profiles_birthday'],$_ARRAY['users_profiles_gender']);

      //:: users_contact
      $_ARRAY['users_contact_user_id']          = $user_id;
      $_ARRAY['users_contact_profiles_phone']   = $_PREPARE->sanitize( $_ARRAY['users_contact_profiles_phone'], 'input' );
      $_ARRAY['users_contact_profiles_website'] = $_PREPARE->sanitize( $_ARRAY['users_contact_profiles_website'], 'input' );
      $_ARRAY['users_contact_country']          = $_PREPARE->sanitize( $_ARRAY['users_contact_country'], 'input' );
      $_ARRAY['users_contact_full_address']     = $_PREPARE->sanitize( $_ARRAY['users_contact_full_address'], 'input' );
      $_ARRAY['users_contact_city']             = $_PREPARE->sanitize( $_ARRAY['users_contact_city'], 'input' );
      $_ARRAY['users_contact_state']            = $_PREPARE->sanitize( $_ARRAY['users_contact_state'], 'input' );
      
      $_CONN->NoQuery("INSERT INTO users_contact VALUES(?,?,?,?,?,?,?)","sssssss",$_ARRAY['users_contact_user_id'],$_ARRAY['users_contact_profiles_phone'],$_ARRAY['users_contact_profiles_website'],$_ARRAY['users_contact_country'],$_ARRAY['users_contact_full_address'],$_ARRAY['users_contact_city'],$_ARRAY['users_contact_state']);
    }

    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['USER']['ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['ERROR'];
    }
    return $error;
  }





  //:: DATA UPDATE
  function _UPDATE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();
    

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['users_profiles_picture'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['users_profiles_picture'] = $_FULL_IMAGE;
          
          //:: OLD IMAGE
          $_OLD_IMAGE  = $_CONN->Query("SELECT `users_profiles_picture` FROM users_profiles where users_profiles_user_id =? limit 1","s",$_ARRAY['user_id']);

          if ( !empty ( $_OLD_IMAGE ) ) {
          $_FILE_LOCATION	=	_UPLOAD_DIR.$_OLD_IMAGE['0']['users_profiles_picture'];
            if ( !empty ( $_OLD_IMAGE['0']['users_profiles_picture'] ) ) {
              if (file_exists($_FILE_LOCATION)) {
                unlink($_FILE_LOCATION);
              }
            }
          }
          //:: /OLD IMAGE

          $_CONN->NoQuery("UPDATE users_profiles SET users_profiles_picture=? WHERE users_profiles_user_id=? limit 1","ss",$_FULL_IMAGE,$_ARRAY['user_id']);
      } else {
          $_ARRAY['users_profiles_picture'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE






    //:: USERS
    $_ARRAY['user_email']           = $_PREPARE->sanitize( $_ARRAY['user_email'], 'input' );
    $_PW                            = $_PREPARE->sanitize( $_ARRAY['user_password'], 'input' );
    $_ARRAY['user_password']        = md5( $_PREPARE->sanitize( $_ARRAY['user_password'], 'input' ) );
    $_ARRAY['user_short_name']      = $_PREPARE->sanitize( $_ARRAY['user_short_name'], 'input' );
    $_ARRAY['user_registered_date'] = strtotime( "now" );
    $_ARRAY['user_session']         = md5( rand().strtotime( "now" ) );
    $_ARRAY['user_status']          = $_PREPARE->sanitize( $_ARRAY['user_status'], 'input' );

    $_RETURN = $_CONN->NoQuery("UPDATE users SET user_group=?, user_email=?, user_short_name=?, user_status=? WHERE user_id=? limit 1","sssss",$_ARRAY['user_group'], $_ARRAY['user_email'], $_ARRAY['user_short_name'], $_ARRAY['user_status'], $_ARRAY['user_id']);
      if ( !empty ( $_PW ) ) {
        $_CONN->NoQuery("UPDATE users SET user_password=? WHERE user_id=? limit 1","si",$_ARRAY['user_password'], $_ARRAY['user_id']);
      }
    if ( $_RETURN ) {

      //:: users_profiles
      $_ARRAY['users_profiles_user_id']     = $_ARRAY['user_id'];
      $_ARRAY['users_profiles_picture']     = $_ARRAY['users_profiles_picture'];
      $_ARRAY['users_profiles_first_name']  = $_PREPARE->sanitize( $_ARRAY['users_profiles_first_name'], 'input' );
      $_ARRAY['users_profiles_last_name']   = $_PREPARE->sanitize( $_ARRAY['users_profiles_last_name'], 'input' );
      $_ARRAY['users_profiles_birthday']    = strtotime( $_PREPARE->sanitize( $_ARRAY['users_profiles_birthday'], 'input' ) );
      
      $_ARRAY['users_profiles_gender']      = $_PREPARE->sanitize( $_ARRAY['users_profiles_gender'], 'input' );
      $_CONN->NoQuery("UPDATE users_profiles SET users_profiles_first_name=?, users_profiles_last_name=?, users_profiles_birthday=?, users_profiles_gender=? WHERE users_profiles_user_id=? limit 1","ssssi",$_ARRAY['users_profiles_first_name'],$_ARRAY['users_profiles_last_name'],$_ARRAY['users_profiles_birthday'],$_ARRAY['users_profiles_gender'],$_ARRAY['users_profiles_user_id']);

      //:: users_contact
      $_ARRAY['users_contact_user_id']          = $_ARRAY['user_id'];
      $_ARRAY['users_contact_profiles_phone']   = $_PREPARE->sanitize( $_ARRAY['users_contact_profiles_phone'], 'input' );
      $_ARRAY['users_contact_profiles_website'] = $_PREPARE->sanitize( $_ARRAY['users_contact_profiles_website'], 'input' );
      $_ARRAY['users_contact_country']          = $_PREPARE->sanitize( $_ARRAY['users_contact_country'], 'input' );
      $_ARRAY['users_contact_full_address']     = $_PREPARE->sanitize( $_ARRAY['users_contact_full_address'], 'input' );
      $_ARRAY['users_contact_city']             = $_PREPARE->sanitize( $_ARRAY['users_contact_city'], 'input' );
      $_ARRAY['users_contact_state']            = $_PREPARE->sanitize( $_ARRAY['users_contact_state'], 'input' );
      
      $_CONN->NoQuery("UPDATE users_contact SET users_contact_profiles_phone=?, users_contact_profiles_website=?, users_contact_country=?, users_contact_full_address=?, users_contact_city=?, users_contact_state=? WHERE users_contact_user_id=? limit 1","ssssssi",$_ARRAY['users_contact_profiles_phone'],$_ARRAY['users_contact_profiles_website'],$_ARRAY['users_contact_country'],$_ARRAY['users_contact_full_address'],$_ARRAY['users_contact_city'],$_ARRAY['users_contact_state'],$_ARRAY['users_contact_user_id']);
    }

      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['USER']['UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['USER']['ERROR'];
      }
    return $error;
  }




  //:: REMOVE
  function _FILE_REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    if ( empty ( $_SESSION['USER_SESSION'] ) ) {
      $_VALIDATE  = $_CONN->Query("SELECT `users_profiles_picture` FROM users_profiles where users_profiles_user_id=? and users_profiles_picture=? limit 1","ss",$_ARRAY['_ID'], $_ARRAY['_FILE']);
    } else {
      $_VALIDATE  = $_CONN->Query("SELECT `users_profiles_picture` FROM users_profiles where users_profiles_user_id=? limit 1","s",$_SESSION['USER_SESSION']['0']['user_id'] );
    }

    if ( !empty ( $_VALIDATE ) ) {
    $_FILE_LOCATION	=	_UPLOAD_DIR.$_VALIDATE['0']['users_profiles_picture'];
      if ( !empty ( $_VALIDATE['0']['users_profiles_picture'] ) ) {
        if (file_exists($_FILE_LOCATION)) {
          unlink($_FILE_LOCATION);
        }
      }
      $_RETURN = $_CONN->NoQuery("UPDATE users_profiles SET users_profiles_picture=? WHERE users_profiles_user_id=? limit 1","ss","",$_ARRAY['_ID']);
    } else {
      $_RETURN  = false;
    }
    return $_RETURN;
  }



  //:: REMOVE
  function _USER_FILE_REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();

      $_VALIDATE  = $_CONN->Query("SELECT `users_profiles_picture` FROM users_profiles where users_profiles_user_id=? and users_profiles_picture=? limit 1","ss",$_SESSION['USER_SESSION']['0']['user_id'], $_ARRAY['_FILE']);

    if ( !empty ( $_VALIDATE ) ) {
    $_FILE_LOCATION	=	_UPLOAD_DIR.$_VALIDATE['0']['users_profiles_picture'];
      if ( !empty ( $_VALIDATE['0']['users_profiles_picture'] ) ) {
        if (file_exists($_FILE_LOCATION)) {
          unlink($_FILE_LOCATION);
        }
      }
      $_RETURN = $_CONN->NoQuery("UPDATE users_profiles SET users_profiles_picture=? WHERE users_profiles_user_id=? limit 1","ss","",$_ARRAY['_ID']);
    } else {
      $_RETURN  = false;
    }
    return $_RETURN;
  }



  //:: REMOVE
  function _REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN  = $_CONN->NoQuery("DELETE FROM users WHERE user_id=? limit 1","i",$_ARRAY['_ID']);
    if ( $_RETURN ) {
      $_CONN->NoQuery("DELETE FROM users_profiles WHERE users_profiles_user_id=? limit 1","i",$_ARRAY['_ID']);
      $_CONN->NoQuery("DELETE FROM users_contact WHERE users_contact_user_id=? limit 1","i",$_ARRAY['_ID']);
    }
    return $_RETURN;
  }


  //:: _REQUIRED_SESSION :: JUST IF NEED AUTHENTIFICATION
  function _REQUIRED_SESSION ( $_ARRAY ) {
    $_ROUTE        = $_ARRAY['_ROUTE'];
    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];

    $NO_SECURE  = array( "user/login", "user/register", "user/recover" );
    if (in_array($_ROUTE, $NO_SECURE)) {
      $_RETURN  = array (
        "_REQUIRED_SESSION"         => false,
        "_REQUIRED_SESSION_STRING"  => '',
        "_REDIRECT_PAGE"            => '',
      );
    } else {
      $_RETURN  = array (
        "_REQUIRED_SESSION"         => true,
        "_REQUIRED_SESSION_STRING"  => 'USER_SESSION',
        "_REDIRECT_PAGE"            => 'user/login',
      );
    }
    return $_RETURN;
  }


  function _LOAD_CSS ( $_PLUGIN, $_ROUTE ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `css_id`, `css_plugin`, `css_plugin_route`, `css_info` FROM custom_css where css_plugin=? limit 1","s","_USER");
    return $_RETURN;
  }


function _PROTECTED_UPDATE_PASSWORD ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_CONN->NoQuery("UPDATE users SET user_password=? WHERE user_id=? limit 1","si",$_ARRAY['user_password'], $_ARRAY['user_id']);
}

  //:: USER REGISTER - USED BY THE DESIGN REGISTER PAGE
  function _PROTECTION_REGISTER ( $_ARRAY ) {
    $_CONN            = $this->_DB();
    $_LANG            = $this->_LANGUAGE();
    $_PREPARE         = $this->_PREPARE();
    $_PLUGIN_SETTIGS  = $this->_SETTINGS_FIELDS_LIST( array() );


    //:: VALIDATE CAPTCHA 
    if ( $_SESSION['captcha'] != $_ARRAY['captcha'] ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['INVALID_CAPTCHA'];
      return $error;
      break;
    }

    $_VALIDATE_EMAIL  = $_CONN->Query("SELECT `user_id` FROM users where user_email=? and user_id!=? limit 1","si",$_ARRAY['user_email'],$_ARRAY['user_id']);
    if( !empty ( $_VALIDATE_EMAIL ) ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['VALIDATE_EMAIL'];
      return $error;
      break;
    }


    //:: USERS
    $_ARRAY['user_group']           = '';
    $_ARRAY['user_email']           = $_PREPARE->sanitize( $_ARRAY['user_email'], 'input' );
    $_ARRAY['user_password']        = md5( $_PREPARE->sanitize( $_ARRAY['user_password'], 'input' ) );
    $_ARRAY['user_short_name']      = '';
    $_ARRAY['user_registered_date'] = strtotime( "now" );
    $_ARRAY['user_session']         = md5( rand().strtotime( "now" ) );
    $_ARRAY['user_status']          = $_PLUGIN_SETTIGS['0']['users_plugin_default_status'];
    
    $_RETURN = $_CONN->NoQuery("INSERT INTO users VALUES(NULL,?,?,?,?,?,?,?)","sssssss",$_ARRAY['user_group'],$_ARRAY['user_email'],$_ARRAY['user_password'],$_ARRAY['user_short_name'],$_ARRAY['user_registered_date'],$_ARRAY['user_session'],$_ARRAY['user_status']);
    if ( $_RETURN ) {
      $user_id  = $_CONN->LastID();


      //:: users_profiles
      $_ARRAY['users_profiles_user_id']     = $user_id;
      $_ARRAY['users_profiles_picture']     = '';
      $_ARRAY['users_profiles_first_name']  = $_PREPARE->sanitize( $_ARRAY['users_profiles_first_name'], 'input' );
      $_ARRAY['users_profiles_last_name']   = $_PREPARE->sanitize( $_ARRAY['users_profiles_last_name'], 'input' );
      $_ARRAY['users_profiles_birthday']    = strtotime( $_PREPARE->sanitize( $_ARRAY['users_profiles_birthday'], 'input' ) );
      $_ARRAY['users_profiles_gender']      = $_PREPARE->sanitize( $_ARRAY['users_profiles_gender'], 'input' );

      $_CONN->NoQuery("INSERT INTO users_profiles VALUES(?,?,?,?,?,?)","ssssss",$_ARRAY['users_profiles_user_id'],$_ARRAY['users_profiles_picture'],$_ARRAY['users_profiles_first_name'],$_ARRAY['users_profiles_last_name'],$_ARRAY['users_profiles_birthday'],$_ARRAY['users_profiles_gender']);


      //:: users_contact
      $_ARRAY['users_contact_user_id']          = $user_id;
      $_ARRAY['users_contact_profiles_phone']   = '';
      $_ARRAY['users_contact_profiles_website'] = '';
      $_ARRAY['users_contact_country']          = '';
      $_ARRAY['users_contact_full_address']     = '';
      $_ARRAY['users_contact_city']             = '';
      $_ARRAY['users_contact_state']            = '';
      
      $_CONN->NoQuery("INSERT INTO users_contact VALUES(?,?,?,?,?,?,?)","sssssss",$_ARRAY['users_contact_user_id'],$_ARRAY['users_contact_profiles_phone'],$_ARRAY['users_contact_profiles_website'],$_ARRAY['users_contact_country'],$_ARRAY['users_contact_full_address'],$_ARRAY['users_contact_city'],$_ARRAY['users_contact_state']);

    }

    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['USER']['REGISTER_ACCOUNT_CREATED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['REGISTER_ERROR'];
    }
    return $error;

  }
  //:: ./USER REGISTER - USED BY THE DESIGN REGISTER PAGE



  //:: USER RECOVER - USED BY THE DESIGN REGISTER PAGE
  function _PROTECTION_RECOVER ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();
    $_SMTP    = $this->_SMTP();

    //:: VALIDATE CAPTCHA 
    if ( $_SESSION['captcha'] != $_ARRAY['captcha'] ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['INVALID_CAPTCHA'];
      return $error;
      break;
    }

    //:: VALIDATE ACCOUNT
    $_ARRAY['user_email']               = $_PREPARE->sanitize( $_ARRAY['user_email'], 'input' );
    $_ARRAY['users_profiles_birthday']  = strtotime( $_PREPARE->sanitize( $_ARRAY['users_profiles_birthday'], 'input' ) );
    $_ARRAY['users_profiles_gender']    = $_PREPARE->sanitize( $_ARRAY['users_profiles_gender'], 'input' );


    $_RETURN  = $_CONN->Query("SELECT `user_id` FROM users left join users_profiles on users_profiles.users_profiles_user_id = users.user_id where user_email=? and users_profiles_birthday=? and users_profiles_gender=? limit 1","sss",$_ARRAY['user_email'],$_ARRAY['users_profiles_birthday'],$_ARRAY['users_profiles_gender']);

    if ( $_RETURN ) {
$_NEW_PASSWORD  = $_PREPARE->create_password();
  //UPDATE THE PASSWORD
  $this->_PROTECTED_UPDATE_PASSWORD ( array ( "user_password" => md5( $_NEW_PASSWORD ), "user_id" => $_RETURN['0']['user_id'] ) );

$details	= '
<div class="rcmBody" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; background-color: #FFFFFF;">
<title>'.$_LANG['USER']['NEW_PASSWORD_ON'].DOMAIN_NAME.'</title>
<table cellspacing="0" cellpadding="0" width="100%"><tbody><tr><td align="center" width="100%"><br><table cellspacing="0" cellpadding="0" width="700" style="border: 1px  solid  #c7c7c7; box-shadow: 0  1px  3px  #c3c2c3; -webkit-box-shadow: 0  1px  7px  #c3c2c3; -moz-box-shadow: 0  1px  3px  #c3c2c3; -moz-background-clip: padding; -webkit-background-clip: padding-box; background-clip: padding-box; background: #fff; border-radius: 0px; padding: 5px;"><tbody><tr><td style="height: 50px; text-align: left;">'._CMS_NAME.'</td>
				</tr><tr><td style="height: 5px; background-color: #FF6600;">
				</td></tr><tr><td align="left" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; font-weight: normal; padding: 15px; background-color: #FFFFFF;">


<div>'.$_LANG['USER']['NEW_PASSOWRD'].$_NEW_PASSWORD.'</div>

<br><div style="background-color: #FFFFCC; border: 1px  solid  #FFCC00; clear: both; color: #333333; font-weight: bold; list-style: none outside none; margin-bottom: 10px; padding: 9px  10px  9px  5px;">
<ul style="list-style: none; line-height: 20px;">

<b>'.$_LANG['USER']['NP_REQUESTED_ON'].'</b>'.date("d-m-Y").'<br/>
<b>'.$_LANG['USER']['NP_IP'].'</b>'._VISITOR_IP.'<br/>


</ul></div>
<br><div style="float: right;"><a style="color: red; text-decoration: none;" href="'.HTTP_SERVER_WEBSITE.'" target="_blank">'._COPYRIGHT.'</a></div> 
<br><br><div style="text-align: center;">'.$_LANG['USER']['NP_AUTOMATICALLY_MESSAGE'].'</div>

					</td>
				</tr></tbody></table></td>
	</tr></tbody></table></div>';


  $headers = "MIME-Version: 1.0" . "\r\n";
  $headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
  $headers .= "From: \r\n";
  $subject = $_LANG['USER']['NEW_PASSWORD_ON'].DOMAIN_NAME;

  //START THE SMTP
  $smtp_email = new \PHPMailer();
  $smtp_email->IsSMTP();
  $smtp_email->SMTPDebug = 0;
  $smtp_email->SMTPAuth = 'login';
  $smtp_email->SMTPSecure = $_SMTP['0']['smtp_secure'];
  $smtp_email->Host = $_SMTP['0']['smtp_host'];
  $smtp_email->Port = $_SMTP['0']['smtp_port'];
  $smtp_email->Username = $_SMTP['0']['smtp_username'];
  $smtp_email->Password = $_SMTP['0']['smtp_password'];

	$smtp_email->SetFrom( $_SMTP['0']['smtp_set_from'], $subject);
	$smtp_email->Subject = $subject;
	$smtp_email->Body = $details;
	$smtp_email->IsHTML(true);
	$smtp_email->AddAddress( $_ARRAY['user_email'] );
	$smtp_email->Send();
  $smtp_email->ClearAddresses();






      $error['code']		=	'3';
      $error['message']	=	$_LANG['USER']['RECOVER_OK'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['RECOVER_ERROR'];
    }
    return $error;

  }
  //:: ./USER RECOVER - USED BY THE DESIGN REGISTER PAGE


  //:: DASHBOARD
  function _DASHBOARD( $_ARRAY ) {
  $_CONN              = $this->_DB();
  $_LANG              = $this->_LANGUAGE();
  $_PREPARE           = $this->_PREPARE();
  $_PLUGIN_SETTIGS    = $this->_SETTINGS_FIELDS_LIST( array() );
  $_PLUGINS           = $this->_PLUGINS();

  $_PLUGINS_LOAD      = glob(_PLUGINS_CLS."_*");
  $_INSTALLED_PLUGINS = $_PLUGINS->_INSTALLED_PLUGINS (array());




  $_WIDGETS = '';
  $_TABLES  = '';

  foreach ( $_INSTALLED_PLUGINS as $_PLUGIN ) {
    $_CLASS = $_PLUGIN['plugin_directory'];
    $_CLASS = new $_CLASS;
    $_INFO  = $_CLASS->_INFO( );
    if ( $_PLUGIN['plugin_status'] == 1 ) {
      if ( method_exists($_CLASS, '_USER_DASHBOARD_WIDGET' ) ) {
        $_WIDGETS .=  $_CLASS->_USER_DASHBOARD_WIDGET( $_ARRAY );
      }
    }
  }

  foreach ( $_INSTALLED_PLUGINS as $_PLUGIN ) {
    $_CLASS = $_PLUGIN['plugin_directory'];
    $_CLASS = new $_CLASS;
    $_INFO  = $_CLASS->_INFO( );
    if ( $_PLUGIN['plugin_status'] == 1 ) {
      if ( method_exists($_CLASS, '_USER_DASHBOARD_TABLE' ) ) {
        $_TABLES .=  $_CLASS->_USER_DASHBOARD_TABLE( $_ARRAY );
      }
    }
  }

  $_RETURN = '<div class="row">'.$_WIDGETS.'</div><div class="row"></div>'.$_TABLES;

    return $_RETURN;
  }


  //:: DESIGN ROUTE!
  function _DESIGN ( $_ARRAY ) {
    $_CONN            = $this->_DB();
    $_LANG            = $this->_LANGUAGE();
    $_PREPARE         = $this->_PREPARE();
    $_PLUGIN_SETTIGS  = $this->_SETTINGS_FIELDS_LIST( array() );
    $_PLUGINS         = $this->_PLUGINS();

    $_ROUTE        = $_ARRAY['_ROUTE'];
    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];
    if ( empty ( $_SESSION['USER_SESSION'] ) ) {
      $_GET_ROUTE_ID = '';
    } else {
      $_GET_ROUTE_ID  = $_SESSION['USER_SESSION']['0']['user_id'];
    }

    $_ALLOWED  = array( "user/login", "user/register", "user/recover", "user/profile", "user/dashboard" );
    if (in_array($_ROUTE, $_ALLOWED)) {
    $_PLUGIN_SETTINGS = $this->_SETTINGS_FIELDS_LIST( array() );

    //LOGIN PAGE
    if ( $_ROUTE == 'user/login' ) {

    if ( $_REQUEST_URI == '/user/login?m=logout' ) {
      session_destroy();
      header ( 'Location: '.HTTP_MASTER.'user/login' );
    }



      $_TITLE         = $_PLUGIN_SETTINGS['0']['users_plugin_settings_log_in_seo_title'];
      $_TITLE_SEO     = $_PLUGIN_SETTINGS['0']['users_plugin_settings_log_in_seo_title'];
      $_DESCRIPTION   = $_PLUGIN_SETTINGS['0']['users_plugin_settings_log_in_seo_description'];
      $_KEYWORDS      = $_PLUGIN_SETTINGS['0']['users_plugin_settings_log_in_seo_keywords'];


      $_FORM          = '';


    $_FIELDS  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

      "GROUP_1"  => array(
          "translation" => $_LANG['USER']['LOG_IN_ACCOUNT_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "user_email"            =>array( 
          "translation" => $_LANG['USER']['EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "email",
          "options" => false,
          "class" => "col-md-12"
        ),
      "user_password"            =>array( 
          "translation" => $_LANG['USER']['PASSWORD'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "password",
          "options" => false,
          "class" => "col-md-12"
        ),

      "captcha"            =>array( 
          "translation" => $_LANG['USER']['CAPTCHA'],
          "field" => "captcha",
          "type" => "security",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "user_id"  =>array(
          "translation" => $_LANG['USER']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10 pull-right"
        )
    );

    ob_start();
    if ( file_exists ( _TMDRP.'_USER/login.top.php' ) ) {
      include( _TMDRP.'_USER/login.top.php' );
    } else {
      include('design/login.top.php');
    }
    $_FIELDS_START = ob_get_contents();
    ob_end_clean();


    ob_start();
    if ( file_exists ( _TMDRP.'_USER/login.bottom.php' ) ) {
      include( _TMDRP.'_USER/login.bottom.php' );
    } else {
      include('design/login.bottom.php');
    }
    $_FIELDS_END = ob_get_contents();
    ob_end_clean();


      $_FIELDS_DATA   = '';
      $_GET_ROUTE     = '_LOGIN';

    }
    //./LOGIN PAGE



    //REGISTER PAGE
    if ( $_ROUTE == 'user/register' ) {

      $_TITLE         = $_PLUGIN_SETTINGS['0']['users_plugin_settings_seo_title'];
      $_TITLE_SEO     = $_PLUGIN_SETTINGS['0']['users_plugin_settings_seo_title'];
      $_DESCRIPTION   = $_PLUGIN_SETTINGS['0']['users_plugin_settings_seo_description'];
      $_KEYWORDS      = $_PLUGIN_SETTINGS['0']['users_plugin_settings_seo_keywords'];


      $_FORM          = '';

    if ( $_PLUGIN_SETTIGS['0']['users_plugin_settings_enable'] == 1 ) {
    $_FIELDS  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

      "GROUP_1"  => array(
          "translation" => $_LANG['USER']['REGISTER_ACCOUNT_PERSONAL_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

      "users_profiles_first_name"            =>array( 
          "translation" => $_LANG['USER']['FIRST_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_profiles_last_name"            =>array( 
          "translation" => $_LANG['USER']['LAST_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "users_profiles_birthday"            =>array( 
          "translation" => $_LANG['USER']['BIRTHDAY'],
          "field" => "date",
          "dateType" => "dd-mm-yyyy",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_profiles_gender"            =>array( 
          "translation" => $_LANG['USER']['GENDER'],
          "field" => "select",
          "method" => "_USER_GENDER",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['USER']['GENDER_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "GROUP_2"  => array(
          "translation" => $_LANG['USER']['REGISTER_ACCOUNT_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

      "user_email"            =>array( 
          "translation" => $_LANG['USER']['EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "email",
          "options" => false,
          "class" => "col-md-6"
        ),
      "user_password"            =>array( 
          "translation" => $_LANG['USER']['PASSWORD'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "password",
          "options" => false,
          "class" => "col-md-6"
        ),


      "captcha"            =>array( 
          "translation" => $_LANG['USER']['CAPTCHA'],
          "field" => "captcha",
          "type" => "security",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "user_id"  =>array(
          "translation" => $_LANG['USER']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10 pull-right"
        )
    );
    } else {
      $_FIELDS  = false;
      
    }


    ob_start();
    if ( file_exists ( _TMDRP.'_USER/register.top.php' ) ) {
      include( _TMDRP.'_USER/register.top.php' );
    } else {
      include('design/register.top.php');
    }
    $_FIELDS_START = ob_get_contents();
    ob_end_clean();

    ob_start();
    if ( file_exists ( _TMDRP.'_USER/register.bottom.php' ) ) {
      include( _TMDRP.'_USER/register.bottom.php' );
    } else {
      include('design/register.bottom.php');
    }
    $_FIELDS_END = ob_get_contents();
    ob_end_clean();

      $_FIELDS_DATA   = '';
      $_GET_ROUTE     = '_REGISTER';

    }
    //./REGISTER PAGE


    // RECOVER
    if ( $_ROUTE == 'user/recover' ) {

      $_TITLE         = $_PLUGIN_SETTINGS['0']['users_plugin_settings_recover_seo_title'];
      $_TITLE_SEO     = $_PLUGIN_SETTINGS['0']['users_plugin_settings_recover_seo_title'];
      $_DESCRIPTION   = $_PLUGIN_SETTINGS['0']['users_plugin_settings_recover_seo_description'];
      $_KEYWORDS      = $_PLUGIN_SETTINGS['0']['users_plugin_settings_recover_seo_keywords'];


      $_FORM          = '';


    $_FIELDS  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

      "GROUP_1"  => array(
          "translation" => $_LANG['USER']['LOG_IN_ACCOUNT_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "user_email"            =>array( 
          "translation" => $_LANG['USER']['EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "email",
          "options" => false,
          "class" => "col-md-12"
        ),

      "users_profiles_birthday"            =>array( 
          "translation" => $_LANG['USER']['BIRTHDAY'],
          "field" => "date",
          "dateType" => "dd-mm-yyyy",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_profiles_gender"            =>array( 
          "translation" => $_LANG['USER']['GENDER'],
          "field" => "select",
          "method" => "_USER_GENDER",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['USER']['GENDER_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "captcha"            =>array( 
          "translation" => $_LANG['USER']['CAPTCHA'],
          "field" => "captcha",
          "type" => "security",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "user_id"  =>array(
          "translation" => $_LANG['USER']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10 pull-right"
        )
    );



    ob_start();
    if ( file_exists ( _TMDRP.'_USER/recover.top.php' ) ) {
      include( _TMDRP.'_USER/recover.top.php' );
    } else {
      include('design/recover.top.php');
    }
    $_FIELDS_START = ob_get_contents();
    ob_end_clean();

    ob_start();
    if ( file_exists ( _TMDRP.'_USER/recover.bottom.php' ) ) {
      include( _TMDRP.'_USER/recover.bottom.php' );
    } else {
      include('design/recover.bottom.php');
    }
    $_FIELDS_END = ob_get_contents();
    ob_end_clean();




      $_FIELDS_DATA   = '';
      $_GET_ROUTE     = '_RECOVER';

    }
    // ./RECOVER




    //PROFILE PAGE
    if ( $_ROUTE == 'user/profile' ) {


      $_TITLE         = $_LANG['USER']['PROFILE_UPDATE'];
      $_TITLE_SEO     = $_LANG['USER']['PROFILE_UPDATE'];
      $_DESCRIPTION   = $_LANG['USER']['PROFILE_UPDATE'];
      $_KEYWORDS      = $_LANG['USER']['PROFILE_UPDATE'];


      $_FORM          = '';


    $_FIELDS  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "require_validation"  => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['USER']['FORM_GROUP_1'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_profiles_first_name"            =>array( 
          "translation" => $_LANG['USER']['FIRST_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_profiles_last_name"            =>array( 
          "translation" => $_LANG['USER']['LAST_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_profiles_birthday"            =>array( 
          "translation" => $_LANG['USER']['BIRTHDAY'],
          "field" => "date",
          "dateType" => "dd-mm-yyyy",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_profiles_gender"            =>array( 
          "translation" => $_LANG['USER']['GENDER'],
          "field" => "select",
          "method" => "_USER_GENDER",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['USER']['GENDER_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "GROUP_2"  => array(
          "translation" => $_LANG['USER']['FORM_GROUP_2'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "user_short_name"            =>array( 
          "translation" => $_LANG['USER']['SHORT_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "user_email"            =>array( 
          "translation" => $_LANG['USER']['EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "email",
          "options" => false,
          "class" => "col-md-6"
        ),
      "user_password"            =>array( 
          "translation" => $_LANG['USER']['PASSWORD'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => false,
          "request" => "password",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_profiles_picture"            =>array( 
          "translation" => $_LANG['USER']['IMAGE'],
          "field" => "upload",
          "type" => "image",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "GROUP_3"  => array(
          "translation" => $_LANG['USER']['FORM_GROUP_3'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_contact_profiles_phone"            =>array( 
          "translation" => $_LANG['USER']['PHONE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_contact_profiles_website"            =>array( 
          "translation" => $_LANG['USER']['WEBSITE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_contact_country"            =>array( 
          "translation" => $_LANG['USER']['COUNTRY'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_contact_state"            =>array( 
          "translation" => $_LANG['USER']['STATE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_contact_city"            =>array( 
          "translation" => $_LANG['USER']['CITY'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "users_contact_full_address"            =>array( 
          "translation" => $_LANG['USER']['FULL_ADDRESS'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "user_group"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "user_registered_date"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "user_session"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_profiles_user_id"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "users_contact_user_id"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "user_id"  =>array(
          "translation" => $_LANG['USER']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );


    ob_start();
    if ( file_exists ( _TMDRP.'_USER/profile.top.php' ) ) {
      include( _TMDRP.'_USER/profile.top.php' );
    } else {
      include('design/profile.top.php');
    }
    $_FIELDS_START = ob_get_contents();
    ob_end_clean();

    ob_start();
    if ( file_exists ( _TMDRP.'_USER/profile.bottom.php' ) ) {
      include( _TMDRP.'_USER/profile.bottom.php' );
    } else {
      include('design/profile.bottom.php');
    }
    $_FIELDS_END = ob_get_contents();
    ob_end_clean();


      $_FIELDS_START  = '';
      $_FIELDS_END    = '';
      
      $_USER_SESSION  = $_SESSION['USER_SESSION'];
      $_FIELDS_DATA   = $_CONN->Query("SELECT `user_id`, `user_group`, `user_email`, `user_password`, `user_short_name`, `user_registered_date`, `user_session`, `user_status`, `users_profiles_user_id`, `users_profiles_picture`, `users_profiles_first_name`, `users_profiles_last_name`, `users_profiles_birthday`, `users_profiles_gender`, `users_contact_user_id`, `users_contact_profiles_phone`, `users_contact_profiles_website`, `users_contact_country`, `users_contact_full_address`, `users_contact_city`, `users_contact_state` FROM users left join users_profiles on users_profiles.users_profiles_user_id = users.user_id left join users_contact on users_contact.users_contact_user_id = users.user_id where user_id=? limit 1","s",$_USER_SESSION['0']['user_id']);
    
    if ( !empty ( $_FIELDS_DATA['0']['users_profiles_birthday'] ) ) {
      $_FIELDS_DATA['0']['users_profiles_birthday']  = date('d-m-Y', $_FIELDS_DATA['0']['users_profiles_birthday'] );
    }
      $_GET_ROUTE     = '_PROFILE';

    }
    //./PROFILE PAGE


    //DASHBOARD PAGE
    if ( $_ROUTE == 'user/dashboard' ) {

      $_TITLE         = $_LANG['USER']['DASHBOARD'];
      $_TITLE_SEO     = $_LANG['USER']['DASHBOARD'];
      $_DESCRIPTION   = $_LANG['USER']['DASHBOARD'];
      $_KEYWORDS      = $_LANG['USER']['DASHBOARD'];



      $_FORM          = $this->_DASHBOARD( array() );
      $_FIELDS  = false;



    ob_start();
    if ( file_exists ( _TMDRP.'_USER/dashboard.top.php' ) ) {
      include( _TMDRP.'_USER/dashboard.top.php' );
    } else {
      include('design/dashboard.top.php');
    }
    $_FIELDS_START = ob_get_contents();
    ob_end_clean();

    ob_start();
    if ( file_exists ( _TMDRP.'_USER/dashboard.bottom.php' ) ) {
      include( _TMDRP.'_USER/dashboard.bottom.php' );
    } else {
      include('design/dashboard.bottom.php');
    }
    $_FIELDS_END = ob_get_contents();
    ob_end_clean();

      $_FIELDS_DATA   = '';
      $_GET_ROUTE     = '_LOGIN';

    }
    //./DASHBOARD PAGE





    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_TITLE_SEO,
        "_DESCRIPTION" => $_DESCRIPTION,
        "_KEYWORDS" => $_KEYWORDS
        ),
      "DESIGN" => array (
        "ICO" => '',
        "title" => $_TITLE,
        "form" => $_FORM,
        "fields_start" =>$_FIELDS_START,
        "fields" =>$_FIELDS,
        "fields_end" =>$_FIELDS_END,
        "fields_data" =>$_FIELDS_DATA,
        "_GET_ROUTE"  => $_GET_ROUTE,
        "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
        "_UPDATE_ROUTE_ID"  => false
      )
    );
  } else {
    $_RETURN  = false;
  }

    return $_RETURN;
  }

  function _VALIDATE_LOGIN ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_RETURN  = $_CONN->Query("SELECT `user_id`, `user_group`, `user_email`, `user_short_name`, `user_registered_date`, `user_session`, `user_status` FROM users where user_email=? and user_password=? limit 1","ss",$_ARRAY['user_email'],md5($_ARRAY['user_password']));
    
    return $_RETURN;
  }

  function _PROTECTION_LOGIN ( $_ARRAY ) {
    $_LANG  = $this->_LANGUAGE();
    $_CONN  = $this->_DB();

    //:: VALIDATE CAPTCHA 
    if ( $_SESSION['captcha'] != $_ARRAY['captcha'] ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['INVALID_CAPTCHA'];
      return $error;
      break;
    }


    $_VALIDATE  = $this->_VALIDATE_LOGIN( $_ARRAY );

    if ( empty ( $_VALIDATE ) ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['USER']['LOGIN_ERROR'];
    } else {

    //:: VALIDATE USER STATUS
      if ( $_VALIDATE['0']['user_status'] == 0 ) {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['USER']['LOGIN_UNAPPROVED'];
      } else {

        session_destroy();
        session_start();
        $_SESSION['USER_SESSION'] = $_VALIDATE;

        $error['redirect']		=	'user/dashboard';
        $error['code']		=	'4';
        $error['message']	=	$_LANG['USER']['LOGIN_OK'];

      }
    }

    return $error;
  }

  //:: USERS MENU / WIDGETS
  function specialMenu ( $_ARRAY ) {

  if ( empty ( $_SESSION['USER_SESSION'] ) ) {
    $_RETURN  = '';
  } else {
    $_LANG  = $this->_LANGUAGE();
    $_CONN  = $this->_DB();
    $_USER_SESSION  = $_SESSION['USER_SESSION'];
    
    $_PROFILE = $_CONN->Query("SELECT `user_id`, `user_group`, `user_email`, `user_short_name`, `user_registered_date`, `user_session`, `user_status`, `users_profiles_picture`, `users_profiles_first_name`, `users_profiles_last_name`, `users_profiles_birthday`, `users_profiles_gender` FROM users left join users_profiles on users_profiles.users_profiles_user_id = users.user_id where user_id=? limit 1","i",$_USER_SESSION['0']['user_id']);

    //:: USER PICTURE
    if ( empty ( $_PROFILE['0']['users_profiles_picture'] ) ) {
      $_USER_PICTURE  = HTTP_PLUGINS.'_USER/img/avatar.png';
    } else {
      $_USER_PICTURE  = _UPLOAD_DIR_HTTP.$_PROFILE['0']['users_profiles_picture'];
    }


    ob_start();
    if ( file_exists ( _TMDRP.'_USER/user-menu.php' ) ) {
      include( _TMDRP.'_USER/user-menu.php' );
    } else {
      include('design/user-menu.php');
    }
    $_RETURN = ob_get_contents();
    ob_end_clean();


  }
    return $_RETURN;
  }


  function _PROTECTION_PROFILE ( $_ARRAY ) {
      $_RETURN  = $this->_VALIDATE_UPDATE ( $_ARRAY );
      return $_RETURN;
  }


  function _PROFILE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();


  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['users_profiles_picture'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['users_profiles_picture'] = $_FULL_IMAGE;
          
          //:: OLD IMAGE
          $_OLD_IMAGE  = $_CONN->Query("SELECT `users_profiles_picture` FROM users_profiles where users_profiles_user_id =? limit 1","s",$_ARRAY['user_id']);

          if ( !empty ( $_OLD_IMAGE ) ) {
          $_FILE_LOCATION	=	_UPLOAD_DIR.$_OLD_IMAGE['0']['users_profiles_picture'];
            if ( !empty ( $_OLD_IMAGE['0']['users_profiles_picture'] ) ) {
              if (file_exists($_FILE_LOCATION)) {
                unlink($_FILE_LOCATION);
              }
            }
          }
          //:: /OLD IMAGE

          $_CONN->NoQuery("UPDATE users_profiles SET users_profiles_picture=? WHERE users_profiles_user_id=? limit 1","ss",$_FULL_IMAGE,$_ARRAY['user_id']);
      } else {
          $_ARRAY['users_profiles_picture'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE



    //:: USERS
    $_ARRAY['user_group']           = '';
    $_ARRAY['user_email']           = $_PREPARE->sanitize( $_ARRAY['user_email'], 'input' );
    $_PW                            = $_PREPARE->sanitize( $_ARRAY['user_password'], 'input' );
    $_ARRAY['user_password']        = md5( $_PREPARE->sanitize( $_ARRAY['user_password'], 'input' ) );
    $_ARRAY['user_short_name']      = $_PREPARE->sanitize( $_ARRAY['user_short_name'], 'input' );
    $_ARRAY['user_registered_date'] = strtotime( "now" );
    $_ARRAY['user_session']         = md5( rand().strtotime( "now" ) );
    $_ARRAY['user_status']          = $_PREPARE->sanitize( $_ARRAY['user_status'], 'input' );

    $_RETURN = $_CONN->NoQuery("UPDATE users SET user_email=?, user_short_name=? WHERE user_id=? limit 1","sss",$_ARRAY['user_email'], $_ARRAY['user_short_name'], $_ARRAY['user_id']);
      if ( !empty ( $_PW ) ) {
        $_CONN->NoQuery("UPDATE users SET user_password=? WHERE user_id=? limit 1","si",$_ARRAY['user_password'], $_ARRAY['user_id']);
      }
    if ( $_RETURN ) {

      //:: users_profiles
      $_ARRAY['users_profiles_user_id']     = $_ARRAY['user_id'];
      $_ARRAY['users_profiles_picture']     = $_ARRAY['users_profiles_picture'];
      $_ARRAY['users_profiles_first_name']  = $_PREPARE->sanitize( $_ARRAY['users_profiles_first_name'], 'input' );
      $_ARRAY['users_profiles_last_name']   = $_PREPARE->sanitize( $_ARRAY['users_profiles_last_name'], 'input' );
      $_ARRAY['users_profiles_birthday']    = strtotime( $_PREPARE->sanitize( $_ARRAY['users_profiles_birthday'], 'input' ) );
      
      $_ARRAY['users_profiles_gender']      = $_PREPARE->sanitize( $_ARRAY['users_profiles_gender'], 'input' );
      $_CONN->NoQuery("UPDATE users_profiles SET users_profiles_first_name=?, users_profiles_last_name=?, users_profiles_birthday=?, users_profiles_gender=? WHERE users_profiles_user_id=? limit 1","ssssi",$_ARRAY['users_profiles_first_name'],$_ARRAY['users_profiles_last_name'],$_ARRAY['users_profiles_birthday'],$_ARRAY['users_profiles_gender'],$_ARRAY['users_profiles_user_id']);

      //:: users_contact
      $_ARRAY['users_contact_user_id']          = $_ARRAY['user_id'];
      $_ARRAY['users_contact_profiles_phone']   = $_PREPARE->sanitize( $_ARRAY['users_contact_profiles_phone'], 'input' );
      $_ARRAY['users_contact_profiles_website'] = $_PREPARE->sanitize( $_ARRAY['users_contact_profiles_website'], 'input' );
      $_ARRAY['users_contact_country']          = $_PREPARE->sanitize( $_ARRAY['users_contact_country'], 'input' );
      $_ARRAY['users_contact_full_address']     = $_PREPARE->sanitize( $_ARRAY['users_contact_full_address'], 'input' );
      $_ARRAY['users_contact_city']             = $_PREPARE->sanitize( $_ARRAY['users_contact_city'], 'input' );
      $_ARRAY['users_contact_state']            = $_PREPARE->sanitize( $_ARRAY['users_contact_state'], 'input' );
      
      $_CONN->NoQuery("UPDATE users_contact SET users_contact_profiles_phone=?, users_contact_profiles_website=?, users_contact_country=?, users_contact_full_address=?, users_contact_city=?, users_contact_state=? WHERE users_contact_user_id=? limit 1","ssssssi",$_ARRAY['users_contact_profiles_phone'],$_ARRAY['users_contact_profiles_website'],$_ARRAY['users_contact_country'],$_ARRAY['users_contact_full_address'],$_ARRAY['users_contact_city'],$_ARRAY['users_contact_state'],$_ARRAY['users_contact_user_id']);
    }

    return $_RETURN;
  }

}

//:: WIDGETS CLASS
$_VIEW->_USER  = $_USER  = new _USER;
?>