<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _CONTACT {
  function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  function _DB () {
    $_DB  = new database;
    return $_DB;
  }

  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();

    
    $_TEXT_TYPE = "props:['color','background-color','text-decoration','font-weight','letter-spacing','line-height','text-align','text-transform','word-spacing','text-shadow','border','border-radius','box-shadow','margin','padding']";
    $_BOX_TYPE  = "props:['background-color','border','border-top','border-right','border-bottom','border-left','border-radius','box-shadow','margin','padding']";
    
    $_COMBINED  = "props:['color','background-color','text-decoration','font-weight','letter-spacing','line-height','text-align','text-transform','word-spacing','text-shadow','border','border-top','border-right','border-bottom','border-left','border-radius','box-shadow','margin','padding','background-color','border','border-radius','box-shadow','margin','padding']";
    
    
    $_INFO  = array (
      "name"=>"Contact",
      "url"=>"_CONTACT",
      "description"=>$_LANG['CONTACT']['DETAILS'],
      "menu" => array(
        "item_1" => array( "option" => false, "url" => "FIELDS/_SETTINGS", "name" => $_LANG['CONTACT']['SETTINGS'] ),
        "item_2" => array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['CONTACT']['ALL'] ),
        "item_3" => array( "option" => true, "url" => "pluginUninstall", "name" => $_LANG['CONTACT']['UNINSTALL'] )
      ),
      "menu_design" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "_ALL" => "contact", "name" => $_LANG['CONTACT']['DESIGN'] )
      ),
      "def"  => "
      
          def: {
            '._CONTACT .page-title':{
              name: '".$_LANG['CONTACT']['DESIGN_PAGE_NAME']."',
              ".$_TEXT_TYPE."
            },
            '._CONTACT .form-title h3':{
              name: '".$_LANG['CONTACT']['DESIGN_FORM_TITLE']."',
              ".$_TEXT_TYPE."
            },
            '._CONTACT label':{
              name: '".$_LANG['CONTACT']['DESIGN_LABEL']."',
              ".$_TEXT_TYPE."
            }
          }
      
      ",
      "protect_fields" => true
    );
    return $_INFO;
  }

  //:: CREATE THE SUBMENU
  function _SUBMENU ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "contact_settings" => array (
          "url" => 'FIELDS/_SETTINGS',
          "translation" => $_LANG['CONTACT']['SETTINGS']
        ),
      "contact_messages" => array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['CONTACT']['ALL']
        )
    );
    return $_RETURN;
  }

  //:: PLUGIN INSTALL
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_SETTINGS = "
      CREATE TABLE IF NOT EXISTS `contact_settings` (
        `contact_settings_id` int(11) NOT NULL AUTO_INCREMENT,
        `contact_settings_google_maps` text NOT NULL,
        `contact_settings_details` text NOT NULL,
        PRIMARY KEY (`contact_settings_id`)
      ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;
    ";
    $_CONN->NoQuery($_SETTINGS);

    $_DEFAULT_DATA  = "
      INSERT INTO `contact_settings` (`contact_settings_id`, `contact_settings_google_maps`, `contact_settings_details`) VALUES (1, '', '');
    ";
    $_CONN->NoQuery($_DEFAULT_DATA);

    $_INSTALL = "
      CREATE TABLE IF NOT EXISTS `contact_messages` (
        `contact_message_id` int(11) NOT NULL AUTO_INCREMENT,
        `contact_message_name` varchar(150) NOT NULL,
        `contact_message_phone` varchar(150) NOT NULL,
        `contact_message_email` varchar(150) NOT NULL,
        `contact_message_subject` varchar(250) NOT NULL,
        `contact_message_message` text NOT NULL,
        `contact_message_date` int(11) NOT NULL,
        `contact_message_status` int(11) NOT NULL,
        PRIMARY KEY (`contact_message_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_INSTALL);
    return $_RETURN;
  }

  //:: PLUGIN UNINSTALL
  function _UNINSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_DROP = "DROP TABLE IF EXISTS `contact_settings`;";
    $_RETURN  = $_CONN->NoQuery($_DROP);
    $_DROP = "DROP TABLE IF EXISTS `contact_messages`;";
    $_RETURN  = $_CONN->NoQuery($_DROP);
    return $_RETURN;
  }


  //:: REQUIRE SESSION PART
  function _SESSION_VALIDATE ( $_ARRAY ) {
    if ( $_ARRAY['_REQUIRED_SESSION'] ) {
      if ( empty ( $_SESSION[$_ARRAY['_REQUIRED_SESSION']] ) ) {
        return false;
      } else {
        return true;
      }
    } else {
      return true;
    }
  }
  /* 
    USE AS $this->_SESSION_VALIDATE( $_ARRAY = array( "_REQUIRED_SESSION" => false) );
  */


  function _VIEW_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['CONTACT']['MESSAGE_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "contact_message_name"            =>array( 
          "translation" => $_LANG['CONTACT']['FORM_VIEW_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false
        ),
      "contact_message_phone"            =>array( 
          "translation" => $_LANG['CONTACT']['FORM_VIEW_PHONE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "155",
          "mandatory" => true,
          "request" => "input",
          "options" => false
        ),
      "contact_message_email"            =>array( 
          "translation" => $_LANG['CONTACT']['FORM_VIEW_EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "email",
          "options" => false
        ),
      "contact_message_subject"            =>array( 
          "translation" => $_LANG['CONTACT']['FORM_VIEW_SUBJECT'],
          "field" => "input",
          "type" => "varchar",
          "length" => "155",
          "mandatory" => true,
          "request" => "input",
          "options" => false
        ),
      "contact_message_message"            =>array( 
          "translation" => $_LANG['CONTACT']['FORM_VIEW_MESSAGE'],
          "field" => "textarea",
          "type" => "textarea",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false
        ),
      "contact_message_date"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "contact_message_status"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "contact_settings_id"  =>array(
          "translation" => $_LANG['CONTACT']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true
        )
    );
    return $_RETURN;
  }

  //:: LISTING DATA : MYSQL DETAILS
  function _VIEW_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `contact_message_id`, `contact_message_name`, `contact_message_phone`, `contact_message_email`, `contact_message_subject`, `contact_message_message`, `contact_message_date`, `contact_message_status` FROM contact_messages where contact_message_id=?","s",$_ARRAY['_ID']);
    return $_RETURN;
  }





  //:: INFO LISTING : HTML FIELDS
  function _ALL_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['CONTACT']['ALL'],
          "group" => true,
          "special" => true
        ),
      "contact_message_name" => array (
          "options" => false,
          "translation" => $_LANG['CONTACT']['NAME']
        ),
      "contact_message_phone" => array (
          "options" => false,
          "translation" => $_LANG['CONTACT']['PHONE']
        ),
      "contact_message_subject" => array (
          "options" => false,
          "translation" => $_LANG['CONTACT']['SUBJECT']
        ),
      "contact_message_id" => array (
          "options" => array (
              "view" => array( "url" => "VIEW/_VIEW", "ico" => "<i class=\"fa fa-folder-open\"></i> ", "name" => $_LANG['CONTACT']['VIEW'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['CONTACT']['REMOVE'] ),
            ),
          "translation" => $_LANG['CONTACT']['OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: LISTING DATA : MYSQL DETAILS
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `contact_message_name`, `contact_message_phone`, `contact_message_subject`, `contact_message_id` FROM contact_messages");
    return $_RETURN;
  }


  //:: LIST ADMINISTRATORS PLUGIN FIELDS
  function _SETTINGS_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['CONTACT']['SETTINGS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "contact_settings_google_maps"            =>array( 
          "translation" => $_LANG['CONTACT']['GOOGLE_MAPS'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "contact_settings_details"            =>array( 
          "translation" => $_LANG['CONTACT']['DETAILS'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "contact_settings_id"  =>array(
          "translation" => $_LANG['CONTACT']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: WEBSITE SETTINGS DATABASE FIELDS
  function _SETTINGS_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `contact_settings_id`, `contact_settings_google_maps`, `contact_settings_details` FROM contact_settings where contact_settings_id=?","i",1);
    return $_RETURN;
  }

  //:: UPDATE SETTINGS
  function _SETTINGS ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("UPDATE contact_settings SET contact_settings_google_maps=?, contact_settings_details=? WHERE contact_settings_id=? limit 1","sss",$_ARRAY['contact_settings_google_maps'],$_ARRAY['contact_settings_details'],$_ARRAY['contact_settings_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['CONTACT']['SETTINGS_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['CONTACT']['ERROR'];
      }
        return $error;
  }

  //:: STORE MESSAGE INTO DATABASE
  function _PROTECTION_SEND_MESSAGE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    

    $_SESSION_VALIDATE  = $this->_SESSION_VALIDATE( array( "_REQUIRED_SESSION" => '' ) );

    if ( !$_SESSION_VALIDATE ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['CONTACT']['NOT_ALLOWD'];
      return $error;
      break;
    }

    //:: VALIDATE CAPTCHA 

    if ( $_SESSION['captcha'] != $_ARRAY['captcha'] ) {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['CONTACT']['INVALID_CAPTCHA'];
      return $error;
      break;
    }

    //:: GET AND USE SMTP DETAILS
    $_ADMIN       = new _ADMINISTRATORS;
    $_SMTP        = $_ADMIN->_SMTP_FIELDS_LIST( $_ARRAY );
    $_EMAIL_DATA  = $_ADMIN->_SETTINGS_FIELDS_LIST( $_ARRAY );

$details	= '
<div class="rcmBody" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; background-color: #FFFFFF;">
<title>'.$_LANG['CONTACT']['NEW_MESSAGE'].DOMAIN_NAME.'</title>
<table cellspacing="0" cellpadding="0" width="100%"><tbody><tr><td align="center" width="100%"><br><table cellspacing="0" cellpadding="0" width="700" style="border: 1px  solid  #c7c7c7; box-shadow: 0  1px  3px  #c3c2c3; -webkit-box-shadow: 0  1px  7px  #c3c2c3; -moz-box-shadow: 0  1px  3px  #c3c2c3; -moz-background-clip: padding; -webkit-background-clip: padding-box; background-clip: padding-box; background: #fff; border-radius: 0px; padding: 5px;"><tbody><tr><td style="height: 50px; text-align: left;">'._CMS_NAME.'</td>
				</tr><tr><td style="height: 5px; background-color: #FF6600;">
				</td></tr><tr><td align="left" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; font-weight: normal; padding: 15px; background-color: #FFFFFF;">


<div>'.$_LANG['CONTACT']['EMAIL_SUBJECT'].$_ARRAY['contact_message_subject'].'</div>

<br><div style="background-color: #FFFFCC; border: 1px  solid  #FFCC00; clear: both; color: #333333; font-weight: bold; list-style: none outside none; margin-bottom: 10px; padding: 9px  10px  9px  5px;">
<ul style="list-style: none; line-height: 20px;">

<b>'.$_LANG['CONTACT']['EMAIL_NAME'].'</b>'.$_ARRAY['contact_message_name'].'<br/>
<b>'.$_LANG['CONTACT']['EMAIL_PHONE'].'</b>'.$_ARRAY['contact_message_phone'].'<br/>
<b>'.$_LANG['CONTACT']['EMAIL_MESSAGE'].'</b><br/>'.$_ARRAY['contact_message_message'].'<br/>


</ul></div>
<br><div style="float: right;"><a style="color: red; text-decoration: none;" href="'.HTTP_SERVER_WEBSITE.'" target="_blank">'._COPYRIGHT.'</a></div> 
<br><br><div style="text-align: center;">'.$_LANG['CONTACT']['CONTACT_FORM_MESSAGE'].'</div>

					</td>
				</tr></tbody></table></td>
	</tr></tbody></table></div>';




  $headers = "MIME-Version: 1.0" . "\r\n";
  $headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
  $headers .= "From: \r\n";
  $subject = $_LANG['CONTACT']['NEW_MESSAGE'].DOMAIN_NAME;

  //START THE SMTP
  $smtp_email = new \PHPMailer();
  $smtp_email->IsSMTP();
  $smtp_email->SMTPDebug = 0;
  $smtp_email->SMTPAuth = 'login';
  $smtp_email->SMTPSecure = $_SMTP['0']['smtp_secure'];
  $smtp_email->Host = $_SMTP['0']['smtp_host'];
  $smtp_email->Port = $_SMTP['0']['smtp_port'];
  $smtp_email->Username = $_SMTP['0']['smtp_username'];
  $smtp_email->Password = $_SMTP['0']['smtp_password'];

	$smtp_email->SetFrom( $_SMTP['0']['smtp_set_from'], $subject);
	$smtp_email->Subject = $subject;
	$smtp_email->Body = $details;
	$smtp_email->IsHTML(true);
	$smtp_email->AddAddress( $_EMAIL_DATA['0']['website_email'] );
	$smtp_email->Send();
  $smtp_email->ClearAddresses();





    $_ARRAY['contact_message_date']   = strtotime( "now" );
    $_ARRAY['contact_message_status'] = "0";
    $_RETURN = $_CONN->NoQuery("INSERT INTO contact_messages VALUES(NULL,?,?,?,?,?,?,?)","sssssss",$_ARRAY['contact_message_name'],$_ARRAY['contact_message_phone'],$_ARRAY['contact_message_email'],$_ARRAY['contact_message_subject'],$_ARRAY['contact_message_message'],$_ARRAY['contact_message_date'],$_ARRAY['contact_message_status']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['CONTACT']['MSSAGE_REGISTERED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['CONTACT']['ERROR'];
    }
    return $error;
  }

  //:: REMOVE
  function _REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN  = $_CONN->NoQuery("DELETE FROM contact_messages WHERE contact_message_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }


  //:: _REQUIRED_SESSION :: JUST IF NEED AUTHENTIFICATION
  function _REQUIRED_SESSION ( $_ARRAY ) {
    $_RETURN  = array (
      "_REQUIRED_SESSION"         => false,
      "_REQUIRED_SESSION_STRING"  => '',
      "_REDIRECT_PAGE"            => '',
    );
    return $_RETURN;
  }


  //:: DESIGN ROUTE!
  function _DESIGN ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_CONTACT = $_CONN->Query("SELECT `contact_settings_id`, `contact_settings_google_maps`, `contact_settings_details` FROM contact_settings where contact_settings_id=? limit 1","s",1);

    if ( !empty ( $_CONTACT ) ) {

    $_FIELDS  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "contact_message_name"            =>array( 
          "translation" => $_LANG['CONTACT']['FORM_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "contact_message_phone"            =>array( 
          "translation" => $_LANG['CONTACT']['FORM_PHONE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "155",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "contact_message_email"            =>array( 
          "translation" => $_LANG['CONTACT']['FORM_EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "email",
          "options" => false,
          "class" => "col-md-12"
        ),
      "contact_message_subject"            =>array( 
          "translation" => $_LANG['CONTACT']['FORM_SUBJECT'],
          "field" => "input",
          "type" => "varchar",
          "length" => "155",
          "minimum_chr" => "15",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "contact_message_message"            =>array( 
          "translation" => $_LANG['CONTACT']['FORM_MESSAGE'],
          "field" => "textarea",
          "type" => "textarea",
          "length" => "5",
          "minimum_chr" => "50",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "contact_message_date"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "contact_message_status"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "captcha"            =>array( 
          "translation" => $_LANG['CONTACT']['CAPTCHA'],
          "field" => "captcha",
          "type" => "security",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "contact_settings_id"  =>array(
          "translation" => $_LANG['CONTACT']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );

    $_FORM     = $_PREPARE->sanitize( $_CONTACT['0']['contact_settings_google_maps'], 'textarea-decode' );


    ob_start();
    if ( file_exists ( _TMDRP.'_CONTACT/design.top.php' ) ) {
      include( _TMDRP.'_CONTACT/design.top.php' );
    } else {
      include('design/design.top.php');
    }
    $fields_start = ob_get_contents();
    ob_end_clean();


    ob_start();
    if ( file_exists ( _TMDRP.'_CONTACT/design.bottom.php' ) ) {
      include( _TMDRP.'_CONTACT/design.bottom.php' );
    } else {
      include('design/design.bottom.php');
    }
    $fields_end = ob_get_contents();
    ob_end_clean();



    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_LANG['CONTACT']['SEO_TITLE'],
        "_DESCRIPTION" => $_LANG['CONTACT']['SEO_DESCRIPTION'],
        "_KEYWORDS" => $_LANG['CONTACT']['SEO_METATAGS']
        ),
      "DESIGN" => array (
        "ICO" => '',
        "title" => $_LANG['CONTACT']['CONTACT_US'],
        "form" => $_FORM,
        "fields_start" =>$fields_start,
        "fields" =>$_FIELDS,
        "fields_end" =>$fields_end,
        "fields_data" =>false,
        "_GET_ROUTE"  => '_SEND_MESSAGE'
      )
    );
    } else{
      $_RETURN  = false;
    }
    return $_RETURN;
  }


  function _LOAD_CSS ( $_PLUGIN, $_ROUTE ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `css_id`, `css_plugin`, `css_plugin_route`, `css_info` FROM custom_css where css_plugin=? limit 1","s","_CONTACT");
    return $_RETURN;
  }



}

//:: DEFINE CLASS
$_VIEW->_CONTACT  = $_CONTACT  = new _CONTACT;
?>