<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _MENU {
  function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  function _DB () {
    $_DB  = new database;
    return $_DB;
  }


  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_INFO  = array (
      "name"=>"Menu",
      "url"=>"_MENU",
      "description"=>$_LANG['MENU']['DESCRIPTION'],
      "menu" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['MENU']['ALL'] ),
        "item_2" => array( "option" => false, "url" => "FIELDS/_MANAGE", "name" => $_LANG['MENU']['ADD'] ),
        "item_3" => array( "option" => true, "url" => "pluginUninstall", "name" => $_LANG['MENU']['UNINSTALL'] )
      ),
    );
    return $_INFO;
  }

  //:: CREATE THE SUBMENU
  function _SUBMENU ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "all_items" => array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['MENU']['ALL']
        ),
      "new_item" => array (
          "url" => 'FIELDS/_MANAGE',
          "translation" => $_LANG['MENU']['ADD']
        )
    );
    return $_RETURN;
  }

  //:: PLUGIN INSTALL
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_INSTALL = "
      CREATE TABLE IF NOT EXISTS `menu` (
        `menu_id` int(11) NOT NULL AUTO_INCREMENT,
        `menu_parent` int(11) NOT NULL,
        `menu_name` varchar(150) NOT NULL,
        `menu_ico` varchar(150) NOT NULL,
        `menu_url` varchar(250) NOT NULL,
        `menu_session` varchar(150) NOT NULL,
        `menu_session_action` int(11) NOT NULL,
        `menu_order` int(11) NOT NULL,
        PRIMARY KEY (`menu_id`)
      ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_INSTALL);
    return $_RETURN;
  }

  //:: PLUGIN UNINSTALL
  function _UNINSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_DROP = "DROP TABLE IF EXISTS `menu`;";
    $_RETURN  = $_CONN->NoQuery($_DROP);
    return $_RETURN;
  }

  //:: GET THE INFO FROM THE DATABASE
  function _MANAGE_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `menu_id`, `menu_parent`, `menu_name`, `menu_ico`, `menu_url`, `menu_session`, `menu_session_action`, `menu_order` FROM menu where menu_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: GENERATE THE HTML FIELDS FOR EDITING/ADDING INFO TO THE DATABASE
  function _MANAGE_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_2"  => array(
          "translation" => $_LANG['MENU']['ITEM_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "menu_parent"            =>array( 
          "translation" => $_LANG['MENU']['PARENT'],
          "field" => "select",
          "method" => "_POSSIBLE_PARENTS",
          "_ARRAY" => array(""),
          "_NO_DATA" => $_LANG['MENU']['NO_DATA'],
          "_SELECT_DATA" => $_LANG['MENU']['SELECT_DATA'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "menu_name"            =>array( 
          "translation" => $_LANG['MENU']['NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "menu_url"            =>array( 
          "translation" => $_LANG['MENU']['URL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "menu_ico"            =>array( 
          "translation" => $_LANG['MENU']['ICO'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "menu_order"            =>array( 
          "translation" => $_LANG['MENU']['ORDER'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "menu_session"            =>array( 
          "translation" => $_LANG['MENU']['SESSION'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "menu_session_action"            =>array( 
          "translation" => $_LANG['MENU']['SESSION_ACTION'],
          "field" => "select",
          "method" => "_SESSION_ACTION",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['MENU']['SESSION_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "menu_id"  =>array(
          "translation" => $_LANG['MENU']['SUBMIT'],
          "field" => "int",
          "type" => "upload",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  function _SESSION_ACTION ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array(
      array( "_ID" => "1", "_NAME" => $_LANG['MENU']['SESSION_SELECT_HIDE'] ),
      array( "_ID" => "2", "_NAME" => $_LANG['MENU']['SESSION_SELECT_SHOW'] ),
    );
    return $_RETURN;
  }


  //:: INFO LISTING : HTML FIELDS
  function _ALL_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['MENU']['ALL'],
          "group" => true,
          "special" => true
        ),
      "_NAME" => array (
          "options" => false,
          "translation" => $_LANG['MENU']['NAME']
        ),
      "_PARENT" => array (
          "options" => false,
          "translation" => $_LANG['MENU']['PARENT']
        ),
      "_URL" => array (
          "options" => false,
          "translation" => $_LANG['MENU']['URL']
        ),
      "_ID" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_MANAGE", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['MENU']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['MENU']['REMOVE'] ),
            ),
          "translation" => $_LANG['MENU']['OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: LISTING DATA : MYSQL DETAILS
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT e.menu_name as _NAME, m.menu_name as _PARENT, e.menu_url as _URL, e.menu_id as _ID FROM menu e left join menu m on m.menu_id = e.menu_parent order by _PARENT desc");
    return $_RETURN;
  }

  //:: POPULATE THE SELECT OPTION
  function _POSSIBLE_PARENTS ($_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `menu_id` as _ID, `menu_name` as _NAME, `menu_parent` as _IGNORE FROM menu");
    return $_RETURN;
  }

  //:: MANAGE DATA ADD / UPDATE
  function _MANAGE ( $_ARRAY ) {
    if ( empty ( $_ARRAY['menu_id'] ) ) {
      $_RETURN  = $this->_ADD ( $_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE ( $_ARRAY );
    }
      return $_RETURN;
  }

  //:: ADD NEW DATA
  function _ADD ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("INSERT INTO menu VALUES(NULL,?,?,?,?,?,?,?)","sssssss",$_ARRAY['menu_parent'],$_ARRAY['menu_name'],$_ARRAY['menu_ico'],$_ARRAY['menu_url'],$_ARRAY['menu_session'],$_ARRAY['menu_session_action'],$_ARRAY['menu_order']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $_ID  = $_CONN->LastID();
      $error['message']	=	$_LANG['MENU']['ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['MENU']['ERROR'];
    }
    return $error;
  }


  //:: DATA UPDATE
  function _UPDATE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("UPDATE menu SET menu_parent=?, menu_name=?, menu_ico=?, menu_url=?, menu_session=?, menu_session_action=?, menu_order=? WHERE menu_id=? limit 1","ssssssss",$_ARRAY['menu_parent'],$_ARRAY['menu_name'],$_ARRAY['menu_ico'],$_ARRAY['menu_url'],$_ARRAY['menu_session'],$_ARRAY['menu_session_action'],$_ARRAY['menu_order'],$_ARRAY['menu_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['MENU']['UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['MENU']['ERROR'];
      }
    return $error;
  }



  //:: REMOVE
  function _REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->NoQuery("DELETE FROM menu WHERE menu_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: VALIDATE IF THE ITEM IS AN PARENT
  function isParent ( $_ID, $_ARRAY ) {
    foreach ( $_ARRAY as $_ARR ) {
      if ( $_ARR['menu_parent'] == $_ID ) {
        return true;
        break;
      }
    }
      return false;
  }

  //:: VALIDATE IF THE LINK IS EXTERNAL
	function isExternal( $_URL ) {
    $_HTTP_URL      = $this->addhttp( $_URL );
		$url_HTTP_host  = parse_url($_HTTP_URL, PHP_URL_HOST);
		$url_host       = parse_url($_URL, PHP_URL_HOST);
		$base_url_host  = parse_url(HTTP_MASTER, PHP_URL_HOST);
		 
		if($url_host == $base_url_host || ( empty($url_host) && empty ( $url_HTTP_host ) ))
		{
			return 'href="'.$_URL.'"';// internal link ...
		}
		else
		{
			return 'href="'.$_HTTP_URL.'" target="_blank"';// external link ...
		}	
	}

  //:: IF NO HTTP JUST GO AND ADD IT
	public function addhttp($url) {
		if (!preg_match("~^(?:f|ht)tps?://~i", $url)) {
			$url = "http://" . $url;
		}
		return $url;
  }

  //:: VALIDATE MENU SESSION
  function _VALIDATE_MENU_SESSION ( $_ARRAY ) {
    $_ARRAY['menu_session'];//SESSION NAME
    $_ARRAY['menu_session_action'];//SESSION ACTION : 1 -> HIDE / 2 -> SHOW

    $_SESSION_NAME    = $_ARRAY['menu_session'];
    $_SESSION_ACTION  = $_ARRAY['menu_session_action'];

    if ( empty ( $_SESSION_NAME ) OR ( $_SESSION_ACTION == 0 ) ) {
    $_RETURN  = 'show';
    } else {
      
      if ( $_SESSION_ACTION == 1 ) {
        if ( empty ( $_SESSION[$_SESSION_NAME] ) ) {
          $_RETURN  = 'show';
        } else {
          $_RETURN  = 'hide';
        }
      } else {
        if ( empty ( $_SESSION[$_SESSION_NAME] ) ) {
          $_RETURN  = 'hide';
        } else {
          $_RETURN  = 'show';
        }
      }
    }
    return $_RETURN;
  }

  // GENERATE DATA
  function _GENERATE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_PREPARE = new prepare();
    $_BUILD = '<div class="collapse navbar-collapse pull-left" id="navbar-collapse"><ul class="nav navbar-nav">';
    $_RETURN = $_CONN->Query("SELECT `menu_id`, `menu_parent`, `menu_name`, `menu_ico`, `menu_url`, `menu_session`, `menu_session_action`, `menu_order` FROM menu order by menu_order ASC");
      if ( !empty ( $_RETURN ) ) {


//:: BUILD THE MENU
foreach ( $_RETURN as $_ITEMS ) {
  if ( empty( $_ITEMS['menu_parent'] ) ) {
    if ( $this->isParent( $_ITEMS['menu_id'], $_RETURN ) ) {

      $_MENU_SESSION = $this->_VALIDATE_MENU_SESSION( array ( "menu_session" => $_ITEMS['menu_session'], "menu_session_action" => $_ITEMS['menu_session_action'] ) );

  if ( $_MENU_SESSION == 'show' ) {
      //:: MENU PARENT
      $_BUILD   .=  '<li class="dropdown">';
      if ( empty ( $_ITEMS['menu_ico'] ) ) {
          $_ICO = '';
        } else {
          $_ICO = $_PREPARE->sanitize( $_ITEMS['menu_ico'], 'textarea-decode' ).' ';
        }
      $_BUILD .=  '<a title="'.$_ITEMS['menu_name'].'" href="#" class="dropdown-toggle" data-toggle="dropdown">'.$_ICO.$_ITEMS['menu_name'].' <span class="caret"></span></a>';

      //:: SUBMENU ITEMS
      $_BUILD .=  '<ul class="dropdown-menu" role="menu">';
        foreach ( $_RETURN as $_ITEMS_SUBMENU ) {
          if ( $_ITEMS['menu_id'] == $_ITEMS_SUBMENU['menu_parent'] ) {
      if ( empty ( $_ITEMS_SUBMENU['menu_ico'] ) ) {
          $_ICO = '';
        } else {
          $_ICO = $_PREPARE->sanitize( $_ITEMS_SUBMENU['menu_ico'], 'textarea-decode' ).' ';
        }
        //VALIDATE SESSION
        $_MENU_SESSION = $this->_VALIDATE_MENU_SESSION( array ( "menu_session" => $_ITEMS_SUBMENU['menu_session'], "menu_session_action" => $_ITEMS_SUBMENU['menu_session_action'] ) );
        
        if ( $_MENU_SESSION == 'show' ) {
            $_BUILD .=  '<li><a title="'.$_ITEMS_SUBMENU['menu_name'].'" '.$this->isExternal($_ITEMS_SUBMENU['menu_url']).'>'.$_ICO.$_ITEMS_SUBMENU['menu_name'].'</a></li>';
        }
            
            
          }
        }
      $_BUILD .=  '</ul>';
      //:: END SUBMENU ITEMS
      $_BUILD .=  '</li>';
      //:: END MENU PARENT
  }

    } else {

  $_MENU_SESSION = $this->_VALIDATE_MENU_SESSION( array ( "menu_session" => $_ITEMS['menu_session'], "menu_session_action" => $_ITEMS['menu_session_action'] ) );

  if ( $_MENU_SESSION == 'show' ) {
    //:: MENU ITEM
      if ( empty ( $_ITEMS['menu_ico'] ) ) {
          $_ICO = '';
        } else {
          $_ICO = $_PREPARE->sanitize( $_ITEMS['menu_ico'], 'textarea-decode' ).' ';
        }
      $_BUILD .=  '<li><a title="'.$_ITEMS['menu_name'].'" '.$this->isExternal($_ITEMS['menu_url']).'>'.$_ICO.$_ITEMS['menu_name'].'</a></li>';
    //:: END MENU ITEM
  }

    }
  }
}
//:: END BUILDING THE MENU
        $_BUILD .=  '</ul></div>';
        return $_BUILD;


      } else {
        return false;
      }

  }


}

//:: DEFINE CLASS
$_VIEW->_MENU  = $_MENU  = new _MENU;
?>