<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _SLIDER {
  function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  function _DB () {
    $_DB  = new database;
    return $_DB;
  }


  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_INFO  = array (
      "name"=>"Slider",
      "url"=>"_SLIDER",
      "description"=>$_LANG['SLIDER']['DESCRIPTION'],
      "menu" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['SLIDER']['ALL'] ),
        "item_2" => array( "option" => false, "url" => "FIELDS/_MANAGE", "name" => $_LANG['SLIDER']['ADD'] ),
        "item_3" => array( "option" => true, "url" => "pluginUninstall", "name" => $_LANG['SLIDER']['UNINSTALL'] )
      ),
      "require_upload" => true//just add this index, and will be automatically considered true
    );
    return $_INFO;
  }

  function _ADDED_MSJ ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-success">'.$_LANG['SLIDER']['ADDED'].'</div>';
  }

  function _UPDATED_MSJ ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-success">'.$_LANG['SLIDER']['UPDATED'].'</div>';
  }

  function _ERROR_MSJ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-danger">'.$_LANG['SLIDER']['ERROR'].'</div>';
  }

  //:: CREATE THE SUBMENU
  function _SUBMENU( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "all_items" => array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['SLIDER']['ALL']
        ),
      "new_item" => array (
          "url" => 'FIELDS/_MANAGE',
          "translation" => $_LANG['SLIDER']['ADD']
        )
    );
    return $_RETURN;
  }

  //:: PLUGIN INSTALL
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_INSTALL = "
    CREATE TABLE IF NOT EXISTS `slider` (
      `slider_id` int(11) NOT NULL AUTO_INCREMENT,
      `slider_title` varchar(150) NOT NULL,
      `slider_text` text NOT NULL,
      `slider_url` varchar(250) NOT NULL,
      `slider_image` varchar(250) NOT NULL,
      `slider_order` int(11) NOT NULL,
      PRIMARY KEY (`slider_id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_INSTALL);
    return $_RETURN;
  }

  //:: PLUGIN UNINSTALL
  function _UNINSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_DROP = "DROP TABLE IF EXISTS `slider`;";
    $_RETURN  = $_CONN->NoQuery($_DROP);
    return $_RETURN;
  }

  //:: GET THE INFO FROM THE DATABASE
  function _MANAGE_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_RETURN = $_CONN->Query("SELECT `slider_id`, `slider_title`, `slider_text`, `slider_url`, `slider_image`, `slider_order` FROM slider where slider_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: GENERATE THE HTML FIELDS FOR EDITING/ADDING INFO TO THE DATABASE
  function _MANAGE_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['SLIDER']['DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "slider_title"            =>array( 
          "translation" => $_LANG['SLIDER']['NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "slider_text"            =>array( 
          "translation" => $_LANG['SLIDER']['TEXT'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "slider_url"            =>array( 
          "translation" => $_LANG['SLIDER']['URL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "slider_image"            =>array( 
          "translation" => $_LANG['SLIDER']['IMAGE'],
          "field" => "upload",
          "type" => "image",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "slider_order"            =>array( 
          "translation" => $_LANG['SLIDER']['ORDER'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "slider_id"  =>array(
          "translation" => $_LANG['SLIDER']['SUBMIT'],
          "field" => "int",
          "type" => "upload",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: INFO LISTING : HTML FIELDS
  function _ALL_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['SLIDER']['ALL'],
          "group" => true,
          "special" => true
        ),
      "slider_title" => array (
          "options" => false,
          "translation" => $_LANG['SLIDER']['NAME']
        ),
      "slider_url" => array (
          "options" => false,
          "translation" => $_LANG['SLIDER']['URL']
        ),
      "slider_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_MANAGE", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['SLIDER']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['SLIDER']['REMOVE'] ),
            ),
          "translation" => $_LANG['SLIDER']['OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: LISTING DATA : MYSQL DETAILS
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_RETURN = $_CONN->Query("SELECT `slider_title`, `slider_url`, `slider_id` FROM slider");
    return $_RETURN;
  }

  //:: MANAGE DATA ADD / UPDATE
  function _MANAGE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['slider_id'] ) ) {
      $_RETURN  = $this->_ADD ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }
      return $_RETURN;
  }

  //:: ADD NEW DATA
  function _ADD ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['slider_image'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['slider_image'] = $_FULL_IMAGE;
      } else {
          $_ARRAY['slider_image'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

    $_RETURN = $_CONN->NoQuery("INSERT INTO slider VALUES(NULL,?,?,?,?,?)","sssss",$_ARRAY['slider_title'],$_ARRAY['slider_text'],$_ARRAY['slider_url'],$_ARRAY['slider_image'],$_ARRAY['slider_order']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $_ID  = $_CONN->LastID();
      $error['message']	=	$_LANG['SLIDER']['ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['SLIDER']['ERROR'];
    }
    return $error;
  }


  //:: DATA UPDATE
  function _UPDATE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['slider_image'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['slider_image'] = $_FULL_IMAGE;
          
          //:: OLD IMAGE
          $_OLD_IMAGE  = $_CONN->Query("SELECT `slider_image` FROM slider where slider_id =? limit 1","s",$_ARRAY['slider_id']);

          if ( !empty ( $_OLD_IMAGE ) ) {
          $_FILE_LOCATION	=	_UPLOAD_DIR.$_OLD_IMAGE['0']['slider_image'];
            if ( !empty ( $_OLD_IMAGE['0']['slider_image'] ) ) {
              if (file_exists($_FILE_LOCATION)) {
                unlink($_FILE_LOCATION);
              }
            }
          }
          //:: /OLD IMAGE

          $_CONN->NoQuery("UPDATE slider SET slider_image=? WHERE slider_id=? limit 1","ss",$_FULL_IMAGE,$_ARRAY['slider_id']);
      } else {
          $_ARRAY['slider_image'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

    $_RETURN = $_CONN->NoQuery("UPDATE slider SET slider_title=?, slider_text=?, slider_url=?, slider_order=? WHERE slider_id=? limit 1","sssss",$_ARRAY['slider_title'],$_ARRAY['slider_text'],$_ARRAY['slider_url'],$_ARRAY['slider_order'],$_ARRAY['slider_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['SLIDER']['UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['SLIDER']['ERROR'];
      }
    return $error;
  }

  //:: REMOVE
  function _FILE_REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_VALIDATE  = $_CONN->Query("SELECT `slider_image` FROM slider where slider_id =? and slider_image=? limit 1","ss",$_ARRAY['_ID'], $_ARRAY['_FILE']);
    if ( !empty ( $_VALIDATE ) ) {
    $_FILE_LOCATION	=	_UPLOAD_DIR.$_VALIDATE['0']['slider_image'];
      if ( !empty ( $_VALIDATE['0']['slider_image'] ) ) {
        if (file_exists($_FILE_LOCATION)) {
          unlink($_FILE_LOCATION);
        }
      }
      $_RETURN = $_CONN->NoQuery("UPDATE slider SET slider_image=? WHERE slider_id=? limit 1","ss","",$_ARRAY['_ID']);
    } else {
      $_RETURN  = false;
    }

    return $_RETURN;
  }


  //:: REMOVE
  function _REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_FILE  = $_CONN->Query("SELECT `slider_image` FROM slider where slider_id=? limit 1","s",$_ARRAY['_ID']);

    if ( !empty ( $_FILE ) ) {
    $_FILE_LOCATION	=	_UPLOAD_DIR.$_FILE['0']['slider_image'];
      if ( !empty ( $_FILE['0']['slider_image'] ) ) {
        if (file_exists($_FILE_LOCATION)) {
          unlink($_FILE_LOCATION);
        }
      }
    }

    $_RETURN  = $_CONN->NoQuery("DELETE FROM slider WHERE slider_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }


  //:: VALIDATE IF THE LINK IS EXTERNAL
	function isExternal( $_URL ) {
    $_HTTP_URL      = $this->addhttp( $_URL );
		$url_HTTP_host  = parse_url($_HTTP_URL, PHP_URL_HOST);
		$url_host       = parse_url($_URL, PHP_URL_HOST);
		$base_url_host  = parse_url(HTTP_MASTER, PHP_URL_HOST);
		 
		if($url_host == $base_url_host || ( empty($url_host) && empty ( $url_HTTP_host ) ))
		{
			return 'href="'.$_URL.'"';// internal link ...
		}
		else
		{
			return 'href="'.$_HTTP_URL.'" target="_blank"';// external link ...
		}	
	}

  //:: IF NO HTTP JUST GO AND ADD IT
	public function addhttp($url) {
		if (!preg_match("~^(?:f|ht)tps?://~i", $url)) {
			$url = "http://" . $url;
		}
		return $url;
  }



  // GENERATE DATA
  function _GENERATE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    //::  DEFINE VARIABLED
    $_SLIDER            = '<div id="_CG_CAROUSEL" class="carousel slide" data-ride="carousel">';
    $_OPTIONS           = '';
    $_OPTIONS_CONTAINER = '';
    $_OPTIONS_START     = '<!-- carousel controls --><ol class="carousel-indicators">';
    $_OPTIONS_END       = '</ol><!-- ./carousel controls -->';
    
    $_IMAGES            = '';
    $_IMAGES_CONTAINER  = '';
    $_IMAGES_START      = '<div class="carousel-inner">';
    $_IMAGES_END        = '</div>';
    
    $_PREV_NEXT         = '';
    
    $t                  = 0;
    $i                  = 0;

    $_RETURN = $_CONN->Query("SELECT `slider_id`, `slider_title`, `slider_text`, `slider_url`, `slider_image`, `slider_order` FROM slider where slider_image!=? order by slider_order ASC","s","");

  if ( !empty ( $_RETURN ) ) {
    foreach ( $_RETURN as $_IMAGE ) {
      if ( $t == 0 ) {
        $_ACTIVE  = ' class="active"';
      } else {
        $_ACTIVE  = ' class=""';
      }
      $_OPTIONS_CONTAINER .= '<li data-target="#_CG_CAROUSEL" data-slide-to="'.$t.'"'.$_ACTIVE.'></li>';
      $t++;
    }
  }


    //:: CAROUSEL OPTIONS
    $_OPTIONS  = $_OPTIONS_START.$_OPTIONS_CONTAINER.$_OPTIONS_END;

  if ( !empty ( $_RETURN ) ) {
    foreach ( $_RETURN as $_IMAGE ) {
        if ( $i == 0 ) {
          $_ACTIVE  = ' class="item active"';
        } else {
          $_ACTIVE  = ' class="item"';
        }

    $_SLIDER_URL  = $this->isExternal($_IMAGE['slider_url']);

    ob_start();
    if ( file_exists ( _TMDRP.'_SLIDER/images.container.php' ) ) {
      include( _TMDRP.'_SLIDER/images.container.php' );
    } else {
      include('design/images.container.php');
    }
    $_IMAGES_CONTAINER .= ob_get_contents();
    ob_end_clean();

        $i++;
    }
  }

    $_IMAGES  = $_IMAGES_START.$_IMAGES_CONTAINER.$_IMAGES_END;

    ob_start();
    if ( file_exists ( _TMDRP.'_SLIDER/slider.menu.php' ) ) {
      include( _TMDRP.'_SLIDER/slider.menu.php' );
    } else {
      include('design/slider.menu.php');
    }
    $_PREV_NEXT  = ob_get_contents();
    ob_end_clean();

    $_SLIDER  .=  $_OPTIONS;
    $_SLIDER  .=  $_IMAGES;
    $_SLIDER  .=  $_PREV_NEXT;

    $_SLIDER  .= '</div>';

  if ( empty ( $_RETURN ) ) {
    $_SLIDER  = false;
  }

    return $_SLIDER;

  }


}

//:: DEFINE CLASS
$_VIEW->_SLIDER  = $_SLIDER  = new _SLIDER;
?>