<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _WIDGETS {
  function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  function _DB () {
    $_DB  = new database;
    return $_DB;
  }


  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_INFO  = array (
      "name"=>"Widgets",
      "url"=>"_WIDGETS",
      "description"=>$_LANG['WIDGETS']['DESCRIPTION'],
      "menu" => array(
        "item_1" => array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['WIDGETS']['ALL'] ),
        "item_2" => array( "option" => false, "url" => "FIELDS/_MANAGE", "name" => $_LANG['WIDGETS']['NEW'] ),
        "item_3" => array( "option" => true, "url" => "pluginUninstall", "name" => $_LANG['WIDGETS']['UNINSTALL'] )
      ),
    );
    return $_INFO;
  }

  //:: CREATE THE SUBMENU
  function _SUBMENU ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "all_widgets" => array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['WIDGETS']['ALL']
        ),
      "new_widget" => array (
          "url" => 'FIELDS/_MANAGE',
          "translation" => $_LANG['WIDGETS']['NEW']
        )
    );
    return $_RETURN;
  }

  //:: PLUGIN INSTALL
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_INSTALL = "
      CREATE TABLE IF NOT EXISTS `widgets` (
        `widget_id` int(11) NOT NULL AUTO_INCREMENT,
        `widget_title` varchar(150) NOT NULL,
        `widget_ico` varchar(250) NOT NULL,
        `widget_data` text NOT NULL,
        `widget_code` text NOT NULL,
        `widget_views` int(11) NOT NULL,
        `widget_status` int(5) NOT NULL,
        PRIMARY KEY (`widget_id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
    ";
    $_RETURN  = $_CONN->NoQuery($_INSTALL);
    return $_RETURN;
  }

  //:: PLUGIN UNINSTALL
  function _UNINSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_DROP = "DROP TABLE IF EXISTS `widgets`;";
    $_RETURN  = $_CONN->NoQuery($_DROP);
    return $_RETURN;
  }

  //:: GET THE INFO FROM THE DATABASE
  function _MANAGE_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `widget_id`, `widget_title`, `widget_ico`, `widget_data`, `widget_code`, `widget_views`, `widget_status` FROM widgets where widget_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  //:: GENERATE THE HTML FIELDS FOR EDITING/ADDING INFO TO THE DATABASE
  function _MANAGE_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP"  => array(
          "translation" => $_LANG['WIDGETS']['DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "widget_title"            =>array( 
          "translation" => $_LANG['WIDGETS']['NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "widget_ico"            =>array( 
          "translation" => $_LANG['WIDGETS']['ICO'],
          "field" => "textarea",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "code",
          "options" => false,
          "class" => "col-md-12"
        ),
      "widget_data"          =>array(
          "translation" => $_LANG['WIDGETS']['DETAILS'],
          "field" => "editor",
          "type" => "text",
          "length" => "NULL",
          "mandatory" => false,
          "request" => "editor",
          "options" => false,
          "class" => "col-md-12"
        ),
      "widget_code"          =>array(
          "translation" => $_LANG['WIDGETS']['CODE'],
          "field" => "textarea",
          "type" => "text",
          "length" => "5",
          "mandatory" => false,
          "request" => "code",
          "options" => false,
          "class" => "col-md-12"
        ),
      "widget_views"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "widget_status"  =>array(
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "widget_id"  =>array(
          "translation" => $_LANG['WIDGETS']['SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  //:: INFO LISTING : HTML FIELDS
  function _ALL_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['WIDGETS']['ALL'],
          "group" => true,
          "special" => true
        ),
      "widget_title" => array (
          "options" => false,
          "translation" => $_LANG['WIDGETS']['NAME']
        ),
      "widget_views" => array (
          "options" => false,
          "translation" => $_LANG['WIDGETS']['VIEWS']
        ),
      "widget_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_MANAGE", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['WIDGETS']['EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['WIDGETS']['REMOVE'] ),
            ),
          "translation" => $_LANG['WIDGETS']['OPTIONS']
        )
    );
    return $_RETURN;
  }

  //:: LISTING DATA : MYSQL DETAILS
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN = $_CONN->Query("SELECT `widget_title`, `widget_views`, `widget_id` FROM widgets order by widget_id desc");
    return $_RETURN;
  }

  //:: MANAGE WIDGET ADD / UPDATE
  function _MANAGE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    if ( empty ( $_ARRAY['widget_id'] ) ) {
      $_RETURN  = $this->_ADD ( $_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE ( $_ARRAY );
    }
      return $_RETURN;
  }

  //:: ADD NEW WIDGET
  function _ADD ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("INSERT INTO widgets VALUES(NULL,?,?,?,?,?,?)","ssssss",$_ARRAY['widget_title'],$_ARRAY['widget_ico'],$_ARRAY['widget_data'],$_ARRAY['widget_code'],$_ARRAY['widget_views'],$_ARRAY['widget_status']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $_ID  = $_CONN->LastID();
      $error['message']	=	$_LANG['WIDGETS']['ADDED'].'<blockquote>&lt;?php echo $_WIDGETS->_SHOW("'.$_ID.'");?&gt;</blockquote>';
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['WIDGETS']['ERROR'];
    }
    return $error;
  }

  //:: WIDGET UPDATE
  function _UPDATE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->NoQuery("UPDATE widgets SET widget_title=?, widget_ico=?, widget_data=?, widget_code=?, widget_views=?, widget_status=? WHERE widget_id=? limit 1","sssssss",$_ARRAY['widget_title'],$_ARRAY['widget_ico'],$_ARRAY['widget_data'],$_ARRAY['widget_code'],$_ARRAY['widget_views'],$_ARRAY['widget_status'],$_ARRAY['widget_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['WIDGETS']['UPDATED'].'<blockquote>&lt;?php echo $_WIDGETS->_SHOW("'.$_ARRAY['widget_id'].'");?&gt;</blockquote>';
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['WIDGETS']['ERROR'];
      }
    return $error;
  }

  //:: WIDGET REMOVE
  function _REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    
    $_RETURN  = $_CONN->NoQuery("DELETE FROM widgets WHERE widget_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }

  function _SHOW ( $_ID ) {
    $_CONN    = new database();
    $_PREPARE = new prepare();
    $_ID      = $_PREPARE->sanitize( $_ID, 'input' );
    $_WIDGET = $_CONN->Query("SELECT `widget_id`, `widget_title`, `widget_ico`, `widget_data`, `widget_code`, `widget_views`, `widget_status` FROM widgets where widget_id=?","i",$_ID);

    $_CONN->NoQuery("UPDATE widgets SET widget_views=widget_views+1 WHERE widget_id=? limit 1","s",$_ID);

    if ( empty ( $_WIDGET ) ) {
      $_RETURN  =  false;
    } else {
        $_WIDGET_TITLE    = $_WIDGET['0']['widget_title'];
        $_WIDGET_ICO      = $_PREPARE->sanitize($_WIDGET['0']['widget_ico'], 'textarea-decode');
        $_WIDGET_DETAILS  = $_PREPARE->sanitize($_WIDGET['0']['widget_data'], 'textarea-decode');
        $_WIDGET_CODE     = $_PREPARE->sanitize($_WIDGET['0']['widget_code'], 'textarea-decode');

        if ( !empty ( $_WIDGET['0']['widget_ico'] ) ) {
          $_WIDGET_ICO  = '<div class="widgets-ico">'.$_WIDGET_ICO.'</div>';
        } else {
          $_WIDGET_ICO  = '';
        }

        ob_start();
        if ( file_exists ( _TMDRP.'_WIDGETS/widget.display.php' ) ) {
          include( _TMDRP.'_WIDGETS/widget.display.php' );
        } else {
          include('design/widget.display.php');
        }
        $_RETURN = ob_get_contents();
        ob_end_clean();

    }

    return $_RETURN;

  }

}

//:: WIDGETS CLASS
$_VIEW->_WIDGETS  = $_WIDGETS  = new _WIDGETS;
?>