<?php
/**
 * @package   Compile Grid
 * @author		Uta Marian - Alexandru
 * @license   http://www.compilegrid.com/license.html
 * @link      http://www.compilegrid.com
 */

class _TICKET {
  function _PREPARE () {
    $_PREPARE = new prepare();
    return $_PREPARE;
  }

  function _LANGUAGE () {
    $_LANGUAGE  = new language();
    $_LANG      = $_LANGUAGE->_get();
    return $_LANG;
  }

  function _DB () {
    $_DB  = new database;
    return $_DB;
  }

  function _ADMINISTRATOR () {
    $_ADMINISTRATOR  = new _ADMINISTRATORS;
    return $_ADMINISTRATOR;
  }

  function _ADDED_MSJ ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    if ( $_ARRAY['_ROUTE'] ) {
        if ( $_ARRAY['_ROUTE'] == '_PRODUCT' ) {
          return '<div class="callout callout-success">'.$_LANG['TICKET']['PRODUCTS_ADDED'].'</div>';
        }
        if ( $_ARRAY['_ROUTE'] == '_MANAGE' ) {
          return '<div class="callout callout-success">'.$_LANG['TICKET']['TICKET_ADDED'].'</div>';
        }
    } else {
      return '<div class="callout callout-success">'.$_LANG['TICKET']['_PLUGIN_DATA_ADDED'].'</div>';
    }
  }

  function _UPDATED_MSJ ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    if ( $_ARRAY['_ROUTE'] ) {
        if ( $_ARRAY['_ROUTE'] == '_PRODUCT' ) {
          return '<div class="callout callout-success">'.$_LANG['TICKET']['PRODUCTS_UPDATED'].'</div>';
        }
        if ( $_ARRAY['_ROUTE'] == '_MANAGE' ) {
          return '<div class="callout callout-success">'.$_LANG['TICKET']['TICKET_UPDATED'].'</div>';
        }
        if ( $_ARRAY['_ROUTE'] == '_REPLY' ) {
          return '<div class="callout callout-success">'.$_LANG['TICKET']['TICKET_REPLY_ADDED'].'</div>';
        }
    } else {
      return '<div class="callout callout-success">'.$_LANG['TICKET']['_PLUGIN_DATA_UPDATED'].'</div>';
    }
  }

  function _ERROR_MSJ( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-danger">'.$_LANG['TICKET']['_PLUGIN_ERROR'].'</div>';
  }

  function _ERROR( ) {
    $_LANG    = $this->_LANGUAGE();
    return '<div class="callout callout-danger">'.$_LANG['TICKET']['_PLUGIN_ERROR'].'</div>';
  }

  function _ADDED ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();

    if ( $_ARRAY['_ROUTE'] == '_ANON_OPEN_TICKET' ) {
      return '<div class="callout callout-success">'.$_LANG['TICKET']['ANON_TICKET_CREATED'].'</div>';
    } else {
      return '<div class="callout callout-success">'.$_LANG['TICKET']['TICKET_ADDED'].'</div>';
    }
  }

  function _UPDATED ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    if ( $_ARRAY['_ROUTE'] ) {
        if ( $_ARRAY['_ROUTE'] == '_STAFF_REPLY_TICKET' ) {
          return '<div class="callout callout-success">'.$_LANG['TICKET']['TICKET_REPLY_ADDED'].'</div>';
        }
        if ( $_ARRAY['_ROUTE'] == '_ANON_REPLY_TICKET' ) {
          return '<div class="callout callout-success">'.$_LANG['TICKET']['TICKET_REPLY_ADDED'].'</div>';
        }
    } else {
      return '<div class="callout callout-success">'.$_LANG['TICKET']['_PLUGIN_DATA_UPDATED'].'</div>';
    }
  }


  //:: PLUGIN DETAILS
  function _INFO ( ) {
    $_LANG    = $this->_LANGUAGE();

    $_INFO  = array (
      "name"=>$_LANG['TICKET']['_PLUGIN_NAME'],
      "url"=>"_TICKET",
      "description"=>$_LANG['TICKET']['_PLUGIN_DESCRIPTION'],
      "menu" => array(
        array( "option" => false, "url" => "FIELDS/_SETTINGS", "name" => $_LANG['TICKET']['SETTINGS'] ),

        array( "option" => false, "url" => "LIST/_ALL", "name" => $_LANG['TICKET']['ALL'] ),
        array( "option" => false, "url" => "FIELDS/_MANAGE", "name" => $_LANG['TICKET']['ADD'] ),

        array( "option" => false, "url" => "LIST/_DEPARTMENTS", "name" => $_LANG['TICKET']['DEPARTMENTS'] ),
        array( "option" => false, "url" => "FIELDS/_DEPARTMENT", "name" => $_LANG['TICKET']['DEPARTMENT'] ),

        array( "option" => false, "url" => "LIST/_PRIORITIES", "name" => $_LANG['TICKET']['PRIORITIES'] ),
        array( "option" => false, "url" => "FIELDS/_PRIORITY", "name" => $_LANG['TICKET']['PRIORITY'] ),

        array( "option" => false, "url" => "LIST/_PRODUCTS", "name" => $_LANG['TICKET']['PRODUCTS'] ),
        array( "option" => false, "url" => "FIELDS/_PRODUCT", "name" => $_LANG['TICKET']['PRODUCT'] ),

        array( "option" => false, "url" => "LIST/_STAFF", "name" => $_LANG['TICKET']['STAFF'] ),
        array( "option" => false, "url" => "FIELDS/_MANAGE_STAFF", "name" => $_LANG['TICKET']['ADD_STAFF'] ),

        array( "option" => true, "url" => "pluginUninstall", "name" => $_LANG['TICKET']['UNINSTALL'] )
      ),
      "table" => false
    );
    return $_INFO;
  }

  //:: CREATE THE SUBMENU
  function _SUBMENU ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
        array (
          "url" => 'LIST/_ALL',
          "translation" => $_LANG['TICKET']['ALL']
        ),
        array (
          "url" => 'FIELDS/_MANAGE',
          "translation" => $_LANG['TICKET']['ADD']
        ),
        array (
          "url" => 'LIST/_STAFF',
          "translation" => $_LANG['TICKET']['STAFF']
        ),
        array (
          "url" => 'FIELDS/_MANAGE_STAFF',
          "translation" => $_LANG['TICKET']['ADD_STAFF']
        ),
    );
    return $_RETURN;
  }

  //:: PLUGIN INSTALL
  function _INSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    //:: ticket_system
      $_INSTALL = "
CREATE TABLE IF NOT EXISTS `ticket_system` (
  `ticket_system_id` int(11) NOT NULL AUTO_INCREMENT,
  `ticket_system_opened_by_type` int(11) NOT NULL,
  `ticket_system_opened_by_id` int(11) NOT NULL,
  `ticket_system_guest` int(11) NOT NULL,
  `ticket_system_user_id` int(11) NOT NULL,
  `ticket_system_department` int(11) NOT NULL,
  `ticket_system_priority` int(11) NOT NULL,
  `ticket_system_product` int(11) NOT NULL,
  `ticket_system_name` varchar(150) NOT NULL,
  `ticket_system_email` varchar(150) NOT NULL,
  `ticket_system_subject` varchar(150) NOT NULL,
  `ticket_system_details` text NOT NULL,
  `ticket_system_file` varchar(250) NOT NULL,
  `ticket_system_unique_url` varchar(250) NOT NULL,
  `ticket_system_status` int(11) NOT NULL,
  `ticket_system_date` int(11) NOT NULL,
  PRIMARY KEY (`ticket_system_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `ticket_system_reply` (
  `ticket_system_reply_id` int(11) NOT NULL AUTO_INCREMENT,
  `ticket_system_reply_ticket_id` int(11) NOT NULL,
  `ticket_system_reply_by_type` int(11) NOT NULL,
  `ticket_system_reply_user_id` int(11) NOT NULL,
  `ticket_system_reply_details` text NOT NULL,
  `ticket_system_reply_file` varchar(250) NOT NULL,
  `ticket_system_reply_status` int(11) NOT NULL,
  `ticket_system_reply_date` int(11) NOT NULL,
  PRIMARY KEY (`ticket_system_reply_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `ticket_system_departments` (
  `tsd_id` int(11) NOT NULL AUTO_INCREMENT,
  `tsd_name` varchar(150) NOT NULL,
  `tsd_ico` varchar(150) NOT NULL,
  PRIMARY KEY (`tsd_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `ticket_system_priority` (
  `ts_priority_id` int(11) NOT NULL AUTO_INCREMENT,
  `ts_priority_name` varchar(250) NOT NULL,
  `ts_priority_ico` varchar(150) NOT NULL,
  `ts_priority_priority` int(11) NOT NULL,
  PRIMARY KEY (`ts_priority_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `ticket_system_products` (
  `tsp_id` int(11) NOT NULL AUTO_INCREMENT,
  `tsp_name` varchar(250) NOT NULL,
  `tsp_cover` varchar(150) NOT NULL,
  `tsp_description` text NOT NULL,
  PRIMARY KEY (`tsp_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `ticket_system_settings` (
  `tss_id` int(11) NOT NULL AUTO_INCREMENT,
  `tss_user_only` int(11) NOT NULL,
  `tss_status` int(11) NOT NULL,
  PRIMARY KEY (`tss_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

INSERT INTO `ticket_system_settings` (`tss_id`, `tss_user_only`, `tss_status`) VALUES
(1, 0, 1);

CREATE TABLE IF NOT EXISTS `ticket_system_staff` (
  `ts_staff_id` int(11) NOT NULL AUTO_INCREMENT,
  `ts_staff_user_id` int(11) NOT NULL,
  `ts_staff_department` int(11) NOT NULL,
  `ts_staff_open_ticket` int(11) NOT NULL,
  PRIMARY KEY (`ts_staff_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

      ";
      $_RETURN  = $_CONN->MultiNoQuery($_INSTALL);

    return $_RETURN;
  }

  //:: PLUGIN UNINSTALL
  function _UNINSTALL ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    $_UNINSTALL = "
      DROP TABLE IF EXISTS `ticket_system`;
      DROP TABLE IF EXISTS `ticket_system_reply`;
      DROP TABLE IF EXISTS `ticket_system_departments`;
      DROP TABLE IF EXISTS `ticket_system_priority`;
      DROP TABLE IF EXISTS `ticket_system_products`;
      DROP TABLE IF EXISTS `ticket_system_settings`;
      DROP TABLE IF EXISTS `ticket_system_staff`;
    ";
    $_RETURN  = $_CONN->MultiNoQuery($_UNINSTALL);
    return $_RETURN;
  }


  //:: DESIGN THE WIDGET
  function _WIDGET ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();

    $_COUNT = $_CONN->Query("SELECT `ticket_system_status` FROM ticket_system");

    ob_start();
    if ( file_exists ( _TMDRP.'_TICKET/admin.widget.php' ) ) {
      include( _TMDRP.'_TICKET/admin.widget.php' );
    } else {
      include('design/admin.widget.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();

    return $_FORM;
  }

  function _STAFF_MEMBERS ( $_ARRAY ) {
    $_CONN        = $this->_DB();

    $_RETURN  = $_CONN->Query("SELECT `ts_staff_id`, `ts_staff_user_id`, `ts_staff_department`, `ts_staff_open_ticket`, `tsd_name`, `tsd_ico`, `user_email` FROM ticket_system_staff left join users on users.user_id = ticket_system_staff.ts_staff_user_id left join ticket_system_departments on ticket_system_departments.tsd_id = ticket_system_staff.ts_staff_department where ts_staff_department=?","i",$_ARRAY['ts_staff_department'] );
    return $_RETURN;
  }


  function _STAFF_MEMBER ( $_ARRAY ) {
    $_CONN        = $this->_DB();
    if ( !empty ( $_SESSION['USER_SESSION'] ) ) {
      $_VALIDATE  = $_CONN->Query("SELECT `ts_staff_id`, `ts_staff_user_id`, `ts_staff_department`, `ts_staff_open_ticket`, `tsd_name`, `tsd_ico` FROM ticket_system_staff left join ticket_system_departments on ticket_system_departments.tsd_id = ticket_system_staff.ts_staff_department where ts_staff_user_id=? limit 1","s",$_ARRAY['_USER_ID'] );
      if ( empty ( $_VALIDATE ) ) {
        return false;
      } else {
        return $_VALIDATE;
      }
    } else {
     return false; 
    }    
  }

  //:: DESIGN THE WIDGET
  function _USER_DASHBOARD_WIDGET ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();

$_STAFF_MEMBER  = $this->_STAFF_MEMBER( array("_USER_ID" => $_SESSION['USER_SESSION']['0']['user_id'] ) );

if ( $_STAFF_MEMBER ) {

    $_COUNT = $_CONN->Query("SELECT `ticket_system_status` FROM ticket_system where ticket_system_department=?","i",$_STAFF_MEMBER['0']['ts_staff_department']);

    $_COUNT_PERSONAL = $_CONN->Query("SELECT `ticket_system_status` FROM ticket_system where ticket_system_user_id=?","i",$_SESSION['USER_SESSION']['0']['user_id']);


    ob_start();
    if ( file_exists ( _TMDRP.'_TICKET/staff.widget.php' ) ) {
      include( _TMDRP.'_TICKET/staff.widget.php' );
    } else {
      include('design/staff.widget.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();


} else {
  $_COUNT = $_CONN->Query("SELECT `ticket_system_status` FROM ticket_system where ticket_system_user_id=?","i",$_SESSION['USER_SESSION']['0']['user_id']);

    ob_start();
    if ( file_exists ( _TMDRP.'_TICKET/user.widget.php' ) ) {
      include( _TMDRP.'_TICKET/user.widget.php' );
    } else {
      include('design/user.widget.php');
    }
    $_FORM = ob_get_contents();
    ob_end_clean();

}

    return $_FORM;
  }

  //:: TICKET SYSTEM : SETTINGS
  function _SETTINGS_FIELDS ( ) {

    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "tss_user_only"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_USER_ONLY'],
          "field" => "select",
          "method" => "_TICKET_MODE",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_USER_ONLY_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "tss_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }
  
  function _TICKET_MODE ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array(
      array( "_ID" => "0", "_NAME" => $_LANG['TICKET']['TICKET_MODE_EVERYONE'] ),
      array( "_ID" => "1", "_NAME" => $_LANG['TICKET']['TICKET_MODE_USER_ONLY'] ),
    );
    return $_RETURN;
  }
  
  function _SETTINGS_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `tss_id`, `tss_user_only`, `tss_status` FROM ticket_system_settings where tss_status=?","i",1);
    return $_RETURN;
  }
  function _SETTINGS ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_CONN    = $this->_DB();

    $_RETURN = $_CONN->NoQuery("UPDATE ticket_system_settings SET tss_user_only=? WHERE tss_status=? limit 1","ss",$_ARRAY['tss_user_only'],1);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['TICKET']['TICKET_SETTINGS_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
      }
        return $error;
  }
  //:: TICKET SYSTEM : SETTINGS


  //:: TICKET SYSTEM : DEPARTMENTS
  function _DEPARTMENTS_FIELDS () {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['TICKET']['DEPARTMENTS'],
          "group" => true,
          "special" => true
        ),
      "tsd_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['DEPARTMENTS_NAME']
        ),
      "tsd_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_DEPARTMENT", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE_DEPARTMENT", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_REMOVE'] ),
            ),
          "translation" => $_LANG['TICKET']['_PLUGIN_OPTIONS']
        )
    );
    return $_RETURN;
  }
  function _DEPARTMENTS_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `tsd_id`, `tsd_name` FROM ticket_system_departments order by tsd_id desc");
    return $_RETURN;
  }
  function _DEPARTMENT_FIELDS ( ) {

    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['TICKET']['DEPARTMENTS_MANAGE'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "tsd_name"            =>array( 
          "translation" => $_LANG['TICKET']['DEPARTMENTS_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "tsd_ico"            =>array( 
          "translation" => $_LANG['TICKET']['DEPARTMENTS_ICO'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "tsd_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }
  function _DEPARTMENT_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `tsd_id`, `tsd_name`, `tsd_ico` FROM ticket_system_departments where tsd_id=?","i",$_ARRAY['_ID']);
    return $_RETURN;
  }
  function _DEPARTMENT ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    if ( empty ( $_ARRAY['tsd_id'] ) ) {
      $_RETURN  = $this->_DEPARTMENT_ADD ( $_ARRAY );
    } else {
      $_RETURN  = $this->_DEPARTMENT_UPDATE ( $_ARRAY );
    }
    return $_RETURN;
  }
  function _DEPARTMENT_ADD ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_RETURN = $_CONN->NoQuery("INSERT INTO ticket_system_departments VALUES(NULL,?,?)","ss",$_ARRAY['tsd_name'],$_ARRAY['tsd_ico']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['TICKET']['DEPARTMENTS_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
    }
      return $error;
  }
  function _DEPARTMENT_UPDATE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_RETURN = $_CONN->NoQuery("UPDATE ticket_system_departments SET tsd_name=?, tsd_ico=? WHERE tsd_id=? limit 1","sss",$_ARRAY['tsd_name'],$_ARRAY['tsd_ico'],$_ARRAY['tsd_id']);

      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['TICKET']['DEPARTMENTS_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
      }
      return $error;
  }
  function _REMOVE_DEPARTMENT ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->NoQuery("DELETE FROM ticket_system_departments WHERE tsd_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }
  //:: TICKET SYSTEM : DEPARTMENTS


  //:: TICKET SYSTEM : PRIORITIES
  function _PRIORITIES_FIELDS () {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['TICKET']['PRIORITIES'],
          "group" => true,
          "special" => true
        ),
      "ts_priority_priority" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['PRIORITIES_NUMBER']
        ),
      "ts_priority_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['PRIORITIES_NAME']
        ),
      "ts_priority_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_PRIORITY", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE_PRIORITY", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_REMOVE'] ),
            ),
          "translation" => $_LANG['TICKET']['_PLUGIN_OPTIONS']
        )
    );
    return $_RETURN;
  }
  function _PRIORITIES_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `ts_priority_id`, `ts_priority_name`, `ts_priority_ico`, `ts_priority_priority` FROM ticket_system_priority order by ts_priority_priority desc");
    return $_RETURN;
  }

  function _PRIORITY_FIELDS ( ) {

    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['TICKET']['PRIORITIES_MANAGE'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "ts_priority_name"            =>array( 
          "translation" => $_LANG['TICKET']['PRIORITIES_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "ts_priority_ico"            =>array( 
          "translation" => $_LANG['TICKET']['PRIORITIES_ICO'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "ts_priority_priority"            =>array( 
          "translation" => $_LANG['TICKET']['PRIORITIES_VALUE'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ts_priority_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }
  function _PRIORITY_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `ts_priority_id`, `ts_priority_name`, `ts_priority_ico`, `ts_priority_priority` FROM ticket_system_priority where ts_priority_id=?","i",$_ARRAY['_ID']);
    return $_RETURN;
  }
  function _PRIORITY ( $_ARRAY ) {
    if ( empty ( $_ARRAY['ts_priority_id'] ) ) {
      $_RETURN  = $this->_PRIORITY_ADD ( $_ARRAY );
    } else {
      $_RETURN  = $this->_PRIORITY_UPDATE ( $_ARRAY );
    }
    return $_RETURN;
  }
  function _PRIORITY_ADD ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_RETURN = $_CONN->NoQuery("INSERT INTO ticket_system_priority VALUES(NULL,?,?,?)","sss",$_ARRAY['ts_priority_name'],$_ARRAY['ts_priority_ico'],$_ARRAY['ts_priority_priority']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['TICKET']['PRIORITIES_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
    }
      return $error;
  }
  function _PRIORITY_UPDATE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_RETURN = $_CONN->NoQuery("UPDATE ticket_system_priority SET ts_priority_name=?, ts_priority_ico=?, ts_priority_priority=? WHERE ts_priority_id=? limit 1","ssss",$_ARRAY['ts_priority_name'],$_ARRAY['ts_priority_ico'],$_ARRAY['ts_priority_priority'],$_ARRAY['ts_priority_id']);

      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['TICKET']['PRIORITIES_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
      }
      return $error;
  }
  function _REMOVE_PRIORITY ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->NoQuery("DELETE FROM ticket_system_priority WHERE ts_priority_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }
  //:: TICKET SYSTEM : PRIORITIES



  //:: TICKET SYSTEM : STAFF
  function _STAFF_FIELDS() {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['TICKET']['ALL_STAFF'],
          "group" => true,
          "special" => true
        ),
      "tsd_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['STAFF_DEPARTMENT']
        ),
      "ts_staff_open_ticket" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['STAFF_OPEN_TICKET_OPTION']
        ),
      "users_profiles_first_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['STAFF_FIRST_NAME']
        ),
      "users_profiles_last_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['STAFF_LAST_NAME']
        ),
      "ts_staff_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_MANAGE_STAFF", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE_STAFF", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_REMOVE'] ),
            ),
          "translation" => $_LANG['TICKET']['_PLUGIN_OPTIONS']
        )
    );
    return $_RETURN;
  }

  function _STAFF_FIELDS_LIST ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `ts_staff_id`, `ts_staff_user_id`, `ts_staff_department`, `ts_staff_open_ticket`, `users_profiles_first_name`, `users_profiles_last_name`, `tsd_name` FROM ticket_system_staff left join users_profiles on users_profiles.users_profiles_user_id = ticket_system_staff.ts_staff_user_id left join ticket_system_departments on ticket_system_departments.tsd_id = ticket_system_staff.ts_staff_department order by tsd_name desc");

    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'ts_staff_open_ticket', '0', $_LANG['TICKET']['STAFF_OPEN_NO'] );
    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'ts_staff_open_ticket', '1', $_LANG['TICKET']['STAFF_OPEN_YES'] );

    return $_RETURN;
  }

  function _MANAGE_STAFF_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => false,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['TICKET']['STAFF_MANAGE'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "ts_staff_user_id"            =>array( 
          "translation" => $_LANG['TICKET']['STAFF_USER'],
          "field" => "select",
          "method" => "_USERS",
          "_ARRAY" => array(""),
          "_NO_DATA" => $_LANG['TICKET']['STAFF_MANAGE_NO_DATA'],
          "_SELECT_DATA" => $_LANG['TICKET']['STAFF_MANAGE_SELECT_DATA'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ts_staff_department"            =>array( 
          "translation" => $_LANG['TICKET']['STAFF_DEPARTMENT'],
          "field" => "select",
          "method" => "_DEPARTMENTS",
          "_ARRAY" => array(""),
          "_NO_DATA" => $_LANG['TICKET']['STAFF_MANAGE_NO_DATA'],
          "_SELECT_DATA" => $_LANG['TICKET']['STAFF_MANAGE_SELECT_DATA'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ts_staff_open_ticket"            =>array( 
          "translation" => $_LANG['TICKET']['STAFF_OPEN_TICKET'],
          "field" => "select",
          "method" => "_OPEN_TICKET",
          "_ARRAY" => array(""),
          "_NO_DATA" => $_LANG['TICKET']['STAFF_OPEN_TICKET_NO_DATA'],
          "_SELECT_DATA" => $_LANG['TICKET']['STAFF_OPEN_TICKET_SELECT_DATA'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ts_staff_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => "int",
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }
  
  function _MANAGE_STAFF_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `ts_staff_id`, `ts_staff_user_id`, `ts_staff_department`, `ts_staff_open_ticket` FROM ticket_system_staff where ts_staff_id=?","i",$_ARRAY['_ID']);
    return $_RETURN;
  }
  function _OPEN_TICKET ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array(
      array( "_ID" => "0", "_NAME" => $_LANG['TICKET']['STAFF_OPEN_NO'] ),
      array( "_ID" => "1", "_NAME" => $_LANG['TICKET']['STAFF_OPEN_YES'] ),
    );
    return $_RETURN;
  }
  function _STAFF_ADD ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_RETURN = $_CONN->NoQuery("INSERT INTO ticket_system_staff VALUES(NULL,?,?,?)","sss",$_ARRAY['ts_staff_user_id'],$_ARRAY['ts_staff_department'],$_ARRAY['ts_staff_open_ticket']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $error['message']	=	$_LANG['TICKET']['STAFF_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
    }
      return $error;
  }
  function _STAFF_UPDATE ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

    $_RETURN = $_CONN->NoQuery("UPDATE ticket_system_staff SET ts_staff_user_id=?, ts_staff_department=?, ts_staff_open_ticket=? WHERE ts_staff_id=? limit 1","ssss",$_ARRAY['ts_staff_user_id'],$_ARRAY['ts_staff_department'],$_ARRAY['ts_staff_open_ticket'],$_ARRAY['ts_staff_id']);

      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['TICKET']['STAFF_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
      }
      return $error;
  }
  function _USERS ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `user_id` as _ID, concat(users_profiles_last_name,' ', users_profiles_first_name,' ( ',user_email ,' ) ') as _NAME FROM users left join users_profiles on users_profiles.users_profiles_user_id = users.user_id");
    return $_RETURN;
  }
  function _DEPARTMENTS ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `tsd_id` as _ID, `tsd_name` as _NAME FROM ticket_system_departments");
    return $_RETURN;
  }
  function _MANAGE_STAFF( $_ARRAY ) {
    $_CONN    = $this->_DB();
    if ( empty ( $_ARRAY['ts_staff_id'] ) ) {
      $_RETURN  = $this->_STAFF_ADD ( $_ARRAY );
    } else {
      $_RETURN  = $this->_STAFF_UPDATE ( $_ARRAY );
    }
    return $_RETURN;
  }
  function _REMOVE_STAFF ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN  = $_CONN->NoQuery("DELETE FROM ticket_system_staff WHERE ts_staff_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }
  //:: TICKET SYSTEM : STAFF


  //:: TICKET SYSTEM : PRODUCTS

  function _PRODUCTS_FIELDS () {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['TICKET']['PRODUCTS'],
          "group" => true,
          "special" => true
        ),
      "tsp_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['PRODUCTS_NAME']
        ),
      "tsp_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_PRODUCT", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_EDIT'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE_PRODUCT", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_REMOVE'] ),
            ),
          "translation" => $_LANG['TICKET']['_PLUGIN_OPTIONS']
        )
    );
    return $_RETURN;
  }
  function _PRODUCTS_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `tsp_id`, `tsp_name` FROM ticket_system_products order by tsp_id desc");
    return $_RETURN;
  }

  function _PRODUCT_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['TICKET']['PRODUCTS_PRODUCT_MANAGE'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "tsp_name"            =>array( 
          "translation" => $_LANG['TICKET']['PRODUCTS_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "tsp_description"            =>array( 
          "translation" => $_LANG['TICKET']['PRODUCTS_DESCRIPTION'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "tsp_cover"            =>array( 
          "translation" => $_LANG['TICKET']['PRODUCTS_COVER'],
          "field" => "upload",
          "type" => "image",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "tsp_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }
  function _PRODUCT_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `tsp_id`, `tsp_name`, `tsp_cover`, `tsp_description` FROM ticket_system_products where tsp_id=?","i",$_ARRAY['_ID']);
    return $_RETURN;
  }
  function _PRODUCT ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['tsp_id'] ) ) {
      $_RETURN  = $this->_PRODUCT_ADD ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    } else {
      $_RETURN  = $this->_PRODUCT_UPDATE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }
      return $_RETURN;
  }
  function _PRODUCT_ADD ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['tsp_cover'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['tsp_cover'] = $_FULL_IMAGE;
      } else {
          $_ARRAY['tsp_cover'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

    $_RETURN = $_CONN->NoQuery("INSERT INTO ticket_system_products VALUES(NULL,?,?,?)","sss",$_ARRAY['tsp_name'],$_ARRAY['tsp_cover'],$_ARRAY['tsp_description']);
    if ( $_RETURN ) {
      $error['code']		=	'3';
      $_ID  = $_CONN->LastID();
      $error['message']	=	$_LANG['TICKET']['PRODUCTS_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
    }
    return $error;
  }
  function _PRODUCT_UPDATE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['tsp_cover'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['tsp_cover'] = $_FULL_IMAGE;
          
          //:: OLD IMAGE
          $_OLD_IMAGE  = $_CONN->Query("SELECT `tsp_cover` FROM ticket_system_products where tsp_id =? limit 1","s",$_ARRAY['tsp_id']);

          if ( !empty ( $_OLD_IMAGE ) ) {
          $_FILE_LOCATION	=	_UPLOAD_DIR.$_OLD_IMAGE['0']['tsp_cover'];
            if ( !empty ( $_OLD_IMAGE['0']['tsp_cover'] ) ) {
              if (file_exists($_FILE_LOCATION)) {
                unlink($_FILE_LOCATION);
              }
            }
          }
          //:: /OLD IMAGE

          $_CONN->NoQuery("UPDATE ticket_system_products SET tsp_cover=? WHERE tsp_id=? limit 1","ss",$_FULL_IMAGE,$_ARRAY['tsp_id']);
      } else {
          $_ARRAY['tsp_cover'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

    $_RETURN = $_CONN->NoQuery("UPDATE ticket_system_products SET tsp_name=?, tsp_description=? WHERE tsp_id=? limit 1","sss",$_ARRAY['tsp_name'],$_ARRAY['tsp_description'],$_ARRAY['tsp_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['TICKET']['PRODUCTS_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
      }
    return $error;
  }

  //:: REMOVE
  function _FILE_REMOVE ( $_ARRAY ) {
    $_CONN    = $this->_DB();

      if ( $_ARRAY['_ROUTE'] == '_PRODUCT' ) {
        $_VALIDATE  = $_CONN->Query("SELECT `tsp_cover` FROM ticket_system_products where tsp_id=? and tsp_cover=? limit 1","ss",$_ARRAY['_ID'], $_ARRAY['_FILE']);
        if ( !empty ( $_VALIDATE ) ) {
        $_FILE_LOCATION	=	_UPLOAD_DIR.$_VALIDATE['0']['tsp_cover'];
        if ( !empty ( $_VALIDATE['0']['tsp_cover'] ) ) {
          if (file_exists($_FILE_LOCATION)) {
            unlink($_FILE_LOCATION);
          }
        }
          $_RETURN = $_CONN->NoQuery("UPDATE ticket_system_products SET tsp_cover=? WHERE tsp_id=? limit 1","ss","",$_ARRAY['_ID']);
        } else {
          $_RETURN  = false;
        }
      }

      if ( $_ARRAY['_ROUTE'] == '_MANAGE' ) {
        $_VALIDATE  = $_CONN->Query("SELECT `ticket_system_file` FROM ticket_system where ticket_system_id=? and ticket_system_file=? limit 1","ss",$_ARRAY['_ID'], $_ARRAY['_FILE']);
        if ( !empty ( $_VALIDATE ) ) {
        $_FILE_LOCATION	=	_UPLOAD_DIR.$_VALIDATE['0']['ticket_system_file'];
        if ( !empty ( $_VALIDATE['0']['ticket_system_file'] ) ) {
          if (file_exists($_FILE_LOCATION)) {
            unlink($_FILE_LOCATION);
          }
        }
          $_RETURN = $_CONN->NoQuery("UPDATE ticket_system SET ticket_system_file=? WHERE ticket_system_id=? limit 1","ss","",$_ARRAY['_ID']);
        } else {
          $_RETURN  = false;
        }
      }

    return $_RETURN;
  }
  function _REMOVE_PRODUCT ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_FILE  = $_CONN->Query("SELECT `tsp_cover` FROM ticket_system_products where tsp_id=? limit 1","s",$_ARRAY['_ID']);
    if ( !empty ( $_FILE['0']['tsp_cover'] ) ) {
    $_FILE_LOCATION	=	_UPLOAD_DIR.$_FILE['0']['tsp_cover'];
    if ( !empty ( $_FILE['0']['tsp_cover'] ) ) {
      if (file_exists($_FILE_LOCATION)) {
				unlink($_FILE_LOCATION);
      }
    }
    }
    $_RETURN  = $_CONN->NoQuery("DELETE FROM ticket_system_products WHERE tsp_id=? limit 1","i",$_ARRAY['_ID']);
    return $_RETURN;
  }
  //:: TICKET SYSTEM : PRODUCTS

  //:: TICKET SYSTEM : MANAGE

  function _ALL_FIELDS () {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['TICKET']['TICKETS'],
          "group" => true,
          "special" => true
        ),
      "ticket_system_date" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_DATE'],
          "type"        => 'date'
        ),
      "ticket_system_status" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_STATUS']
        ),
      "tsd_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_DEPARTMENT']
        ),
      "ticket_system_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_NAME']
        ),
        "ticket_system_subject" => array (
            "options" => false,
            "translation" => $_LANG['TICKET']['TICKET_SUBJECT']
          ),
      "tsp_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_PRODUCT']
        ),



      "ticket_system_id" => array (
          "options" => array (
              "edit" => array( "url" => "FIELDS/_MANAGE", "ico" => "<i class=\"fa fa-edit\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_EDIT'] ),
              "reply" => array( "url" => "FIELDS/_REPLY", "ico" => "<i class=\"glyphicon glyphicon-envelope\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_REPLY'] ),
              "remove" => array( "url" => "", "route" => "_REMOVE_TICKET", "class" => "pluginItemRemove", "ico" => "<i class=\"fa fa-trash\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_REMOVE'] ),
            ),
          "translation" => $_LANG['TICKET']['_PLUGIN_OPTIONS']
        )
    );
    return $_RETURN;
  }
  function _ALL_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();
    $_LANG    = $this->_LANGUAGE();

    $_RETURN = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_subject`, `ticket_system_status`, `tsp_name`, `tsd_name`, `users_profiles_first_name`, `users_profiles_last_name`, `ticket_system_date` FROM ticket_system left join ticket_system_products on ticket_system_products.tsp_id = ticket_system.ticket_system_product left join ticket_system_departments on ticket_system_departments.tsd_id = ticket_system.ticket_system_department left join users_profiles on users_profiles.users_profiles_user_id = ticket_system.ticket_system_user_id left join ticket_system_priority on ticket_system_priority.ts_priority_id = ticket_system.ticket_system_priority order by ticket_system_id desc");

    $_RETURN  = $_PREPARE->_array_key_replace( $_RETURN, 'ticket_system_name', '', 'users_profiles_last_name,users_profiles_first_name' );

    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'ticket_system_status', '0', $_LANG['TICKET']['TICKET_STATUS_CLOSE'] );
    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'ticket_system_status', '1', $_LANG['TICKET']['TICKET_STATUS_OPEN'] );

    return $_RETURN;
  }

  function _MANAGE_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['TICKET']['TICKET_GUEST_MODE'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

        //:: DECIDE IF GUEST OR USER
      "ticket_system_guest"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_GUEST'],
          "field" => "select",
          "method" => "_USER_TYPE",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_GUEST_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "ticket_system_user_id"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_USER'],
          "field" => "select",
          "method" => "_USERS",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_USER_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
        //:: USER EMAIL / NAME IF GUEST
      "ticket_system_name"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_GUEST_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "ticket_system_email"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_GUEST_EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "email",
          "options" => false,
          "class" => "col-md-6"
        ),

      "GROUP_3"  => array(
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "ticket_system_department"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS_DEPARTMENT'],
          "field" => "select",
          "method" => "_DEPARTMENTS_SELECT",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_SETTINGS_DEPARTMENT_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "ticket_system_priority"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS_PRIORITY'],
          "field" => "select",
          "method" => "_PRIORITY_SELECT",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_SETTINGS_PRIORITY_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "GROUP_4"  => array(
          "translation" => $_LANG['TICKET']['TICKET_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "ticket_system_product"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_PRODUCT'],
          "field" => "select",
          "method" => "_PRODUCTS_SELECT",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_PRODUCT_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_subject"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_SUBJECT'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_details"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_INFO'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "ticket_system_file"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_FILE'],
          "field" => "upload",
          "type" => "file",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_status"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_FIELDS_STATUS'],
          "field" => "select",
          "method" => "_TICKET_STATUS",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_STATUS_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),


      "ticket_system_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  function _DEPARTMENTS_SELECT ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `tsd_id` as _ID, `tsd_name` as _NAME FROM ticket_system_departments");
    return $_RETURN;
  }

  function _PRODUCTS_SELECT ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `tsp_id` as _ID, `tsp_name` as _NAME FROM ticket_system_products");
    return $_RETURN;
  }

  function _PRIORITY_SELECT ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `ts_priority_id` as _ID, `ts_priority_name` as _NAME FROM ticket_system_priority");
    return $_RETURN;
  }

  function _MANAGE_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status` FROM ticket_system where ticket_system_id=?","i",$_ARRAY['_ID']);
    return $_RETURN;
  }
  function _TICKET_STATUS ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array(
      array( "_ID" => "0", "_NAME" => $_LANG['TICKET']['TICKET_STATUS_CLOSE'] ),
      array( "_ID" => "1", "_NAME" => $_LANG['TICKET']['TICKET_STATUS_OPEN'] ),
    );
    return $_RETURN;
  }
  function _USER_TYPE ( $_ARRAY ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array(
      array( "_ID" => "0", "_NAME" => $_LANG['TICKET']['TICKET_GUEST_YES'] ),
      array( "_ID" => "1", "_NAME" => $_LANG['TICKET']['TICKET_GUEST_NO'] ),
    );
    return $_RETURN;
  }

  //:: ADD THE TICKET TO THE DATABASE
  function _MANAGE ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['ticket_system_id'] ) ) {
      $_RETURN  = $this->_ADD_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    } else {
      $_RETURN  = $this->_UPDATE_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }
      return $_RETURN;
  }

  function _ADD_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();
    

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['ticket_system_file'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
        'rar'   => TRUE,
        'zip'   => TRUE,
        '7zip'   => TRUE,
        'pdf'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['ticket_system_file'] = $_FULL_IMAGE;
      } else {
          $_ARRAY['ticket_system_file'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE
    $_ARRAY['ticket_system_unique_url'] = md5( rand().strtotime("now") );
    if ( empty ( $_ARRAY['ticket_system_user_id'] ) ) { $_ARRAY['ticket_system_user_id'] = ''; }
    if ( empty ( $_ARRAY['ticket_system_name'] ) ) { $_ARRAY['ticket_system_name'] = ''; }
    if ( empty ( $_ARRAY['ticket_system_email'] ) ) { $_ARRAY['ticket_system_email'] = ''; }
    
    //:: OPENED BY
    //:: 1 - admin
    //:: 2 - staff
    //:: 3 - user
    //:: 4 - visitor
    $ticket_system_opened_by_type = '1';
    
    //:: STORE THE ADMIN ID
    $ticket_system_opened_by_id = $_SESSION['ADMIN_SESSION']['0']['admin_id'];
    $ticket_system_date         = strtotime( "now" );

    $_RETURN = $_CONN->NoQuery("INSERT INTO ticket_system VALUES(NULL,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)","sssssssssssssss",$ticket_system_opened_by_type,$ticket_system_opened_by_id,$_ARRAY['ticket_system_guest'],$_ARRAY['ticket_system_user_id'],$_ARRAY['ticket_system_department'],$_ARRAY['ticket_system_priority'],$_ARRAY['ticket_system_product'],$_ARRAY['ticket_system_name'],$_ARRAY['ticket_system_email'],$_ARRAY['ticket_system_subject'],$_ARRAY['ticket_system_details'],$_ARRAY['ticket_system_file'],$_ARRAY['ticket_system_unique_url'],$_ARRAY['ticket_system_status'],$ticket_system_date);
    if ( $_RETURN ) {

    $_ADMIN       = $this->_ADMINISTRATOR();
    $_SMTP        = $_ADMIN->_SMTP_FIELDS_LIST( $_ARRAY );

//:: START SMTP AND SEND THE EMAIL

  //:: GET THE NOTIFICATION EMAIL
  if ( $_ARRAY['ticket_system_guest'] == 0 ) {
    //GUEST MODE
    $_NOTIFICATION_EMAIL  = $_ARRAY['ticket_system_email'];
  } else {
    //USER MODE
    $_USER_DETAILS        = $_CONN->Query("SELECT `user_email` FROM users where user_id=? limit 1","i",$_ARRAY['ticket_system_user_id']);
    $_NOTIFICATION_EMAIL  = $_USER_DETAILS['0']['user_email'];
  }

  $details	= '
  
<div class="rcmBody" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; background-color: #FFFFFF;">
<title>'.$_ARRAY['ticket_system_subject'].'</title>
<table cellspacing="0" cellpadding="0" width="100%"><tbody><tr><td align="center" width="100%"><br><table cellspacing="0" cellpadding="0" width="700" style="border: 1px  solid  #c7c7c7; box-shadow: 0  1px  3px  #c3c2c3; -webkit-box-shadow: 0  1px  7px  #c3c2c3; -moz-box-shadow: 0  1px  3px  #c3c2c3; -moz-background-clip: padding; -webkit-background-clip: padding-box; background-clip: padding-box; background: #fff; border-radius: 0px; padding: 5px;"><tbody><tr><td style="height: 50px; text-align: left;">'._CMS_NAME.'</td>
				</tr><tr><td style="height: 5px; background-color: #FF6600;">
				</td></tr><tr><td align="left" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; font-weight: normal; padding: 15px; background-color: #FFFFFF;">

<br><div style="background-color: #FFFFCC; border: 1px  solid  #FFCC00; clear: both; color: #333333; font-weight: bold; list-style: none outside none; margin-bottom: 10px; padding: 9px  10px  9px  5px;">

'.$_PREPARE->sanitize( $_ARRAY['ticket_system_details'], 'textarea-decode' ).'

<br><br>
<div style="text-align: center;"><a href="'.HTTP_SERVER_WEBSITE.'ticket/direct?id='.$_ARRAY['ticket_system_unique_url'].'">'.$_LANG['TICKET']['TICKET_VIEW_DETAILS'].'</a></div>
</div>
<br><div style="float: right;"><a style="color: red; text-decoration: none;" href="'.HTTP_SERVER_WEBSITE.'" target="_blank">'._COPYRIGHT.'</a></div> 


					</td>
				</tr></tbody></table></td>
	</tr></tbody></table></div>
  
  ';

  $headers = "MIME-Version: 1.0" . "\r\n";
  $headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
  $headers .= "From: \r\n";
  $subject = $_ARRAY['ticket_system_subject'];

  //START THE SMTP
  $smtp_email = new \PHPMailer();
  $smtp_email->IsSMTP();
  $smtp_email->SMTPDebug = 0;
  $smtp_email->SMTPAuth = 'login';
  $smtp_email->SMTPSecure = $_SMTP['0']['smtp_secure'];
  $smtp_email->Host = $_SMTP['0']['smtp_host'];
  $smtp_email->Port = $_SMTP['0']['smtp_port'];
  $smtp_email->Username = $_SMTP['0']['smtp_username'];
  $smtp_email->Password = $_SMTP['0']['smtp_password'];

	$smtp_email->SetFrom( $_SMTP['0']['smtp_set_from'], $_SMTP['0']['smtp_set_name']);
	$smtp_email->Subject = $subject;
	$smtp_email->Body = $details;
	$smtp_email->IsHTML(true);
	$smtp_email->AddAddress( $_NOTIFICATION_EMAIL );
	$smtp_email->Send();
  $smtp_email->ClearAddresses();
//:: START SMTP AND SEND THE EMAIL


      $error['code']		=	'3';
      $_ID  = $_CONN->LastID();
      $error['message']	=	$_LANG['TICKET']['TICKET_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
    }
    return $error;
  }

  function _UPDATE_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['ticket_system_file'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['ticket_system_file'] = $_FULL_IMAGE;
          
          //:: OLD IMAGE
          $_OLD_IMAGE  = $_CONN->Query("SELECT `ticket_system_file` FROM ticket_system where ticket_system_id =? limit 1","s",$_ARRAY['ticket_system_id']);

          if ( !empty ( $_OLD_IMAGE['0']['ticket_system_file'] ) ) {
          $_FILE_LOCATION	=	_UPLOAD_DIR.$_OLD_IMAGE['0']['ticket_system_file'];
            if (file_exists($_FILE_LOCATION)) {
              unlink($_FILE_LOCATION);
            }
          }
          //:: /OLD IMAGE

          $_CONN->NoQuery("UPDATE ticket_system SET ticket_system_file=? WHERE ticket_system_id=? limit 1","ss",$_FULL_IMAGE,$_ARRAY['ticket_system_id']);
      } else {
          $_ARRAY['ticket_system_file'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

    $_RETURN = $_CONN->NoQuery("UPDATE ticket_system SET ticket_system_department=?, ticket_system_priority=?, ticket_system_product=?, ticket_system_subject=?, ticket_system_details=?, ticket_system_status=? WHERE ticket_system_id=? limit 1","sssssss",$_ARRAY['ticket_system_department'],$_ARRAY['ticket_system_priority'],$_ARRAY['ticket_system_product'],$_ARRAY['ticket_system_subject'],$_ARRAY['ticket_system_details'],$_ARRAY['ticket_system_status'],$_ARRAY['ticket_system_id']);
      if ( $_RETURN ) {
        $error['code']		=	'1';
        $error['message']	=	$_LANG['TICKET']['TICKET_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
      }
    return $error;
  }


  function _REMOVE_TICKET ( $_ARRAY ) {
    $_CONN    = $this->_DB();

    //:: REMOVE REPLY LIST
      $_REPLY_LST  = $_CONN->Query("SELECT `ticket_system_reply_id`, `ticket_system_reply_file` FROM ticket_system_reply where ticket_system_reply_ticket_id=?","s",$_ARRAY['_ID']);
    
      foreach ( $_REPLY_LST as $_REPLY ) {

      //:: RMV THE FILE
        if ( !empty ( $_REPLY['ticket_system_reply_file'] ) ) {
        $_FILE_LOCATION	=	_UPLOAD_DIR.$_REPLY['ticket_system_reply_file'];
          if (file_exists($_FILE_LOCATION)) {
            unlink($_FILE_LOCATION);
          }
        }
      //:: RMV THE FILE
        $_CONN->NoQuery("DELETE FROM ticket_system_reply WHERE ticket_system_reply_id=? limit 1","i",$_REPLY['ticket_system_reply_id']);
      }
    //:: END REMOVE REPLY LIST

    $_FILE  = $_CONN->Query("SELECT `ticket_system_file` FROM ticket_system where ticket_system_id=? limit 1","s",$_ARRAY['_ID']);
    if ( !empty ( $_FILE['0']['ticket_system_file'] ) ) {
    $_FILE_LOCATION	=	_UPLOAD_DIR.$_FILE['0']['ticket_system_file'];
      if (file_exists($_FILE_LOCATION)) {
				unlink($_FILE_LOCATION);
      }
    }
    $_RETURN  = $_CONN->NoQuery("DELETE FROM ticket_system WHERE ticket_system_id=? limit 1","i",$_ARRAY['_ID']);



    return $_RETURN;
  }
  //:: TICKET SYSTEM : MANAGE


  //:: TICKET SYSTEM : REPLY
  function _REPLY ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['ticket_system_id'] ) ) {
      $_RETURN  = false;
    } else {
      $_RETURN  = $this->_ADD_REPLY ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }
      return $_RETURN;
  }

  function _ADD_REPLY ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['ticket_system_file'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
        'rar'   => TRUE,
        'zip'   => TRUE,
        '7zip'   => TRUE,
        'pdf'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['ticket_system_file'] = $_FULL_IMAGE;
      } else {
          $_ARRAY['ticket_system_file'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

  $_CONN->NoQuery("UPDATE ticket_system SET ticket_system_status=? WHERE ticket_system_id=? limit 1","ss",$_ARRAY['ticket_system_status'],$_ARRAY['ticket_system_id']);

    //:: STORE THE REPLY
    $ticket_system_reply_ticket_id  = $_ARRAY['ticket_system_id'];
    $ticket_system_reply_by_type    = '1';
    $ticket_system_reply_user_id    = $_SESSION['ADMIN_SESSION']['0']['admin_id'];
    $ticket_system_reply_details    = $_ARRAY['ticket_system_details'];
    $ticket_system_reply_file       = $_ARRAY['ticket_system_file'];
    $ticket_system_reply_status     = '';
    $ticket_system_reply_date       = strtotime( "now" );

    $_RETURN = $_CONN->NoQuery("INSERT INTO ticket_system_reply VALUES(NULL,?,?,?,?,?,?,?)","sssssss",$ticket_system_reply_ticket_id,$ticket_system_reply_by_type,$ticket_system_reply_user_id,$ticket_system_reply_details,$ticket_system_reply_file,$ticket_system_reply_status,$ticket_system_reply_date);
    //:: END STORE THE REPLY

      if ( $_RETURN ) {

//:: START SMTP AND SEND THE EMAIL
    $_ADMIN       = $this->_ADMINISTRATOR();
    $_SMTP        = $_ADMIN->_SMTP_FIELDS_LIST( $_ARRAY );


  //:: GET THE NOTIFICATION EMAIL
  $_TS  = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_opened_by_type`, `ticket_system_opened_by_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status` FROM ticket_system where ticket_system_id=? limit 1","i",$_ARRAY['ticket_system_id']);

  if ( $_TS['0']['ticket_system_guest'] == 0 ) {
    //GUEST MODE
    $_NOTIFICATION_EMAIL  = $_TS['0']['ticket_system_email'];
  } else {
    //USER MODE
    $_USER_DETAILS        = $_CONN->Query("SELECT `user_email` FROM users where user_id=? limit 1","i",$_TS['0']['ticket_system_user_id']);
    $_NOTIFICATION_EMAIL  = $_USER_DETAILS['0']['user_email'];
  }

  $details	= '

<div class="rcmBody" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; background-color: #FFFFFF;">
<title>'.$_TS['0']['ticket_system_subject'].'</title>
<table cellspacing="0" cellpadding="0" width="100%"><tbody><tr><td align="center" width="100%"><br><table cellspacing="0" cellpadding="0" width="700" style="border: 1px  solid  #c7c7c7; box-shadow: 0  1px  3px  #c3c2c3; -webkit-box-shadow: 0  1px  7px  #c3c2c3; -moz-box-shadow: 0  1px  3px  #c3c2c3; -moz-background-clip: padding; -webkit-background-clip: padding-box; background-clip: padding-box; background: #fff; border-radius: 0px; padding: 5px;"><tbody><tr><td style="height: 50px; text-align: left;">'._CMS_NAME.'</td>
				</tr><tr><td style="height: 5px; background-color: #FF6600;">
				</td></tr><tr><td align="left" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; font-weight: normal; padding: 15px; background-color: #FFFFFF;">

<br><div style="background-color: #FFFFCC; border: 1px  solid  #FFCC00; clear: both; color: #333333; font-weight: bold; list-style: none outside none; margin-bottom: 10px; padding: 9px  10px  9px  5px;">

'.$_PREPARE->sanitize( $_ARRAY['ticket_system_details'], 'textarea-decode' ).'

<br><br>
<div style="text-align: center;"><a href="'.HTTP_SERVER_WEBSITE.'ticket/direct?id='.$_TS['0']['ticket_system_unique_url'].'">'.$_LANG['TICKET']['TICKET_VIEW_DETAILS'].'</a></div>
</div>
<br><div style="float: right;"><a style="color: red; text-decoration: none;" href="'.HTTP_SERVER_WEBSITE.'" target="_blank">'._COPYRIGHT.'</a></div> 


					</td>
				</tr></tbody></table></td>
	</tr></tbody></table></div>
  
  ';

  $headers = "MIME-Version: 1.0" . "\r\n";
  $headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
  $headers .= "From: \r\n";
  $subject = $_LANG['TICKET']['REPLY_RE'].$_TS['0']['ticket_system_subject'];

  //START THE SMTP
  $smtp_email = new \PHPMailer();
  $smtp_email->IsSMTP();
  $smtp_email->SMTPDebug = 0;
  $smtp_email->SMTPAuth = 'login';
  $smtp_email->SMTPSecure = $_SMTP['0']['smtp_secure'];
  $smtp_email->Host = $_SMTP['0']['smtp_host'];
  $smtp_email->Port = $_SMTP['0']['smtp_port'];
  $smtp_email->Username = $_SMTP['0']['smtp_username'];
  $smtp_email->Password = $_SMTP['0']['smtp_password'];

	$smtp_email->SetFrom( $_SMTP['0']['smtp_set_from'], $_SMTP['0']['smtp_set_name']);
	$smtp_email->Subject = $subject;
	$smtp_email->Body = $details;
	$smtp_email->IsHTML(true);
	$smtp_email->AddAddress( $_NOTIFICATION_EMAIL );
	$smtp_email->Send();
  $smtp_email->ClearAddresses();


//:: END START SMTP AND SEND THE EMAIL


        $error['code']		=	'1';
        $error['message']	=	$_LANG['TICKET']['TICKET_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
      }
    return $error;

  }
  //:: END TICKET SYSTEM : REPLY


  function _REPLY_FIELDS ( ) {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['TICKET']['REPLY'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

      "ticket_system_details"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_INFO'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "ticket_system_file"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_FILE'],
          "field" => "upload",
          "type" => "file",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_status"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_FIELDS_STATUS'],
          "field" => "select",
          "method" => "_TICKET_STATUS",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_STATUS_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),


      "ticket_system_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );
    return $_RETURN;
  }

  function _REPLY_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_RETURN = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status` FROM ticket_system where ticket_system_id=?","i",$_ARRAY['_ID']);
    $_RETURN['0']['ticket_system_details']  = '';
    $_RETURN['0']['ticket_system_file']     = '';
    return $_RETURN;
  }

  //:: EXTRA TOP / BOTTOM ADMIN CODE
  function _EXTRA_CODE ( $_ARRAY ) {
    /**
     * $_ARRAY['_POSITION']
     * _TOP
     * _BOTTOM
     * $_ARRAY['_ROUTE']
     * PLUGIN ROUTE
     */
    $_ROUTE     = $_ARRAY['_ROUTE'];
    $_POSITION  = $_ARRAY['_POSITION'];
    $_RETURN    = '';

    //:: OPEN TICKET PAGE
    if ( $_ROUTE == '_MANAGE' ) {
      if ( $_POSITION == '_TOP' ) {
        $_RETURN  = '';
      }
      if ( $_POSITION == '_BOTTOM' ) {
        $_RETURN  = '
        <script>
          $( document ).ready(function() {
            function _DISABLE_ALL() {
              $("#ticket_system_name" ).attr("disabled", true);
              $("#ticket_system_email" ).attr("disabled", true);
              $("#ticket_system_user_id" ).attr("disabled", true);
            }
            function _DISABLE_TICKET_UPDATE() {
              $("#ticket_system_name" ).attr("disabled", true);
              $("#ticket_system_email" ).attr("disabled", true);
              $("#ticket_system_user_id" ).attr("disabled", true);
              $("#ticket_system_guest" ).attr("disabled", true);
            }
            function _USER_MODE () {
              $("#ticket_system_user_id").removeAttr("disabled");
            }
            function _GUEST_MODE () {
              $("#ticket_system_name").removeAttr("disabled");
              $("#ticket_system_email").removeAttr("disabled");
            }
            var _VALIDATE_TYPE  = $("#ticket_system_guest").val();
            if ( !_VALIDATE_TYPE ) {
              _DISABLE_ALL();
            } else {
              _DISABLE_TICKET_UPDATE();
              /*
              if ( _VALIDATE_TYPE == 0 ) {
                _GUEST_MODE ();
              } else {
                _USER_MODE ();
              }
              */
            }

          $(document).on("change","#ticket_system_guest",function() {
            _DISABLE_ALL();
            _SELECTED = $("#ticket_system_guest").val();
            if ( _SELECTED == 0 ) {
              _GUEST_MODE ();
            } else {
              _USER_MODE ();
            }
          });

          });
        </script>
        
        ';
      }
    }
    //:: END OPEN TICKET PAGE

    //:: TICKET REPLY PAGE
    if ( $_ROUTE == '_REPLY' ) {
      if ( $_POSITION == '_TOP' ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_TICKET_DETAILS = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status`, `ticket_system_date`, `tsd_name`, `ts_priority_name`, `tsp_name` FROM ticket_system left join ticket_system_departments on ticket_system_departments.tsd_id = ticket_system.ticket_system_department left join ticket_system_priority on ticket_system_priority.ts_priority_id = ticket_system.ticket_system_priority left join ticket_system_products on ticket_system_products.tsp_id = ticket_system.ticket_system_product where ticket_system_id=?","i",$_ARRAY['_ID']);

  //:: GET CLIENT INFO
  if ( $_TICKET_DETAILS['0']['ticket_system_guest'] == 0 ) {
    //GUEST MODE
    $_CLIENT_NAME   = $_TICKET_DETAILS['0']['ticket_system_name'];
    $_CLIENT_EMAIL  = $_TICKET_DETAILS['0']['ticket_system_email'];
  } else {
    //:: USER MODE
    $_USER_DETAILS        = $_CONN->Query("SELECT `user_email`, `users_profiles_first_name`, `users_profiles_last_name` FROM users left join users_profiles on users_profiles.users_profiles_user_id = users.user_id where user_id=? limit 1","i",$_TICKET_DETAILS['0']['ticket_system_user_id']);

    $_CLIENT_NAME   = $_USER_DETAILS['0']['users_profiles_first_name'].' '.$_USER_DETAILS['0']['users_profiles_last_name'];
    $_CLIENT_EMAIL  = $_USER_DETAILS['0']['user_email'];
  }




        $_RETURN  = '
        <div class="margin-top-10">



<!-- CLIENT DETAILS -->
<div class="col-md-6">
<div class="box box-success">

<div class="box-header">
  <h3 class="box-title">'.$_LANG['TICKET']['REPLY_CLIENT_DETAILS'].'</h3>
</div>


<div class="box-body no-padding">
<table class="table table-condensed">

  <tbody>
    <tr>
      <td>'.$_LANG['TICKET']['REPLY_NAME'].'</td>
      <td>'.$_CLIENT_NAME.'</td>
    </tr>

    <tr>
      <td>'.$_LANG['TICKET']['REPLY_EMAIL'].'</td>
      <td>'.$_CLIENT_EMAIL.'</td>
    </tr>

  </tbody>
</table>
</div><!-- /.box-body -->

</div>
</div>
<!-- ./ CLIENT DETAILS -->



<!-- TICKET DETAILS -->
<div class="col-md-6">
<div class="box box-success">

<div class="box-header">
  <h3 class="box-title">'.$_LANG['TICKET']['REPLY_TICKET_DETAILS'].'</h3>
</div>



<div class="box-body no-padding">
<table class="table table-condensed">

  <tbody>
    <tr>
      <td>'.$_LANG['TICKET']['REPLY_DEPARTMENT'].'</td>
      <td>'.$_TICKET_DETAILS['0']['tsd_name'].'</td>
    </tr>

    <tr>
      <td>'.$_LANG['TICKET']['REPLY_PRIORITY'].'</td>
      <td>'.$_TICKET_DETAILS['0']['ts_priority_name'].'</td>
    </tr>

    <tr>
      <td>'.$_LANG['TICKET']['REPLY_PRODUT'].'</td>
      <td>'.$_TICKET_DETAILS['0']['tsp_name'].'</td>
    </tr>

  </tbody>
</table>
</div><!-- /.box-body -->

</div>
</div>
<!-- ./ TICKET DETAILS -->


        </div>
        ';
      }

      if ( $_POSITION == '_BOTTOM' ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

      $_TICKET_DETAILS = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_opened_by_type`, `ticket_system_opened_by_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status`, `ticket_system_date`, `tsd_name`, `ts_priority_name`, `tsp_name` FROM ticket_system left join ticket_system_departments on ticket_system_departments.tsd_id = ticket_system.ticket_system_department left join ticket_system_priority on ticket_system_priority.ts_priority_id = ticket_system.ticket_system_priority left join ticket_system_products on ticket_system_products.tsp_id = ticket_system.ticket_system_product where ticket_system_id=?","i",$_ARRAY['_ID']);


    
    //:: OPENED BY
    //:: 1 - admin
    //:: 2 - staff
    //:: 3 - user
    //:: 4 - visitor

  //:: OPENED BY ADMIN
    if ( $_TICKET_DETAILS['0']['ticket_system_opened_by_type'] == 1 ) {
      $_TDI = $_CONN->Query("SELECT `admin_id`, `admin_name`, `admin_email`, `admin_username`, `admin_image`, `admin_password`, `admin_session_id` FROM administrator where admin_id=?","i",$_TICKET_DETAILS['0']['ticket_system_opened_by_id']);
      $_TDI_NAME      = $_TDI['0']['admin_name'];

      if ( empty ( $_TDI['0']['admin_image'] ) ) {
        $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
      } else {
        $_TDI_IMAGE_SRC = _UPLOAD_DIR_HTTP.$_TDI['0']['admin_image'];
      }
    }
  //:: END OPENED BY ADMIN

  //:: OPENED BY STAFF
    if ( $_TICKET_DETAILS['0']['ticket_system_opened_by_type'] == 2 ) {
      $_TDI = $_CONN->Query("SELECT `users_profiles_user_id`, `users_profiles_picture`, `users_profiles_first_name`, `users_profiles_last_name` FROM users_profiles where users_profiles_user_id=?","i",$_TICKET_DETAILS['0']['ticket_system_opened_by_id']);
      $_TDI_NAME      = $_TDI['0']['users_profiles_first_name'].' '.$_TDI['0']['users_profiles_last_name'];

      if ( empty ( $_TDI['0']['users_profiles_picture'] ) ) {
        $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
      } else {
        $_TDI_IMAGE_SRC = _UPLOAD_DIR_HTTP.$_TDI['0']['users_profiles_picture'];
      }
    }
  //:: END OPENED BY STAFF

  //:: OPENED BY USER
    if ( $_TICKET_DETAILS['0']['ticket_system_opened_by_type'] == 3 ) {
      $_TDI = $_CONN->Query("SELECT `users_profiles_user_id`, `users_profiles_picture`, `users_profiles_first_name`, `users_profiles_last_name` FROM users_profiles where users_profiles_user_id=?","i",$_TICKET_DETAILS['0']['ticket_system_opened_by_id']);
      $_TDI_NAME      = $_TDI['0']['users_profiles_first_name'].' '.$_TDI['0']['users_profiles_last_name'];

      if ( empty ( $_TDI['0']['users_profiles_picture'] ) ) {
        $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
      } else {
        $_TDI_IMAGE_SRC = _UPLOAD_DIR_HTTP.$_TDI['0']['users_profiles_picture'];
      }
    }
  //:: END OPENED BY USER

  //:: OPENED BY VISITOR
    if ( $_TICKET_DETAILS['0']['ticket_system_opened_by_type'] == 4 ) {
      $_TDI_NAME      = $_TICKET_DETAILS['0']['ticket_system_name'];
      $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
    }
  //:: END OPENED BY VISITOR

  // :: FIRST REPLY TICKET DETAILS
      $DATE   = date( DATE_FORMAT, $_TICKET_DETAILS['0']['ticket_system_date'] );
      $HOUR   = date( HOUR_FORMAT, $_TICKET_DETAILS['0']['ticket_system_date'] );

      $_TDI_DATE      = $DATE.' '.$HOUR;
      $_TDI_DETAILS   = $_PREPARE->sanitize( $_TICKET_DETAILS['0']['ticket_system_details'], 'textarea-decode' );

      $_TDI_ATTACHMENT  = '';
      if ( !empty ( $_TICKET_DETAILS['0']['ticket_system_file'] ) ) {
        $_TDI_ATTACHMENT  = "<a target='_blank' href='".HTTP_SERVER_WEBSITE."administrators/get?f=".$_TICKET_DETAILS['0']['ticket_system_file']."'>".$_LANG['TICKET']['REPLY_DOWNLOAD']."</a>";
      }
  // :: FIRST REPLY TICKET DETAILS

    if ( ( $_TICKET_DETAILS['0']['ticket_system_opened_by_type'] == 1 ) or ( $_TICKET_DETAILS['0']['ticket_system_opened_by_type'] == 2 ) ) {
          $_FIRST_REPLY = '
      <!-- Message. Default to the left -->
      <div class="direct-chat-msg">
        <div class="direct-chat-info clearfix">
          <span class="direct-chat-name pull-left">'.$_TDI_NAME.'</span>
          <span class="direct-chat-timestamp pull-right">'.$_TDI_DATE.'</span>
        </div><!-- /.direct-chat-info -->

      <img class="direct-chat-img" src="'.$_TDI_IMAGE_SRC.'" alt="">

        <div class="direct-chat-text">
          '.$_TDI_DETAILS.'
          '.$_TDI_ATTACHMENT.'
        </div><!-- /.direct-chat-text -->
      </div><!-- /.direct-chat-msg -->
          ';
    } else {
          $_FIRST_REPLY = '
      <!-- Message. Default to the left -->
      <div class="direct-chat-msg right">
        <div class="direct-chat-info clearfix">
          <span class="direct-chat-name pull-right">'.$_TDI_NAME.'</span>
          <span class="direct-chat-timestamp pull-left">'.$_TDI_DATE.'</span>
        </div><!-- /.direct-chat-info -->

      <img class="direct-chat-img" src="'.$_TDI_IMAGE_SRC.'" alt="">

        <div class="direct-chat-text">
          '.$_TDI_DETAILS.'
          '.$_TDI_ATTACHMENT.'
        </div><!-- /.direct-chat-text -->
      </div><!-- /.direct-chat-msg -->
          ';
    }

      $_REPLY_LOAD  = $_CONN->Query("SELECT `ticket_system_reply_id`, `ticket_system_reply_ticket_id`, `ticket_system_reply_by_type`, `ticket_system_reply_user_id`, `ticket_system_reply_details`, `ticket_system_reply_file`, `ticket_system_reply_status`, `ticket_system_reply_date` FROM ticket_system_reply where ticket_system_reply_ticket_id=? order by ticket_system_reply_id DESC","i",$_TICKET_DETAILS['0']['ticket_system_id']);

        $_RETURN  = '
<div class="margin-top-10 col-md-12">
<div class="box box-danger direct-chat direct-chat-primary">

<div class="box-header with-border">
  <h3 class="box-title">'.$_LANG['TICKET']['TICKETS_REPLIES'].'</h3>
</div><!-- /.box-header -->


<div class="box-body">
<!-- Conversations are loaded here -->
  <div class="col-md-12">
';


  foreach ( $_REPLY_LOAD as $_REPLY_DETAILS ) {


  //:: OPENED BY ADMIN
    if ( $_REPLY_DETAILS['ticket_system_reply_by_type'] == 1 ) {
      $_TDI = $_CONN->Query("SELECT `admin_id`, `admin_name`, `admin_email`, `admin_username`, `admin_image`, `admin_password`, `admin_session_id` FROM administrator where admin_id=?","i",$_REPLY_DETAILS['ticket_system_reply_user_id']);
      $_TDI_NAME      = $_TDI['0']['admin_name'];

      if ( empty ( $_TDI['0']['admin_image'] ) ) {
        $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
      } else {
        $_TDI_IMAGE_SRC = _UPLOAD_DIR_HTTP.$_TDI['0']['admin_image'];
      }
    }
  //:: END OPENED BY ADMIN

  //:: OPENED BY STAFF
    if ( $_REPLY_DETAILS['ticket_system_reply_by_type'] == 2 ) {
      $_TDI = $_CONN->Query("SELECT `users_profiles_user_id`, `users_profiles_picture`, `users_profiles_first_name`, `users_profiles_last_name` FROM users_profiles where users_profiles_user_id=?","i",$_REPLY_DETAILS['ticket_system_reply_user_id']);
      $_TDI_NAME      = $_TDI['0']['users_profiles_first_name'].' '.$_TDI['0']['users_profiles_last_name'];

      if ( empty ( $_TDI['0']['users_profiles_picture'] ) ) {
        $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
      } else {
        $_TDI_IMAGE_SRC = _UPLOAD_DIR_HTTP.$_TDI['0']['users_profiles_picture'];
      }
    }
  //:: END OPENED BY STAFF

  //:: OPENED BY USER
    if ( $_REPLY_DETAILS['ticket_system_reply_by_type'] == 3 ) {
      $_TDI = $_CONN->Query("SELECT `users_profiles_user_id`, `users_profiles_picture`, `users_profiles_first_name`, `users_profiles_last_name` FROM users_profiles where users_profiles_user_id=?","i",$_REPLY_DETAILS['ticket_system_reply_user_id']);
      $_TDI_NAME      = $_TDI['0']['users_profiles_first_name'].' '.$_TDI['0']['users_profiles_last_name'];

      if ( empty ( $_TDI['0']['users_profiles_picture'] ) ) {
        $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
      } else {
        $_TDI_IMAGE_SRC = _UPLOAD_DIR_HTTP.$_TDI['0']['users_profiles_picture'];
      }
    }
  //:: END OPENED BY USER

  //:: OPENED BY VISITOR
    if ( $_REPLY_DETAILS['ticket_system_reply_by_type'] == 4 ) {
      $_TDI_NAME      = $_TICKET_DETAILS['0']['ticket_system_name'];
      $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
    }
  //:: END OPENED BY VISITOR

      $DATE   = date( DATE_FORMAT, $_REPLY_DETAILS['ticket_system_reply_date'] );
      $HOUR   = date( HOUR_FORMAT, $_REPLY_DETAILS['ticket_system_reply_date'] );

      $_TDI_DATE      = $DATE.' '.$HOUR;
      $_TDI_DETAILS   = $_PREPARE->sanitize( $_REPLY_DETAILS['ticket_system_reply_details'], 'textarea-decode' );

      $_TDI_ATTACHMENT  = '';
      if ( !empty ( $_REPLY_DETAILS['ticket_system_reply_file'] ) ) {
        $_TDI_ATTACHMENT  = "<a target='_blank' href='".HTTP_SERVER_WEBSITE."administrators/get?f=".$_REPLY_DETAILS['ticket_system_reply_file']."'>".$_LANG['TICKET']['REPLY_DOWNLOAD']."</a>";
      }


    if ( ( $_REPLY_DETAILS['ticket_system_reply_by_type'] == 1 ) or ( $_REPLY_DETAILS['ticket_system_reply_by_type'] == 2 ) ) {
      
      if ( $_REPLY_DETAILS['ticket_system_reply_user_id'] != $_TICKET_DETAILS['0']['ticket_system_user_id'] ) {
          $_RETURN .= '
      <!-- Message. Default to the left -->
      <div class="direct-chat-msg">
        <div class="direct-chat-info clearfix">
          <span class="direct-chat-name pull-left">'.$_TDI_NAME.'</span>
          <span class="direct-chat-timestamp pull-right">'.$_TDI_DATE.'</span>
        </div><!-- /.direct-chat-info -->

      <img class="direct-chat-img" src="'.$_TDI_IMAGE_SRC.'" alt="">

        <div class="direct-chat-text">
          '.$_TDI_DETAILS.'
          '.$_TDI_ATTACHMENT.'
        </div><!-- /.direct-chat-text -->
      </div><!-- /.direct-chat-msg -->
          ';
      } else {
          $_RETURN .= '
<div class="direct-chat-msg right">
  <div class="direct-chat-info clearfix">
    <span class="direct-chat-name pull-right">'.$_TDI_NAME.'</span>
    <span class="direct-chat-timestamp pull-left">'.$_TDI_DATE.'</span>
  </div><!-- /.direct-chat-info -->
      <img class="direct-chat-img" src="'.$_TDI_IMAGE_SRC.'" alt="">
  <div class="direct-chat-text">
          '.$_TDI_DETAILS.'
          '.$_TDI_ATTACHMENT.'
  </div><!-- /.direct-chat-text -->
</div>
          ';
      }

    } else {
          $_RETURN .= '
<div class="direct-chat-msg right">
  <div class="direct-chat-info clearfix">
    <span class="direct-chat-name pull-right">'.$_TDI_NAME.'</span>
    <span class="direct-chat-timestamp pull-left">'.$_TDI_DATE.'</span>
  </div><!-- /.direct-chat-info -->
      <img class="direct-chat-img" src="'.$_TDI_IMAGE_SRC.'" alt="">
  <div class="direct-chat-text">
          '.$_TDI_DETAILS.'
          '.$_TDI_ATTACHMENT.'
  </div><!-- /.direct-chat-text -->
</div>
          ';
    }




  }

$_RETURN .= '

'.$_FIRST_REPLY.'

  </div><!--/.direct-chat-messages-->
</div><!-- /.box-body -->

</div>
</div>

        <div class="row"><br /></div>
        ';
      }
    }
    //:: END TICKET REPLY PAGE

    return $_RETURN;
  }


  function _LOAD_CSS ( $_PLUGIN, $_ROUTE ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    
    $_RETURN = $_CONN->Query("SELECT `css_id`, `css_plugin`, `css_plugin_route`, `css_info` FROM custom_css where css_plugin=? limit 1","s","_TICKET");
    return $_RETURN;
  }


  //:: USERS PART
  //:: _REQUIRED_SESSION :: JUST IF NEED AUTHENTIFICATION
  function _REQUIRED_SESSION ( $_ARRAY ) {
    $_ROUTE        = $_ARRAY['_ROUTE'];
    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];

    $NO_SECURE  = array( "ticket/new", "ticket/direct", "ticket/anon-get" );
    if (in_array($_ROUTE, $NO_SECURE)) {
      $_RETURN  = array (
        "_REQUIRED_SESSION"         => false,
        "_REQUIRED_SESSION_STRING"  => '',
        "_REDIRECT_PAGE"            => '',
      );
    } else {
      $_RETURN  = array (
        "_REQUIRED_SESSION"         => true,
        "_REQUIRED_SESSION_STRING"  => 'USER_SESSION',
        "_REDIRECT_PAGE"            => 'user/login',
      );
    }
    return $_RETURN;
  }

  //:: ADD THE TICKET TO THE DATABASE
  function _STAFF_OPEN_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['ticket_system_id'] ) ) {
      $_RETURN  = $this->_STAFF_ADD_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    } else {
     #$_RETURN  = $this->_STAFF_UPDATE_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }
      return $_RETURN;
  }



  function _STAFF_ADD_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();
    

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['ticket_system_file'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
        'rar'   => TRUE,
        'zip'   => TRUE,
        '7zip'   => TRUE,
        'pdf'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['ticket_system_file'] = $_FULL_IMAGE;
      } else {
          $_ARRAY['ticket_system_file'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE
    $_ARRAY['ticket_system_unique_url'] = md5( rand().strtotime("now") );
    if ( empty ( $_ARRAY['ticket_system_user_id'] ) ) { $_ARRAY['ticket_system_user_id'] = ''; }
    if ( empty ( $_ARRAY['ticket_system_name'] ) ) { $_ARRAY['ticket_system_name'] = ''; }
    if ( empty ( $_ARRAY['ticket_system_email'] ) ) { $_ARRAY['ticket_system_email'] = ''; }
    
    //:: OPENED BY
    //:: 1 - admin
    //:: 2 - staff
    //:: 3 - user
    //:: 4 - visitor
    $ticket_system_opened_by_type = '2';
    
    //:: STORE THE ADMIN ID
    $ticket_system_opened_by_id = $_SESSION['USER_SESSION']['0']['user_id'];
    $ticket_system_date         = strtotime( "now" );

    $_RETURN = $_CONN->NoQuery("INSERT INTO ticket_system VALUES(NULL,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)","sssssssssssssss",$ticket_system_opened_by_type,$ticket_system_opened_by_id,$_ARRAY['ticket_system_guest'],$_ARRAY['ticket_system_user_id'],$_ARRAY['ticket_system_department'],$_ARRAY['ticket_system_priority'],$_ARRAY['ticket_system_product'],$_ARRAY['ticket_system_name'],$_ARRAY['ticket_system_email'],$_ARRAY['ticket_system_subject'],$_ARRAY['ticket_system_details'],$_ARRAY['ticket_system_file'],$_ARRAY['ticket_system_unique_url'],$_ARRAY['ticket_system_status'],$ticket_system_date);
    if ( $_RETURN ) {

    $_ADMIN       = $this->_ADMINISTRATOR();
    $_SMTP        = $_ADMIN->_SMTP_FIELDS_LIST( $_ARRAY );

//:: START SMTP AND SEND THE EMAIL

  //:: GET THE NOTIFICATION EMAIL
  if ( $_ARRAY['ticket_system_guest'] == 0 ) {
    //GUEST MODE
    $_NOTIFICATION_EMAIL  = $_ARRAY['ticket_system_email'];
  } else {
    //USER MODE
    $_USER_DETAILS        = $_CONN->Query("SELECT `user_email` FROM users where user_id=? limit 1","i",$_ARRAY['ticket_system_user_id']);
    $_NOTIFICATION_EMAIL  = $_USER_DETAILS['0']['user_email'];
  }

  $details	= '
  
<div class="rcmBody" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; background-color: #FFFFFF;">
<title>'.$_ARRAY['ticket_system_subject'].'</title>
<table cellspacing="0" cellpadding="0" width="100%"><tbody><tr><td align="center" width="100%"><br><table cellspacing="0" cellpadding="0" width="700" style="border: 1px  solid  #c7c7c7; box-shadow: 0  1px  3px  #c3c2c3; -webkit-box-shadow: 0  1px  7px  #c3c2c3; -moz-box-shadow: 0  1px  3px  #c3c2c3; -moz-background-clip: padding; -webkit-background-clip: padding-box; background-clip: padding-box; background: #fff; border-radius: 0px; padding: 5px;"><tbody><tr><td style="height: 50px; text-align: left;">'._CMS_NAME.'</td>
				</tr><tr><td style="height: 5px; background-color: #FF6600;">
				</td></tr><tr><td align="left" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; font-weight: normal; padding: 15px; background-color: #FFFFFF;">

<br><div style="background-color: #FFFFCC; border: 1px  solid  #FFCC00; clear: both; color: #333333; font-weight: bold; list-style: none outside none; margin-bottom: 10px; padding: 9px  10px  9px  5px;">

'.$_PREPARE->sanitize( $_ARRAY['ticket_system_details'], 'textarea-decode' ).'

<br><br>
<div style="text-align: center;"><a href="'.HTTP_SERVER_WEBSITE.'ticket/direct?id='.$_ARRAY['ticket_system_unique_url'].'">'.$_LANG['TICKET']['TICKET_VIEW_DETAILS'].'</a></div>
</div>
<br><div style="float: right;"><a style="color: red; text-decoration: none;" href="'.HTTP_SERVER_WEBSITE.'" target="_blank">'._COPYRIGHT.'</a></div> 


					</td>
				</tr></tbody></table></td>
	</tr></tbody></table></div>
  
  ';

  $headers = "MIME-Version: 1.0" . "\r\n";
  $headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
  $headers .= "From: \r\n";
  $subject = $_ARRAY['ticket_system_subject'];

  //START THE SMTP
  $smtp_email = new \PHPMailer();
  $smtp_email->IsSMTP();
  $smtp_email->SMTPDebug = 0;
  $smtp_email->SMTPAuth = 'login';
  $smtp_email->SMTPSecure = $_SMTP['0']['smtp_secure'];
  $smtp_email->Host = $_SMTP['0']['smtp_host'];
  $smtp_email->Port = $_SMTP['0']['smtp_port'];
  $smtp_email->Username = $_SMTP['0']['smtp_username'];
  $smtp_email->Password = $_SMTP['0']['smtp_password'];

	$smtp_email->SetFrom( $_SMTP['0']['smtp_set_from'], $_SMTP['0']['smtp_set_name']);
	$smtp_email->Subject = $subject;
	$smtp_email->Body = $details;
	$smtp_email->IsHTML(true);
	$smtp_email->AddAddress( $_NOTIFICATION_EMAIL );
	$smtp_email->Send();
  $smtp_email->ClearAddresses();
//:: START SMTP AND SEND THE EMAIL


      $error['code']		=	'3';
      $_ID  = $_CONN->LastID();
      $error['message']	=	$_LANG['TICKET']['TICKET_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
    }
    return $error;
  }


  //:: STAFF TICKETS LIST
  function _STAFF_ALL_TICKETS_FIELDS () {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['TICKET']['TICKETS'],
          "group" => true,
          "special" => true
        ),
      "ticket_system_date" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_DATE'],
          "type"        => 'date'
        ),
      "ticket_system_status" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_STATUS']
        ),
      "ts_priority_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_PRIORITY']
        ),
      "ticket_system_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_CLIENT']
        ),
        "ticket_system_subject" => array (
            "options" => false,
            "translation" => $_LANG['TICKET']['TICKET_SUBJECT']
          ),
      "tsp_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_PRODUCT']
        ),



      "ticket_system_id" => array (
          "options" => array (
              "reply" => array( "url" => "ticket/staff/details", "ico" => "<i class=\"glyphicon glyphicon-envelope\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_REPLY'] )
            ),
          "translation" => $_LANG['TICKET']['_PLUGIN_OPTIONS']
        )
    );
    return $_RETURN;
  }


  function _STAFF_ALL_TICKETS_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();
    $_LANG    = $this->_LANGUAGE();

    $_STAFF_MEMBER  = $this->_STAFF_MEMBER( array("_USER_ID" => $_SESSION['USER_SESSION']['0']['user_id'] ) );


    if (array_key_exists('_LIMIT', $_ARRAY)) {
      $_LIMIT = ' limit '.$_ARRAY['_LIMIT'];
    } else {
      $_LIMIT = '';
    }


    $_RETURN = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_subject`, `ticket_system_status`, `tsp_name`, `tsd_name`, `users_profiles_first_name`, `users_profiles_last_name`, `ts_priority_name`, `ticket_system_date` FROM ticket_system left join ticket_system_products on ticket_system_products.tsp_id = ticket_system.ticket_system_product left join ticket_system_departments on ticket_system_departments.tsd_id = ticket_system.ticket_system_department left join users_profiles on users_profiles.users_profiles_user_id = ticket_system.ticket_system_user_id left join ticket_system_priority on ticket_system_priority.ts_priority_id = ticket_system.ticket_system_priority where ticket_system_department=? order by ticket_system_id desc ".$_LIMIT,"i",$_STAFF_MEMBER['0']['ts_staff_department']);

    $_RETURN  = $_PREPARE->_array_key_replace( $_RETURN, 'ticket_system_name', '', 'users_profiles_last_name,users_profiles_first_name' );

    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'ticket_system_status', '0', $_LANG['TICKET']['TICKET_STATUS_CLOSE'] );
    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'ticket_system_status', '1', $_LANG['TICKET']['TICKET_STATUS_OPEN'] );

    return $_RETURN;
  }

  //:: ./ STAFF TICKETS LIST


  //:: USER TICKETS LIST
  function _USER_ALL_TICKETS_FIELDS () {
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = array (
      "GROUP"  => array(
          "translation" => $_LANG['TICKET']['TICKETS'],
          "group" => true,
          "special" => true
        ),
      "ticket_system_date" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_DATE'],
          "type"        => 'date'
        ),
      "ticket_system_status" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_STATUS']
        ),
        "ticket_system_subject" => array (
            "options" => false,
            "translation" => $_LANG['TICKET']['TICKET_SUBJECT']
          ),
      "tsp_name" => array (
          "options" => false,
          "translation" => $_LANG['TICKET']['TICKET_PRODUCT']
        ),



      "ticket_system_id" => array (
          "options" => array (
              "reply" => array( "url" => "ticket/details", "ico" => "<i class=\"glyphicon glyphicon-envelope\"></i> ", "name" => $_LANG['TICKET']['_PLUGIN_REPLY'] )
            ),
          "translation" => $_LANG['TICKET']['_PLUGIN_OPTIONS']
        )
    );
    return $_RETURN;
  }


  function _USER_ALL_TICKETS_FIELDS_LIST ( $_ARRAY ) {
    $_CONN    = $this->_DB();
    $_PREPARE = $this->_PREPARE();
    $_LANG    = $this->_LANGUAGE();

    if (array_key_exists('_LIMIT', $_ARRAY)) {
      $_LIMIT = ' limit '.$_ARRAY['_LIMIT'];
    } else {
      $_LIMIT = '';
    }

    $_RETURN = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_subject`, `ticket_system_status`, `tsp_name`, `tsd_name`, `users_profiles_first_name`, `users_profiles_last_name`, `ts_priority_name`, `ticket_system_date` FROM ticket_system left join ticket_system_products on ticket_system_products.tsp_id = ticket_system.ticket_system_product left join ticket_system_departments on ticket_system_departments.tsd_id = ticket_system.ticket_system_department left join users_profiles on users_profiles.users_profiles_user_id = ticket_system.ticket_system_user_id left join ticket_system_priority on ticket_system_priority.ts_priority_id = ticket_system.ticket_system_priority where ticket_system_user_id=? order by ticket_system_id desc ".$_LIMIT,"i",$_SESSION['USER_SESSION']['0']['user_id']);

    $_RETURN  = $_PREPARE->_array_key_replace( $_RETURN, 'ticket_system_name', '', 'users_profiles_last_name,users_profiles_first_name' );

    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'ticket_system_status', '0', $_LANG['TICKET']['TICKET_STATUS_CLOSE'] );
    $_RETURN  = $_PREPARE->_array_replace( $_RETURN, 'ticket_system_status', '1', $_LANG['TICKET']['TICKET_STATUS_OPEN'] );

    return $_RETURN;
  }

  //:: ./ USER TICKETS LIST

  //:: TICKET SYSTEM : STAFF REPLY
  function _STAFF_REPLY_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['ticket_system_id'] ) ) {
      $_RETURN  = false;
    } else {
      $_RETURN  = $this->_ADD_STAFF_REPLY ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }

    return $_RETURN;
  }


  function _ADD_STAFF_REPLY ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['ticket_system_file'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
        'rar'   => TRUE,
        'zip'   => TRUE,
        '7zip'   => TRUE,
        'pdf'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['ticket_system_file'] = $_FULL_IMAGE;
      } else {
          $_ARRAY['ticket_system_file'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

  $_CONN->NoQuery("UPDATE ticket_system SET ticket_system_status=? WHERE ticket_system_id=? limit 1","ss",$_ARRAY['ticket_system_status'],$_ARRAY['ticket_system_id']);

    //:: STORE THE REPLY
    $ticket_system_reply_ticket_id  = $_ARRAY['ticket_system_id'];
    $ticket_system_reply_by_type    = '2';
    $ticket_system_reply_user_id    = $_SESSION['USER_SESSION']['0']['user_id'];
    $ticket_system_reply_details    = $_ARRAY['ticket_system_details'];
    $ticket_system_reply_file       = $_ARRAY['ticket_system_file'];
    $ticket_system_reply_status     = '';
    $ticket_system_reply_date       = strtotime( "now" );

    $_RETURN = $_CONN->NoQuery("INSERT INTO ticket_system_reply VALUES(NULL,?,?,?,?,?,?,?)","sssssss",$ticket_system_reply_ticket_id,$ticket_system_reply_by_type,$ticket_system_reply_user_id,$ticket_system_reply_details,$ticket_system_reply_file,$ticket_system_reply_status,$ticket_system_reply_date);
    //:: END STORE THE REPLY

      if ( $_RETURN ) {

//:: START SMTP AND SEND THE EMAIL
    $_ADMIN       = $this->_ADMINISTRATOR();
    $_SMTP        = $_ADMIN->_SMTP_FIELDS_LIST( $_ARRAY );


  //:: GET THE NOTIFICATION EMAIL
  $_TS  = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_opened_by_type`, `ticket_system_opened_by_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status` FROM ticket_system where ticket_system_id=? limit 1","i",$_ARRAY['ticket_system_id']);

  if ( $_TS['0']['ticket_system_guest'] == 0 ) {
    //GUEST MODE
    $_NOTIFICATION_EMAIL  = $_TS['0']['ticket_system_email'];
  } else {
    //USER MODE
    $_USER_DETAILS        = $_CONN->Query("SELECT `user_email` FROM users where user_id=? limit 1","i",$_TS['0']['ticket_system_user_id']);
    $_NOTIFICATION_EMAIL  = $_USER_DETAILS['0']['user_email'];
  }

  $details	= '

<div class="rcmBody" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; background-color: #FFFFFF;">
<title>'.$_TS['0']['ticket_system_subject'].'</title>
<table cellspacing="0" cellpadding="0" width="100%"><tbody><tr><td align="center" width="100%"><br><table cellspacing="0" cellpadding="0" width="700" style="border: 1px  solid  #c7c7c7; box-shadow: 0  1px  3px  #c3c2c3; -webkit-box-shadow: 0  1px  7px  #c3c2c3; -moz-box-shadow: 0  1px  3px  #c3c2c3; -moz-background-clip: padding; -webkit-background-clip: padding-box; background-clip: padding-box; background: #fff; border-radius: 0px; padding: 5px;"><tbody><tr><td style="height: 50px; text-align: left;">'._CMS_NAME.'</td>
				</tr><tr><td style="height: 5px; background-color: #FF6600;">
				</td></tr><tr><td align="left" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; font-weight: normal; padding: 15px; background-color: #FFFFFF;">

<br><div style="background-color: #FFFFCC; border: 1px  solid  #FFCC00; clear: both; color: #333333; font-weight: bold; list-style: none outside none; margin-bottom: 10px; padding: 9px  10px  9px  5px;">

'.$_PREPARE->sanitize( $_ARRAY['ticket_system_details'], 'textarea-decode' ).'

<br><br>
<div style="text-align: center;"><a href="'.HTTP_SERVER_WEBSITE.'ticket/direct?id='.$_TS['0']['ticket_system_unique_url'].'">'.$_LANG['TICKET']['TICKET_VIEW_DETAILS'].'</a></div>
</div>
<br><div style="float: right;"><a style="color: red; text-decoration: none;" href="'.HTTP_SERVER_WEBSITE.'" target="_blank">'._COPYRIGHT.'</a></div> 


					</td>
				</tr></tbody></table></td>
	</tr></tbody></table></div>
  
  ';

  $headers = "MIME-Version: 1.0" . "\r\n";
  $headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
  $headers .= "From: \r\n";
  $subject = $_LANG['TICKET']['REPLY_RE'].$_TS['0']['ticket_system_subject'];

  //START THE SMTP
  $smtp_email = new \PHPMailer();
  $smtp_email->IsSMTP();
  $smtp_email->SMTPDebug = 0;
  $smtp_email->SMTPAuth = 'login';
  $smtp_email->SMTPSecure = $_SMTP['0']['smtp_secure'];
  $smtp_email->Host = $_SMTP['0']['smtp_host'];
  $smtp_email->Port = $_SMTP['0']['smtp_port'];
  $smtp_email->Username = $_SMTP['0']['smtp_username'];
  $smtp_email->Password = $_SMTP['0']['smtp_password'];

	$smtp_email->SetFrom( $_SMTP['0']['smtp_set_from'], $_SMTP['0']['smtp_set_name']);
	$smtp_email->Subject = $subject;
	$smtp_email->Body = $details;
	$smtp_email->IsHTML(true);
	$smtp_email->AddAddress( $_NOTIFICATION_EMAIL );
	$smtp_email->Send();
  $smtp_email->ClearAddresses();


//:: END START SMTP AND SEND THE EMAIL


        $error['code']		=	'1';
        $error['message']	=	$_LANG['TICKET']['TICKET_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
      }
    return $error;

  }
  //:: END TICKET SYSTEM : REPLY

  //:: USER PART
  //:: ADD THE TICKET TO THE DATABASE
  function _USER_OPEN_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['ticket_system_id'] ) ) {
      $_RETURN  = $this->_USER_ADD_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    } else {
     #$_RETURN  = $this->_STAFF_UPDATE_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }
      return $_RETURN;
  }

  function _USER_ADD_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();
    

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['ticket_system_file'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
        'rar'   => TRUE,
        'zip'   => TRUE,
        '7zip'   => TRUE,
        'pdf'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['ticket_system_file'] = $_FULL_IMAGE;
      } else {
          $_ARRAY['ticket_system_file'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE
    $_ARRAY['ticket_system_unique_url'] = md5( rand().strtotime("now") );
    if ( empty ( $_ARRAY['ticket_system_user_id'] ) ) { $_ARRAY['ticket_system_user_id'] = ''; }
    if ( empty ( $_ARRAY['ticket_system_name'] ) ) { $_ARRAY['ticket_system_name'] = ''; }
    if ( empty ( $_ARRAY['ticket_system_email'] ) ) { $_ARRAY['ticket_system_email'] = ''; }
    if ( empty ( $_ARRAY['ticket_system_guest'] ) ) { $_ARRAY['ticket_system_guest'] = 1; }
    if ( empty ( $_ARRAY['ticket_system_status'] ) ) { $_ARRAY['ticket_system_status'] = 1; }
    
    //:: OPENED BY
    //:: 1 - admin
    //:: 2 - staff
    //:: 3 - user
    //:: 4 - visitor
    $ticket_system_opened_by_type     = '3';
    $_ARRAY['ticket_system_user_id']  = $_SESSION['USER_SESSION']['0']['user_id'];
    //:: STORE THE ADMIN ID
    $ticket_system_opened_by_id       = $_SESSION['USER_SESSION']['0']['user_id'];
    $ticket_system_date               = strtotime( "now" );

    $_RETURN = $_CONN->NoQuery("INSERT INTO ticket_system VALUES(NULL,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)","sssssssssssssss",$ticket_system_opened_by_type,$ticket_system_opened_by_id,$_ARRAY['ticket_system_guest'],$_ARRAY['ticket_system_user_id'],$_ARRAY['ticket_system_department'],$_ARRAY['ticket_system_priority'],$_ARRAY['ticket_system_product'],$_ARRAY['ticket_system_name'],$_ARRAY['ticket_system_email'],$_ARRAY['ticket_system_subject'],$_ARRAY['ticket_system_details'],$_ARRAY['ticket_system_file'],$_ARRAY['ticket_system_unique_url'],$_ARRAY['ticket_system_status'],$ticket_system_date);
    if ( $_RETURN ) {

    $_ADMIN       = $this->_ADMINISTRATOR();
    $_SMTP        = $_ADMIN->_SMTP_FIELDS_LIST( $_ARRAY );

    $_TICKET_ID = $_CONN->LastID();

//:: START SMTP AND SEND THE EMAIL

  //:: GET THE NOTIFICATION EMAILS
  $_STAFF_MEMBERS = $this->_STAFF_MEMBERS( array( "ts_staff_department" => $_ARRAY['ticket_system_department'] ) );
  //:: ./ GET THE NOTIFICATION EMAIL

  foreach ( $_STAFF_MEMBERS as $_STAFF ) {
    $_NOTIFICATION_EMAIL  = $_STAFF['user_email'];

    $details	= '
    
  <div class="rcmBody" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; background-color: #FFFFFF;">
  <title>'.$_ARRAY['ticket_system_subject'].'</title>
  <table cellspacing="0" cellpadding="0" width="100%"><tbody><tr><td align="center" width="100%"><br><table cellspacing="0" cellpadding="0" width="700" style="border: 1px  solid  #c7c7c7; box-shadow: 0  1px  3px  #c3c2c3; -webkit-box-shadow: 0  1px  7px  #c3c2c3; -moz-box-shadow: 0  1px  3px  #c3c2c3; -moz-background-clip: padding; -webkit-background-clip: padding-box; background-clip: padding-box; background: #fff; border-radius: 0px; padding: 5px;"><tbody><tr><td style="height: 50px; text-align: left;">'._CMS_NAME.'</td>
          </tr><tr><td style="height: 5px; background-color: #FF6600;">
          </td></tr><tr><td align="left" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; font-weight: normal; padding: 15px; background-color: #FFFFFF;">

  <br><div style="background-color: #FFFFCC; border: 1px  solid  #FFCC00; clear: both; color: #333333; font-weight: bold; list-style: none outside none; margin-bottom: 10px; padding: 9px  10px  9px  5px;">

  '.$_PREPARE->sanitize( $_ARRAY['ticket_system_details'], 'textarea-decode' ).'

  <br><br>
  <div style="text-align: center;"><a href="'.HTTP_SERVER_WEBSITE.'ticket/staff/details?id='.$_TICKET_ID.'">'.$_LANG['TICKET']['EMAIL_STAFF_VIEW_REPLY'].'</a></div>
  </div>
  <br><div style="float: right;"><a style="color: red; text-decoration: none;" href="'.HTTP_SERVER_WEBSITE.'" target="_blank">'._COPYRIGHT.'</a></div> 


            </td>
          </tr></tbody></table></td>
    </tr></tbody></table></div>
    
    ';

  $headers = "MIME-Version: 1.0" . "\r\n";
  $headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
  $headers .= "From: \r\n";
  $subject = $_LANG['TICKET']['EMAIL_STAFF_NEW_TICKET'].' '.$_ARRAY['ticket_system_subject'];

  //START THE SMTP
  $smtp_email = new \PHPMailer();
  $smtp_email->IsSMTP();
  $smtp_email->SMTPDebug = 0;
  $smtp_email->SMTPAuth = 'login';
  $smtp_email->SMTPSecure = $_SMTP['0']['smtp_secure'];
  $smtp_email->Host = $_SMTP['0']['smtp_host'];
  $smtp_email->Port = $_SMTP['0']['smtp_port'];
  $smtp_email->Username = $_SMTP['0']['smtp_username'];
  $smtp_email->Password = $_SMTP['0']['smtp_password'];

	$smtp_email->SetFrom( $_SMTP['0']['smtp_set_from'], $_SMTP['0']['smtp_set_name']);
	$smtp_email->Subject = $subject;
	$smtp_email->Body = $details;
	$smtp_email->IsHTML(true);
	$smtp_email->AddAddress( $_NOTIFICATION_EMAIL );
	$smtp_email->Send();
  $smtp_email->ClearAddresses();

  }

//:: ./ START SMTP AND SEND THE EMAIL



      $error['code']		=	'3';
      $_ID  = $_CONN->LastID();
      $error['message']	=	$_LANG['TICKET']['TICKET_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
    }
    return $error;
  }




  //:: TICKET SYSTEM : USER REPLY
  function _USER_REPLY_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['ticket_system_id'] ) ) {
      $_RETURN  = false;
    } else {
      $_RETURN  = $this->_ADD_USER_REPLY ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }

    return $_RETURN;
  }


  function _ADD_USER_REPLY ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();
    $_ARRAY['ticket_system_status'] = 1;

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['ticket_system_file'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
        'rar'   => TRUE,
        'zip'   => TRUE,
        '7zip'   => TRUE,
        'pdf'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['ticket_system_file'] = $_FULL_IMAGE;
      } else {
          $_ARRAY['ticket_system_file'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

  $_CONN->NoQuery("UPDATE ticket_system SET ticket_system_status=? WHERE ticket_system_id=? limit 1","ss",$_ARRAY['ticket_system_status'],$_ARRAY['ticket_system_id']);

    //:: STORE THE REPLY
    $ticket_system_reply_ticket_id  = $_ARRAY['ticket_system_id'];
    $ticket_system_reply_by_type    = '3';
    $ticket_system_reply_user_id    = $_SESSION['USER_SESSION']['0']['user_id'];
    $ticket_system_reply_details    = $_ARRAY['ticket_system_details'];
    $ticket_system_reply_file       = $_ARRAY['ticket_system_file'];
    $ticket_system_reply_status     = '';
    $ticket_system_reply_date       = strtotime( "now" );

    $_RETURN = $_CONN->NoQuery("INSERT INTO ticket_system_reply VALUES(NULL,?,?,?,?,?,?,?)","sssssss",$ticket_system_reply_ticket_id,$ticket_system_reply_by_type,$ticket_system_reply_user_id,$ticket_system_reply_details,$ticket_system_reply_file,$ticket_system_reply_status,$ticket_system_reply_date);
    //:: END STORE THE REPLY

      if ( $_RETURN ) {

      $_GET_DETAILS  = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status` FROM ticket_system where ticket_system_id=?","i",$_ARRAY['ticket_system_id']);

//:: START SMTP AND SEND THE EMAIL
    $_ADMIN       = $this->_ADMINISTRATOR();
    $_SMTP        = $_ADMIN->_SMTP_FIELDS_LIST( $_ARRAY );


  //:: GET THE NOTIFICATION EMAILS
  $_STAFF_MEMBERS = $this->_STAFF_MEMBERS( array( "ts_staff_department" => $_GET_DETAILS['0']['ticket_system_department'] ) );
  //:: ./ GET THE NOTIFICATION EMAIL

  foreach ( $_STAFF_MEMBERS as $_STAFF ) {
    $_NOTIFICATION_EMAIL  = $_STAFF['user_email'];

  $details	= '

<div class="rcmBody" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; background-color: #FFFFFF;">
<title>'.$_GET_DETAILS['0']['ticket_system_subject'].'</title>
<table cellspacing="0" cellpadding="0" width="100%"><tbody><tr><td align="center" width="100%"><br><table cellspacing="0" cellpadding="0" width="700" style="border: 1px  solid  #c7c7c7; box-shadow: 0  1px  3px  #c3c2c3; -webkit-box-shadow: 0  1px  7px  #c3c2c3; -moz-box-shadow: 0  1px  3px  #c3c2c3; -moz-background-clip: padding; -webkit-background-clip: padding-box; background-clip: padding-box; background: #fff; border-radius: 0px; padding: 5px;"><tbody><tr><td style="height: 50px; text-align: left;">'._CMS_NAME.'</td>
				</tr><tr><td style="height: 5px; background-color: #FF6600;">
				</td></tr><tr><td align="left" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; font-weight: normal; padding: 15px; background-color: #FFFFFF;">

<br><div style="background-color: #FFFFCC; border: 1px  solid  #FFCC00; clear: both; color: #333333; font-weight: bold; list-style: none outside none; margin-bottom: 10px; padding: 9px  10px  9px  5px;">

'.$_PREPARE->sanitize( $_ARRAY['ticket_system_details'], 'textarea-decode' ).'

<br><br>
<div style="text-align: center;"><a href="'.HTTP_SERVER_WEBSITE.'ticket/staff/details?id='.$_ARRAY['ticket_system_id'].'">'.$_LANG['TICKET']['EMAIL_STAFF_VIEW_REPLY'].'</a></div>
</div>
<br><div style="float: right;"><a style="color: red; text-decoration: none;" href="'.HTTP_SERVER_WEBSITE.'" target="_blank">'._COPYRIGHT.'</a></div> 


					</td>
				</tr></tbody></table></td>
	</tr></tbody></table></div>
  
  ';

  $headers = "MIME-Version: 1.0" . "\r\n";
  $headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
  $headers .= "From: \r\n";
  $subject = $_LANG['TICKET']['REPLY_RE'].$_GET_DETAILS['0']['ticket_system_subject'];

  //START THE SMTP
  $smtp_email = new \PHPMailer();
  $smtp_email->IsSMTP();
  $smtp_email->SMTPDebug = 0;
  $smtp_email->SMTPAuth = 'login';
  $smtp_email->SMTPSecure = $_SMTP['0']['smtp_secure'];
  $smtp_email->Host = $_SMTP['0']['smtp_host'];
  $smtp_email->Port = $_SMTP['0']['smtp_port'];
  $smtp_email->Username = $_SMTP['0']['smtp_username'];
  $smtp_email->Password = $_SMTP['0']['smtp_password'];

	$smtp_email->SetFrom( $_SMTP['0']['smtp_set_from'], $_SMTP['0']['smtp_set_name']);
	$smtp_email->Subject = $subject;
	$smtp_email->Body = $details;
	$smtp_email->IsHTML(true);
	$smtp_email->AddAddress( $_NOTIFICATION_EMAIL );
	$smtp_email->Send();
  $smtp_email->ClearAddresses();

  }

//:: END START SMTP AND SEND THE EMAIL


        $error['code']		=	'1';
        $error['message']	=	$_LANG['TICKET']['TICKET_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
      }
    return $error;

  }
  //:: END TICKET SYSTEM : REPLY





//  ANONIM OPEN TICKET
  //:: ADD THE TICKET TO THE DATABASE
  function _ANON_OPEN_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['ticket_system_id'] ) ) {
      $_RETURN  = $this->_ANON_ADD_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }
      return $_RETURN;
  }


  function _ANON_ADD_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();
    

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['ticket_system_file'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
        'rar'   => TRUE,
        'zip'   => TRUE,
        '7zip'   => TRUE,
        'pdf'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['ticket_system_file'] = $_FULL_IMAGE;
      } else {
          $_ARRAY['ticket_system_file'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE
    $_ARRAY['ticket_system_unique_url'] = md5( rand().strtotime("now") );
    if ( empty ( $_ARRAY['ticket_system_user_id'] ) ) { $_ARRAY['ticket_system_user_id'] = ''; }
    if ( empty ( $_ARRAY['ticket_system_name'] ) ) { $_ARRAY['ticket_system_name'] = ''; }
    if ( empty ( $_ARRAY['ticket_system_email'] ) ) { $_ARRAY['ticket_system_email'] = ''; }
    if ( empty ( $_ARRAY['ticket_system_guest'] ) ) { $_ARRAY['ticket_system_guest'] = 0; }
    if ( empty ( $_ARRAY['ticket_system_status'] ) ) { $_ARRAY['ticket_system_status'] = 1; }
    
    //:: OPENED BY
    //:: 1 - admin
    //:: 2 - staff
    //:: 3 - user
    //:: 4 - visitor
    $ticket_system_opened_by_type     = '4';
    $_ARRAY['ticket_system_user_id']  = '';
    $ticket_system_opened_by_id       = '';
    $ticket_system_date               = strtotime( "now" );

    $_RETURN = $_CONN->NoQuery("INSERT INTO ticket_system VALUES(NULL,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)","sssssssssssssss",$ticket_system_opened_by_type,$ticket_system_opened_by_id,$_ARRAY['ticket_system_guest'],$_ARRAY['ticket_system_user_id'],$_ARRAY['ticket_system_department'],$_ARRAY['ticket_system_priority'],$_ARRAY['ticket_system_product'],$_ARRAY['ticket_system_name'],$_ARRAY['ticket_system_email'],$_ARRAY['ticket_system_subject'],$_ARRAY['ticket_system_details'],$_ARRAY['ticket_system_file'],$_ARRAY['ticket_system_unique_url'],$_ARRAY['ticket_system_status'],$ticket_system_date);
    if ( $_RETURN ) {

    $_ADMIN       = $this->_ADMINISTRATOR();
    $_SMTP        = $_ADMIN->_SMTP_FIELDS_LIST( $_ARRAY );

    $_TICKET_ID = $_CONN->LastID();

//:: START SMTP AND SEND THE EMAIL

  //:: GET THE NOTIFICATION EMAILS
  $_STAFF_MEMBERS = $this->_STAFF_MEMBERS( array( "ts_staff_department" => $_ARRAY['ticket_system_department'] ) );
  //:: ./ GET THE NOTIFICATION EMAIL

  foreach ( $_STAFF_MEMBERS as $_STAFF ) {
    $_NOTIFICATION_EMAIL  = $_STAFF['user_email'];

    $details	= '
    
  <div class="rcmBody" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; background-color: #FFFFFF;">
  <title>'.$_ARRAY['ticket_system_subject'].'</title>
  <table cellspacing="0" cellpadding="0" width="100%"><tbody><tr><td align="center" width="100%"><br><table cellspacing="0" cellpadding="0" width="700" style="border: 1px  solid  #c7c7c7; box-shadow: 0  1px  3px  #c3c2c3; -webkit-box-shadow: 0  1px  7px  #c3c2c3; -moz-box-shadow: 0  1px  3px  #c3c2c3; -moz-background-clip: padding; -webkit-background-clip: padding-box; background-clip: padding-box; background: #fff; border-radius: 0px; padding: 5px;"><tbody><tr><td style="height: 50px; text-align: left;">'._CMS_NAME.'</td>
          </tr><tr><td style="height: 5px; background-color: #FF6600;">
          </td></tr><tr><td align="left" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; font-weight: normal; padding: 15px; background-color: #FFFFFF;">

  <br><div style="background-color: #FFFFCC; border: 1px  solid  #FFCC00; clear: both; color: #333333; font-weight: bold; list-style: none outside none; margin-bottom: 10px; padding: 9px  10px  9px  5px;">

  '.$_PREPARE->sanitize( $_ARRAY['ticket_system_details'], 'textarea-decode' ).'

  <br><br>
  <div style="text-align: center;"><a href="'.HTTP_SERVER_WEBSITE.'ticket/staff/details?id='.$_TICKET_ID.'">'.$_LANG['TICKET']['EMAIL_STAFF_VIEW_REPLY'].'</a></div>
  </div>
  <br><div style="float: right;"><a style="color: red; text-decoration: none;" href="'.HTTP_SERVER_WEBSITE.'" target="_blank">'._COPYRIGHT.'</a></div> 


            </td>
          </tr></tbody></table></td>
    </tr></tbody></table></div>
    
    ';

  $headers = "MIME-Version: 1.0" . "\r\n";
  $headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
  $headers .= "From: \r\n";
  $subject = $_LANG['TICKET']['EMAIL_STAFF_NEW_TICKET'].' '.$_ARRAY['ticket_system_subject'];

  //START THE SMTP
  $smtp_email = new \PHPMailer();
  $smtp_email->IsSMTP();
  $smtp_email->SMTPDebug = 0;
  $smtp_email->SMTPAuth = 'login';
  $smtp_email->SMTPSecure = $_SMTP['0']['smtp_secure'];
  $smtp_email->Host = $_SMTP['0']['smtp_host'];
  $smtp_email->Port = $_SMTP['0']['smtp_port'];
  $smtp_email->Username = $_SMTP['0']['smtp_username'];
  $smtp_email->Password = $_SMTP['0']['smtp_password'];

	$smtp_email->SetFrom( $_SMTP['0']['smtp_set_from'], $_SMTP['0']['smtp_set_name']);
	$smtp_email->Subject = $subject;
	$smtp_email->Body = $details;
	$smtp_email->IsHTML(true);
	$smtp_email->AddAddress( $_NOTIFICATION_EMAIL );
	$smtp_email->Send();
  $smtp_email->ClearAddresses();

  }

//:: ./ START SMTP AND SEND THE EMAIL



      $error['code']		=	'3';
      $_ID  = $_CONN->LastID();
      $error['message']	=	$_LANG['TICKET']['TICKET_ADDED'];
    } else {
      $error['code']		=	'2';
      $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
    }
    return $error;
  }
// ./ ANONIM OPEN TICKET

// ANONIM REPLY
  function _ANON_REPLY_TICKET ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    if ( empty ( $_ARRAY['ticket_system_id'] ) ) {
      $_RETURN  = false;
    } else {
      $_RETURN  = $this->_ADD_ANON_REPLY ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY );
    }
    return $_RETURN;
  }


  function _ADD_ANON_REPLY ( $_ARRAY, $_UPLOAD, $_FILES_ARRAY ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();
    $_ARRAY['ticket_system_status'] = 1;

  //::: FIRST UPLOAD THE PICTURE
    $files = $_UPLOAD->get_upload_var( $_FILES_ARRAY['ticket_system_file'] );
    foreach( $files as $file ) {
            $args = array(
          'upload_file'         =>   $file,
          'upload_directory'    =>   _UPLOAD_DIR,
          'allowed_size'        =>   MAX_UPLOAD_SIZE,
          'extension_check'     =>   TRUE,
          'upload_overwrite'    =>   FALSE,
      );
      $allowed_extensions = array(
        'pdf'   => FALSE,
        'png'   => TRUE,
        'jpg'   => TRUE,
        'jpeg'   => TRUE,
        'rar'   => TRUE,
        'zip'   => TRUE,
        '7zip'   => TRUE,
        'pdf'   => TRUE,
      );
      $upload_hook = $_UPLOAD->get_upload( $args, $allowed_extensions );
      if( $upload_hook['upload_move'] == TRUE ) {
          $upload_output = $_UPLOAD->get_upload_move();
          $_FULL_IMAGE	=	$upload_output['uploaded_file'].'.'.$upload_output['uploaded_extension'];
          $_ARRAY['ticket_system_file'] = $_FULL_IMAGE;
      } else {
          $_ARRAY['ticket_system_file'] = '';
      }
    }
  //::: /FIRST UPLOAD THE PICTURE

  $_CONN->NoQuery("UPDATE ticket_system SET ticket_system_status=? WHERE ticket_system_id=? limit 1","ss",$_ARRAY['ticket_system_status'],$_ARRAY['ticket_system_id']);

    //:: STORE THE REPLY
    $ticket_system_reply_ticket_id  = $_ARRAY['ticket_system_id'];
    $ticket_system_reply_by_type    = '4';
    $ticket_system_reply_user_id    = '';
    $ticket_system_reply_details    = $_ARRAY['ticket_system_details'];
    $ticket_system_reply_file       = $_ARRAY['ticket_system_file'];
    $ticket_system_reply_status     = '';
    $ticket_system_reply_date       = strtotime( "now" );

    $_RETURN = $_CONN->NoQuery("INSERT INTO ticket_system_reply VALUES(NULL,?,?,?,?,?,?,?)","sssssss",$ticket_system_reply_ticket_id,$ticket_system_reply_by_type,$ticket_system_reply_user_id,$ticket_system_reply_details,$ticket_system_reply_file,$ticket_system_reply_status,$ticket_system_reply_date);
    //:: END STORE THE REPLY

      if ( $_RETURN ) {

      $_GET_DETAILS  = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status` FROM ticket_system where ticket_system_id=?","i",$_ARRAY['ticket_system_id']);

//:: START SMTP AND SEND THE EMAIL
    $_ADMIN       = $this->_ADMINISTRATOR();
    $_SMTP        = $_ADMIN->_SMTP_FIELDS_LIST( $_ARRAY );


  //:: GET THE NOTIFICATION EMAILS
  $_STAFF_MEMBERS = $this->_STAFF_MEMBERS( array( "ts_staff_department" => $_GET_DETAILS['0']['ticket_system_department'] ) );
  //:: ./ GET THE NOTIFICATION EMAIL

  foreach ( $_STAFF_MEMBERS as $_STAFF ) {
    $_NOTIFICATION_EMAIL  = $_STAFF['user_email'];

  $details	= '

<div class="rcmBody" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; background-color: #FFFFFF;">
<title>'.$_GET_DETAILS['0']['ticket_system_subject'].'</title>
<table cellspacing="0" cellpadding="0" width="100%"><tbody><tr><td align="center" width="100%"><br><table cellspacing="0" cellpadding="0" width="700" style="border: 1px  solid  #c7c7c7; box-shadow: 0  1px  3px  #c3c2c3; -webkit-box-shadow: 0  1px  7px  #c3c2c3; -moz-box-shadow: 0  1px  3px  #c3c2c3; -moz-background-clip: padding; -webkit-background-clip: padding-box; background-clip: padding-box; background: #fff; border-radius: 0px; padding: 5px;"><tbody><tr><td style="height: 50px; text-align: left;">'._CMS_NAME.'</td>
				</tr><tr><td style="height: 5px; background-color: #FF6600;">
				</td></tr><tr><td align="left" style="font-family: Arial, Tahoma; color: #000000; font-size: 12px; font-weight: normal; padding: 15px; background-color: #FFFFFF;">

<br><div style="background-color: #FFFFCC; border: 1px  solid  #FFCC00; clear: both; color: #333333; font-weight: bold; list-style: none outside none; margin-bottom: 10px; padding: 9px  10px  9px  5px;">

'.$_PREPARE->sanitize( $_ARRAY['ticket_system_details'], 'textarea-decode' ).'

<br><br>
<div style="text-align: center;"><a href="'.HTTP_SERVER_WEBSITE.'ticket/staff/details?id='.$_ARRAY['ticket_system_id'].'">'.$_LANG['TICKET']['EMAIL_STAFF_VIEW_REPLY'].'</a></div>
</div>
<br><div style="float: right;"><a style="color: red; text-decoration: none;" href="'.HTTP_SERVER_WEBSITE.'" target="_blank">'._COPYRIGHT.'</a></div> 


					</td>
				</tr></tbody></table></td>
	</tr></tbody></table></div>
  
  ';

  $headers = "MIME-Version: 1.0" . "\r\n";
  $headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
  $headers .= "From: \r\n";
  $subject = $_LANG['TICKET']['REPLY_RE'].$_GET_DETAILS['0']['ticket_system_subject'];

  //START THE SMTP
  $smtp_email = new \PHPMailer();
  $smtp_email->IsSMTP();
  $smtp_email->SMTPDebug = 0;
  $smtp_email->SMTPAuth = 'login';
  $smtp_email->SMTPSecure = $_SMTP['0']['smtp_secure'];
  $smtp_email->Host = $_SMTP['0']['smtp_host'];
  $smtp_email->Port = $_SMTP['0']['smtp_port'];
  $smtp_email->Username = $_SMTP['0']['smtp_username'];
  $smtp_email->Password = $_SMTP['0']['smtp_password'];

	$smtp_email->SetFrom( $_SMTP['0']['smtp_set_from'], $_SMTP['0']['smtp_set_name']);
	$smtp_email->Subject = $subject;
	$smtp_email->Body = $details;
	$smtp_email->IsHTML(true);
	$smtp_email->AddAddress( $_NOTIFICATION_EMAIL );
	$smtp_email->Send();
  $smtp_email->ClearAddresses();

  }

//:: END START SMTP AND SEND THE EMAIL


        $error['code']		=	'1';
        $error['message']	=	$_LANG['TICKET']['TICKET_UPDATED'];
      } else {
        $error['code']		=	'2';
        $error['message']	=	$_LANG['TICKET']['_PLUGIN_ERROR'];
      }
    return $error;

  }
// ./ ANONIM REPLY

  //:: THIS FUNCTION WILL FIND THE TICKET ID BASED ON THE FILE
  function _VALIDATE_FILE ( $_ARRAY ) {
    $_CONN    = $this->_DB();

  if ( $_ARRAY['_MODE'] == '_STAFF' ) {
    //:: SEARCH IN TICKETS
    $_RETURN = $_CONN->Query("SELECT `ticket_system_id` FROM ticket_system where ticket_system_file=?","s",$_ARRAY['_FILE']);
    if ( $_RETURN ) {
      //:: VALIDATE DEPARTMENT

    $_STAFF_MEMBER      = $this->_STAFF_MEMBER( array("_USER_ID" => $_SESSION['USER_SESSION']['0']['user_id'] ) );
    $_STAFF_DEPARTMENT  = $_STAFF_MEMBER['0']['ts_staff_department'];
    $_TICKET            = $this->_MANAGE_FIELDS_LIST( array( "_ID" => $_RETURN['0']['ticket_system_id'] ) );
      
        if ( $_STAFF_DEPARTMENT != $_TICKET['0']['ticket_system_department'] ) {
          $_RETURN  = false;
        } else {
          $_RETURN = true;
        }

    } else {
    //:: SEARCH IN REPLIES
      $_RETURN = $_CONN->Query("SELECT `ticket_system_reply_ticket_id` FROM ticket_system_reply where ticket_system_reply_file=?","s",$_ARRAY['_FILE']);
        if ( $_RETURN ) {

    $_STAFF_MEMBER      = $this->_STAFF_MEMBER( array("_USER_ID" => $_SESSION['USER_SESSION']['0']['user_id'] ) );
    $_STAFF_DEPARTMENT  = $_STAFF_MEMBER['0']['ts_staff_department'];
    $_TICKET            = $this->_MANAGE_FIELDS_LIST( array( "_ID" => $_RETURN['0']['ticket_system_reply_ticket_id'] ) );

        if ( $_STAFF_DEPARTMENT != $_TICKET['0']['ticket_system_department'] ) {
          $_RETURN  = false;
        } else {
          $_RETURN = true;
        }

        } else {
          $_RETURN = false;
        }
    }
  }

  if ( $_ARRAY['_MODE'] == '_USER' ) {
    //:: SEARCH IN TICKETS
    $_RETURN = $_CONN->Query("SELECT `ticket_system_id` FROM ticket_system where ticket_system_file=?","s",$_ARRAY['_FILE']);
    if ( $_RETURN ) {
      //:: VALIDATE USER
      $_TICKET            = $this->_MANAGE_FIELDS_LIST( array( "_ID" => $_RETURN['0']['ticket_system_id'] ) );

          if ( $_SESSION['USER_SESSION']['0']['user_id'] != $_TICKET['0']['ticket_system_user_id'] ) {
            $_RETURN  = false;
          } else {
            $_RETURN = true;
          }

    } else {
    //:: SEARCH IN REPLIES
      $_RETURN = $_CONN->Query("SELECT `ticket_system_reply_ticket_id` FROM ticket_system_reply where ticket_system_reply_file=?","s",$_ARRAY['_FILE']);
        if ( $_RETURN ) {
        //VALIDATE USER
        $_TICKET            = $this->_MANAGE_FIELDS_LIST( array( "_ID" => $_RETURN['0']['ticket_system_reply_ticket_id'] ) );

          if ( $_SESSION['USER_SESSION']['0']['user_id'] != $_TICKET['0']['ticket_system_user_id'] ) {
            $_RETURN  = false;
          } else {
            $_RETURN = true;
          }

        } else {
          $_RETURN = false;
        }
    }
  }

  if ( $_ARRAY['_MODE'] == '_ANON' ) {

  if ( !empty ( $_SERVER['HTTP_REFERER'] ) ) {
    $_REF = $_SERVER['HTTP_REFERER'];

    $_REQUEST_ID  = explode("?", $_REF );
    if ( count( $_REQUEST_ID ) > 1 ) {
      $_REQUEST_ID  = explode("id=", $_REQUEST_ID['1'] );
    }
    if ( count( $_REQUEST_ID ) > 1 ) {
      $_GET_ROUTE_ID    = $_REQUEST_ID['1'];
    } else {
      $_GET_ROUTE_ID    = '';
    }
    $_DECODE_ID = $_CONN->Query("SELECT `ticket_system_id` FROM ticket_system where ticket_system_unique_url=?","s",$_GET_ROUTE_ID);
    $_DECODE_ID = $_DECODE_ID['0']['ticket_system_id'];

    //:: SEARCH IN TICKETS
    $_RETURN = $_CONN->Query("SELECT `ticket_system_id` FROM ticket_system where ticket_system_file=?","s",$_ARRAY['_FILE']);
    if ( $_RETURN ) {
      //:: VALIDATE USER
      $_TICKET            = $this->_MANAGE_FIELDS_LIST( array( "_ID" => $_RETURN['0']['ticket_system_id'] ) );

          if ( $_DECODE_ID != $_TICKET['0']['ticket_system_id'] ) {
            $_RETURN  = false;
          } else {
            $_RETURN = true;
          }

    } else {
    //:: SEARCH IN REPLIES
      $_RETURN = $_CONN->Query("SELECT `ticket_system_reply_ticket_id` FROM ticket_system_reply where ticket_system_reply_file=?","s",$_ARRAY['_FILE']);
        if ( $_RETURN ) {
        //VALIDATE USER
        $_TICKET            = $this->_MANAGE_FIELDS_LIST( array( "_ID" => $_RETURN['0']['ticket_system_reply_ticket_id'] ) );

          if ( $_DECODE_ID != $_TICKET['0']['ticket_system_id'] ) {
            $_RETURN  = false;
          } else {
            $_RETURN = true;
          }

        } else {
          $_RETURN = false;
        }
    }
  } else {
    $_RETURN = false;
  }
}

    return $_RETURN;
  }


  function _USER_DASHBOARD_TABLE ( $_ARRAY ) {
    $_PREPARE = $this->_PREPARE();
    $_LANG    = $this->_LANGUAGE();
    $_RETURN  = '';

    $_STAFF_MEMBER  = $this->_STAFF_MEMBER( array("_USER_ID" => $_SESSION['USER_SESSION']['0']['user_id'] ) );

    if ( $_STAFF_MEMBER ) {
    //:: TICKETS ADDED BY OTHERS
    $_TITLE           = $_LANG['TICKET']['USER_LATEST_TICKETS'].' [ '.$_STAFF_MEMBER['0']['tsd_name'].' ]';
    $_ALL_FIELDS      = $this->_STAFF_ALL_TICKETS_FIELDS( );
    $_ALL_FIELDS_LIST = $this->_STAFF_ALL_TICKETS_FIELDS_LIST( array("_LIMIT" => 10 ) );

    ob_start();
    if ( file_exists ( _TMDRP.'_TICKET/table.php' ) ) {
      include( _TMDRP.'_TICKET/table.php' );
    } else {
      include('design/table.php');
    }
    $_RETURN .= ob_get_contents();
    ob_end_clean();
    //:: TICKETS ADDED BY OTHERS
    }

    $_RETURN .= '<hr class="sm"/>';

    //:: TICKETS ADDED AS USER
    $_TITLE           = $_LANG['TICKET']['USER_LATEST_TICKETS_YOU'];
    $_ALL_FIELDS      = $this->_USER_ALL_TICKETS_FIELDS( );
    $_ALL_FIELDS_LIST = $this->_USER_ALL_TICKETS_FIELDS_LIST( array("_LIMIT" => 10 ) );

    ob_start();
    if ( file_exists ( _TMDRP.'_TICKET/table.php' ) ) {
      include( _TMDRP.'_TICKET/table.php' );
    } else {
      include('design/table.php');
    }
    $_RETURN .= ob_get_contents();
    ob_end_clean();
    //:: TICKETS ADDED AS USER



    return $_RETURN;
    
  }



  //:: DESIGN ROUTE!
  function _DESIGN ( $_ARRAY ) {
    $_CONN            = $this->_DB();
    $_LANG            = $this->_LANGUAGE();
    $_PREPARE         = $this->_PREPARE();
    $_PLUGIN_SETTIGS  = $this->_SETTINGS_FIELDS_LIST( array() );

    $_ROUTE        = $_ARRAY['_ROUTE'];
    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];

    $_REQUEST_ID  = explode("?", $_REQUEST_URI );
    if ( count( $_REQUEST_ID ) > 1 ) {
      $_REQUEST_ID  = explode("id=", $_REQUEST_ID['1'] );
    }
    if ( count( $_REQUEST_ID ) > 1 ) {
      $_GET_ROUTE_ID    = $_REQUEST_ID['1'];
    } else {
      $_GET_ROUTE_ID    = '';
    }

    $_TICKET_SYSTEM_ID  = $_GET_ROUTE_ID;

    if ( !empty ( $_SESSION['USER_SESSION'] ) ) {
      $_STAFF_MEMBER  = $this->_STAFF_MEMBER( array("_USER_ID" => $_SESSION['USER_SESSION']['0']['user_id'] ) );
    } else {
      $_STAFF_MEMBER  = false;
    }
    if ( $_STAFF_MEMBER ) {
      
      if ( $_STAFF_MEMBER['0']['ts_staff_open_ticket'] == 1 ) {
        $_ALLOWED  = array( "ticket/user-get", "ticket/staff-get", "ticket/open", "ticket/all", "ticket/details", "ticket/direct", "ticket/staff/open", "ticket/staff/all", "ticket/staff/details" );
      } else {
        $_ALLOWED  = array( "ticket/user-get", "ticket/staff-get", "ticket/open", "ticket/all", "ticket/details", "ticket/direct", "ticket/staff/all", "ticket/staff/details" );
      }

    } else {
      if ( empty ( $_SESSION['USER_SESSION'] ) ) {
        if ( $_PLUGIN_SETTIGS['0']['tss_user_only'] == 1 ) {
          $_ALLOWED  = array( "ticket/direct", "ticket/anon-get" );
        } else {
          $_ALLOWED  = array( "ticket/new", "ticket/direct", "ticket/anon-get" );
        }
      } else {
        $_ALLOWED  = array( "ticket/user-get", "ticket/open", "ticket/all", "ticket/details", "ticket/direct" );
      }
    }

  if (in_array($_ROUTE, $_ALLOWED)) {
    $_TITLE_SEO = '';
    $_DESCRIPTION = '';
    $_KEYWORDS = '';
    $_TITLE = '';
    $_FORM = '';
    $_FIELDS_START = '';
    $_FIELDS = '';
    $_FIELDS_END = '';
    $_FIELDS_DATA = '';
    $_GET_ROUTE = '';
    $_GET_ROUTE_ID = '';
    $_UPDATE_ROUTE_ID = '';



    //STAFF GET FILE
    if ( $_ROUTE == 'ticket/staff-get' ) {
    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];

    $_REQUEST_FILE  = explode("?f=", $_REQUEST_URI );
    if ( count( $_REQUEST_FILE ) > 1 ) {
      $_FILE    = _UPLOAD_DIR.$_REQUEST_FILE['1'];
    } else {
      $_FILE    = '';
    }

      //:: VALIDATE STAFF PERMISSIONS
      $_VALIDATE_FILE = $this->_VALIDATE_FILE( array( "_FILE" => $_PREPARE->sanitize( $_REQUEST_FILE['1'], 'input' ), "_MODE" => "_STAFF" ) );
        if ( !$_VALIDATE_FILE ) {
          die( $_LANG['TICKET']['_PLUGIN_FILE_NOT_FOUND'] );
        }


      // Quick check to verify that the file exists
      if( !file_exists($_FILE) ) die( $_LANG['TICKET']['_PLUGIN_FILE_NOT_FOUND'] );
      // Force the download
      header("Content-Disposition: attachment; filename=".basename($_FILE));
      header("Content-Length: " . filesize($_FILE));
      header("Content-Type: application/octet-stream;");
      readfile($_FILE);

      $_TITLE_SEO   = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD'];
      $_DESCRIPTION = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD'];
      $_KEYWORDS    = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD'];
      $_TITLE       = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD'];
      $_FORM        = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD_INFO'];

      $_RETURN  = array (
        "SEO" => array (
          "_TITLE" => $_TITLE_SEO,
          "_DESCRIPTION" => $_DESCRIPTION,
          "_KEYWORDS" => $_KEYWORDS
          ),
        "DESIGN" => array (
          "_LIST_MODE" => true,
          "ICO" => '',
          "title" => $_TITLE,
          "form" => $_FORM,
          "fields_start" =>$_FIELDS_START,
          "fields" =>$_FIELDS,
          "fields_end" =>$_FIELDS_END,
          "fields_data" =>$_FIELDS_DATA,
          "_GET_ROUTE"  => "_STAFF_ALL_TICKETS",
          "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
          "_UPDATE_ROUTE_ID"  => $_UPDATE_ROUTE_ID
        )
      );
    }

    //USER GET FILE
    if ( $_ROUTE == 'ticket/user-get' ) {
    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];

    $_REQUEST_FILE  = explode("?f=", $_REQUEST_URI );
    if ( count( $_REQUEST_FILE ) > 1 ) {
      $_FILE    = _UPLOAD_DIR.$_REQUEST_FILE['1'];
    } else {
      $_FILE    = '';
    }

      //:: VALIDATE STAFF PERMISSIONS
      $_VALIDATE_FILE = $this->_VALIDATE_FILE( array( "_FILE" => $_PREPARE->sanitize( $_REQUEST_FILE['1'], 'input' ), "_MODE" => "_USER" ) );
        if ( !$_VALIDATE_FILE ) {
          die( $_LANG['TICKET']['_PLUGIN_FILE_NOT_FOUND'] );
        }



      // Quick check to verify that the file exists
      if( !file_exists($_FILE) ) die( $_LANG['TICKET']['_PLUGIN_FILE_NOT_FOUND'] );
      // Force the download
      header("Content-Disposition: attachment; filename=".basename($_FILE));
      header("Content-Length: " . filesize($_FILE));
      header("Content-Type: application/octet-stream;");
      readfile($_FILE);

      $_TITLE_SEO   = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD'];
      $_DESCRIPTION = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD'];
      $_KEYWORDS    = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD'];
      $_TITLE       = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD'];
      $_FORM        = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD_INFO'];

      $_RETURN  = array (
        "SEO" => array (
          "_TITLE" => $_TITLE_SEO,
          "_DESCRIPTION" => $_DESCRIPTION,
          "_KEYWORDS" => $_KEYWORDS
          ),
        "DESIGN" => array (
          "_LIST_MODE" => true,
          "ICO" => '',
          "title" => $_TITLE,
          "form" => $_FORM,
          "fields_start" =>$_FIELDS_START,
          "fields" =>$_FIELDS,
          "fields_end" =>$_FIELDS_END,
          "fields_data" =>$_FIELDS_DATA,
          "_GET_ROUTE"  => "_STAFF_ALL_TICKETS",
          "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
          "_UPDATE_ROUTE_ID"  => $_UPDATE_ROUTE_ID
        )
      );
    }

    //ANONIMOUSE TICKEG: GET FILE
    if ( $_ROUTE == 'ticket/anon-get' ) {
    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];

    $_REQUEST_FILE  = explode("?f=", $_REQUEST_URI );
    if ( count( $_REQUEST_FILE ) > 1 ) {
      $_FILE    = _UPLOAD_DIR.$_REQUEST_FILE['1'];
    } else {
      $_FILE    = '';
    }

      //:: VALIDATE STAFF PERMISSIONS
      $_VALIDATE_FILE = $this->_VALIDATE_FILE( array( "_FILE" => $_PREPARE->sanitize( $_REQUEST_FILE['1'], 'input' ), "_MODE" => "_ANON" ) );
        if ( !$_VALIDATE_FILE ) {
          die( $_LANG['TICKET']['_PLUGIN_FILE_NOT_FOUND'] );
        }


      // Quick check to verify that the file exists
      if( !file_exists($_FILE) ) die( $_LANG['TICKET']['_PLUGIN_FILE_NOT_FOUND'] );
      // Force the download
      header("Content-Disposition: attachment; filename=".basename($_FILE));
      header("Content-Length: " . filesize($_FILE));
      header("Content-Type: application/octet-stream;");
      readfile($_FILE);

      $_TITLE_SEO   = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD'];
      $_DESCRIPTION = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD'];
      $_KEYWORDS    = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD'];
      $_TITLE       = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD'];
      $_FORM        = $_LANG['TICKET']['_PLUGIN_FILE_DOWNLOAD_INFO'];

      $_RETURN  = array (
        "SEO" => array (
          "_TITLE" => $_TITLE_SEO,
          "_DESCRIPTION" => $_DESCRIPTION,
          "_KEYWORDS" => $_KEYWORDS
          ),
        "DESIGN" => array (
          "_LIST_MODE" => true,
          "ICO" => '',
          "title" => $_TITLE,
          "form" => $_FORM,
          "fields_start" =>$_FIELDS_START,
          "fields" =>$_FIELDS,
          "fields_end" =>$_FIELDS_END,
          "fields_data" =>$_FIELDS_DATA,
          "_GET_ROUTE"  => "_STAFF_ALL_TICKETS",
          "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
          "_UPDATE_ROUTE_ID"  => $_UPDATE_ROUTE_ID
        )
      );
    }

    //STAFF OPEN TICKET
    if ( $_ROUTE == 'ticket/staff/open' ) {

      $_TITLE         = $_LANG['TICKET']['STAFF_FORM_OPEN'];
      $_TITLE_SEO     = $_LANG['TICKET']['STAFF_FORM_OPEN'];
      $_DESCRIPTION   = $_LANG['TICKET']['STAFF_FORM_OPEN'];
      $_KEYWORDS      = $_LANG['TICKET']['STAFF_FORM_OPEN'];

    $_FORM  = '<div class="row">'.$this->_USER_DASHBOARD_WIDGET( array( ) ).'</div>';

    $_FIELDS  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['TICKET']['TICKET_GUEST_MODE'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

        //:: DECIDE IF GUEST OR USER
      "ticket_system_guest"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_GUEST'],
          "field" => "select",
          "method" => "_USER_TYPE",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_GUEST_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "ticket_system_user_id"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_USER'],
          "field" => "select",
          "method" => "_USERS",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_USER_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
        //:: USER EMAIL / NAME IF GUEST
      "ticket_system_name"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_GUEST_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "ticket_system_email"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_GUEST_EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "email",
          "options" => false,
          "class" => "col-md-6"
        ),
      "GROUP_3"  => array(
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "ticket_system_department"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS_DEPARTMENT'],
          "field" => "select",
          "method" => "_DEPARTMENTS_SELECT",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_SETTINGS_DEPARTMENT_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "ticket_system_priority"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS_PRIORITY'],
          "field" => "select",
          "method" => "_PRIORITY_SELECT",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_SETTINGS_PRIORITY_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "GROUP_4"  => array(
          "translation" => $_LANG['TICKET']['TICKET_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "ticket_system_product"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_PRODUCT'],
          "field" => "select",
          "method" => "_PRODUCTS_SELECT",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_PRODUCT_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_subject"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_SUBJECT'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "15",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_details"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_INFO'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "minimum_chr" => "20",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "ticket_system_file"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_FILE'],
          "field" => "upload",
          "type" => "file",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_status"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_FIELDS_STATUS'],
          "field" => "select",
          "method" => "_TICKET_STATUS",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_STATUS_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),


      "ticket_system_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );


      $_FIELDS_START  = '';
      $_FIELDS_END    = '';
      $_FIELDS_DATA   = '';
      $_GET_ROUTE     = '_STAFF_OPEN_TICKET';

    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_TITLE_SEO,
        "_DESCRIPTION" => $_DESCRIPTION,
        "_KEYWORDS" => $_KEYWORDS
        ),
      "DESIGN" => array (
        "ICO" => '',
        "title" => $_TITLE,
        "form" => $_FORM,
        "fields_start" =>$_FIELDS_START,
        "fields" =>$_FIELDS,
        "fields_end" =>$_FIELDS_END,
        "fields_data" =>$_FIELDS_DATA,
        "_GET_ROUTE"  => $_GET_ROUTE,
        "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
        "_UPDATE_ROUTE_ID"  => $_UPDATE_ROUTE_ID
      )
    );
    }
    //./STAFF OPEN

    //STAFF LIST TICKETS
    if ( $_ROUTE == 'ticket/staff/all' ) {

    $_TITLE_SEO = $_TITLE = $_LANG['TICKET']['STAFF_FORM_ALL_OPENED_TICKETS'] . ' [ '.$_STAFF_MEMBER['0']['tsd_name'].' ] ';


    $_FORM  = '<div class="row">'.$this->_USER_DASHBOARD_WIDGET( array( ) ).'</div>';

    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_TITLE_SEO,
        "_DESCRIPTION" => $_DESCRIPTION,
        "_KEYWORDS" => $_KEYWORDS
        ),
      "DESIGN" => array (
        "_LIST_MODE" => true,
        "ICO" => '',
        "title" => $_TITLE,
        "form" => $_FORM,
        "fields_start" =>$_FIELDS_START,
        "fields" =>$_FIELDS,
        "fields_end" =>$_FIELDS_END,
        "fields_data" =>$_FIELDS_DATA,
        "_GET_ROUTE"  => "_STAFF_ALL_TICKETS",
        "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
        "_UPDATE_ROUTE_ID"  => $_UPDATE_ROUTE_ID
      )
    );
    }
    // ./STAFF LIST TICKETS


    //STAFF TICKET DETAILS
    if ( $_ROUTE == 'ticket/staff/details' ) {



      $_TITLE         = $_LANG['TICKET']['STAFF_FORM_TICKET_DETAILS'];
      $_TITLE_SEO     = $_LANG['TICKET']['STAFF_FORM_TICKET_DETAILS'];
      $_DESCRIPTION   = $_LANG['TICKET']['STAFF_FORM_TICKET_DETAILS'];
      $_KEYWORDS      = $_LANG['TICKET']['STAFF_FORM_TICKET_DETAILS'];

    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];

    $_REQUEST_ID  = explode("?", $_REQUEST_URI );
    if ( count( $_REQUEST_ID ) > 1 ) {
      $_REQUEST_ID  = explode("id=", $_REQUEST_ID['1'] );
    }

    if ( count( $_REQUEST_ID ) > 1 ) {
      $_GET_ROUTE_ID    = $_REQUEST_ID['1'];
      $_UPDATE_ROUTE_ID = $_REQUEST_ID['1'];
    } else {
      $_GET_ROUTE_ID    = '';
      $_UPDATE_ROUTE_ID = '';
    }


    $_FORM  = '<div class="row">'.$this->_USER_DASHBOARD_WIDGET( array( ) ).'</div>';

    $_FIELDS  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['TICKET']['REPLY'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

      "ticket_system_details"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_INFO'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "minimum_chr" => "25",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "ticket_system_file"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_FILE'],
          "field" => "upload",
          "type" => "file",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_status"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_FIELDS_STATUS'],
          "field" => "select",
          "method" => "_TICKET_STATUS",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_STATUS_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),


      "ticket_system_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );

    $_FIELDS_DATA = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status` FROM ticket_system where ticket_system_id=?","i",$_GET_ROUTE_ID);
    $_FIELDS_DATA['0']['ticket_system_details']  = '';
    $_FIELDS_DATA['0']['ticket_system_file']     = '';


    if ( $_STAFF_MEMBER['0']['ts_staff_department'] != $_FIELDS_DATA['0']['ticket_system_department'] ) {
      header ( 'Location: '.HTTP_MASTER.'user/dashboard' );
    }

    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_TITLE_SEO,
        "_DESCRIPTION" => $_DESCRIPTION,
        "_KEYWORDS" => $_KEYWORDS
        ),
      "DESIGN" => array (
        "ICO" => '',
        "title" => $_TITLE,
        "form" => $_FORM,
        "fields_start" =>$_FIELDS_START,
        "fields" =>$_FIELDS,
        "fields_end" =>$_FIELDS_END,
        "fields_data" =>$_FIELDS_DATA,
        "_GET_ROUTE"  => "_STAFF_REPLY_TICKET",
        "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
        "_UPDATE_ROUTE_ID"  => $_UPDATE_ROUTE_ID
      )
    );
    }
    // ./STAFF TICKET DETAILS


    // USER OPEN TICKET
    if ( $_ROUTE == 'ticket/open' ) {

      $_TITLE         = $_LANG['TICKET']['STAFF_FORM_OPEN'];
      $_TITLE_SEO     = $_LANG['TICKET']['STAFF_FORM_OPEN'];
      $_DESCRIPTION   = $_LANG['TICKET']['STAFF_FORM_OPEN'];
      $_KEYWORDS      = $_LANG['TICKET']['STAFF_FORM_OPEN'];

    $_FORM  = '<div class="row">'.$this->_USER_DASHBOARD_WIDGET( array( ) ).'</div>';

    $_FIELDS  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_3"  => array(
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "ticket_system_department"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS_DEPARTMENT'],
          "field" => "select",
          "method" => "_DEPARTMENTS_SELECT",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_SETTINGS_DEPARTMENT_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      
      "ticket_system_priority"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS_PRIORITY'],
          "field" => "select",
          "method" => "_PRIORITY_SELECT",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_SETTINGS_PRIORITY_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "GROUP_4"  => array(
          "translation" => $_LANG['TICKET']['TICKET_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "ticket_system_product"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_PRODUCT'],
          "field" => "select",
          "method" => "_PRODUCTS_SELECT",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_PRODUCT_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_subject"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_SUBJECT'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "15",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_details"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_INFO'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "minimum_chr" => "25",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "ticket_system_file"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_FILE'],
          "field" => "upload",
          "type" => "file",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );


      $_FIELDS_START  = '';
      $_FIELDS_END    = '';
      $_FIELDS_DATA   = '';
      $_GET_ROUTE     = '_USER_OPEN_TICKET';

    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_TITLE_SEO,
        "_DESCRIPTION" => $_DESCRIPTION,
        "_KEYWORDS" => $_KEYWORDS
        ),
      "DESIGN" => array (
        "ICO" => '',
        "title" => $_TITLE,
        "form" => $_FORM,
        "fields_start" =>$_FIELDS_START,
        "fields" =>$_FIELDS,
        "fields_end" =>$_FIELDS_END,
        "fields_data" =>$_FIELDS_DATA,
        "_GET_ROUTE"  => $_GET_ROUTE,
        "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
        "_UPDATE_ROUTE_ID"  => $_UPDATE_ROUTE_ID
      )
    );
    }
    // ./ USER OPEN TICKET

    
    // USER LIST TICKETS
    if ( $_ROUTE == 'ticket/all' ) {

    $_TITLE_SEO = $_TITLE = $_LANG['TICKET']['STAFF_FORM_ALL_OPENED_TICKETS'];

    $_FORM  = '<div class="row">'.$this->_USER_DASHBOARD_WIDGET( array( ) ).'</div>';

    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_TITLE_SEO,
        "_DESCRIPTION" => $_DESCRIPTION,
        "_KEYWORDS" => $_KEYWORDS
        ),
      "DESIGN" => array (
        "_LIST_MODE" => true,
        "ICO" => '',
        "title" => $_TITLE,
        "form" => $_FORM,
        "fields_start" =>$_FIELDS_START,
        "fields" =>$_FIELDS,
        "fields_end" =>$_FIELDS_END,
        "fields_data" =>$_FIELDS_DATA,
        "_GET_ROUTE"  => "_USER_ALL_TICKETS",
        "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
        "_UPDATE_ROUTE_ID"  => $_UPDATE_ROUTE_ID
      )
    );
    }
    // ./USER LIST TICKETS


    //USER TICKET DETAILS
    if ( $_ROUTE == 'ticket/details' ) {

      $_TITLE         = $_LANG['TICKET']['STAFF_FORM_TICKET_DETAILS'];
      $_TITLE_SEO     = $_LANG['TICKET']['STAFF_FORM_TICKET_DETAILS'];
      $_DESCRIPTION   = $_LANG['TICKET']['STAFF_FORM_TICKET_DETAILS'];
      $_KEYWORDS      = $_LANG['TICKET']['STAFF_FORM_TICKET_DETAILS'];

    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];

    $_REQUEST_ID  = explode("?", $_REQUEST_URI );
    $_REQUEST_ID  = explode("id=", $_REQUEST_ID['1'] );
    if ( count( $_REQUEST_ID ) > 1 ) {
      $_GET_ROUTE_ID    = $_REQUEST_ID['1'];
      $_UPDATE_ROUTE_ID = $_REQUEST_ID['1'];
    } else {
      $_GET_ROUTE_ID    = '';
      $_UPDATE_ROUTE_ID = '';
    }

    $_FORM  = '<div class="row">'.$this->_USER_DASHBOARD_WIDGET( array( ) ).'</div>';

    $_FIELDS  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['TICKET']['REPLY'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

      "ticket_system_details"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_INFO'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "minimum_chr" => "10",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "ticket_system_file"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_FILE'],
          "field" => "upload",
          "type" => "file",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );

    $_FIELDS_DATA = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status` FROM ticket_system where ticket_system_id=? and ticket_system_user_id=?","ii",$_GET_ROUTE_ID,$_SESSION['USER_SESSION']['0']['user_id']);

    if ( empty ( $_FIELDS_DATA ) ) {
      header ( 'Location: '.HTTP_MASTER.'user/dashboard' );
    }

    $_FIELDS_DATA['0']['ticket_system_details']  = '';
    $_FIELDS_DATA['0']['ticket_system_file']     = '';

    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_TITLE_SEO,
        "_DESCRIPTION" => $_DESCRIPTION,
        "_KEYWORDS" => $_KEYWORDS
        ),
      "DESIGN" => array (
        "ICO" => '',
        "title" => $_TITLE,
        "form" => $_FORM,
        "fields_start" =>$_FIELDS_START,
        "fields" =>$_FIELDS,
        "fields_end" =>$_FIELDS_END,
        "fields_data" =>$_FIELDS_DATA,
        "_GET_ROUTE"  => "_USER_REPLY_TICKET",
        "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
        "_UPDATE_ROUTE_ID"  => $_UPDATE_ROUTE_ID
      )
    );
    }
    // ./USER TICKET DETAILS




    // ANONIM OPEN TICKET
    if ( $_ROUTE == 'ticket/new' ) {

      $_TITLE         = $_LANG['TICKET']['STAFF_FORM_OPEN'];
      $_TITLE_SEO     = $_LANG['TICKET']['STAFF_FORM_OPEN'];
      $_DESCRIPTION   = $_LANG['TICKET']['STAFF_FORM_OPEN'];
      $_KEYWORDS      = $_LANG['TICKET']['STAFF_FORM_OPEN'];

    $_FORM          = "";

    $_FIELDS  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_3"  => array(
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

        //:: USER EMAIL / NAME IF GUEST
      "ticket_system_name"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_YOUR_NAME'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      "ticket_system_email"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_YOUR_EMAIL'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "5",
          "mandatory" => true,
          "request" => "email",
          "options" => false,
          "class" => "col-md-6"
        ),

      "ticket_system_department"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS_DEPARTMENT'],
          "field" => "select",
          "method" => "_DEPARTMENTS_SELECT",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_SETTINGS_DEPARTMENT_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),
      
      "ticket_system_priority"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_SETTINGS_PRIORITY'],
          "field" => "select",
          "method" => "_PRIORITY_SELECT",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_SETTINGS_PRIORITY_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-6"
        ),

      "GROUP_4"  => array(
          "translation" => $_LANG['TICKET']['TICKET_DETAILS'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "ticket_system_product"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_PRODUCT'],
          "field" => "select",
          "method" => "_PRODUCTS_SELECT",
          "_ARRAY" => array(""),
          "_NO_DATA" => '',
          "_SELECT_DATA" => $_LANG['TICKET']['TICKET_PRODUCT_SELECT'],
          "type" => "varchar",
          "length" => "150",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_subject"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_SUBJECT'],
          "field" => "input",
          "type" => "varchar",
          "length" => "150",
          "minimum_chr" => "15",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_details"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_INFO'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "minimum_chr" => "25",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "ticket_system_file"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_FILE'],
          "field" => "upload",
          "type" => "file",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );


      $_FIELDS_START  = '';
      $_FIELDS_END    = '';
      $_FIELDS_DATA   = '';
      $_GET_ROUTE     = '_ANON_OPEN_TICKET';

    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_TITLE_SEO,
        "_DESCRIPTION" => $_DESCRIPTION,
        "_KEYWORDS" => $_KEYWORDS
        ),
      "DESIGN" => array (
        "ICO" => '',
        "title" => $_TITLE,
        "form" => $_FORM,
        "fields_start" =>$_FIELDS_START,
        "fields" =>$_FIELDS,
        "fields_end" =>$_FIELDS_END,
        "fields_data" =>$_FIELDS_DATA,
        "_GET_ROUTE"  => $_GET_ROUTE,
        "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
        "_UPDATE_ROUTE_ID"  => $_UPDATE_ROUTE_ID
      )
    );
    }
    // ./ ANONIM OPEN TICKET



    // OPEN TICKET DETAILS - FAST LINK

    //USER TICKET DETAILS
    if ( $_ROUTE == 'ticket/direct' ) {

      $_TITLE         = $_LANG['TICKET']['STAFF_FORM_TICKET_DETAILS'];
      $_TITLE_SEO     = $_LANG['TICKET']['STAFF_FORM_TICKET_DETAILS'];
      $_DESCRIPTION   = $_LANG['TICKET']['STAFF_FORM_TICKET_DETAILS'];
      $_KEYWORDS      = $_LANG['TICKET']['STAFF_FORM_TICKET_DETAILS'];


    $_REQUEST_URI  = $_ARRAY['_REQUEST_URI'];

    $_REQUEST_ID  = explode("?", $_REQUEST_URI );
    $_REQUEST_ID  = explode("id=", $_REQUEST_ID['1'] );

    if ( count( $_REQUEST_ID ) > 1 ) {
      $_FAST_URL  = $_REQUEST_ID['1'];
    }

    $_FORM  = '';
    $_FIELDS  = array (
      "form_requirements"  =>array(
          "require_upload" => true,
          "translation" => NULL,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),
      "GROUP_1"  => array(
          "translation" => $_LANG['TICKET']['REPLY'],
          "group" => true,
          "field" => NULL,
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => NULL,
          "options" => false
        ),

      "ticket_system_details"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_INFO'],
          "field" => "editor",
          "type" => "varchar",
          "length" => "5",
          "minimum_chr" => "10",
          "mandatory" => true,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),

      "ticket_system_file"            =>array( 
          "translation" => $_LANG['TICKET']['TICKET_FILE'],
          "field" => "upload",
          "type" => "file",
          "length" => "250",
          "mandatory" => false,
          "request" => "input",
          "options" => false,
          "class" => "col-md-12"
        ),
      "ticket_system_id"  =>array(
          "translation" => $_LANG['TICKET']['_PLUGIN_SUBMIT'],
          "field" => "int",
          "type" => NULL,
          "length" => "11",
          "mandatory" => false,
          "request" => "",
          "options" => true,
          "class" => "margin-left-10"
        )
    );

    $_FIELDS_DATA = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status` FROM ticket_system where ticket_system_unique_url=?","s",$_FAST_URL);

    if ( empty ( $_FIELDS_DATA ) ) {
      header ( 'Location: '.HTTP_MASTER.'user/dashboard' );
    }

      $_GET_ROUTE_ID    = $_FIELDS_DATA['0']['ticket_system_id'];
      $_UPDATE_ROUTE_ID = $_FAST_URL;

    $_FIELDS_DATA['0']['ticket_system_details']  = '';
    $_FIELDS_DATA['0']['ticket_system_file']     = '';

    $_RETURN  = array (
      "SEO" => array (
        "_TITLE" => $_TITLE_SEO,
        "_DESCRIPTION" => $_DESCRIPTION,
        "_KEYWORDS" => $_KEYWORDS
        ),
      "DESIGN" => array (
        "ICO" => '',
        "title" => $_TITLE,
        "form" => $_FORM,
        "fields_start" =>$_FIELDS_START,
        "fields" =>$_FIELDS,
        "fields_end" =>$_FIELDS_END,
        "fields_data" =>$_FIELDS_DATA,
        "_GET_ROUTE"  => "_ANON_REPLY_TICKET",
        "_GET_ROUTE_ID"  => $_GET_ROUTE_ID,
        "_UPDATE_ROUTE_ID"  => $_UPDATE_ROUTE_ID
      )
    );
    }
    // ./OPEN TICKET DETAILS - FAST LINK







  } else {
    $_RETURN  = false;
  }

    return $_RETURN;
  }


  //:: EXTRA TOP / BOTTOM ADMIN CODE
  function _EXTRA_USER_CODE ( $_ARRAY ) {
    /**
     * $_ARRAY['_POSITION']
     * _TOP
     * _BOTTOM
     * $_ARRAY['_ROUTE']
     * PLUGIN ROUTE
     */
    $_ROUTE     = $_ARRAY['_ROUTE'];
    $_POSITION  = $_ARRAY['_POSITION'];
    $_RETURN    = '';

    if ( $_ROUTE == '_STAFF_REPLY_TICKET' ) {
      $_GET_URL = 'ticket/staff-get';
    }

    if ( $_ROUTE == '_USER_REPLY_TICKET' ) {
      $_GET_URL = 'ticket/user-get';
    }
      
    if ( $_ROUTE == '_ANON_REPLY_TICKET' ) {
      $_GET_URL = 'ticket/anon-get';
    }
        

    //:: OPEN TICKET PAGE
    if ( $_ROUTE == '_STAFF_OPEN_TICKET' ) {
      if ( $_POSITION == '_TOP' ) {
        $_RETURN  = '';
      }
      if ( $_POSITION == '_BOTTOM' ) {

    ob_start();
    if ( file_exists ( _TMDRP.'_TICKET/staff.open-ticket.bottom.php' ) ) {
      include( _TMDRP.'_TICKET/staff.open-ticket.bottom.php' );
    } else {
      include('design/staff.open-ticket.bottom.php');
    }
    $_RETURN = ob_get_contents();
    ob_end_clean();

      }
    }
    //:: END OPEN TICKET PAGE

    //:: TICKET REPLY PAGE
    if ( $_ROUTE == '_STAFF_REPLY_TICKET' OR $_ROUTE == '_USER_REPLY_TICKET' OR $_ROUTE == '_ANON_REPLY_TICKET' ) {
      if ( $_POSITION == '_TOP' && $_ROUTE == '_STAFF_REPLY_TICKET' ) {
   
        
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_TICKET_DETAILS = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status`, `ticket_system_date`, `tsd_name`, `ts_priority_name`, `tsp_name` FROM ticket_system left join ticket_system_departments on ticket_system_departments.tsd_id = ticket_system.ticket_system_department left join ticket_system_priority on ticket_system_priority.ts_priority_id = ticket_system.ticket_system_priority left join ticket_system_products on ticket_system_products.tsp_id = ticket_system.ticket_system_product where ticket_system_id=?","i",$_ARRAY['_ID']);

  //:: GET CLIENT INFO
  if ( $_TICKET_DETAILS['0']['ticket_system_guest'] == 0 ) {
    //GUEST MODE
    $_CLIENT_NAME   = $_TICKET_DETAILS['0']['ticket_system_name'];
    $_CLIENT_EMAIL  = $_TICKET_DETAILS['0']['ticket_system_email'];
  } else {
    //:: USER MODE
    $_USER_DETAILS        = $_CONN->Query("SELECT `user_email`, `users_profiles_first_name`, `users_profiles_last_name` FROM users left join users_profiles on users_profiles.users_profiles_user_id = users.user_id where user_id=? limit 1","i",$_TICKET_DETAILS['0']['ticket_system_user_id']);

    $_CLIENT_NAME   = $_USER_DETAILS['0']['users_profiles_first_name'].' '.$_USER_DETAILS['0']['users_profiles_last_name'];
    $_CLIENT_EMAIL  = $_USER_DETAILS['0']['user_email'];
  }

    ob_start();
    if ( file_exists ( _TMDRP.'_TICKET/staff.reply-ticket.top.php' ) ) {
      include( _TMDRP.'_TICKET/staff.reply-ticket.top.php' );
    } else {
      include('design/staff.reply-ticket.top.php');
    }
    $_RETURN = ob_get_contents();
    ob_end_clean();


      }

      if ( $_POSITION == '_BOTTOM' ) {
    $_CONN    = $this->_DB();
    $_LANG    = $this->_LANGUAGE();
    $_PREPARE = $this->_PREPARE();

      $_TICKET_DETAILS = $_CONN->Query("SELECT `ticket_system_id`, `ticket_system_opened_by_type`, `ticket_system_opened_by_id`, `ticket_system_guest`, `ticket_system_user_id`, `ticket_system_department`, `ticket_system_priority`, `ticket_system_product`, `ticket_system_name`, `ticket_system_email`, `ticket_system_subject`, `ticket_system_details`, `ticket_system_file`, `ticket_system_unique_url`, `ticket_system_status`, `ticket_system_date`, `tsd_name`, `ts_priority_name`, `tsp_name` FROM ticket_system left join ticket_system_departments on ticket_system_departments.tsd_id = ticket_system.ticket_system_department left join ticket_system_priority on ticket_system_priority.ts_priority_id = ticket_system.ticket_system_priority left join ticket_system_products on ticket_system_products.tsp_id = ticket_system.ticket_system_product where ticket_system_id=?","i",$_ARRAY['_ID']);

    //:: OPENED BY
    //:: 1 - admin
    //:: 2 - staff
    //:: 3 - user
    //:: 4 - visitor

  //:: OPENED BY ADMIN
    if ( $_TICKET_DETAILS['0']['ticket_system_opened_by_type'] == 1 ) {
      $_TDI = $_CONN->Query("SELECT `admin_id`, `admin_name`, `admin_email`, `admin_username`, `admin_image`, `admin_password`, `admin_session_id` FROM administrator where admin_id=?","i",$_TICKET_DETAILS['0']['ticket_system_opened_by_id']);
      $_TDI_NAME      = $_TDI['0']['admin_name'];

      if ( empty ( $_TDI['0']['admin_image'] ) ) {
        $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
      } else {
        $_TDI_IMAGE_SRC = _UPLOAD_DIR_HTTP.$_TDI['0']['admin_image'];
      }
    }
  //:: END OPENED BY ADMIN

  //:: OPENED BY STAFF
    if ( $_TICKET_DETAILS['0']['ticket_system_opened_by_type'] == 2 ) {
      $_TDI = $_CONN->Query("SELECT `users_profiles_user_id`, `users_profiles_picture`, `users_profiles_first_name`, `users_profiles_last_name` FROM users_profiles where users_profiles_user_id=?","i",$_TICKET_DETAILS['0']['ticket_system_opened_by_id']);
      $_TDI_NAME      = $_TDI['0']['users_profiles_first_name'].' '.$_TDI['0']['users_profiles_last_name'];

      if ( empty ( $_TDI['0']['users_profiles_picture'] ) ) {
        $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
      } else {
        $_TDI_IMAGE_SRC = _UPLOAD_DIR_HTTP.$_TDI['0']['users_profiles_picture'];
      }
    }
  //:: END OPENED BY STAFF

  //:: OPENED BY USER
    if ( $_TICKET_DETAILS['0']['ticket_system_opened_by_type'] == 3 ) {
      $_TDI = $_CONN->Query("SELECT `users_profiles_user_id`, `users_profiles_picture`, `users_profiles_first_name`, `users_profiles_last_name` FROM users_profiles where users_profiles_user_id=?","i",$_TICKET_DETAILS['0']['ticket_system_opened_by_id']);
      $_TDI_NAME      = $_TDI['0']['users_profiles_first_name'].' '.$_TDI['0']['users_profiles_last_name'];

      if ( empty ( $_TDI['0']['users_profiles_picture'] ) ) {
        $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
      } else {
        $_TDI_IMAGE_SRC = _UPLOAD_DIR_HTTP.$_TDI['0']['users_profiles_picture'];
      }
    }
  //:: END OPENED BY USER

  //:: OPENED BY VISITOR
    if ( $_TICKET_DETAILS['0']['ticket_system_opened_by_type'] == 4 ) {
      $_TDI_NAME      = $_TICKET_DETAILS['0']['ticket_system_name'];
      $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
    }
  //:: END OPENED BY VISITOR

  // :: FIRST REPLY TICKET DETAILS
      $DATE   = date( DATE_FORMAT, $_TICKET_DETAILS['0']['ticket_system_date'] );
      $HOUR   = date( HOUR_FORMAT, $_TICKET_DETAILS['0']['ticket_system_date'] );

      $_TDI_DATE      = $DATE.' '.$HOUR;
      $_TDI_DETAILS   = $_PREPARE->sanitize( $_TICKET_DETAILS['0']['ticket_system_details'], 'textarea-decode' );

      $_TDI_ATTACHMENT  = '';
      if ( !empty ( $_TICKET_DETAILS['0']['ticket_system_file'] ) ) {
        $_TDI_ATTACHMENT  = "<a target='_blank' href='".HTTP_SERVER_WEBSITE.$_GET_URL."?f=".$_TICKET_DETAILS['0']['ticket_system_file']."'>".$_LANG['TICKET']['REPLY_DOWNLOAD']."</a>";
      }
  // :: FIRST REPLY TICKET DETAILS

    if ( ( $_TICKET_DETAILS['0']['ticket_system_opened_by_type'] == 1 ) or ( $_TICKET_DETAILS['0']['ticket_system_opened_by_type'] == 2 ) ) {

      ob_start();
      if ( file_exists ( _TMDRP.'_TICKET/reply.design_left.php' ) ) {
        include( _TMDRP.'_TICKET/reply.design_left.php' );
      } else {
        include('design/reply.design_left.php');
      }
      $_FIRST_REPLY = ob_get_contents();
      ob_end_clean();

    } else {

      ob_start();
      if ( file_exists ( _TMDRP.'_TICKET/reply.design_right.php' ) ) {
        include( _TMDRP.'_TICKET/reply.design_right.php' );
      } else {
        include('design/reply.design_right.php');
      }
      $_FIRST_REPLY = ob_get_contents();
      ob_end_clean();

    }

      $_REPLY_LOAD  = $_CONN->Query("SELECT `ticket_system_reply_id`, `ticket_system_reply_ticket_id`, `ticket_system_reply_by_type`, `ticket_system_reply_user_id`, `ticket_system_reply_details`, `ticket_system_reply_file`, `ticket_system_reply_status`, `ticket_system_reply_date` FROM ticket_system_reply where ticket_system_reply_ticket_id=? order by ticket_system_reply_id DESC","i",$_TICKET_DETAILS['0']['ticket_system_id']);

    ob_start();
    if ( file_exists ( _TMDRP.'_TICKET/reply.top.php' ) ) {
      include( _TMDRP.'_TICKET/reply.top.php' );
    } else {
      include('design/reply.top.php');
    }
    $_RETURN = ob_get_contents();
    ob_end_clean();


  foreach ( $_REPLY_LOAD as $_REPLY_DETAILS ) {

  //:: OPENED BY ADMIN
    if ( $_REPLY_DETAILS['ticket_system_reply_by_type'] == 1 ) {
      $_TDI = $_CONN->Query("SELECT `admin_id`, `admin_name`, `admin_email`, `admin_username`, `admin_image`, `admin_password`, `admin_session_id` FROM administrator where admin_id=?","i",$_REPLY_DETAILS['ticket_system_reply_user_id']);
      $_TDI_NAME      = $_TDI['0']['admin_name'];

      if ( empty ( $_TDI['0']['admin_image'] ) ) {
        $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
      } else {
        $_TDI_IMAGE_SRC = _UPLOAD_DIR_HTTP.$_TDI['0']['admin_image'];
      }
    }
  //:: END OPENED BY ADMIN

  //:: OPENED BY STAFF
    if ( $_REPLY_DETAILS['ticket_system_reply_by_type'] == 2 ) {
      $_TDI = $_CONN->Query("SELECT `users_profiles_user_id`, `users_profiles_picture`, `users_profiles_first_name`, `users_profiles_last_name` FROM users_profiles where users_profiles_user_id=?","i",$_REPLY_DETAILS['ticket_system_reply_user_id']);
      $_TDI_NAME      = $_TDI['0']['users_profiles_first_name'].' '.$_TDI['0']['users_profiles_last_name'];

      if ( empty ( $_TDI['0']['users_profiles_picture'] ) ) {
        $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
      } else {
        $_TDI_IMAGE_SRC = _UPLOAD_DIR_HTTP.$_TDI['0']['users_profiles_picture'];
      }
    }
  //:: END OPENED BY STAFF

  //:: OPENED BY USER
    if ( $_REPLY_DETAILS['ticket_system_reply_by_type'] == 3 ) {
      $_TDI = $_CONN->Query("SELECT `users_profiles_user_id`, `users_profiles_picture`, `users_profiles_first_name`, `users_profiles_last_name` FROM users_profiles where users_profiles_user_id=?","i",$_REPLY_DETAILS['ticket_system_reply_user_id']);
      $_TDI_NAME      = $_TDI['0']['users_profiles_first_name'].' '.$_TDI['0']['users_profiles_last_name'];

      if ( empty ( $_TDI['0']['users_profiles_picture'] ) ) {
        $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
      } else {
        $_TDI_IMAGE_SRC = _UPLOAD_DIR_HTTP.$_TDI['0']['users_profiles_picture'];
      }
    }
  //:: END OPENED BY USER

  //:: OPENED BY VISITOR
    if ( $_REPLY_DETAILS['ticket_system_reply_by_type'] == 4 ) {
      $_TDI_NAME      = $_TICKET_DETAILS['0']['ticket_system_name'];
      $_TDI_IMAGE_SRC = HTTP_PLUGINS.'_ADMINISTRATORS/img/avatar.png';
    }
  //:: END OPENED BY VISITOR

      $DATE   = date( DATE_FORMAT, $_REPLY_DETAILS['ticket_system_reply_date'] );
      $HOUR   = date( HOUR_FORMAT, $_REPLY_DETAILS['ticket_system_reply_date'] );

      $_TDI_DATE      = $DATE.' '.$HOUR;
      $_TDI_DETAILS   = $_PREPARE->sanitize( $_REPLY_DETAILS['ticket_system_reply_details'], 'textarea-decode' );

      $_TDI_ATTACHMENT  = '';
      if ( !empty ( $_REPLY_DETAILS['ticket_system_reply_file'] ) ) {
        $_TDI_ATTACHMENT  = "<a target='_blank' href='".HTTP_SERVER_WEBSITE.$_GET_URL."?f=".$_REPLY_DETAILS['ticket_system_reply_file']."'>".$_LANG['TICKET']['REPLY_DOWNLOAD']."</a>";
      }


    if ( ( $_REPLY_DETAILS['ticket_system_reply_by_type'] == 1 ) or ( $_REPLY_DETAILS['ticket_system_reply_by_type'] == 2 ) ) {
      
      if ( $_REPLY_DETAILS['ticket_system_reply_user_id'] == $_TICKET_DETAILS['0']['ticket_system_user_id'] ) {

      ob_start();
      if ( file_exists ( _TMDRP.'_TICKET/reply.design_left.php' ) ) {
        include( _TMDRP.'_TICKET/reply.design_left.php' );
      } else {
        include('design/reply.design_left.php');
      }
      $_RETURN .= ob_get_contents();
      ob_end_clean();


      } else {

        ob_start();
        if ( file_exists ( _TMDRP.'_TICKET/reply.design_right.php' ) ) {
          include( _TMDRP.'_TICKET/reply.design_right.php' );
        } else {
          include('design/reply.design_right.php');
        }
        $_RETURN .= ob_get_contents();
        ob_end_clean();

      }

    } else {

        ob_start();
        if ( file_exists ( _TMDRP.'_TICKET/reply.design_right.php' ) ) {
          include( _TMDRP.'_TICKET/reply.design_right.php' );
        } else {
          include('design/reply.design_right.php');
        }
        $_RETURN .= ob_get_contents();
        ob_end_clean();

    }

  }

        ob_start();
        if ( file_exists ( _TMDRP.'_TICKET/reply.bottom.php' ) ) {
          include( _TMDRP.'_TICKET/reply.bottom.php' );
        } else {
          include('design/reply.bottom.php');
        }
        $_RETURN .= ob_get_contents();
        ob_end_clean();

      }
    }
    //:: END TICKET REPLY PAGE

    return $_RETURN;
  }

}

//:: _TICKET CLASS
$_VIEW->_TICKET  = $_PAGE  = new _TICKET;
?>